// Code generated by go-swagger; DO NOT EDIT.

package application

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewApplicationComponentCollectionGetParams creates a new ApplicationComponentCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewApplicationComponentCollectionGetParams() *ApplicationComponentCollectionGetParams {
	return &ApplicationComponentCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewApplicationComponentCollectionGetParamsWithTimeout creates a new ApplicationComponentCollectionGetParams object
// with the ability to set a timeout on a request.
func NewApplicationComponentCollectionGetParamsWithTimeout(timeout time.Duration) *ApplicationComponentCollectionGetParams {
	return &ApplicationComponentCollectionGetParams{
		timeout: timeout,
	}
}

// NewApplicationComponentCollectionGetParamsWithContext creates a new ApplicationComponentCollectionGetParams object
// with the ability to set a context for a request.
func NewApplicationComponentCollectionGetParamsWithContext(ctx context.Context) *ApplicationComponentCollectionGetParams {
	return &ApplicationComponentCollectionGetParams{
		Context: ctx,
	}
}

// NewApplicationComponentCollectionGetParamsWithHTTPClient creates a new ApplicationComponentCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewApplicationComponentCollectionGetParamsWithHTTPClient(client *http.Client) *ApplicationComponentCollectionGetParams {
	return &ApplicationComponentCollectionGetParams{
		HTTPClient: client,
	}
}

/* ApplicationComponentCollectionGetParams contains all the parameters to send to the API endpoint
   for the application component collection get operation.

   Typically these are written to a http.Request.
*/
type ApplicationComponentCollectionGetParams struct {

	/* ApplicationUUID.

	   Application UUID
	*/
	ApplicationUUIDPathParameter string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* StorageServiceName.

	   Filter by storage_service.name
	*/
	StorageServiceNameQueryParameter *string

	/* StorageServiceUUID.

	   Filter by storage_service.uuid
	*/
	StorageServiceUUIDQueryParameter *string

	/* UUID.

	   Filter by UUID
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the application component collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationComponentCollectionGetParams) WithDefaults() *ApplicationComponentCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the application component collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationComponentCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ApplicationComponentCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithTimeout(timeout time.Duration) *ApplicationComponentCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithContext(ctx context.Context) *ApplicationComponentCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithHTTPClient(client *http.Client) *ApplicationComponentCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationUUIDPathParameter adds the applicationUUID to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithApplicationUUIDPathParameter(applicationUUID string) *ApplicationComponentCollectionGetParams {
	o.SetApplicationUUIDPathParameter(applicationUUID)
	return o
}

// SetApplicationUUIDPathParameter adds the applicationUuid to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetApplicationUUIDPathParameter(applicationUUID string) {
	o.ApplicationUUIDPathParameter = applicationUUID
}

// WithFieldsQueryParameter adds the fields to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithFieldsQueryParameter(fields []string) *ApplicationComponentCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ApplicationComponentCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithNameQueryParameter(name *string) *ApplicationComponentCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ApplicationComponentCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ApplicationComponentCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ApplicationComponentCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithStorageServiceNameQueryParameter adds the storageServiceName to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithStorageServiceNameQueryParameter(storageServiceName *string) *ApplicationComponentCollectionGetParams {
	o.SetStorageServiceNameQueryParameter(storageServiceName)
	return o
}

// SetStorageServiceNameQueryParameter adds the storageServiceName to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetStorageServiceNameQueryParameter(storageServiceName *string) {
	o.StorageServiceNameQueryParameter = storageServiceName
}

// WithStorageServiceUUIDQueryParameter adds the storageServiceUUID to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithStorageServiceUUIDQueryParameter(storageServiceUUID *string) *ApplicationComponentCollectionGetParams {
	o.SetStorageServiceUUIDQueryParameter(storageServiceUUID)
	return o
}

// SetStorageServiceUUIDQueryParameter adds the storageServiceUuid to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetStorageServiceUUIDQueryParameter(storageServiceUUID *string) {
	o.StorageServiceUUIDQueryParameter = storageServiceUUID
}

// WithUUIDQueryParameter adds the uuid to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) WithUUIDQueryParameter(uuid *string) *ApplicationComponentCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the application component collection get params
func (o *ApplicationComponentCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *ApplicationComponentCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param application.uuid
	if err := r.SetPathParam("application.uuid", o.ApplicationUUIDPathParameter); err != nil {
		return err
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.StorageServiceNameQueryParameter != nil {

		// query param storage_service.name
		var qrStorageServiceName string

		if o.StorageServiceNameQueryParameter != nil {
			qrStorageServiceName = *o.StorageServiceNameQueryParameter
		}
		qStorageServiceName := qrStorageServiceName
		if qStorageServiceName != "" {

			if err := r.SetQueryParam("storage_service.name", qStorageServiceName); err != nil {
				return err
			}
		}
	}

	if o.StorageServiceUUIDQueryParameter != nil {

		// query param storage_service.uuid
		var qrStorageServiceUUID string

		if o.StorageServiceUUIDQueryParameter != nil {
			qrStorageServiceUUID = *o.StorageServiceUUIDQueryParameter
		}
		qStorageServiceUUID := qrStorageServiceUUID
		if qStorageServiceUUID != "" {

			if err := r.SetQueryParam("storage_service.uuid", qStorageServiceUUID); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamApplicationComponentCollectionGet binds the parameter fields
func (o *ApplicationComponentCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamApplicationComponentCollectionGet binds the parameter order_by
func (o *ApplicationComponentCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
