// Code generated by go-swagger; DO NOT EDIT.

package application

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewApplicationComponentSnapshotCollectionGetParams creates a new ApplicationComponentSnapshotCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewApplicationComponentSnapshotCollectionGetParams() *ApplicationComponentSnapshotCollectionGetParams {
	return &ApplicationComponentSnapshotCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewApplicationComponentSnapshotCollectionGetParamsWithTimeout creates a new ApplicationComponentSnapshotCollectionGetParams object
// with the ability to set a timeout on a request.
func NewApplicationComponentSnapshotCollectionGetParamsWithTimeout(timeout time.Duration) *ApplicationComponentSnapshotCollectionGetParams {
	return &ApplicationComponentSnapshotCollectionGetParams{
		timeout: timeout,
	}
}

// NewApplicationComponentSnapshotCollectionGetParamsWithContext creates a new ApplicationComponentSnapshotCollectionGetParams object
// with the ability to set a context for a request.
func NewApplicationComponentSnapshotCollectionGetParamsWithContext(ctx context.Context) *ApplicationComponentSnapshotCollectionGetParams {
	return &ApplicationComponentSnapshotCollectionGetParams{
		Context: ctx,
	}
}

// NewApplicationComponentSnapshotCollectionGetParamsWithHTTPClient creates a new ApplicationComponentSnapshotCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewApplicationComponentSnapshotCollectionGetParamsWithHTTPClient(client *http.Client) *ApplicationComponentSnapshotCollectionGetParams {
	return &ApplicationComponentSnapshotCollectionGetParams{
		HTTPClient: client,
	}
}

/* ApplicationComponentSnapshotCollectionGetParams contains all the parameters to send to the API endpoint
   for the application component snapshot collection get operation.

   Typically these are written to a http.Request.
*/
type ApplicationComponentSnapshotCollectionGetParams struct {

	/* ApplicationUUID.

	   Application UUID
	*/
	ApplicationUUIDPathParameter string

	/* Comment.

	   Filter by comment
	*/
	CommentQueryParameter *string

	/* ComponentName.

	   Filter by Application Component Name
	*/
	ComponentNameQueryParameter *string

	/* ComponentUUID.

	   Application Component UUID
	*/
	ComponentUUIDPathParameter string

	/* ConsistencyType.

	   Filter by consistency_type
	*/
	ConsistencyTypeQueryParameter *string

	/* CreateTime.

	   Filter by create_time
	*/
	CreateTimeQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* IsPartial.

	   Filter by is_partial
	*/
	IsPartialQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the application component snapshot collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationComponentSnapshotCollectionGetParams) WithDefaults() *ApplicationComponentSnapshotCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the application component snapshot collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationComponentSnapshotCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ApplicationComponentSnapshotCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithTimeout(timeout time.Duration) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithContext(ctx context.Context) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithHTTPClient(client *http.Client) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationUUIDPathParameter adds the applicationUUID to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithApplicationUUIDPathParameter(applicationUUID string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetApplicationUUIDPathParameter(applicationUUID)
	return o
}

// SetApplicationUUIDPathParameter adds the applicationUuid to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetApplicationUUIDPathParameter(applicationUUID string) {
	o.ApplicationUUIDPathParameter = applicationUUID
}

// WithCommentQueryParameter adds the comment to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithCommentQueryParameter(comment *string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetCommentQueryParameter(comment)
	return o
}

// SetCommentQueryParameter adds the comment to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetCommentQueryParameter(comment *string) {
	o.CommentQueryParameter = comment
}

// WithComponentNameQueryParameter adds the componentName to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithComponentNameQueryParameter(componentName *string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetComponentNameQueryParameter(componentName)
	return o
}

// SetComponentNameQueryParameter adds the componentName to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetComponentNameQueryParameter(componentName *string) {
	o.ComponentNameQueryParameter = componentName
}

// WithComponentUUIDPathParameter adds the componentUUID to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithComponentUUIDPathParameter(componentUUID string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetComponentUUIDPathParameter(componentUUID)
	return o
}

// SetComponentUUIDPathParameter adds the componentUuid to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetComponentUUIDPathParameter(componentUUID string) {
	o.ComponentUUIDPathParameter = componentUUID
}

// WithConsistencyTypeQueryParameter adds the consistencyType to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithConsistencyTypeQueryParameter(consistencyType *string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetConsistencyTypeQueryParameter(consistencyType)
	return o
}

// SetConsistencyTypeQueryParameter adds the consistencyType to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetConsistencyTypeQueryParameter(consistencyType *string) {
	o.ConsistencyTypeQueryParameter = consistencyType
}

// WithCreateTimeQueryParameter adds the createTime to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithCreateTimeQueryParameter(createTime *string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetCreateTimeQueryParameter(createTime)
	return o
}

// SetCreateTimeQueryParameter adds the createTime to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetCreateTimeQueryParameter(createTime *string) {
	o.CreateTimeQueryParameter = createTime
}

// WithFieldsQueryParameter adds the fields to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithFieldsQueryParameter(fields []string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIsPartialQueryParameter adds the isPartial to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithIsPartialQueryParameter(isPartial *string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetIsPartialQueryParameter(isPartial)
	return o
}

// SetIsPartialQueryParameter adds the isPartial to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetIsPartialQueryParameter(isPartial *string) {
	o.IsPartialQueryParameter = isPartial
}

// WithMaxRecordsQueryParameter adds the maxRecords to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithNameQueryParameter(name *string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithUUIDQueryParameter adds the uuid to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) WithUUIDQueryParameter(uuid *string) *ApplicationComponentSnapshotCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the application component snapshot collection get params
func (o *ApplicationComponentSnapshotCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *ApplicationComponentSnapshotCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param application.uuid
	if err := r.SetPathParam("application.uuid", o.ApplicationUUIDPathParameter); err != nil {
		return err
	}

	if o.CommentQueryParameter != nil {

		// query param comment
		var qrComment string

		if o.CommentQueryParameter != nil {
			qrComment = *o.CommentQueryParameter
		}
		qComment := qrComment
		if qComment != "" {

			if err := r.SetQueryParam("comment", qComment); err != nil {
				return err
			}
		}
	}

	if o.ComponentNameQueryParameter != nil {

		// query param component.name
		var qrComponentName string

		if o.ComponentNameQueryParameter != nil {
			qrComponentName = *o.ComponentNameQueryParameter
		}
		qComponentName := qrComponentName
		if qComponentName != "" {

			if err := r.SetQueryParam("component.name", qComponentName); err != nil {
				return err
			}
		}
	}

	// path param component.uuid
	if err := r.SetPathParam("component.uuid", o.ComponentUUIDPathParameter); err != nil {
		return err
	}

	if o.ConsistencyTypeQueryParameter != nil {

		// query param consistency_type
		var qrConsistencyType string

		if o.ConsistencyTypeQueryParameter != nil {
			qrConsistencyType = *o.ConsistencyTypeQueryParameter
		}
		qConsistencyType := qrConsistencyType
		if qConsistencyType != "" {

			if err := r.SetQueryParam("consistency_type", qConsistencyType); err != nil {
				return err
			}
		}
	}

	if o.CreateTimeQueryParameter != nil {

		// query param create_time
		var qrCreateTime string

		if o.CreateTimeQueryParameter != nil {
			qrCreateTime = *o.CreateTimeQueryParameter
		}
		qCreateTime := qrCreateTime
		if qCreateTime != "" {

			if err := r.SetQueryParam("create_time", qCreateTime); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IsPartialQueryParameter != nil {

		// query param is_partial
		var qrIsPartial string

		if o.IsPartialQueryParameter != nil {
			qrIsPartial = *o.IsPartialQueryParameter
		}
		qIsPartial := qrIsPartial
		if qIsPartial != "" {

			if err := r.SetQueryParam("is_partial", qIsPartial); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamApplicationComponentSnapshotCollectionGet binds the parameter fields
func (o *ApplicationComponentSnapshotCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamApplicationComponentSnapshotCollectionGet binds the parameter order_by
func (o *ApplicationComponentSnapshotCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
