// Code generated by go-swagger; DO NOT EDIT.

package application

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewApplicationComponentSnapshotCreateParams creates a new ApplicationComponentSnapshotCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewApplicationComponentSnapshotCreateParams() *ApplicationComponentSnapshotCreateParams {
	return &ApplicationComponentSnapshotCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewApplicationComponentSnapshotCreateParamsWithTimeout creates a new ApplicationComponentSnapshotCreateParams object
// with the ability to set a timeout on a request.
func NewApplicationComponentSnapshotCreateParamsWithTimeout(timeout time.Duration) *ApplicationComponentSnapshotCreateParams {
	return &ApplicationComponentSnapshotCreateParams{
		timeout: timeout,
	}
}

// NewApplicationComponentSnapshotCreateParamsWithContext creates a new ApplicationComponentSnapshotCreateParams object
// with the ability to set a context for a request.
func NewApplicationComponentSnapshotCreateParamsWithContext(ctx context.Context) *ApplicationComponentSnapshotCreateParams {
	return &ApplicationComponentSnapshotCreateParams{
		Context: ctx,
	}
}

// NewApplicationComponentSnapshotCreateParamsWithHTTPClient creates a new ApplicationComponentSnapshotCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewApplicationComponentSnapshotCreateParamsWithHTTPClient(client *http.Client) *ApplicationComponentSnapshotCreateParams {
	return &ApplicationComponentSnapshotCreateParams{
		HTTPClient: client,
	}
}

/* ApplicationComponentSnapshotCreateParams contains all the parameters to send to the API endpoint
   for the application component snapshot create operation.

   Typically these are written to a http.Request.
*/
type ApplicationComponentSnapshotCreateParams struct {

	/* ApplicationUUID.

	   Application UUID
	*/
	ApplicationUUIDPathParameter string

	/* ComponentUUID.

	   Application Component UUID
	*/
	ComponentUUIDPathParameter string

	/* Info.

	   Info specification
	*/
	Info *models.ApplicationComponentSnapshot

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the application component snapshot create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationComponentSnapshotCreateParams) WithDefaults() *ApplicationComponentSnapshotCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the application component snapshot create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationComponentSnapshotCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)

		returnTimeoutQueryParameterDefault = int64(0)
	)

	val := ApplicationComponentSnapshotCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) WithTimeout(timeout time.Duration) *ApplicationComponentSnapshotCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) WithContext(ctx context.Context) *ApplicationComponentSnapshotCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) WithHTTPClient(client *http.Client) *ApplicationComponentSnapshotCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationUUIDPathParameter adds the applicationUUID to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) WithApplicationUUIDPathParameter(applicationUUID string) *ApplicationComponentSnapshotCreateParams {
	o.SetApplicationUUIDPathParameter(applicationUUID)
	return o
}

// SetApplicationUUIDPathParameter adds the applicationUuid to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) SetApplicationUUIDPathParameter(applicationUUID string) {
	o.ApplicationUUIDPathParameter = applicationUUID
}

// WithComponentUUIDPathParameter adds the componentUUID to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) WithComponentUUIDPathParameter(componentUUID string) *ApplicationComponentSnapshotCreateParams {
	o.SetComponentUUIDPathParameter(componentUUID)
	return o
}

// SetComponentUUIDPathParameter adds the componentUuid to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) SetComponentUUIDPathParameter(componentUUID string) {
	o.ComponentUUIDPathParameter = componentUUID
}

// WithInfo adds the info to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) WithInfo(info *models.ApplicationComponentSnapshot) *ApplicationComponentSnapshotCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) SetInfo(info *models.ApplicationComponentSnapshot) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ApplicationComponentSnapshotCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ApplicationComponentSnapshotCreateParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the application component snapshot create params
func (o *ApplicationComponentSnapshotCreateParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *ApplicationComponentSnapshotCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param application.uuid
	if err := r.SetPathParam("application.uuid", o.ApplicationUUIDPathParameter); err != nil {
		return err
	}

	// path param component.uuid
	if err := r.SetPathParam("component.uuid", o.ComponentUUIDPathParameter); err != nil {
		return err
	}
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
