// Code generated by go-swagger; DO NOT EDIT.

package application

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewApplicationTemplateCollectionGetParams creates a new ApplicationTemplateCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewApplicationTemplateCollectionGetParams() *ApplicationTemplateCollectionGetParams {
	return &ApplicationTemplateCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewApplicationTemplateCollectionGetParamsWithTimeout creates a new ApplicationTemplateCollectionGetParams object
// with the ability to set a timeout on a request.
func NewApplicationTemplateCollectionGetParamsWithTimeout(timeout time.Duration) *ApplicationTemplateCollectionGetParams {
	return &ApplicationTemplateCollectionGetParams{
		timeout: timeout,
	}
}

// NewApplicationTemplateCollectionGetParamsWithContext creates a new ApplicationTemplateCollectionGetParams object
// with the ability to set a context for a request.
func NewApplicationTemplateCollectionGetParamsWithContext(ctx context.Context) *ApplicationTemplateCollectionGetParams {
	return &ApplicationTemplateCollectionGetParams{
		Context: ctx,
	}
}

// NewApplicationTemplateCollectionGetParamsWithHTTPClient creates a new ApplicationTemplateCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewApplicationTemplateCollectionGetParamsWithHTTPClient(client *http.Client) *ApplicationTemplateCollectionGetParams {
	return &ApplicationTemplateCollectionGetParams{
		HTTPClient: client,
	}
}

/* ApplicationTemplateCollectionGetParams contains all the parameters to send to the API endpoint
   for the application template collection get operation.

   Typically these are written to a http.Request.
*/
type ApplicationTemplateCollectionGetParams struct {

	/* Description.

	   Filter by description
	*/
	DescriptionQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* MissingPrerequisites.

	   Filter by missing_prerequisites
	*/
	MissingPrerequisitesQueryParameter *string

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* Protocol.

	   Filter by protocol
	*/
	ProtocolQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the application template collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationTemplateCollectionGetParams) WithDefaults() *ApplicationTemplateCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the application template collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationTemplateCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ApplicationTemplateCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithTimeout(timeout time.Duration) *ApplicationTemplateCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithContext(ctx context.Context) *ApplicationTemplateCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithHTTPClient(client *http.Client) *ApplicationTemplateCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDescriptionQueryParameter adds the description to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithDescriptionQueryParameter(description *string) *ApplicationTemplateCollectionGetParams {
	o.SetDescriptionQueryParameter(description)
	return o
}

// SetDescriptionQueryParameter adds the description to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetDescriptionQueryParameter(description *string) {
	o.DescriptionQueryParameter = description
}

// WithFieldsQueryParameter adds the fields to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithFieldsQueryParameter(fields []string) *ApplicationTemplateCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ApplicationTemplateCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithMissingPrerequisitesQueryParameter adds the missingPrerequisites to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithMissingPrerequisitesQueryParameter(missingPrerequisites *string) *ApplicationTemplateCollectionGetParams {
	o.SetMissingPrerequisitesQueryParameter(missingPrerequisites)
	return o
}

// SetMissingPrerequisitesQueryParameter adds the missingPrerequisites to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetMissingPrerequisitesQueryParameter(missingPrerequisites *string) {
	o.MissingPrerequisitesQueryParameter = missingPrerequisites
}

// WithNameQueryParameter adds the name to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithNameQueryParameter(name *string) *ApplicationTemplateCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ApplicationTemplateCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithProtocolQueryParameter adds the protocol to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithProtocolQueryParameter(protocol *string) *ApplicationTemplateCollectionGetParams {
	o.SetProtocolQueryParameter(protocol)
	return o
}

// SetProtocolQueryParameter adds the protocol to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetProtocolQueryParameter(protocol *string) {
	o.ProtocolQueryParameter = protocol
}

// WithReturnRecordsQueryParameter adds the returnRecords to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ApplicationTemplateCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ApplicationTemplateCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the application template collection get params
func (o *ApplicationTemplateCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *ApplicationTemplateCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DescriptionQueryParameter != nil {

		// query param description
		var qrDescription string

		if o.DescriptionQueryParameter != nil {
			qrDescription = *o.DescriptionQueryParameter
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.MissingPrerequisitesQueryParameter != nil {

		// query param missing_prerequisites
		var qrMissingPrerequisites string

		if o.MissingPrerequisitesQueryParameter != nil {
			qrMissingPrerequisites = *o.MissingPrerequisitesQueryParameter
		}
		qMissingPrerequisites := qrMissingPrerequisites
		if qMissingPrerequisites != "" {

			if err := r.SetQueryParam("missing_prerequisites", qMissingPrerequisites); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ProtocolQueryParameter != nil {

		// query param protocol
		var qrProtocol string

		if o.ProtocolQueryParameter != nil {
			qrProtocol = *o.ProtocolQueryParameter
		}
		qProtocol := qrProtocol
		if qProtocol != "" {

			if err := r.SetQueryParam("protocol", qProtocol); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamApplicationTemplateCollectionGet binds the parameter fields
func (o *ApplicationTemplateCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamApplicationTemplateCollectionGet binds the parameter order_by
func (o *ApplicationTemplateCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
