// Code generated by go-swagger; DO NOT EDIT.

package application

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewApplicationTemplateGetParams creates a new ApplicationTemplateGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewApplicationTemplateGetParams() *ApplicationTemplateGetParams {
	return &ApplicationTemplateGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewApplicationTemplateGetParamsWithTimeout creates a new ApplicationTemplateGetParams object
// with the ability to set a timeout on a request.
func NewApplicationTemplateGetParamsWithTimeout(timeout time.Duration) *ApplicationTemplateGetParams {
	return &ApplicationTemplateGetParams{
		timeout: timeout,
	}
}

// NewApplicationTemplateGetParamsWithContext creates a new ApplicationTemplateGetParams object
// with the ability to set a context for a request.
func NewApplicationTemplateGetParamsWithContext(ctx context.Context) *ApplicationTemplateGetParams {
	return &ApplicationTemplateGetParams{
		Context: ctx,
	}
}

// NewApplicationTemplateGetParamsWithHTTPClient creates a new ApplicationTemplateGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewApplicationTemplateGetParamsWithHTTPClient(client *http.Client) *ApplicationTemplateGetParams {
	return &ApplicationTemplateGetParams{
		HTTPClient: client,
	}
}

/* ApplicationTemplateGetParams contains all the parameters to send to the API endpoint
   for the application template get operation.

   Typically these are written to a http.Request.
*/
type ApplicationTemplateGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Name.

	   Template Name
	*/
	NamePathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the application template get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationTemplateGetParams) WithDefaults() *ApplicationTemplateGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the application template get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationTemplateGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the application template get params
func (o *ApplicationTemplateGetParams) WithTimeout(timeout time.Duration) *ApplicationTemplateGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the application template get params
func (o *ApplicationTemplateGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the application template get params
func (o *ApplicationTemplateGetParams) WithContext(ctx context.Context) *ApplicationTemplateGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the application template get params
func (o *ApplicationTemplateGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the application template get params
func (o *ApplicationTemplateGetParams) WithHTTPClient(client *http.Client) *ApplicationTemplateGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the application template get params
func (o *ApplicationTemplateGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the application template get params
func (o *ApplicationTemplateGetParams) WithFieldsQueryParameter(fields []string) *ApplicationTemplateGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the application template get params
func (o *ApplicationTemplateGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithNamePathParameter adds the name to the application template get params
func (o *ApplicationTemplateGetParams) WithNamePathParameter(name string) *ApplicationTemplateGetParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the application template get params
func (o *ApplicationTemplateGetParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WriteToRequest writes these params to a swagger request
func (o *ApplicationTemplateGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamApplicationTemplateGet binds the parameter fields
func (o *ApplicationTemplateGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
