// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewCapacityPoolCollectionGetParams creates a new CapacityPoolCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCapacityPoolCollectionGetParams() *CapacityPoolCollectionGetParams {
	return &CapacityPoolCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCapacityPoolCollectionGetParamsWithTimeout creates a new CapacityPoolCollectionGetParams object
// with the ability to set a timeout on a request.
func NewCapacityPoolCollectionGetParamsWithTimeout(timeout time.Duration) *CapacityPoolCollectionGetParams {
	return &CapacityPoolCollectionGetParams{
		timeout: timeout,
	}
}

// NewCapacityPoolCollectionGetParamsWithContext creates a new CapacityPoolCollectionGetParams object
// with the ability to set a context for a request.
func NewCapacityPoolCollectionGetParamsWithContext(ctx context.Context) *CapacityPoolCollectionGetParams {
	return &CapacityPoolCollectionGetParams{
		Context: ctx,
	}
}

// NewCapacityPoolCollectionGetParamsWithHTTPClient creates a new CapacityPoolCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewCapacityPoolCollectionGetParamsWithHTTPClient(client *http.Client) *CapacityPoolCollectionGetParams {
	return &CapacityPoolCollectionGetParams{
		HTTPClient: client,
	}
}

/* CapacityPoolCollectionGetParams contains all the parameters to send to the API endpoint
   for the capacity pool collection get operation.

   Typically these are written to a http.Request.
*/
type CapacityPoolCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* LicenseManagerUUID.

	   Filter by license_manager.uuid
	*/
	LicenseManagerUUIDQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* NodesNodeName.

	   Filter by nodes.node.name
	*/
	NodesNodeNameQueryParameter *string

	/* NodesNodeUUID.

	   Filter by nodes.node.uuid
	*/
	NodesNodeUUIDQueryParameter *string

	/* NodesUsedSize.

	   Filter by nodes.used_size
	*/
	NodesUsedSizeQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SerialNumber.

	   Filter by serial_number
	*/
	SerialNumberQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the capacity pool collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CapacityPoolCollectionGetParams) WithDefaults() *CapacityPoolCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the capacity pool collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CapacityPoolCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := CapacityPoolCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithTimeout(timeout time.Duration) *CapacityPoolCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithContext(ctx context.Context) *CapacityPoolCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithHTTPClient(client *http.Client) *CapacityPoolCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithFieldsQueryParameter(fields []string) *CapacityPoolCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithLicenseManagerUUIDQueryParameter adds the licenseManagerUUID to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithLicenseManagerUUIDQueryParameter(licenseManagerUUID *string) *CapacityPoolCollectionGetParams {
	o.SetLicenseManagerUUIDQueryParameter(licenseManagerUUID)
	return o
}

// SetLicenseManagerUUIDQueryParameter adds the licenseManagerUuid to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetLicenseManagerUUIDQueryParameter(licenseManagerUUID *string) {
	o.LicenseManagerUUIDQueryParameter = licenseManagerUUID
}

// WithMaxRecordsQueryParameter adds the maxRecords to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *CapacityPoolCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNodesNodeNameQueryParameter adds the nodesNodeName to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithNodesNodeNameQueryParameter(nodesNodeName *string) *CapacityPoolCollectionGetParams {
	o.SetNodesNodeNameQueryParameter(nodesNodeName)
	return o
}

// SetNodesNodeNameQueryParameter adds the nodesNodeName to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetNodesNodeNameQueryParameter(nodesNodeName *string) {
	o.NodesNodeNameQueryParameter = nodesNodeName
}

// WithNodesNodeUUIDQueryParameter adds the nodesNodeUUID to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithNodesNodeUUIDQueryParameter(nodesNodeUUID *string) *CapacityPoolCollectionGetParams {
	o.SetNodesNodeUUIDQueryParameter(nodesNodeUUID)
	return o
}

// SetNodesNodeUUIDQueryParameter adds the nodesNodeUuid to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetNodesNodeUUIDQueryParameter(nodesNodeUUID *string) {
	o.NodesNodeUUIDQueryParameter = nodesNodeUUID
}

// WithNodesUsedSizeQueryParameter adds the nodesUsedSize to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithNodesUsedSizeQueryParameter(nodesUsedSize *int64) *CapacityPoolCollectionGetParams {
	o.SetNodesUsedSizeQueryParameter(nodesUsedSize)
	return o
}

// SetNodesUsedSizeQueryParameter adds the nodesUsedSize to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetNodesUsedSizeQueryParameter(nodesUsedSize *int64) {
	o.NodesUsedSizeQueryParameter = nodesUsedSize
}

// WithOrderByQueryParameter adds the orderBy to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *CapacityPoolCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *CapacityPoolCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *CapacityPoolCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSerialNumberQueryParameter adds the serialNumber to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) WithSerialNumberQueryParameter(serialNumber *string) *CapacityPoolCollectionGetParams {
	o.SetSerialNumberQueryParameter(serialNumber)
	return o
}

// SetSerialNumberQueryParameter adds the serialNumber to the capacity pool collection get params
func (o *CapacityPoolCollectionGetParams) SetSerialNumberQueryParameter(serialNumber *string) {
	o.SerialNumberQueryParameter = serialNumber
}

// WriteToRequest writes these params to a swagger request
func (o *CapacityPoolCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.LicenseManagerUUIDQueryParameter != nil {

		// query param license_manager.uuid
		var qrLicenseManagerUUID string

		if o.LicenseManagerUUIDQueryParameter != nil {
			qrLicenseManagerUUID = *o.LicenseManagerUUIDQueryParameter
		}
		qLicenseManagerUUID := qrLicenseManagerUUID
		if qLicenseManagerUUID != "" {

			if err := r.SetQueryParam("license_manager.uuid", qLicenseManagerUUID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NodesNodeNameQueryParameter != nil {

		// query param nodes.node.name
		var qrNodesNodeName string

		if o.NodesNodeNameQueryParameter != nil {
			qrNodesNodeName = *o.NodesNodeNameQueryParameter
		}
		qNodesNodeName := qrNodesNodeName
		if qNodesNodeName != "" {

			if err := r.SetQueryParam("nodes.node.name", qNodesNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodesNodeUUIDQueryParameter != nil {

		// query param nodes.node.uuid
		var qrNodesNodeUUID string

		if o.NodesNodeUUIDQueryParameter != nil {
			qrNodesNodeUUID = *o.NodesNodeUUIDQueryParameter
		}
		qNodesNodeUUID := qrNodesNodeUUID
		if qNodesNodeUUID != "" {

			if err := r.SetQueryParam("nodes.node.uuid", qNodesNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.NodesUsedSizeQueryParameter != nil {

		// query param nodes.used_size
		var qrNodesUsedSize int64

		if o.NodesUsedSizeQueryParameter != nil {
			qrNodesUsedSize = *o.NodesUsedSizeQueryParameter
		}
		qNodesUsedSize := swag.FormatInt64(qrNodesUsedSize)
		if qNodesUsedSize != "" {

			if err := r.SetQueryParam("nodes.used_size", qNodesUsedSize); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SerialNumberQueryParameter != nil {

		// query param serial_number
		var qrSerialNumber string

		if o.SerialNumberQueryParameter != nil {
			qrSerialNumber = *o.SerialNumberQueryParameter
		}
		qSerialNumber := qrSerialNumber
		if qSerialNumber != "" {

			if err := r.SetQueryParam("serial_number", qSerialNumber); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamCapacityPoolCollectionGet binds the parameter fields
func (o *CapacityPoolCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamCapacityPoolCollectionGet binds the parameter order_by
func (o *CapacityPoolCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
