// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewClusterGetParams creates a new ClusterGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewClusterGetParams() *ClusterGetParams {
	return &ClusterGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewClusterGetParamsWithTimeout creates a new ClusterGetParams object
// with the ability to set a timeout on a request.
func NewClusterGetParamsWithTimeout(timeout time.Duration) *ClusterGetParams {
	return &ClusterGetParams{
		timeout: timeout,
	}
}

// NewClusterGetParamsWithContext creates a new ClusterGetParams object
// with the ability to set a context for a request.
func NewClusterGetParamsWithContext(ctx context.Context) *ClusterGetParams {
	return &ClusterGetParams{
		Context: ctx,
	}
}

// NewClusterGetParamsWithHTTPClient creates a new ClusterGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewClusterGetParamsWithHTTPClient(client *http.Client) *ClusterGetParams {
	return &ClusterGetParams{
		HTTPClient: client,
	}
}

/* ClusterGetParams contains all the parameters to send to the API endpoint
   for the cluster get operation.

   Typically these are written to a http.Request.
*/
type ClusterGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cluster get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterGetParams) WithDefaults() *ClusterGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cluster get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the cluster get params
func (o *ClusterGetParams) WithTimeout(timeout time.Duration) *ClusterGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cluster get params
func (o *ClusterGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cluster get params
func (o *ClusterGetParams) WithContext(ctx context.Context) *ClusterGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cluster get params
func (o *ClusterGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cluster get params
func (o *ClusterGetParams) WithHTTPClient(client *http.Client) *ClusterGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cluster get params
func (o *ClusterGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the cluster get params
func (o *ClusterGetParams) WithFieldsQueryParameter(fields []string) *ClusterGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the cluster get params
func (o *ClusterGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WriteToRequest writes these params to a swagger request
func (o *ClusterGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamClusterGet binds the parameter fields
func (o *ClusterGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
