// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewClusterNtpServersCollectionGetParams creates a new ClusterNtpServersCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewClusterNtpServersCollectionGetParams() *ClusterNtpServersCollectionGetParams {
	return &ClusterNtpServersCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewClusterNtpServersCollectionGetParamsWithTimeout creates a new ClusterNtpServersCollectionGetParams object
// with the ability to set a timeout on a request.
func NewClusterNtpServersCollectionGetParamsWithTimeout(timeout time.Duration) *ClusterNtpServersCollectionGetParams {
	return &ClusterNtpServersCollectionGetParams{
		timeout: timeout,
	}
}

// NewClusterNtpServersCollectionGetParamsWithContext creates a new ClusterNtpServersCollectionGetParams object
// with the ability to set a context for a request.
func NewClusterNtpServersCollectionGetParamsWithContext(ctx context.Context) *ClusterNtpServersCollectionGetParams {
	return &ClusterNtpServersCollectionGetParams{
		Context: ctx,
	}
}

// NewClusterNtpServersCollectionGetParamsWithHTTPClient creates a new ClusterNtpServersCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewClusterNtpServersCollectionGetParamsWithHTTPClient(client *http.Client) *ClusterNtpServersCollectionGetParams {
	return &ClusterNtpServersCollectionGetParams{
		HTTPClient: client,
	}
}

/* ClusterNtpServersCollectionGetParams contains all the parameters to send to the API endpoint
   for the cluster ntp servers collection get operation.

   Typically these are written to a http.Request.
*/
type ClusterNtpServersCollectionGetParams struct {

	/* AuthenticationEnabled.

	   Filter by authentication_enabled
	*/
	AuthenticationEnabledQueryParameter *bool

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* KeyID.

	   Filter by key.id
	*/
	KeyIDQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Server.

	   Filter by server
	*/
	ServerQueryParameter *string

	/* Version.

	   Filter by version
	*/
	VersionQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cluster ntp servers collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterNtpServersCollectionGetParams) WithDefaults() *ClusterNtpServersCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cluster ntp servers collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterNtpServersCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ClusterNtpServersCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithTimeout(timeout time.Duration) *ClusterNtpServersCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithContext(ctx context.Context) *ClusterNtpServersCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithHTTPClient(client *http.Client) *ClusterNtpServersCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAuthenticationEnabledQueryParameter adds the authenticationEnabled to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithAuthenticationEnabledQueryParameter(authenticationEnabled *bool) *ClusterNtpServersCollectionGetParams {
	o.SetAuthenticationEnabledQueryParameter(authenticationEnabled)
	return o
}

// SetAuthenticationEnabledQueryParameter adds the authenticationEnabled to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetAuthenticationEnabledQueryParameter(authenticationEnabled *bool) {
	o.AuthenticationEnabledQueryParameter = authenticationEnabled
}

// WithFieldsQueryParameter adds the fields to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithFieldsQueryParameter(fields []string) *ClusterNtpServersCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithKeyIDQueryParameter adds the keyID to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithKeyIDQueryParameter(keyID *int64) *ClusterNtpServersCollectionGetParams {
	o.SetKeyIDQueryParameter(keyID)
	return o
}

// SetKeyIDQueryParameter adds the keyId to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetKeyIDQueryParameter(keyID *int64) {
	o.KeyIDQueryParameter = keyID
}

// WithMaxRecordsQueryParameter adds the maxRecords to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ClusterNtpServersCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ClusterNtpServersCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ClusterNtpServersCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ClusterNtpServersCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithServerQueryParameter adds the server to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithServerQueryParameter(server *string) *ClusterNtpServersCollectionGetParams {
	o.SetServerQueryParameter(server)
	return o
}

// SetServerQueryParameter adds the server to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetServerQueryParameter(server *string) {
	o.ServerQueryParameter = server
}

// WithVersionQueryParameter adds the version to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) WithVersionQueryParameter(version *string) *ClusterNtpServersCollectionGetParams {
	o.SetVersionQueryParameter(version)
	return o
}

// SetVersionQueryParameter adds the version to the cluster ntp servers collection get params
func (o *ClusterNtpServersCollectionGetParams) SetVersionQueryParameter(version *string) {
	o.VersionQueryParameter = version
}

// WriteToRequest writes these params to a swagger request
func (o *ClusterNtpServersCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AuthenticationEnabledQueryParameter != nil {

		// query param authentication_enabled
		var qrAuthenticationEnabled bool

		if o.AuthenticationEnabledQueryParameter != nil {
			qrAuthenticationEnabled = *o.AuthenticationEnabledQueryParameter
		}
		qAuthenticationEnabled := swag.FormatBool(qrAuthenticationEnabled)
		if qAuthenticationEnabled != "" {

			if err := r.SetQueryParam("authentication_enabled", qAuthenticationEnabled); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.KeyIDQueryParameter != nil {

		// query param key.id
		var qrKeyID int64

		if o.KeyIDQueryParameter != nil {
			qrKeyID = *o.KeyIDQueryParameter
		}
		qKeyID := swag.FormatInt64(qrKeyID)
		if qKeyID != "" {

			if err := r.SetQueryParam("key.id", qKeyID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ServerQueryParameter != nil {

		// query param server
		var qrServer string

		if o.ServerQueryParameter != nil {
			qrServer = *o.ServerQueryParameter
		}
		qServer := qrServer
		if qServer != "" {

			if err := r.SetQueryParam("server", qServer); err != nil {
				return err
			}
		}
	}

	if o.VersionQueryParameter != nil {

		// query param version
		var qrVersion string

		if o.VersionQueryParameter != nil {
			qrVersion = *o.VersionQueryParameter
		}
		qVersion := qrVersion
		if qVersion != "" {

			if err := r.SetQueryParam("version", qVersion); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamClusterNtpServersCollectionGet binds the parameter fields
func (o *ClusterNtpServersCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamClusterNtpServersCollectionGet binds the parameter order_by
func (o *ClusterNtpServersCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
