// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewClusterPeerModifyParams creates a new ClusterPeerModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewClusterPeerModifyParams() *ClusterPeerModifyParams {
	return &ClusterPeerModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewClusterPeerModifyParamsWithTimeout creates a new ClusterPeerModifyParams object
// with the ability to set a timeout on a request.
func NewClusterPeerModifyParamsWithTimeout(timeout time.Duration) *ClusterPeerModifyParams {
	return &ClusterPeerModifyParams{
		timeout: timeout,
	}
}

// NewClusterPeerModifyParamsWithContext creates a new ClusterPeerModifyParams object
// with the ability to set a context for a request.
func NewClusterPeerModifyParamsWithContext(ctx context.Context) *ClusterPeerModifyParams {
	return &ClusterPeerModifyParams{
		Context: ctx,
	}
}

// NewClusterPeerModifyParamsWithHTTPClient creates a new ClusterPeerModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewClusterPeerModifyParamsWithHTTPClient(client *http.Client) *ClusterPeerModifyParams {
	return &ClusterPeerModifyParams{
		HTTPClient: client,
	}
}

/* ClusterPeerModifyParams contains all the parameters to send to the API endpoint
   for the cluster peer modify operation.

   Typically these are written to a http.Request.
*/
type ClusterPeerModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.ClusterPeer

	/* UUID.

	   Cluster peer relationship UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cluster peer modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterPeerModifyParams) WithDefaults() *ClusterPeerModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cluster peer modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterPeerModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the cluster peer modify params
func (o *ClusterPeerModifyParams) WithTimeout(timeout time.Duration) *ClusterPeerModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cluster peer modify params
func (o *ClusterPeerModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cluster peer modify params
func (o *ClusterPeerModifyParams) WithContext(ctx context.Context) *ClusterPeerModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cluster peer modify params
func (o *ClusterPeerModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cluster peer modify params
func (o *ClusterPeerModifyParams) WithHTTPClient(client *http.Client) *ClusterPeerModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cluster peer modify params
func (o *ClusterPeerModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the cluster peer modify params
func (o *ClusterPeerModifyParams) WithInfo(info *models.ClusterPeer) *ClusterPeerModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the cluster peer modify params
func (o *ClusterPeerModifyParams) SetInfo(info *models.ClusterPeer) {
	o.Info = info
}

// WithUUIDPathParameter adds the uuid to the cluster peer modify params
func (o *ClusterPeerModifyParams) WithUUIDPathParameter(uuid string) *ClusterPeerModifyParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the cluster peer modify params
func (o *ClusterPeerModifyParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *ClusterPeerModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
