// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// MediatorCreateReader is a Reader for the MediatorCreate structure.
type MediatorCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *MediatorCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewMediatorCreateAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewMediatorCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewMediatorCreateAccepted creates a MediatorCreateAccepted with default headers values
func NewMediatorCreateAccepted() *MediatorCreateAccepted {
	return &MediatorCreateAccepted{}
}

/* MediatorCreateAccepted describes a response with status code 202, with default header values.

Accepted
*/
type MediatorCreateAccepted struct {
	Payload *models.JobLinkResponse
}

func (o *MediatorCreateAccepted) Error() string {
	return fmt.Sprintf("[POST /cluster/mediators][%d] mediatorCreateAccepted  %+v", 202, o.Payload)
}
func (o *MediatorCreateAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *MediatorCreateAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewMediatorCreateDefault creates a MediatorCreateDefault with default headers values
func NewMediatorCreateDefault(code int) *MediatorCreateDefault {
	return &MediatorCreateDefault{
		_statusCode: code,
	}
}

/* MediatorCreateDefault describes a response with status code -1, with default header values.

 ONTAP Error Response codes
| Error code  |  Description |
|-------------|--------------|
| 13369351    | Update to mediator failed. Reason: does not authorized for that command. Check that the peer cluster and mediator are reachable.|

*/
type MediatorCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the mediator create default response
func (o *MediatorCreateDefault) Code() int {
	return o._statusCode
}

func (o *MediatorCreateDefault) Error() string {
	return fmt.Sprintf("[POST /cluster/mediators][%d] mediator_create default  %+v", o._statusCode, o.Payload)
}
func (o *MediatorCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *MediatorCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
