// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewMetroclusterDiagnosticsGetParams creates a new MetroclusterDiagnosticsGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMetroclusterDiagnosticsGetParams() *MetroclusterDiagnosticsGetParams {
	return &MetroclusterDiagnosticsGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMetroclusterDiagnosticsGetParamsWithTimeout creates a new MetroclusterDiagnosticsGetParams object
// with the ability to set a timeout on a request.
func NewMetroclusterDiagnosticsGetParamsWithTimeout(timeout time.Duration) *MetroclusterDiagnosticsGetParams {
	return &MetroclusterDiagnosticsGetParams{
		timeout: timeout,
	}
}

// NewMetroclusterDiagnosticsGetParamsWithContext creates a new MetroclusterDiagnosticsGetParams object
// with the ability to set a context for a request.
func NewMetroclusterDiagnosticsGetParamsWithContext(ctx context.Context) *MetroclusterDiagnosticsGetParams {
	return &MetroclusterDiagnosticsGetParams{
		Context: ctx,
	}
}

// NewMetroclusterDiagnosticsGetParamsWithHTTPClient creates a new MetroclusterDiagnosticsGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewMetroclusterDiagnosticsGetParamsWithHTTPClient(client *http.Client) *MetroclusterDiagnosticsGetParams {
	return &MetroclusterDiagnosticsGetParams{
		HTTPClient: client,
	}
}

/* MetroclusterDiagnosticsGetParams contains all the parameters to send to the API endpoint
   for the metrocluster diagnostics get operation.

   Typically these are written to a http.Request.
*/
type MetroclusterDiagnosticsGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the metrocluster diagnostics get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MetroclusterDiagnosticsGetParams) WithDefaults() *MetroclusterDiagnosticsGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the metrocluster diagnostics get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MetroclusterDiagnosticsGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) WithTimeout(timeout time.Duration) *MetroclusterDiagnosticsGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) WithContext(ctx context.Context) *MetroclusterDiagnosticsGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) WithHTTPClient(client *http.Client) *MetroclusterDiagnosticsGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) WithFieldsQueryParameter(fields []string) *MetroclusterDiagnosticsGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *MetroclusterDiagnosticsGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the metrocluster diagnostics get params
func (o *MetroclusterDiagnosticsGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WriteToRequest writes these params to a swagger request
func (o *MetroclusterDiagnosticsGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamMetroclusterDiagnosticsGet binds the parameter fields
func (o *MetroclusterDiagnosticsGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
