// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewCifsShareACLCollectionGetParams creates a new CifsShareACLCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCifsShareACLCollectionGetParams() *CifsShareACLCollectionGetParams {
	return &CifsShareACLCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCifsShareACLCollectionGetParamsWithTimeout creates a new CifsShareACLCollectionGetParams object
// with the ability to set a timeout on a request.
func NewCifsShareACLCollectionGetParamsWithTimeout(timeout time.Duration) *CifsShareACLCollectionGetParams {
	return &CifsShareACLCollectionGetParams{
		timeout: timeout,
	}
}

// NewCifsShareACLCollectionGetParamsWithContext creates a new CifsShareACLCollectionGetParams object
// with the ability to set a context for a request.
func NewCifsShareACLCollectionGetParamsWithContext(ctx context.Context) *CifsShareACLCollectionGetParams {
	return &CifsShareACLCollectionGetParams{
		Context: ctx,
	}
}

// NewCifsShareACLCollectionGetParamsWithHTTPClient creates a new CifsShareACLCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewCifsShareACLCollectionGetParamsWithHTTPClient(client *http.Client) *CifsShareACLCollectionGetParams {
	return &CifsShareACLCollectionGetParams{
		HTTPClient: client,
	}
}

/* CifsShareACLCollectionGetParams contains all the parameters to send to the API endpoint
   for the cifs share acl collection get operation.

   Typically these are written to a http.Request.
*/
type CifsShareACLCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* Permission.

	   Filter by permission
	*/
	PermissionQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Share.

	   CIFS Share Name
	*/
	SharePathParameter string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	/* Type.

	   Filter by type
	*/
	TypeQueryParameter *string

	/* UserOrGroup.

	   Filter by user_or_group
	*/
	UserOrGroupQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cifs share acl collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsShareACLCollectionGetParams) WithDefaults() *CifsShareACLCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cifs share acl collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsShareACLCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := CifsShareACLCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithTimeout(timeout time.Duration) *CifsShareACLCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithContext(ctx context.Context) *CifsShareACLCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithHTTPClient(client *http.Client) *CifsShareACLCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithFieldsQueryParameter(fields []string) *CifsShareACLCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *CifsShareACLCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *CifsShareACLCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPermissionQueryParameter adds the permission to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithPermissionQueryParameter(permission *string) *CifsShareACLCollectionGetParams {
	o.SetPermissionQueryParameter(permission)
	return o
}

// SetPermissionQueryParameter adds the permission to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetPermissionQueryParameter(permission *string) {
	o.PermissionQueryParameter = permission
}

// WithReturnRecordsQueryParameter adds the returnRecords to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *CifsShareACLCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *CifsShareACLCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSharePathParameter adds the share to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithSharePathParameter(share string) *CifsShareACLCollectionGetParams {
	o.SetSharePathParameter(share)
	return o
}

// SetSharePathParameter adds the share to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetSharePathParameter(share string) {
	o.SharePathParameter = share
}

// WithSVMNameQueryParameter adds the svmName to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *CifsShareACLCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDPathParameter adds the svmUUID to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithSVMUUIDPathParameter(svmUUID string) *CifsShareACLCollectionGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WithTypeQueryParameter adds the typeVar to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithTypeQueryParameter(typeVar *string) *CifsShareACLCollectionGetParams {
	o.SetTypeQueryParameter(typeVar)
	return o
}

// SetTypeQueryParameter adds the type to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetTypeQueryParameter(typeVar *string) {
	o.TypeQueryParameter = typeVar
}

// WithUserOrGroupQueryParameter adds the userOrGroup to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) WithUserOrGroupQueryParameter(userOrGroup *string) *CifsShareACLCollectionGetParams {
	o.SetUserOrGroupQueryParameter(userOrGroup)
	return o
}

// SetUserOrGroupQueryParameter adds the userOrGroup to the cifs share acl collection get params
func (o *CifsShareACLCollectionGetParams) SetUserOrGroupQueryParameter(userOrGroup *string) {
	o.UserOrGroupQueryParameter = userOrGroup
}

// WriteToRequest writes these params to a swagger request
func (o *CifsShareACLCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PermissionQueryParameter != nil {

		// query param permission
		var qrPermission string

		if o.PermissionQueryParameter != nil {
			qrPermission = *o.PermissionQueryParameter
		}
		qPermission := qrPermission
		if qPermission != "" {

			if err := r.SetQueryParam("permission", qPermission); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param share
	if err := r.SetPathParam("share", o.SharePathParameter); err != nil {
		return err
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if o.TypeQueryParameter != nil {

		// query param type
		var qrType string

		if o.TypeQueryParameter != nil {
			qrType = *o.TypeQueryParameter
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if o.UserOrGroupQueryParameter != nil {

		// query param user_or_group
		var qrUserOrGroup string

		if o.UserOrGroupQueryParameter != nil {
			qrUserOrGroup = *o.UserOrGroupQueryParameter
		}
		qUserOrGroup := qrUserOrGroup
		if qUserOrGroup != "" {

			if err := r.SetQueryParam("user_or_group", qUserOrGroup); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamCifsShareACLCollectionGet binds the parameter fields
func (o *CifsShareACLCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamCifsShareACLCollectionGet binds the parameter order_by
func (o *CifsShareACLCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
