// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCifsShareACLDeleteParams creates a new CifsShareACLDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCifsShareACLDeleteParams() *CifsShareACLDeleteParams {
	return &CifsShareACLDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCifsShareACLDeleteParamsWithTimeout creates a new CifsShareACLDeleteParams object
// with the ability to set a timeout on a request.
func NewCifsShareACLDeleteParamsWithTimeout(timeout time.Duration) *CifsShareACLDeleteParams {
	return &CifsShareACLDeleteParams{
		timeout: timeout,
	}
}

// NewCifsShareACLDeleteParamsWithContext creates a new CifsShareACLDeleteParams object
// with the ability to set a context for a request.
func NewCifsShareACLDeleteParamsWithContext(ctx context.Context) *CifsShareACLDeleteParams {
	return &CifsShareACLDeleteParams{
		Context: ctx,
	}
}

// NewCifsShareACLDeleteParamsWithHTTPClient creates a new CifsShareACLDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewCifsShareACLDeleteParamsWithHTTPClient(client *http.Client) *CifsShareACLDeleteParams {
	return &CifsShareACLDeleteParams{
		HTTPClient: client,
	}
}

/* CifsShareACLDeleteParams contains all the parameters to send to the API endpoint
   for the cifs share acl delete operation.

   Typically these are written to a http.Request.
*/
type CifsShareACLDeleteParams struct {

	/* Share.

	   Share name
	*/
	SharePathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	/* Type.

	   User or group type
	*/
	TypePathParameter string

	/* UserOrGroup.

	   User or group name
	*/
	UserOrGroupPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cifs share acl delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsShareACLDeleteParams) WithDefaults() *CifsShareACLDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cifs share acl delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsShareACLDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) WithTimeout(timeout time.Duration) *CifsShareACLDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) WithContext(ctx context.Context) *CifsShareACLDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) WithHTTPClient(client *http.Client) *CifsShareACLDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithSharePathParameter adds the share to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) WithSharePathParameter(share string) *CifsShareACLDeleteParams {
	o.SetSharePathParameter(share)
	return o
}

// SetSharePathParameter adds the share to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) SetSharePathParameter(share string) {
	o.SharePathParameter = share
}

// WithSVMUUIDPathParameter adds the svmUUID to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *CifsShareACLDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WithTypePathParameter adds the typeVar to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) WithTypePathParameter(typeVar string) *CifsShareACLDeleteParams {
	o.SetTypePathParameter(typeVar)
	return o
}

// SetTypePathParameter adds the type to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) SetTypePathParameter(typeVar string) {
	o.TypePathParameter = typeVar
}

// WithUserOrGroupPathParameter adds the userOrGroup to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) WithUserOrGroupPathParameter(userOrGroup string) *CifsShareACLDeleteParams {
	o.SetUserOrGroupPathParameter(userOrGroup)
	return o
}

// SetUserOrGroupPathParameter adds the userOrGroup to the cifs share acl delete params
func (o *CifsShareACLDeleteParams) SetUserOrGroupPathParameter(userOrGroup string) {
	o.UserOrGroupPathParameter = userOrGroup
}

// WriteToRequest writes these params to a swagger request
func (o *CifsShareACLDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param share
	if err := r.SetPathParam("share", o.SharePathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	// path param type
	if err := r.SetPathParam("type", o.TypePathParameter); err != nil {
		return err
	}

	// path param user_or_group
	if err := r.SetPathParam("user_or_group", o.UserOrGroupPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
