// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewFileAccessEventDeleteParams creates a new FileAccessEventDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFileAccessEventDeleteParams() *FileAccessEventDeleteParams {
	return &FileAccessEventDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFileAccessEventDeleteParamsWithTimeout creates a new FileAccessEventDeleteParams object
// with the ability to set a timeout on a request.
func NewFileAccessEventDeleteParamsWithTimeout(timeout time.Duration) *FileAccessEventDeleteParams {
	return &FileAccessEventDeleteParams{
		timeout: timeout,
	}
}

// NewFileAccessEventDeleteParamsWithContext creates a new FileAccessEventDeleteParams object
// with the ability to set a context for a request.
func NewFileAccessEventDeleteParamsWithContext(ctx context.Context) *FileAccessEventDeleteParams {
	return &FileAccessEventDeleteParams{
		Context: ctx,
	}
}

// NewFileAccessEventDeleteParamsWithHTTPClient creates a new FileAccessEventDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewFileAccessEventDeleteParamsWithHTTPClient(client *http.Client) *FileAccessEventDeleteParams {
	return &FileAccessEventDeleteParams{
		HTTPClient: client,
	}
}

/* FileAccessEventDeleteParams contains all the parameters to send to the API endpoint
   for the file access event delete operation.

   Typically these are written to a http.Request.
*/
type FileAccessEventDeleteParams struct {

	/* Index.

	   Sequence number of traced event.
	*/
	IndexPathParameter int64

	/* NodeUUID.

	   Node UUID.
	*/
	NodeUUIDPathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the file access event delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessEventDeleteParams) WithDefaults() *FileAccessEventDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the file access event delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessEventDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the file access event delete params
func (o *FileAccessEventDeleteParams) WithTimeout(timeout time.Duration) *FileAccessEventDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the file access event delete params
func (o *FileAccessEventDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the file access event delete params
func (o *FileAccessEventDeleteParams) WithContext(ctx context.Context) *FileAccessEventDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the file access event delete params
func (o *FileAccessEventDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the file access event delete params
func (o *FileAccessEventDeleteParams) WithHTTPClient(client *http.Client) *FileAccessEventDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the file access event delete params
func (o *FileAccessEventDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndexPathParameter adds the index to the file access event delete params
func (o *FileAccessEventDeleteParams) WithIndexPathParameter(index int64) *FileAccessEventDeleteParams {
	o.SetIndexPathParameter(index)
	return o
}

// SetIndexPathParameter adds the index to the file access event delete params
func (o *FileAccessEventDeleteParams) SetIndexPathParameter(index int64) {
	o.IndexPathParameter = index
}

// WithNodeUUIDPathParameter adds the nodeUUID to the file access event delete params
func (o *FileAccessEventDeleteParams) WithNodeUUIDPathParameter(nodeUUID string) *FileAccessEventDeleteParams {
	o.SetNodeUUIDPathParameter(nodeUUID)
	return o
}

// SetNodeUUIDPathParameter adds the nodeUuid to the file access event delete params
func (o *FileAccessEventDeleteParams) SetNodeUUIDPathParameter(nodeUUID string) {
	o.NodeUUIDPathParameter = nodeUUID
}

// WithSVMUUIDPathParameter adds the svmUUID to the file access event delete params
func (o *FileAccessEventDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *FileAccessEventDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the file access event delete params
func (o *FileAccessEventDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *FileAccessEventDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.IndexPathParameter)); err != nil {
		return err
	}

	// path param node.uuid
	if err := r.SetPathParam("node.uuid", o.NodeUUIDPathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
