// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewFileAccessEventGetParams creates a new FileAccessEventGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFileAccessEventGetParams() *FileAccessEventGetParams {
	return &FileAccessEventGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFileAccessEventGetParamsWithTimeout creates a new FileAccessEventGetParams object
// with the ability to set a timeout on a request.
func NewFileAccessEventGetParamsWithTimeout(timeout time.Duration) *FileAccessEventGetParams {
	return &FileAccessEventGetParams{
		timeout: timeout,
	}
}

// NewFileAccessEventGetParamsWithContext creates a new FileAccessEventGetParams object
// with the ability to set a context for a request.
func NewFileAccessEventGetParamsWithContext(ctx context.Context) *FileAccessEventGetParams {
	return &FileAccessEventGetParams{
		Context: ctx,
	}
}

// NewFileAccessEventGetParamsWithHTTPClient creates a new FileAccessEventGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewFileAccessEventGetParamsWithHTTPClient(client *http.Client) *FileAccessEventGetParams {
	return &FileAccessEventGetParams{
		HTTPClient: client,
	}
}

/* FileAccessEventGetParams contains all the parameters to send to the API endpoint
   for the file access event get operation.

   Typically these are written to a http.Request.
*/
type FileAccessEventGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Index.

	   Sequence number of traced event.
	*/
	IndexPathParameter int64

	/* NodeUUID.

	   Node UUID.
	*/
	NodeUUIDPathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the file access event get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessEventGetParams) WithDefaults() *FileAccessEventGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the file access event get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessEventGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the file access event get params
func (o *FileAccessEventGetParams) WithTimeout(timeout time.Duration) *FileAccessEventGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the file access event get params
func (o *FileAccessEventGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the file access event get params
func (o *FileAccessEventGetParams) WithContext(ctx context.Context) *FileAccessEventGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the file access event get params
func (o *FileAccessEventGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the file access event get params
func (o *FileAccessEventGetParams) WithHTTPClient(client *http.Client) *FileAccessEventGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the file access event get params
func (o *FileAccessEventGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the file access event get params
func (o *FileAccessEventGetParams) WithFieldsQueryParameter(fields []string) *FileAccessEventGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the file access event get params
func (o *FileAccessEventGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIndexPathParameter adds the index to the file access event get params
func (o *FileAccessEventGetParams) WithIndexPathParameter(index int64) *FileAccessEventGetParams {
	o.SetIndexPathParameter(index)
	return o
}

// SetIndexPathParameter adds the index to the file access event get params
func (o *FileAccessEventGetParams) SetIndexPathParameter(index int64) {
	o.IndexPathParameter = index
}

// WithNodeUUIDPathParameter adds the nodeUUID to the file access event get params
func (o *FileAccessEventGetParams) WithNodeUUIDPathParameter(nodeUUID string) *FileAccessEventGetParams {
	o.SetNodeUUIDPathParameter(nodeUUID)
	return o
}

// SetNodeUUIDPathParameter adds the nodeUuid to the file access event get params
func (o *FileAccessEventGetParams) SetNodeUUIDPathParameter(nodeUUID string) {
	o.NodeUUIDPathParameter = nodeUUID
}

// WithSVMUUIDPathParameter adds the svmUUID to the file access event get params
func (o *FileAccessEventGetParams) WithSVMUUIDPathParameter(svmUUID string) *FileAccessEventGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the file access event get params
func (o *FileAccessEventGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *FileAccessEventGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.IndexPathParameter)); err != nil {
		return err
	}

	// path param node.uuid
	if err := r.SetPathParam("node.uuid", o.NodeUUIDPathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamFileAccessEventGet binds the parameter fields
func (o *FileAccessEventGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
