// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewFileAccessFilterCreateParams creates a new FileAccessFilterCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFileAccessFilterCreateParams() *FileAccessFilterCreateParams {
	return &FileAccessFilterCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFileAccessFilterCreateParamsWithTimeout creates a new FileAccessFilterCreateParams object
// with the ability to set a timeout on a request.
func NewFileAccessFilterCreateParamsWithTimeout(timeout time.Duration) *FileAccessFilterCreateParams {
	return &FileAccessFilterCreateParams{
		timeout: timeout,
	}
}

// NewFileAccessFilterCreateParamsWithContext creates a new FileAccessFilterCreateParams object
// with the ability to set a context for a request.
func NewFileAccessFilterCreateParamsWithContext(ctx context.Context) *FileAccessFilterCreateParams {
	return &FileAccessFilterCreateParams{
		Context: ctx,
	}
}

// NewFileAccessFilterCreateParamsWithHTTPClient creates a new FileAccessFilterCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewFileAccessFilterCreateParamsWithHTTPClient(client *http.Client) *FileAccessFilterCreateParams {
	return &FileAccessFilterCreateParams{
		HTTPClient: client,
	}
}

/* FileAccessFilterCreateParams contains all the parameters to send to the API endpoint
   for the file access filter create operation.

   Typically these are written to a http.Request.
*/
type FileAccessFilterCreateParams struct {

	/* Info.

	   Information specification
	*/
	Info *models.FileAccessFilter

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the file access filter create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessFilterCreateParams) WithDefaults() *FileAccessFilterCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the file access filter create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessFilterCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := FileAccessFilterCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the file access filter create params
func (o *FileAccessFilterCreateParams) WithTimeout(timeout time.Duration) *FileAccessFilterCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the file access filter create params
func (o *FileAccessFilterCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the file access filter create params
func (o *FileAccessFilterCreateParams) WithContext(ctx context.Context) *FileAccessFilterCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the file access filter create params
func (o *FileAccessFilterCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the file access filter create params
func (o *FileAccessFilterCreateParams) WithHTTPClient(client *http.Client) *FileAccessFilterCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the file access filter create params
func (o *FileAccessFilterCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the file access filter create params
func (o *FileAccessFilterCreateParams) WithInfo(info *models.FileAccessFilter) *FileAccessFilterCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the file access filter create params
func (o *FileAccessFilterCreateParams) SetInfo(info *models.FileAccessFilter) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the file access filter create params
func (o *FileAccessFilterCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *FileAccessFilterCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the file access filter create params
func (o *FileAccessFilterCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *FileAccessFilterCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
