// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewFileAccessFilterDeleteParams creates a new FileAccessFilterDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFileAccessFilterDeleteParams() *FileAccessFilterDeleteParams {
	return &FileAccessFilterDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFileAccessFilterDeleteParamsWithTimeout creates a new FileAccessFilterDeleteParams object
// with the ability to set a timeout on a request.
func NewFileAccessFilterDeleteParamsWithTimeout(timeout time.Duration) *FileAccessFilterDeleteParams {
	return &FileAccessFilterDeleteParams{
		timeout: timeout,
	}
}

// NewFileAccessFilterDeleteParamsWithContext creates a new FileAccessFilterDeleteParams object
// with the ability to set a context for a request.
func NewFileAccessFilterDeleteParamsWithContext(ctx context.Context) *FileAccessFilterDeleteParams {
	return &FileAccessFilterDeleteParams{
		Context: ctx,
	}
}

// NewFileAccessFilterDeleteParamsWithHTTPClient creates a new FileAccessFilterDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewFileAccessFilterDeleteParamsWithHTTPClient(client *http.Client) *FileAccessFilterDeleteParams {
	return &FileAccessFilterDeleteParams{
		HTTPClient: client,
	}
}

/* FileAccessFilterDeleteParams contains all the parameters to send to the API endpoint
   for the file access filter delete operation.

   Typically these are written to a http.Request.
*/
type FileAccessFilterDeleteParams struct {

	/* Index.

	   Filter index.
	*/
	IndexPathParameter int64

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the file access filter delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessFilterDeleteParams) WithDefaults() *FileAccessFilterDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the file access filter delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessFilterDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the file access filter delete params
func (o *FileAccessFilterDeleteParams) WithTimeout(timeout time.Duration) *FileAccessFilterDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the file access filter delete params
func (o *FileAccessFilterDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the file access filter delete params
func (o *FileAccessFilterDeleteParams) WithContext(ctx context.Context) *FileAccessFilterDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the file access filter delete params
func (o *FileAccessFilterDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the file access filter delete params
func (o *FileAccessFilterDeleteParams) WithHTTPClient(client *http.Client) *FileAccessFilterDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the file access filter delete params
func (o *FileAccessFilterDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndexPathParameter adds the index to the file access filter delete params
func (o *FileAccessFilterDeleteParams) WithIndexPathParameter(index int64) *FileAccessFilterDeleteParams {
	o.SetIndexPathParameter(index)
	return o
}

// SetIndexPathParameter adds the index to the file access filter delete params
func (o *FileAccessFilterDeleteParams) SetIndexPathParameter(index int64) {
	o.IndexPathParameter = index
}

// WithSVMUUIDPathParameter adds the svmUUID to the file access filter delete params
func (o *FileAccessFilterDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *FileAccessFilterDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the file access filter delete params
func (o *FileAccessFilterDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *FileAccessFilterDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.IndexPathParameter)); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
