// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewFileAccessFilterGetParams creates a new FileAccessFilterGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFileAccessFilterGetParams() *FileAccessFilterGetParams {
	return &FileAccessFilterGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFileAccessFilterGetParamsWithTimeout creates a new FileAccessFilterGetParams object
// with the ability to set a timeout on a request.
func NewFileAccessFilterGetParamsWithTimeout(timeout time.Duration) *FileAccessFilterGetParams {
	return &FileAccessFilterGetParams{
		timeout: timeout,
	}
}

// NewFileAccessFilterGetParamsWithContext creates a new FileAccessFilterGetParams object
// with the ability to set a context for a request.
func NewFileAccessFilterGetParamsWithContext(ctx context.Context) *FileAccessFilterGetParams {
	return &FileAccessFilterGetParams{
		Context: ctx,
	}
}

// NewFileAccessFilterGetParamsWithHTTPClient creates a new FileAccessFilterGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewFileAccessFilterGetParamsWithHTTPClient(client *http.Client) *FileAccessFilterGetParams {
	return &FileAccessFilterGetParams{
		HTTPClient: client,
	}
}

/* FileAccessFilterGetParams contains all the parameters to send to the API endpoint
   for the file access filter get operation.

   Typically these are written to a http.Request.
*/
type FileAccessFilterGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	// Index.
	IndexPathParameter int64

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the file access filter get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessFilterGetParams) WithDefaults() *FileAccessFilterGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the file access filter get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileAccessFilterGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the file access filter get params
func (o *FileAccessFilterGetParams) WithTimeout(timeout time.Duration) *FileAccessFilterGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the file access filter get params
func (o *FileAccessFilterGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the file access filter get params
func (o *FileAccessFilterGetParams) WithContext(ctx context.Context) *FileAccessFilterGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the file access filter get params
func (o *FileAccessFilterGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the file access filter get params
func (o *FileAccessFilterGetParams) WithHTTPClient(client *http.Client) *FileAccessFilterGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the file access filter get params
func (o *FileAccessFilterGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the file access filter get params
func (o *FileAccessFilterGetParams) WithFieldsQueryParameter(fields []string) *FileAccessFilterGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the file access filter get params
func (o *FileAccessFilterGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIndexPathParameter adds the index to the file access filter get params
func (o *FileAccessFilterGetParams) WithIndexPathParameter(index int64) *FileAccessFilterGetParams {
	o.SetIndexPathParameter(index)
	return o
}

// SetIndexPathParameter adds the index to the file access filter get params
func (o *FileAccessFilterGetParams) SetIndexPathParameter(index int64) {
	o.IndexPathParameter = index
}

// WithSVMUUIDPathParameter adds the svmUUID to the file access filter get params
func (o *FileAccessFilterGetParams) WithSVMUUIDPathParameter(svmUUID string) *FileAccessFilterGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the file access filter get params
func (o *FileAccessFilterGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *FileAccessFilterGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.IndexPathParameter)); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamFileAccessFilterGet binds the parameter fields
func (o *FileAccessFilterGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
