// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewFpolicyPolicyModifyParams creates a new FpolicyPolicyModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFpolicyPolicyModifyParams() *FpolicyPolicyModifyParams {
	return &FpolicyPolicyModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFpolicyPolicyModifyParamsWithTimeout creates a new FpolicyPolicyModifyParams object
// with the ability to set a timeout on a request.
func NewFpolicyPolicyModifyParamsWithTimeout(timeout time.Duration) *FpolicyPolicyModifyParams {
	return &FpolicyPolicyModifyParams{
		timeout: timeout,
	}
}

// NewFpolicyPolicyModifyParamsWithContext creates a new FpolicyPolicyModifyParams object
// with the ability to set a context for a request.
func NewFpolicyPolicyModifyParamsWithContext(ctx context.Context) *FpolicyPolicyModifyParams {
	return &FpolicyPolicyModifyParams{
		Context: ctx,
	}
}

// NewFpolicyPolicyModifyParamsWithHTTPClient creates a new FpolicyPolicyModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewFpolicyPolicyModifyParamsWithHTTPClient(client *http.Client) *FpolicyPolicyModifyParams {
	return &FpolicyPolicyModifyParams{
		HTTPClient: client,
	}
}

/* FpolicyPolicyModifyParams contains all the parameters to send to the API endpoint
   for the fpolicy policy modify operation.

   Typically these are written to a http.Request.
*/
type FpolicyPolicyModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.FpolicyPolicy

	// Name.
	NamePathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the fpolicy policy modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FpolicyPolicyModifyParams) WithDefaults() *FpolicyPolicyModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the fpolicy policy modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FpolicyPolicyModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) WithTimeout(timeout time.Duration) *FpolicyPolicyModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) WithContext(ctx context.Context) *FpolicyPolicyModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) WithHTTPClient(client *http.Client) *FpolicyPolicyModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) WithInfo(info *models.FpolicyPolicy) *FpolicyPolicyModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) SetInfo(info *models.FpolicyPolicy) {
	o.Info = info
}

// WithNamePathParameter adds the name to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) WithNamePathParameter(name string) *FpolicyPolicyModifyParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WithSVMUUIDPathParameter adds the svmUUID to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) WithSVMUUIDPathParameter(svmUUID string) *FpolicyPolicyModifyParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the fpolicy policy modify params
func (o *FpolicyPolicyModifyParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *FpolicyPolicyModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
