// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewLocalCifsGroupMembersDeleteParams creates a new LocalCifsGroupMembersDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLocalCifsGroupMembersDeleteParams() *LocalCifsGroupMembersDeleteParams {
	return &LocalCifsGroupMembersDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLocalCifsGroupMembersDeleteParamsWithTimeout creates a new LocalCifsGroupMembersDeleteParams object
// with the ability to set a timeout on a request.
func NewLocalCifsGroupMembersDeleteParamsWithTimeout(timeout time.Duration) *LocalCifsGroupMembersDeleteParams {
	return &LocalCifsGroupMembersDeleteParams{
		timeout: timeout,
	}
}

// NewLocalCifsGroupMembersDeleteParamsWithContext creates a new LocalCifsGroupMembersDeleteParams object
// with the ability to set a context for a request.
func NewLocalCifsGroupMembersDeleteParamsWithContext(ctx context.Context) *LocalCifsGroupMembersDeleteParams {
	return &LocalCifsGroupMembersDeleteParams{
		Context: ctx,
	}
}

// NewLocalCifsGroupMembersDeleteParamsWithHTTPClient creates a new LocalCifsGroupMembersDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewLocalCifsGroupMembersDeleteParamsWithHTTPClient(client *http.Client) *LocalCifsGroupMembersDeleteParams {
	return &LocalCifsGroupMembersDeleteParams{
		HTTPClient: client,
	}
}

/* LocalCifsGroupMembersDeleteParams contains all the parameters to send to the API endpoint
   for the local cifs group members delete operation.

   Typically these are written to a http.Request.
*/
type LocalCifsGroupMembersDeleteParams struct {

	/* LocalCifsGroupSid.

	   Local group SID
	*/
	LocalCifsGroupSIDPathParameter string

	/* Name.

	   Member name
	*/
	NamePathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the local cifs group members delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsGroupMembersDeleteParams) WithDefaults() *LocalCifsGroupMembersDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the local cifs group members delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsGroupMembersDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) WithTimeout(timeout time.Duration) *LocalCifsGroupMembersDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) WithContext(ctx context.Context) *LocalCifsGroupMembersDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) WithHTTPClient(client *http.Client) *LocalCifsGroupMembersDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLocalCifsGroupSIDPathParameter adds the localCifsGroupSid to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) WithLocalCifsGroupSIDPathParameter(localCifsGroupSid string) *LocalCifsGroupMembersDeleteParams {
	o.SetLocalCifsGroupSIDPathParameter(localCifsGroupSid)
	return o
}

// SetLocalCifsGroupSIDPathParameter adds the localCifsGroupSid to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) SetLocalCifsGroupSIDPathParameter(localCifsGroupSid string) {
	o.LocalCifsGroupSIDPathParameter = localCifsGroupSid
}

// WithNamePathParameter adds the name to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) WithNamePathParameter(name string) *LocalCifsGroupMembersDeleteParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WithSVMUUIDPathParameter adds the svmUUID to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *LocalCifsGroupMembersDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the local cifs group members delete params
func (o *LocalCifsGroupMembersDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *LocalCifsGroupMembersDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param local_cifs_group.sid
	if err := r.SetPathParam("local_cifs_group.sid", o.LocalCifsGroupSIDPathParameter); err != nil {
		return err
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
