// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewLocalCifsUserDeleteParams creates a new LocalCifsUserDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLocalCifsUserDeleteParams() *LocalCifsUserDeleteParams {
	return &LocalCifsUserDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLocalCifsUserDeleteParamsWithTimeout creates a new LocalCifsUserDeleteParams object
// with the ability to set a timeout on a request.
func NewLocalCifsUserDeleteParamsWithTimeout(timeout time.Duration) *LocalCifsUserDeleteParams {
	return &LocalCifsUserDeleteParams{
		timeout: timeout,
	}
}

// NewLocalCifsUserDeleteParamsWithContext creates a new LocalCifsUserDeleteParams object
// with the ability to set a context for a request.
func NewLocalCifsUserDeleteParamsWithContext(ctx context.Context) *LocalCifsUserDeleteParams {
	return &LocalCifsUserDeleteParams{
		Context: ctx,
	}
}

// NewLocalCifsUserDeleteParamsWithHTTPClient creates a new LocalCifsUserDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewLocalCifsUserDeleteParamsWithHTTPClient(client *http.Client) *LocalCifsUserDeleteParams {
	return &LocalCifsUserDeleteParams{
		HTTPClient: client,
	}
}

/* LocalCifsUserDeleteParams contains all the parameters to send to the API endpoint
   for the local cifs user delete operation.

   Typically these are written to a http.Request.
*/
type LocalCifsUserDeleteParams struct {

	/* Sid.

	   Local user SID
	*/
	SIDPathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the local cifs user delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsUserDeleteParams) WithDefaults() *LocalCifsUserDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the local cifs user delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsUserDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) WithTimeout(timeout time.Duration) *LocalCifsUserDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) WithContext(ctx context.Context) *LocalCifsUserDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) WithHTTPClient(client *http.Client) *LocalCifsUserDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithSIDPathParameter adds the sid to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) WithSIDPathParameter(sid string) *LocalCifsUserDeleteParams {
	o.SetSIDPathParameter(sid)
	return o
}

// SetSIDPathParameter adds the sid to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) SetSIDPathParameter(sid string) {
	o.SIDPathParameter = sid
}

// WithSVMUUIDPathParameter adds the svmUUID to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *LocalCifsUserDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the local cifs user delete params
func (o *LocalCifsUserDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *LocalCifsUserDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param sid
	if err := r.SetPathParam("sid", o.SIDPathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
