// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3AuditDeleteReader is a Reader for the S3AuditDelete structure.
type S3AuditDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3AuditDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewS3AuditDeleteAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3AuditDeleteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3AuditDeleteAccepted creates a S3AuditDeleteAccepted with default headers values
func NewS3AuditDeleteAccepted() *S3AuditDeleteAccepted {
	return &S3AuditDeleteAccepted{}
}

/* S3AuditDeleteAccepted describes a response with status code 202, with default header values.

Accepted
*/
type S3AuditDeleteAccepted struct {
}

func (o *S3AuditDeleteAccepted) Error() string {
	return fmt.Sprintf("[DELETE /protocols/s3audits/{svm.uuid}][%d] s3AuditDeleteAccepted ", 202)
}

func (o *S3AuditDeleteAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewS3AuditDeleteDefault creates a S3AuditDeleteDefault with default headers values
func NewS3AuditDeleteDefault(code int) *S3AuditDeleteDefault {
	return &S3AuditDeleteDefault{
		_statusCode: code,
	}
}

/* S3AuditDeleteDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 140902420 | Failed to delete audit configuration for the SVM. |
| 140902421 | Failed to delete audit configuration for the SVM because audit is enabled for the SVM. |
| 140902422 | Failed to delete audit configuration for the SVM because final conolidation is in progress. Wait a few mintues, and try the operation again. |

*/
type S3AuditDeleteDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 audit delete default response
func (o *S3AuditDeleteDefault) Code() int {
	return o._statusCode
}

func (o *S3AuditDeleteDefault) Error() string {
	return fmt.Sprintf("[DELETE /protocols/s3audits/{svm.uuid}][%d] s3_audit_delete default  %+v", o._statusCode, o.Payload)
}
func (o *S3AuditDeleteDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3AuditDeleteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
