// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewS3AuditEventSelectorCollectionGetParams creates a new S3AuditEventSelectorCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewS3AuditEventSelectorCollectionGetParams() *S3AuditEventSelectorCollectionGetParams {
	return &S3AuditEventSelectorCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewS3AuditEventSelectorCollectionGetParamsWithTimeout creates a new S3AuditEventSelectorCollectionGetParams object
// with the ability to set a timeout on a request.
func NewS3AuditEventSelectorCollectionGetParamsWithTimeout(timeout time.Duration) *S3AuditEventSelectorCollectionGetParams {
	return &S3AuditEventSelectorCollectionGetParams{
		timeout: timeout,
	}
}

// NewS3AuditEventSelectorCollectionGetParamsWithContext creates a new S3AuditEventSelectorCollectionGetParams object
// with the ability to set a context for a request.
func NewS3AuditEventSelectorCollectionGetParamsWithContext(ctx context.Context) *S3AuditEventSelectorCollectionGetParams {
	return &S3AuditEventSelectorCollectionGetParams{
		Context: ctx,
	}
}

// NewS3AuditEventSelectorCollectionGetParamsWithHTTPClient creates a new S3AuditEventSelectorCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewS3AuditEventSelectorCollectionGetParamsWithHTTPClient(client *http.Client) *S3AuditEventSelectorCollectionGetParams {
	return &S3AuditEventSelectorCollectionGetParams{
		HTTPClient: client,
	}
}

/* S3AuditEventSelectorCollectionGetParams contains all the parameters to send to the API endpoint
   for the s3 audit event selector collection get operation.

   Typically these are written to a http.Request.
*/
type S3AuditEventSelectorCollectionGetParams struct {

	/* Access.

	   Filter by access
	*/
	AccessQueryParameter *string

	/* Bucket.

	   Filter by bucket
	*/
	BucketQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* Permission.

	   Filter by permission
	*/
	PermissionQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the s3 audit event selector collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3AuditEventSelectorCollectionGetParams) WithDefaults() *S3AuditEventSelectorCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the s3 audit event selector collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3AuditEventSelectorCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := S3AuditEventSelectorCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithTimeout(timeout time.Duration) *S3AuditEventSelectorCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithContext(ctx context.Context) *S3AuditEventSelectorCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithHTTPClient(client *http.Client) *S3AuditEventSelectorCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccessQueryParameter adds the access to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithAccessQueryParameter(access *string) *S3AuditEventSelectorCollectionGetParams {
	o.SetAccessQueryParameter(access)
	return o
}

// SetAccessQueryParameter adds the access to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetAccessQueryParameter(access *string) {
	o.AccessQueryParameter = access
}

// WithBucketQueryParameter adds the bucket to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithBucketQueryParameter(bucket *string) *S3AuditEventSelectorCollectionGetParams {
	o.SetBucketQueryParameter(bucket)
	return o
}

// SetBucketQueryParameter adds the bucket to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetBucketQueryParameter(bucket *string) {
	o.BucketQueryParameter = bucket
}

// WithFieldsQueryParameter adds the fields to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithFieldsQueryParameter(fields []string) *S3AuditEventSelectorCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *S3AuditEventSelectorCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *S3AuditEventSelectorCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPermissionQueryParameter adds the permission to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithPermissionQueryParameter(permission *string) *S3AuditEventSelectorCollectionGetParams {
	o.SetPermissionQueryParameter(permission)
	return o
}

// SetPermissionQueryParameter adds the permission to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetPermissionQueryParameter(permission *string) {
	o.PermissionQueryParameter = permission
}

// WithReturnRecordsQueryParameter adds the returnRecords to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *S3AuditEventSelectorCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *S3AuditEventSelectorCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMNameQueryParameter adds the svmName to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *S3AuditEventSelectorCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *S3AuditEventSelectorCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the s3 audit event selector collection get params
func (o *S3AuditEventSelectorCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *S3AuditEventSelectorCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccessQueryParameter != nil {

		// query param access
		var qrAccess string

		if o.AccessQueryParameter != nil {
			qrAccess = *o.AccessQueryParameter
		}
		qAccess := qrAccess
		if qAccess != "" {

			if err := r.SetQueryParam("access", qAccess); err != nil {
				return err
			}
		}
	}

	if o.BucketQueryParameter != nil {

		// query param bucket
		var qrBucket string

		if o.BucketQueryParameter != nil {
			qrBucket = *o.BucketQueryParameter
		}
		qBucket := qrBucket
		if qBucket != "" {

			if err := r.SetQueryParam("bucket", qBucket); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PermissionQueryParameter != nil {

		// query param permission
		var qrPermission string

		if o.PermissionQueryParameter != nil {
			qrPermission = *o.PermissionQueryParameter
		}
		qPermission := qrPermission
		if qPermission != "" {

			if err := r.SetQueryParam("permission", qPermission); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamS3AuditEventSelectorCollectionGet binds the parameter fields
func (o *S3AuditEventSelectorCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamS3AuditEventSelectorCollectionGet binds the parameter order_by
func (o *S3AuditEventSelectorCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
