// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewS3AuditEventSelectorGetParams creates a new S3AuditEventSelectorGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewS3AuditEventSelectorGetParams() *S3AuditEventSelectorGetParams {
	return &S3AuditEventSelectorGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewS3AuditEventSelectorGetParamsWithTimeout creates a new S3AuditEventSelectorGetParams object
// with the ability to set a timeout on a request.
func NewS3AuditEventSelectorGetParamsWithTimeout(timeout time.Duration) *S3AuditEventSelectorGetParams {
	return &S3AuditEventSelectorGetParams{
		timeout: timeout,
	}
}

// NewS3AuditEventSelectorGetParamsWithContext creates a new S3AuditEventSelectorGetParams object
// with the ability to set a context for a request.
func NewS3AuditEventSelectorGetParamsWithContext(ctx context.Context) *S3AuditEventSelectorGetParams {
	return &S3AuditEventSelectorGetParams{
		Context: ctx,
	}
}

// NewS3AuditEventSelectorGetParamsWithHTTPClient creates a new S3AuditEventSelectorGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewS3AuditEventSelectorGetParamsWithHTTPClient(client *http.Client) *S3AuditEventSelectorGetParams {
	return &S3AuditEventSelectorGetParams{
		HTTPClient: client,
	}
}

/* S3AuditEventSelectorGetParams contains all the parameters to send to the API endpoint
   for the s3 audit event selector get operation.

   Typically these are written to a http.Request.
*/
type S3AuditEventSelectorGetParams struct {

	/* Bucket.

	   Bucket name
	*/
	BucketPathParameter string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the s3 audit event selector get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3AuditEventSelectorGetParams) WithDefaults() *S3AuditEventSelectorGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the s3 audit event selector get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3AuditEventSelectorGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) WithTimeout(timeout time.Duration) *S3AuditEventSelectorGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) WithContext(ctx context.Context) *S3AuditEventSelectorGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) WithHTTPClient(client *http.Client) *S3AuditEventSelectorGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBucketPathParameter adds the bucket to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) WithBucketPathParameter(bucket string) *S3AuditEventSelectorGetParams {
	o.SetBucketPathParameter(bucket)
	return o
}

// SetBucketPathParameter adds the bucket to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) SetBucketPathParameter(bucket string) {
	o.BucketPathParameter = bucket
}

// WithFieldsQueryParameter adds the fields to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) WithFieldsQueryParameter(fields []string) *S3AuditEventSelectorGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithSVMUUIDPathParameter adds the svmUUID to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) WithSVMUUIDPathParameter(svmUUID string) *S3AuditEventSelectorGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the s3 audit event selector get params
func (o *S3AuditEventSelectorGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *S3AuditEventSelectorGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param bucket
	if err := r.SetPathParam("bucket", o.BucketPathParameter); err != nil {
		return err
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamS3AuditEventSelectorGet binds the parameter fields
func (o *S3AuditEventSelectorGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
