// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewS3AuditEventSelectorModifyParams creates a new S3AuditEventSelectorModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewS3AuditEventSelectorModifyParams() *S3AuditEventSelectorModifyParams {
	return &S3AuditEventSelectorModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewS3AuditEventSelectorModifyParamsWithTimeout creates a new S3AuditEventSelectorModifyParams object
// with the ability to set a timeout on a request.
func NewS3AuditEventSelectorModifyParamsWithTimeout(timeout time.Duration) *S3AuditEventSelectorModifyParams {
	return &S3AuditEventSelectorModifyParams{
		timeout: timeout,
	}
}

// NewS3AuditEventSelectorModifyParamsWithContext creates a new S3AuditEventSelectorModifyParams object
// with the ability to set a context for a request.
func NewS3AuditEventSelectorModifyParamsWithContext(ctx context.Context) *S3AuditEventSelectorModifyParams {
	return &S3AuditEventSelectorModifyParams{
		Context: ctx,
	}
}

// NewS3AuditEventSelectorModifyParamsWithHTTPClient creates a new S3AuditEventSelectorModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewS3AuditEventSelectorModifyParamsWithHTTPClient(client *http.Client) *S3AuditEventSelectorModifyParams {
	return &S3AuditEventSelectorModifyParams{
		HTTPClient: client,
	}
}

/* S3AuditEventSelectorModifyParams contains all the parameters to send to the API endpoint
   for the s3 audit event selector modify operation.

   Typically these are written to a http.Request.
*/
type S3AuditEventSelectorModifyParams struct {

	/* Bucket.

	   Bucket name
	*/
	BucketPathParameter string

	/* Info.

	   Info specification
	*/
	Info *models.S3AuditEventSelector

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the s3 audit event selector modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3AuditEventSelectorModifyParams) WithDefaults() *S3AuditEventSelectorModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the s3 audit event selector modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3AuditEventSelectorModifyParams) SetDefaults() {
	var (
		returnTimeoutQueryParameterDefault = int64(0)
	)

	val := S3AuditEventSelectorModifyParams{
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) WithTimeout(timeout time.Duration) *S3AuditEventSelectorModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) WithContext(ctx context.Context) *S3AuditEventSelectorModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) WithHTTPClient(client *http.Client) *S3AuditEventSelectorModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBucketPathParameter adds the bucket to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) WithBucketPathParameter(bucket string) *S3AuditEventSelectorModifyParams {
	o.SetBucketPathParameter(bucket)
	return o
}

// SetBucketPathParameter adds the bucket to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) SetBucketPathParameter(bucket string) {
	o.BucketPathParameter = bucket
}

// WithInfo adds the info to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) WithInfo(info *models.S3AuditEventSelector) *S3AuditEventSelectorModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) SetInfo(info *models.S3AuditEventSelector) {
	o.Info = info
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *S3AuditEventSelectorModifyParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMUUIDPathParameter adds the svmUUID to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) WithSVMUUIDPathParameter(svmUUID string) *S3AuditEventSelectorModifyParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the s3 audit event selector modify params
func (o *S3AuditEventSelectorModifyParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *S3AuditEventSelectorModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param bucket
	if err := r.SetPathParam("bucket", o.BucketPathParameter); err != nil {
		return err
	}
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
