// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3AuditModifyReader is a Reader for the S3AuditModify structure.
type S3AuditModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3AuditModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewS3AuditModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3AuditModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3AuditModifyAccepted creates a S3AuditModifyAccepted with default headers values
func NewS3AuditModifyAccepted() *S3AuditModifyAccepted {
	return &S3AuditModifyAccepted{}
}

/* S3AuditModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type S3AuditModifyAccepted struct {
}

func (o *S3AuditModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /protocols/s3audits/{svm.uuid}][%d] s3AuditModifyAccepted ", 202)
}

func (o *S3AuditModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewS3AuditModifyDefault creates a S3AuditModifyDefault with default headers values
func NewS3AuditModifyDefault(code int) *S3AuditModifyDefault {
	return &S3AuditModifyDefault{
		_statusCode: code,
	}
}

/* S3AuditModifyDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 140902401 | Failed to create an audit configuration for the SVM. |
| 140902402 | Audit configuration is already present. |
| 140902402 | Audit configuration is already enabled. |
| 140902403 | Failed to create staging volume. |
| 140902415 | Failed to modify an audit configuration because no audit configuration exists for SVM. |
| 140902416 | Failed to modify audit configuration for SVM. |
| 140902422 | Final consolidation is in progress, audit delete failed. |
| 140902423 | Failed to delete the audit configuration for the SVM. |
| 140902425 | Audit configuration is not available for disabling. |
| 140902430 | Audit configuration is not available for enabling. |
| 140902431 | Audit enable failed, audit configuration already enabled for the SVM. |
| 140902432 | Final consolidation is in progress, audit enable failed. |
| 140902445 | Audit disable failed, audit configuration does not exist for the SVM. |
| 140902446 | Audit configuration is already disabled. |
| 140902446 | Audit disable failed, audit configuration does not exist for the SVM. |
| 140902456 | The specified log_path does not exist. |
| 140902457 | The log_path must be a directory. |
| 140902458 | The log_path must be a canonical path in the SVM's namespace. |
| 140902459 | The log_path cannot be empty. |
| 140902460 | Rotate size must be greater than or equal to 1024 KB. |
| 140902461 | The destination path must not contain a symbolic link. |
| 140902470 | The log_path exceeds a maximum supported length of characters. |
| 140902471 | The log_path contains an unsupported read-only (DP/LS) volume. |
| 140902472 | The log_path is not a valid destination for the SVM. |
| 140902474 | The log_path contains an unsupported Snaplock volume. |
| 140902478 | The log_path validation failed. |
| 140902478 | The log_path cannot be accessed for validation. |
| 140902490 | Audit configuration is absent for rotate. |
| 140902491 | Failed to rotate audit log. |
| 140902492 | Cannot rotate audit log, auditing is not enabled for this SVM. |
ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 9699340    | SVM UUID lookup failed                                                        |
| 9699407    | Additional fields are provided                                                |

*/
type S3AuditModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 audit modify default response
func (o *S3AuditModifyDefault) Code() int {
	return o._statusCode
}

func (o *S3AuditModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /protocols/s3audits/{svm.uuid}][%d] s3_audit_modify default  %+v", o._statusCode, o.Payload)
}
func (o *S3AuditModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3AuditModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
