// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVscanOnDemandPolicyCollectionGetParams creates a new VscanOnDemandPolicyCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVscanOnDemandPolicyCollectionGetParams() *VscanOnDemandPolicyCollectionGetParams {
	return &VscanOnDemandPolicyCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVscanOnDemandPolicyCollectionGetParamsWithTimeout creates a new VscanOnDemandPolicyCollectionGetParams object
// with the ability to set a timeout on a request.
func NewVscanOnDemandPolicyCollectionGetParamsWithTimeout(timeout time.Duration) *VscanOnDemandPolicyCollectionGetParams {
	return &VscanOnDemandPolicyCollectionGetParams{
		timeout: timeout,
	}
}

// NewVscanOnDemandPolicyCollectionGetParamsWithContext creates a new VscanOnDemandPolicyCollectionGetParams object
// with the ability to set a context for a request.
func NewVscanOnDemandPolicyCollectionGetParamsWithContext(ctx context.Context) *VscanOnDemandPolicyCollectionGetParams {
	return &VscanOnDemandPolicyCollectionGetParams{
		Context: ctx,
	}
}

// NewVscanOnDemandPolicyCollectionGetParamsWithHTTPClient creates a new VscanOnDemandPolicyCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewVscanOnDemandPolicyCollectionGetParamsWithHTTPClient(client *http.Client) *VscanOnDemandPolicyCollectionGetParams {
	return &VscanOnDemandPolicyCollectionGetParams{
		HTTPClient: client,
	}
}

/* VscanOnDemandPolicyCollectionGetParams contains all the parameters to send to the API endpoint
   for the vscan on demand policy collection get operation.

   Typically these are written to a http.Request.
*/
type VscanOnDemandPolicyCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* LogPath.

	   Filter by log_path
	*/
	LogPathQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* ScanPaths.

	   Filter by scan_paths
	*/
	ScanPathsQueryParameter *string

	/* ScheduleName.

	   Filter by schedule.name
	*/
	ScheduleNameQueryParameter *string

	/* ScheduleUUID.

	   Filter by schedule.uuid
	*/
	ScheduleUUIDQueryParameter *string

	/* ScopeExcludeExtensions.

	   Filter by scope.exclude_extensions
	*/
	ScopeExcludeExtensionsQueryParameter *string

	/* ScopeExcludePaths.

	   Filter by scope.exclude_paths
	*/
	ScopeExcludePathsQueryParameter *string

	/* ScopeIncludeExtensions.

	   Filter by scope.include_extensions
	*/
	ScopeIncludeExtensionsQueryParameter *string

	/* ScopeMaxFileSize.

	   Filter by scope.max_file_size
	*/
	ScopeMaxFileSizeQueryParameter *int64

	/* ScopeScanWithoutExtension.

	   Filter by scope.scan_without_extension
	*/
	ScopeScanWithoutExtensionQueryParameter *bool

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the vscan on demand policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanOnDemandPolicyCollectionGetParams) WithDefaults() *VscanOnDemandPolicyCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the vscan on demand policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanOnDemandPolicyCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := VscanOnDemandPolicyCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithTimeout(timeout time.Duration) *VscanOnDemandPolicyCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithContext(ctx context.Context) *VscanOnDemandPolicyCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithHTTPClient(client *http.Client) *VscanOnDemandPolicyCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithFieldsQueryParameter(fields []string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithLogPathQueryParameter adds the logPath to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithLogPathQueryParameter(logPath *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetLogPathQueryParameter(logPath)
	return o
}

// SetLogPathQueryParameter adds the logPath to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetLogPathQueryParameter(logPath *string) {
	o.LogPathQueryParameter = logPath
}

// WithMaxRecordsQueryParameter adds the maxRecords to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *VscanOnDemandPolicyCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithNameQueryParameter(name *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *VscanOnDemandPolicyCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *VscanOnDemandPolicyCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithScanPathsQueryParameter adds the scanPaths to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScanPathsQueryParameter(scanPaths *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScanPathsQueryParameter(scanPaths)
	return o
}

// SetScanPathsQueryParameter adds the scanPaths to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScanPathsQueryParameter(scanPaths *string) {
	o.ScanPathsQueryParameter = scanPaths
}

// WithScheduleNameQueryParameter adds the scheduleName to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScheduleNameQueryParameter(scheduleName *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScheduleNameQueryParameter(scheduleName)
	return o
}

// SetScheduleNameQueryParameter adds the scheduleName to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScheduleNameQueryParameter(scheduleName *string) {
	o.ScheduleNameQueryParameter = scheduleName
}

// WithScheduleUUIDQueryParameter adds the scheduleUUID to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScheduleUUIDQueryParameter(scheduleUUID *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScheduleUUIDQueryParameter(scheduleUUID)
	return o
}

// SetScheduleUUIDQueryParameter adds the scheduleUuid to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScheduleUUIDQueryParameter(scheduleUUID *string) {
	o.ScheduleUUIDQueryParameter = scheduleUUID
}

// WithScopeExcludeExtensionsQueryParameter adds the scopeExcludeExtensions to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeExcludeExtensionsQueryParameter(scopeExcludeExtensions *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeExcludeExtensionsQueryParameter(scopeExcludeExtensions)
	return o
}

// SetScopeExcludeExtensionsQueryParameter adds the scopeExcludeExtensions to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeExcludeExtensionsQueryParameter(scopeExcludeExtensions *string) {
	o.ScopeExcludeExtensionsQueryParameter = scopeExcludeExtensions
}

// WithScopeExcludePathsQueryParameter adds the scopeExcludePaths to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeExcludePathsQueryParameter(scopeExcludePaths *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeExcludePathsQueryParameter(scopeExcludePaths)
	return o
}

// SetScopeExcludePathsQueryParameter adds the scopeExcludePaths to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeExcludePathsQueryParameter(scopeExcludePaths *string) {
	o.ScopeExcludePathsQueryParameter = scopeExcludePaths
}

// WithScopeIncludeExtensionsQueryParameter adds the scopeIncludeExtensions to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeIncludeExtensionsQueryParameter(scopeIncludeExtensions *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeIncludeExtensionsQueryParameter(scopeIncludeExtensions)
	return o
}

// SetScopeIncludeExtensionsQueryParameter adds the scopeIncludeExtensions to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeIncludeExtensionsQueryParameter(scopeIncludeExtensions *string) {
	o.ScopeIncludeExtensionsQueryParameter = scopeIncludeExtensions
}

// WithScopeMaxFileSizeQueryParameter adds the scopeMaxFileSize to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeMaxFileSizeQueryParameter(scopeMaxFileSize *int64) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeMaxFileSizeQueryParameter(scopeMaxFileSize)
	return o
}

// SetScopeMaxFileSizeQueryParameter adds the scopeMaxFileSize to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeMaxFileSizeQueryParameter(scopeMaxFileSize *int64) {
	o.ScopeMaxFileSizeQueryParameter = scopeMaxFileSize
}

// WithScopeScanWithoutExtensionQueryParameter adds the scopeScanWithoutExtension to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeScanWithoutExtensionQueryParameter(scopeScanWithoutExtension *bool) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeScanWithoutExtensionQueryParameter(scopeScanWithoutExtension)
	return o
}

// SetScopeScanWithoutExtensionQueryParameter adds the scopeScanWithoutExtension to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeScanWithoutExtensionQueryParameter(scopeScanWithoutExtension *bool) {
	o.ScopeScanWithoutExtensionQueryParameter = scopeScanWithoutExtension
}

// WithSVMNameQueryParameter adds the svmName to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDPathParameter adds the svmUUID to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithSVMUUIDPathParameter(svmUUID string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *VscanOnDemandPolicyCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.LogPathQueryParameter != nil {

		// query param log_path
		var qrLogPath string

		if o.LogPathQueryParameter != nil {
			qrLogPath = *o.LogPathQueryParameter
		}
		qLogPath := qrLogPath
		if qLogPath != "" {

			if err := r.SetQueryParam("log_path", qLogPath); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ScanPathsQueryParameter != nil {

		// query param scan_paths
		var qrScanPaths string

		if o.ScanPathsQueryParameter != nil {
			qrScanPaths = *o.ScanPathsQueryParameter
		}
		qScanPaths := qrScanPaths
		if qScanPaths != "" {

			if err := r.SetQueryParam("scan_paths", qScanPaths); err != nil {
				return err
			}
		}
	}

	if o.ScheduleNameQueryParameter != nil {

		// query param schedule.name
		var qrScheduleName string

		if o.ScheduleNameQueryParameter != nil {
			qrScheduleName = *o.ScheduleNameQueryParameter
		}
		qScheduleName := qrScheduleName
		if qScheduleName != "" {

			if err := r.SetQueryParam("schedule.name", qScheduleName); err != nil {
				return err
			}
		}
	}

	if o.ScheduleUUIDQueryParameter != nil {

		// query param schedule.uuid
		var qrScheduleUUID string

		if o.ScheduleUUIDQueryParameter != nil {
			qrScheduleUUID = *o.ScheduleUUIDQueryParameter
		}
		qScheduleUUID := qrScheduleUUID
		if qScheduleUUID != "" {

			if err := r.SetQueryParam("schedule.uuid", qScheduleUUID); err != nil {
				return err
			}
		}
	}

	if o.ScopeExcludeExtensionsQueryParameter != nil {

		// query param scope.exclude_extensions
		var qrScopeExcludeExtensions string

		if o.ScopeExcludeExtensionsQueryParameter != nil {
			qrScopeExcludeExtensions = *o.ScopeExcludeExtensionsQueryParameter
		}
		qScopeExcludeExtensions := qrScopeExcludeExtensions
		if qScopeExcludeExtensions != "" {

			if err := r.SetQueryParam("scope.exclude_extensions", qScopeExcludeExtensions); err != nil {
				return err
			}
		}
	}

	if o.ScopeExcludePathsQueryParameter != nil {

		// query param scope.exclude_paths
		var qrScopeExcludePaths string

		if o.ScopeExcludePathsQueryParameter != nil {
			qrScopeExcludePaths = *o.ScopeExcludePathsQueryParameter
		}
		qScopeExcludePaths := qrScopeExcludePaths
		if qScopeExcludePaths != "" {

			if err := r.SetQueryParam("scope.exclude_paths", qScopeExcludePaths); err != nil {
				return err
			}
		}
	}

	if o.ScopeIncludeExtensionsQueryParameter != nil {

		// query param scope.include_extensions
		var qrScopeIncludeExtensions string

		if o.ScopeIncludeExtensionsQueryParameter != nil {
			qrScopeIncludeExtensions = *o.ScopeIncludeExtensionsQueryParameter
		}
		qScopeIncludeExtensions := qrScopeIncludeExtensions
		if qScopeIncludeExtensions != "" {

			if err := r.SetQueryParam("scope.include_extensions", qScopeIncludeExtensions); err != nil {
				return err
			}
		}
	}

	if o.ScopeMaxFileSizeQueryParameter != nil {

		// query param scope.max_file_size
		var qrScopeMaxFileSize int64

		if o.ScopeMaxFileSizeQueryParameter != nil {
			qrScopeMaxFileSize = *o.ScopeMaxFileSizeQueryParameter
		}
		qScopeMaxFileSize := swag.FormatInt64(qrScopeMaxFileSize)
		if qScopeMaxFileSize != "" {

			if err := r.SetQueryParam("scope.max_file_size", qScopeMaxFileSize); err != nil {
				return err
			}
		}
	}

	if o.ScopeScanWithoutExtensionQueryParameter != nil {

		// query param scope.scan_without_extension
		var qrScopeScanWithoutExtension bool

		if o.ScopeScanWithoutExtensionQueryParameter != nil {
			qrScopeScanWithoutExtension = *o.ScopeScanWithoutExtensionQueryParameter
		}
		qScopeScanWithoutExtension := swag.FormatBool(qrScopeScanWithoutExtension)
		if qScopeScanWithoutExtension != "" {

			if err := r.SetQueryParam("scope.scan_without_extension", qScopeScanWithoutExtension); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamVscanOnDemandPolicyCollectionGet binds the parameter fields
func (o *VscanOnDemandPolicyCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamVscanOnDemandPolicyCollectionGet binds the parameter order_by
func (o *VscanOnDemandPolicyCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
