// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVscanScannerCollectionGetParams creates a new VscanScannerCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVscanScannerCollectionGetParams() *VscanScannerCollectionGetParams {
	return &VscanScannerCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVscanScannerCollectionGetParamsWithTimeout creates a new VscanScannerCollectionGetParams object
// with the ability to set a timeout on a request.
func NewVscanScannerCollectionGetParamsWithTimeout(timeout time.Duration) *VscanScannerCollectionGetParams {
	return &VscanScannerCollectionGetParams{
		timeout: timeout,
	}
}

// NewVscanScannerCollectionGetParamsWithContext creates a new VscanScannerCollectionGetParams object
// with the ability to set a context for a request.
func NewVscanScannerCollectionGetParamsWithContext(ctx context.Context) *VscanScannerCollectionGetParams {
	return &VscanScannerCollectionGetParams{
		Context: ctx,
	}
}

// NewVscanScannerCollectionGetParamsWithHTTPClient creates a new VscanScannerCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewVscanScannerCollectionGetParamsWithHTTPClient(client *http.Client) *VscanScannerCollectionGetParams {
	return &VscanScannerCollectionGetParams{
		HTTPClient: client,
	}
}

/* VscanScannerCollectionGetParams contains all the parameters to send to the API endpoint
   for the vscan scanner collection get operation.

   Typically these are written to a http.Request.
*/
type VscanScannerCollectionGetParams struct {

	/* ClusterName.

	   Filter by cluster.name
	*/
	ClusterNameQueryParameter *string

	/* ClusterUUID.

	   Filter by cluster.uuid
	*/
	ClusterUUIDQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* PrivilegedUsers.

	   Filter by privileged_users
	*/
	PrivilegedUsersQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Role.

	   Filter by role
	*/
	RoleQueryParameter *string

	/* Servers.

	   Filter by servers
	*/
	ServersQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the vscan scanner collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanScannerCollectionGetParams) WithDefaults() *VscanScannerCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the vscan scanner collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanScannerCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := VscanScannerCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithTimeout(timeout time.Duration) *VscanScannerCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithContext(ctx context.Context) *VscanScannerCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithHTTPClient(client *http.Client) *VscanScannerCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClusterNameQueryParameter adds the clusterName to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithClusterNameQueryParameter(clusterName *string) *VscanScannerCollectionGetParams {
	o.SetClusterNameQueryParameter(clusterName)
	return o
}

// SetClusterNameQueryParameter adds the clusterName to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetClusterNameQueryParameter(clusterName *string) {
	o.ClusterNameQueryParameter = clusterName
}

// WithClusterUUIDQueryParameter adds the clusterUUID to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithClusterUUIDQueryParameter(clusterUUID *string) *VscanScannerCollectionGetParams {
	o.SetClusterUUIDQueryParameter(clusterUUID)
	return o
}

// SetClusterUUIDQueryParameter adds the clusterUuid to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetClusterUUIDQueryParameter(clusterUUID *string) {
	o.ClusterUUIDQueryParameter = clusterUUID
}

// WithFieldsQueryParameter adds the fields to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithFieldsQueryParameter(fields []string) *VscanScannerCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *VscanScannerCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithNameQueryParameter(name *string) *VscanScannerCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *VscanScannerCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPrivilegedUsersQueryParameter adds the privilegedUsers to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithPrivilegedUsersQueryParameter(privilegedUsers *string) *VscanScannerCollectionGetParams {
	o.SetPrivilegedUsersQueryParameter(privilegedUsers)
	return o
}

// SetPrivilegedUsersQueryParameter adds the privilegedUsers to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetPrivilegedUsersQueryParameter(privilegedUsers *string) {
	o.PrivilegedUsersQueryParameter = privilegedUsers
}

// WithReturnRecordsQueryParameter adds the returnRecords to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *VscanScannerCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *VscanScannerCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithRoleQueryParameter adds the role to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithRoleQueryParameter(role *string) *VscanScannerCollectionGetParams {
	o.SetRoleQueryParameter(role)
	return o
}

// SetRoleQueryParameter adds the role to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetRoleQueryParameter(role *string) {
	o.RoleQueryParameter = role
}

// WithServersQueryParameter adds the servers to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithServersQueryParameter(servers *string) *VscanScannerCollectionGetParams {
	o.SetServersQueryParameter(servers)
	return o
}

// SetServersQueryParameter adds the servers to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetServersQueryParameter(servers *string) {
	o.ServersQueryParameter = servers
}

// WithSVMNameQueryParameter adds the svmName to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *VscanScannerCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDPathParameter adds the svmUUID to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) WithSVMUUIDPathParameter(svmUUID string) *VscanScannerCollectionGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the vscan scanner collection get params
func (o *VscanScannerCollectionGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *VscanScannerCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ClusterNameQueryParameter != nil {

		// query param cluster.name
		var qrClusterName string

		if o.ClusterNameQueryParameter != nil {
			qrClusterName = *o.ClusterNameQueryParameter
		}
		qClusterName := qrClusterName
		if qClusterName != "" {

			if err := r.SetQueryParam("cluster.name", qClusterName); err != nil {
				return err
			}
		}
	}

	if o.ClusterUUIDQueryParameter != nil {

		// query param cluster.uuid
		var qrClusterUUID string

		if o.ClusterUUIDQueryParameter != nil {
			qrClusterUUID = *o.ClusterUUIDQueryParameter
		}
		qClusterUUID := qrClusterUUID
		if qClusterUUID != "" {

			if err := r.SetQueryParam("cluster.uuid", qClusterUUID); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PrivilegedUsersQueryParameter != nil {

		// query param privileged_users
		var qrPrivilegedUsers string

		if o.PrivilegedUsersQueryParameter != nil {
			qrPrivilegedUsers = *o.PrivilegedUsersQueryParameter
		}
		qPrivilegedUsers := qrPrivilegedUsers
		if qPrivilegedUsers != "" {

			if err := r.SetQueryParam("privileged_users", qPrivilegedUsers); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.RoleQueryParameter != nil {

		// query param role
		var qrRole string

		if o.RoleQueryParameter != nil {
			qrRole = *o.RoleQueryParameter
		}
		qRole := qrRole
		if qRole != "" {

			if err := r.SetQueryParam("role", qRole); err != nil {
				return err
			}
		}
	}

	if o.ServersQueryParameter != nil {

		// query param servers
		var qrServers string

		if o.ServersQueryParameter != nil {
			qrServers = *o.ServersQueryParameter
		}
		qServers := qrServers
		if qServers != "" {

			if err := r.SetQueryParam("servers", qServers); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamVscanScannerCollectionGet binds the parameter fields
func (o *VscanScannerCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamVscanScannerCollectionGet binds the parameter order_by
func (o *VscanScannerCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
