// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewVscanScannerModifyParams creates a new VscanScannerModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVscanScannerModifyParams() *VscanScannerModifyParams {
	return &VscanScannerModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVscanScannerModifyParamsWithTimeout creates a new VscanScannerModifyParams object
// with the ability to set a timeout on a request.
func NewVscanScannerModifyParamsWithTimeout(timeout time.Duration) *VscanScannerModifyParams {
	return &VscanScannerModifyParams{
		timeout: timeout,
	}
}

// NewVscanScannerModifyParamsWithContext creates a new VscanScannerModifyParams object
// with the ability to set a context for a request.
func NewVscanScannerModifyParamsWithContext(ctx context.Context) *VscanScannerModifyParams {
	return &VscanScannerModifyParams{
		Context: ctx,
	}
}

// NewVscanScannerModifyParamsWithHTTPClient creates a new VscanScannerModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewVscanScannerModifyParamsWithHTTPClient(client *http.Client) *VscanScannerModifyParams {
	return &VscanScannerModifyParams{
		HTTPClient: client,
	}
}

/* VscanScannerModifyParams contains all the parameters to send to the API endpoint
   for the vscan scanner modify operation.

   Typically these are written to a http.Request.
*/
type VscanScannerModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.VscanScannerPool

	// Name.
	NamePathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the vscan scanner modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanScannerModifyParams) WithDefaults() *VscanScannerModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the vscan scanner modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanScannerModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the vscan scanner modify params
func (o *VscanScannerModifyParams) WithTimeout(timeout time.Duration) *VscanScannerModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the vscan scanner modify params
func (o *VscanScannerModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the vscan scanner modify params
func (o *VscanScannerModifyParams) WithContext(ctx context.Context) *VscanScannerModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the vscan scanner modify params
func (o *VscanScannerModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the vscan scanner modify params
func (o *VscanScannerModifyParams) WithHTTPClient(client *http.Client) *VscanScannerModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the vscan scanner modify params
func (o *VscanScannerModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the vscan scanner modify params
func (o *VscanScannerModifyParams) WithInfo(info *models.VscanScannerPool) *VscanScannerModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the vscan scanner modify params
func (o *VscanScannerModifyParams) SetInfo(info *models.VscanScannerPool) {
	o.Info = info
}

// WithNamePathParameter adds the name to the vscan scanner modify params
func (o *VscanScannerModifyParams) WithNamePathParameter(name string) *VscanScannerModifyParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the vscan scanner modify params
func (o *VscanScannerModifyParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WithSVMUUIDPathParameter adds the svmUUID to the vscan scanner modify params
func (o *VscanScannerModifyParams) WithSVMUUIDPathParameter(svmUUID string) *VscanScannerModifyParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the vscan scanner modify params
func (o *VscanScannerModifyParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *VscanScannerModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
