// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNvmeInterfaceGetParams creates a new NvmeInterfaceGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNvmeInterfaceGetParams() *NvmeInterfaceGetParams {
	return &NvmeInterfaceGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNvmeInterfaceGetParamsWithTimeout creates a new NvmeInterfaceGetParams object
// with the ability to set a timeout on a request.
func NewNvmeInterfaceGetParamsWithTimeout(timeout time.Duration) *NvmeInterfaceGetParams {
	return &NvmeInterfaceGetParams{
		timeout: timeout,
	}
}

// NewNvmeInterfaceGetParamsWithContext creates a new NvmeInterfaceGetParams object
// with the ability to set a context for a request.
func NewNvmeInterfaceGetParamsWithContext(ctx context.Context) *NvmeInterfaceGetParams {
	return &NvmeInterfaceGetParams{
		Context: ctx,
	}
}

// NewNvmeInterfaceGetParamsWithHTTPClient creates a new NvmeInterfaceGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNvmeInterfaceGetParamsWithHTTPClient(client *http.Client) *NvmeInterfaceGetParams {
	return &NvmeInterfaceGetParams{
		HTTPClient: client,
	}
}

/* NvmeInterfaceGetParams contains all the parameters to send to the API endpoint
   for the nvme interface get operation.

   Typically these are written to a http.Request.
*/
type NvmeInterfaceGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* UUID.

	   The unique identifier of the NVMe interface.

	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nvme interface get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeInterfaceGetParams) WithDefaults() *NvmeInterfaceGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nvme interface get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeInterfaceGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the nvme interface get params
func (o *NvmeInterfaceGetParams) WithTimeout(timeout time.Duration) *NvmeInterfaceGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nvme interface get params
func (o *NvmeInterfaceGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nvme interface get params
func (o *NvmeInterfaceGetParams) WithContext(ctx context.Context) *NvmeInterfaceGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nvme interface get params
func (o *NvmeInterfaceGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nvme interface get params
func (o *NvmeInterfaceGetParams) WithHTTPClient(client *http.Client) *NvmeInterfaceGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nvme interface get params
func (o *NvmeInterfaceGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the nvme interface get params
func (o *NvmeInterfaceGetParams) WithFieldsQueryParameter(fields []string) *NvmeInterfaceGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the nvme interface get params
func (o *NvmeInterfaceGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithUUIDPathParameter adds the uuid to the nvme interface get params
func (o *NvmeInterfaceGetParams) WithUUIDPathParameter(uuid string) *NvmeInterfaceGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the nvme interface get params
func (o *NvmeInterfaceGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *NvmeInterfaceGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNvmeInterfaceGet binds the parameter fields
func (o *NvmeInterfaceGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
