// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewNvmeNamespaceCreateParams creates a new NvmeNamespaceCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNvmeNamespaceCreateParams() *NvmeNamespaceCreateParams {
	return &NvmeNamespaceCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNvmeNamespaceCreateParamsWithTimeout creates a new NvmeNamespaceCreateParams object
// with the ability to set a timeout on a request.
func NewNvmeNamespaceCreateParamsWithTimeout(timeout time.Duration) *NvmeNamespaceCreateParams {
	return &NvmeNamespaceCreateParams{
		timeout: timeout,
	}
}

// NewNvmeNamespaceCreateParamsWithContext creates a new NvmeNamespaceCreateParams object
// with the ability to set a context for a request.
func NewNvmeNamespaceCreateParamsWithContext(ctx context.Context) *NvmeNamespaceCreateParams {
	return &NvmeNamespaceCreateParams{
		Context: ctx,
	}
}

// NewNvmeNamespaceCreateParamsWithHTTPClient creates a new NvmeNamespaceCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewNvmeNamespaceCreateParamsWithHTTPClient(client *http.Client) *NvmeNamespaceCreateParams {
	return &NvmeNamespaceCreateParams{
		HTTPClient: client,
	}
}

/* NvmeNamespaceCreateParams contains all the parameters to send to the API endpoint
   for the nvme namespace create operation.

   Typically these are written to a http.Request.
*/
type NvmeNamespaceCreateParams struct {

	/* Info.

	   The property values for the new NVMe namespace.

	*/
	Info *models.NvmeNamespace

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nvme namespace create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeNamespaceCreateParams) WithDefaults() *NvmeNamespaceCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nvme namespace create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeNamespaceCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := NvmeNamespaceCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) WithTimeout(timeout time.Duration) *NvmeNamespaceCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) WithContext(ctx context.Context) *NvmeNamespaceCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) WithHTTPClient(client *http.Client) *NvmeNamespaceCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) WithInfo(info *models.NvmeNamespace) *NvmeNamespaceCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) SetInfo(info *models.NvmeNamespace) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *NvmeNamespaceCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the nvme namespace create params
func (o *NvmeNamespaceCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *NvmeNamespaceCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
