// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NvmeServiceCreateReader is a Reader for the NvmeServiceCreate structure.
type NvmeServiceCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *NvmeServiceCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewNvmeServiceCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewNvmeServiceCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewNvmeServiceCreateCreated creates a NvmeServiceCreateCreated with default headers values
func NewNvmeServiceCreateCreated() *NvmeServiceCreateCreated {
	return &NvmeServiceCreateCreated{}
}

/* NvmeServiceCreateCreated describes a response with status code 201, with default header values.

Created
*/
type NvmeServiceCreateCreated struct {
	Payload *models.NvmeServiceResponse
}

func (o *NvmeServiceCreateCreated) Error() string {
	return fmt.Sprintf("[POST /protocols/nvme/services][%d] nvmeServiceCreateCreated  %+v", 201, o.Payload)
}
func (o *NvmeServiceCreateCreated) GetPayload() *models.NvmeServiceResponse {
	return o.Payload
}

func (o *NvmeServiceCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.NvmeServiceResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewNvmeServiceCreateDefault creates a NvmeServiceCreateDefault with default headers values
func NewNvmeServiceCreateDefault(code int) *NvmeServiceCreateDefault {
	return &NvmeServiceCreateDefault{
		_statusCode: code,
	}
}

/* NvmeServiceCreateDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 1115127 | The cluster lacks a valid NVMe license. |
| 2621462 | The supplied SVM does not exist. |
| 2621507 | NVMe is not allowed for the specified SVM. |
| 2621706 | The specified `svm.uuid` and `svm.name` do not refer to the same SVM. |
| 2621707 | No SVM was specified. Either `svm.name` or `svm.uuid` must be supplied. |
| 5374893 | The SVM is stopped. The SVM must be running to create an NVMe service. |
| 72089650 | An NVMe service already exists for the specified SVM. |
| 72089900 | An NVMe service cannot be creating in an SVM that is configured for a SAN protocol. |

*/
type NvmeServiceCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the nvme service create default response
func (o *NvmeServiceCreateDefault) Code() int {
	return o._statusCode
}

func (o *NvmeServiceCreateDefault) Error() string {
	return fmt.Sprintf("[POST /protocols/nvme/services][%d] nvme_service_create default  %+v", o._statusCode, o.Payload)
}
func (o *NvmeServiceCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *NvmeServiceCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
