// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewNvmeServiceDeleteParams creates a new NvmeServiceDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNvmeServiceDeleteParams() *NvmeServiceDeleteParams {
	return &NvmeServiceDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNvmeServiceDeleteParamsWithTimeout creates a new NvmeServiceDeleteParams object
// with the ability to set a timeout on a request.
func NewNvmeServiceDeleteParamsWithTimeout(timeout time.Duration) *NvmeServiceDeleteParams {
	return &NvmeServiceDeleteParams{
		timeout: timeout,
	}
}

// NewNvmeServiceDeleteParamsWithContext creates a new NvmeServiceDeleteParams object
// with the ability to set a context for a request.
func NewNvmeServiceDeleteParamsWithContext(ctx context.Context) *NvmeServiceDeleteParams {
	return &NvmeServiceDeleteParams{
		Context: ctx,
	}
}

// NewNvmeServiceDeleteParamsWithHTTPClient creates a new NvmeServiceDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewNvmeServiceDeleteParamsWithHTTPClient(client *http.Client) *NvmeServiceDeleteParams {
	return &NvmeServiceDeleteParams{
		HTTPClient: client,
	}
}

/* NvmeServiceDeleteParams contains all the parameters to send to the API endpoint
   for the nvme service delete operation.

   Typically these are written to a http.Request.
*/
type NvmeServiceDeleteParams struct {

	/* SvmUUID.

	   The unique identifier of the SVM whose NVMe service is to be deleted.

	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nvme service delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeServiceDeleteParams) WithDefaults() *NvmeServiceDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nvme service delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeServiceDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the nvme service delete params
func (o *NvmeServiceDeleteParams) WithTimeout(timeout time.Duration) *NvmeServiceDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nvme service delete params
func (o *NvmeServiceDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nvme service delete params
func (o *NvmeServiceDeleteParams) WithContext(ctx context.Context) *NvmeServiceDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nvme service delete params
func (o *NvmeServiceDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nvme service delete params
func (o *NvmeServiceDeleteParams) WithHTTPClient(client *http.Client) *NvmeServiceDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nvme service delete params
func (o *NvmeServiceDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithSVMUUIDPathParameter adds the svmUUID to the nvme service delete params
func (o *NvmeServiceDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *NvmeServiceDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the nvme service delete params
func (o *NvmeServiceDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *NvmeServiceDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
