// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewNvmeSubsystemMapDeleteParams creates a new NvmeSubsystemMapDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNvmeSubsystemMapDeleteParams() *NvmeSubsystemMapDeleteParams {
	return &NvmeSubsystemMapDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNvmeSubsystemMapDeleteParamsWithTimeout creates a new NvmeSubsystemMapDeleteParams object
// with the ability to set a timeout on a request.
func NewNvmeSubsystemMapDeleteParamsWithTimeout(timeout time.Duration) *NvmeSubsystemMapDeleteParams {
	return &NvmeSubsystemMapDeleteParams{
		timeout: timeout,
	}
}

// NewNvmeSubsystemMapDeleteParamsWithContext creates a new NvmeSubsystemMapDeleteParams object
// with the ability to set a context for a request.
func NewNvmeSubsystemMapDeleteParamsWithContext(ctx context.Context) *NvmeSubsystemMapDeleteParams {
	return &NvmeSubsystemMapDeleteParams{
		Context: ctx,
	}
}

// NewNvmeSubsystemMapDeleteParamsWithHTTPClient creates a new NvmeSubsystemMapDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewNvmeSubsystemMapDeleteParamsWithHTTPClient(client *http.Client) *NvmeSubsystemMapDeleteParams {
	return &NvmeSubsystemMapDeleteParams{
		HTTPClient: client,
	}
}

/* NvmeSubsystemMapDeleteParams contains all the parameters to send to the API endpoint
   for the nvme subsystem map delete operation.

   Typically these are written to a http.Request.
*/
type NvmeSubsystemMapDeleteParams struct {

	/* NamespaceUUID.

	   The unique identifier of the NVMe namespace.

	*/
	NamespaceUUIDPathParameter string

	/* SubsystemUUID.

	   The unique identifier of the NVMe subsystem.

	*/
	SubsystemUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nvme subsystem map delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeSubsystemMapDeleteParams) WithDefaults() *NvmeSubsystemMapDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nvme subsystem map delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeSubsystemMapDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) WithTimeout(timeout time.Duration) *NvmeSubsystemMapDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) WithContext(ctx context.Context) *NvmeSubsystemMapDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) WithHTTPClient(client *http.Client) *NvmeSubsystemMapDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespaceUUIDPathParameter adds the namespaceUUID to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) WithNamespaceUUIDPathParameter(namespaceUUID string) *NvmeSubsystemMapDeleteParams {
	o.SetNamespaceUUIDPathParameter(namespaceUUID)
	return o
}

// SetNamespaceUUIDPathParameter adds the namespaceUuid to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) SetNamespaceUUIDPathParameter(namespaceUUID string) {
	o.NamespaceUUIDPathParameter = namespaceUUID
}

// WithSubsystemUUIDPathParameter adds the subsystemUUID to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) WithSubsystemUUIDPathParameter(subsystemUUID string) *NvmeSubsystemMapDeleteParams {
	o.SetSubsystemUUIDPathParameter(subsystemUUID)
	return o
}

// SetSubsystemUUIDPathParameter adds the subsystemUuid to the nvme subsystem map delete params
func (o *NvmeSubsystemMapDeleteParams) SetSubsystemUUIDPathParameter(subsystemUUID string) {
	o.SubsystemUUIDPathParameter = subsystemUUID
}

// WriteToRequest writes these params to a swagger request
func (o *NvmeSubsystemMapDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace.uuid
	if err := r.SetPathParam("namespace.uuid", o.NamespaceUUIDPathParameter); err != nil {
		return err
	}

	// path param subsystem.uuid
	if err := r.SetPathParam("subsystem.uuid", o.SubsystemUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
