// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewNvmeSubsystemModifyParams creates a new NvmeSubsystemModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNvmeSubsystemModifyParams() *NvmeSubsystemModifyParams {
	return &NvmeSubsystemModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNvmeSubsystemModifyParamsWithTimeout creates a new NvmeSubsystemModifyParams object
// with the ability to set a timeout on a request.
func NewNvmeSubsystemModifyParamsWithTimeout(timeout time.Duration) *NvmeSubsystemModifyParams {
	return &NvmeSubsystemModifyParams{
		timeout: timeout,
	}
}

// NewNvmeSubsystemModifyParamsWithContext creates a new NvmeSubsystemModifyParams object
// with the ability to set a context for a request.
func NewNvmeSubsystemModifyParamsWithContext(ctx context.Context) *NvmeSubsystemModifyParams {
	return &NvmeSubsystemModifyParams{
		Context: ctx,
	}
}

// NewNvmeSubsystemModifyParamsWithHTTPClient creates a new NvmeSubsystemModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewNvmeSubsystemModifyParamsWithHTTPClient(client *http.Client) *NvmeSubsystemModifyParams {
	return &NvmeSubsystemModifyParams{
		HTTPClient: client,
	}
}

/* NvmeSubsystemModifyParams contains all the parameters to send to the API endpoint
   for the nvme subsystem modify operation.

   Typically these are written to a http.Request.
*/
type NvmeSubsystemModifyParams struct {

	/* Info.

	   The new property values for the NVMe subsystem.

	*/
	Info *models.NvmeSubsystem

	/* UUID.

	   The unique identifier of the NVMe subsystem.

	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nvme subsystem modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeSubsystemModifyParams) WithDefaults() *NvmeSubsystemModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nvme subsystem modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeSubsystemModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) WithTimeout(timeout time.Duration) *NvmeSubsystemModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) WithContext(ctx context.Context) *NvmeSubsystemModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) WithHTTPClient(client *http.Client) *NvmeSubsystemModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) WithInfo(info *models.NvmeSubsystem) *NvmeSubsystemModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) SetInfo(info *models.NvmeSubsystem) {
	o.Info = info
}

// WithUUIDPathParameter adds the uuid to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) WithUUIDPathParameter(uuid string) *NvmeSubsystemModifyParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the nvme subsystem modify params
func (o *NvmeSubsystemModifyParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *NvmeSubsystemModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
