// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewDNSCreateParams creates a new DNSCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDNSCreateParams() *DNSCreateParams {
	return &DNSCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDNSCreateParamsWithTimeout creates a new DNSCreateParams object
// with the ability to set a timeout on a request.
func NewDNSCreateParamsWithTimeout(timeout time.Duration) *DNSCreateParams {
	return &DNSCreateParams{
		timeout: timeout,
	}
}

// NewDNSCreateParamsWithContext creates a new DNSCreateParams object
// with the ability to set a context for a request.
func NewDNSCreateParamsWithContext(ctx context.Context) *DNSCreateParams {
	return &DNSCreateParams{
		Context: ctx,
	}
}

// NewDNSCreateParamsWithHTTPClient creates a new DNSCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewDNSCreateParamsWithHTTPClient(client *http.Client) *DNSCreateParams {
	return &DNSCreateParams{
		HTTPClient: client,
	}
}

/* DNSCreateParams contains all the parameters to send to the API endpoint
   for the dns create operation.

   Typically these are written to a http.Request.
*/
type DNSCreateParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.DNS

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dns create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DNSCreateParams) WithDefaults() *DNSCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dns create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DNSCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := DNSCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the dns create params
func (o *DNSCreateParams) WithTimeout(timeout time.Duration) *DNSCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dns create params
func (o *DNSCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dns create params
func (o *DNSCreateParams) WithContext(ctx context.Context) *DNSCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dns create params
func (o *DNSCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dns create params
func (o *DNSCreateParams) WithHTTPClient(client *http.Client) *DNSCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dns create params
func (o *DNSCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the dns create params
func (o *DNSCreateParams) WithInfo(info *models.DNS) *DNSCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the dns create params
func (o *DNSCreateParams) SetInfo(info *models.DNS) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the dns create params
func (o *DNSCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *DNSCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the dns create params
func (o *DNSCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *DNSCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
