// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDNSDeleteParams creates a new DNSDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDNSDeleteParams() *DNSDeleteParams {
	return &DNSDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDNSDeleteParamsWithTimeout creates a new DNSDeleteParams object
// with the ability to set a timeout on a request.
func NewDNSDeleteParamsWithTimeout(timeout time.Duration) *DNSDeleteParams {
	return &DNSDeleteParams{
		timeout: timeout,
	}
}

// NewDNSDeleteParamsWithContext creates a new DNSDeleteParams object
// with the ability to set a context for a request.
func NewDNSDeleteParamsWithContext(ctx context.Context) *DNSDeleteParams {
	return &DNSDeleteParams{
		Context: ctx,
	}
}

// NewDNSDeleteParamsWithHTTPClient creates a new DNSDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewDNSDeleteParamsWithHTTPClient(client *http.Client) *DNSDeleteParams {
	return &DNSDeleteParams{
		HTTPClient: client,
	}
}

/* DNSDeleteParams contains all the parameters to send to the API endpoint
   for the dns delete operation.

   Typically these are written to a http.Request.
*/
type DNSDeleteParams struct {

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dns delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DNSDeleteParams) WithDefaults() *DNSDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dns delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DNSDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the dns delete params
func (o *DNSDeleteParams) WithTimeout(timeout time.Duration) *DNSDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dns delete params
func (o *DNSDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dns delete params
func (o *DNSDeleteParams) WithContext(ctx context.Context) *DNSDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dns delete params
func (o *DNSDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dns delete params
func (o *DNSDeleteParams) WithHTTPClient(client *http.Client) *DNSDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dns delete params
func (o *DNSDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithSVMUUIDPathParameter adds the svmUUID to the dns delete params
func (o *DNSDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *DNSDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the dns delete params
func (o *DNSDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *DNSDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
