// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDNSGetParams creates a new DNSGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDNSGetParams() *DNSGetParams {
	return &DNSGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDNSGetParamsWithTimeout creates a new DNSGetParams object
// with the ability to set a timeout on a request.
func NewDNSGetParamsWithTimeout(timeout time.Duration) *DNSGetParams {
	return &DNSGetParams{
		timeout: timeout,
	}
}

// NewDNSGetParamsWithContext creates a new DNSGetParams object
// with the ability to set a context for a request.
func NewDNSGetParamsWithContext(ctx context.Context) *DNSGetParams {
	return &DNSGetParams{
		Context: ctx,
	}
}

// NewDNSGetParamsWithHTTPClient creates a new DNSGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewDNSGetParamsWithHTTPClient(client *http.Client) *DNSGetParams {
	return &DNSGetParams{
		HTTPClient: client,
	}
}

/* DNSGetParams contains all the parameters to send to the API endpoint
   for the dns get operation.

   Typically these are written to a http.Request.
*/
type DNSGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the dns get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DNSGetParams) WithDefaults() *DNSGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the dns get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DNSGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the dns get params
func (o *DNSGetParams) WithTimeout(timeout time.Duration) *DNSGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dns get params
func (o *DNSGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dns get params
func (o *DNSGetParams) WithContext(ctx context.Context) *DNSGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dns get params
func (o *DNSGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dns get params
func (o *DNSGetParams) WithHTTPClient(client *http.Client) *DNSGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dns get params
func (o *DNSGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the dns get params
func (o *DNSGetParams) WithFieldsQueryParameter(fields []string) *DNSGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the dns get params
func (o *DNSGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithSVMUUIDPathParameter adds the svmUUID to the dns get params
func (o *DNSGetParams) WithSVMUUIDPathParameter(svmUUID string) *DNSGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the dns get params
func (o *DNSGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *DNSGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamDNSGet binds the parameter fields
func (o *DNSGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
