// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewLocalHostCollectionGetParams creates a new LocalHostCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLocalHostCollectionGetParams() *LocalHostCollectionGetParams {
	return &LocalHostCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLocalHostCollectionGetParamsWithTimeout creates a new LocalHostCollectionGetParams object
// with the ability to set a timeout on a request.
func NewLocalHostCollectionGetParamsWithTimeout(timeout time.Duration) *LocalHostCollectionGetParams {
	return &LocalHostCollectionGetParams{
		timeout: timeout,
	}
}

// NewLocalHostCollectionGetParamsWithContext creates a new LocalHostCollectionGetParams object
// with the ability to set a context for a request.
func NewLocalHostCollectionGetParamsWithContext(ctx context.Context) *LocalHostCollectionGetParams {
	return &LocalHostCollectionGetParams{
		Context: ctx,
	}
}

// NewLocalHostCollectionGetParamsWithHTTPClient creates a new LocalHostCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewLocalHostCollectionGetParamsWithHTTPClient(client *http.Client) *LocalHostCollectionGetParams {
	return &LocalHostCollectionGetParams{
		HTTPClient: client,
	}
}

/* LocalHostCollectionGetParams contains all the parameters to send to the API endpoint
   for the local host collection get operation.

   Typically these are written to a http.Request.
*/
type LocalHostCollectionGetParams struct {

	/* Address.

	   Filter by address
	*/
	AddressQueryParameter *string

	/* Aliases.

	   Filter by aliases
	*/
	AliasesQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Hostname.

	   Filter by hostname
	*/
	HostnameQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* OwnerName.

	   Filter by owner.name
	*/
	OwnerNameQueryParameter *string

	/* OwnerUUID.

	   Filter by owner.uuid
	*/
	OwnerUUIDQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Scope.

	   Filter by scope
	*/
	ScopeQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the local host collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalHostCollectionGetParams) WithDefaults() *LocalHostCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the local host collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalHostCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := LocalHostCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the local host collection get params
func (o *LocalHostCollectionGetParams) WithTimeout(timeout time.Duration) *LocalHostCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the local host collection get params
func (o *LocalHostCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the local host collection get params
func (o *LocalHostCollectionGetParams) WithContext(ctx context.Context) *LocalHostCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the local host collection get params
func (o *LocalHostCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the local host collection get params
func (o *LocalHostCollectionGetParams) WithHTTPClient(client *http.Client) *LocalHostCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the local host collection get params
func (o *LocalHostCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAddressQueryParameter adds the address to the local host collection get params
func (o *LocalHostCollectionGetParams) WithAddressQueryParameter(address *string) *LocalHostCollectionGetParams {
	o.SetAddressQueryParameter(address)
	return o
}

// SetAddressQueryParameter adds the address to the local host collection get params
func (o *LocalHostCollectionGetParams) SetAddressQueryParameter(address *string) {
	o.AddressQueryParameter = address
}

// WithAliasesQueryParameter adds the aliases to the local host collection get params
func (o *LocalHostCollectionGetParams) WithAliasesQueryParameter(aliases *string) *LocalHostCollectionGetParams {
	o.SetAliasesQueryParameter(aliases)
	return o
}

// SetAliasesQueryParameter adds the aliases to the local host collection get params
func (o *LocalHostCollectionGetParams) SetAliasesQueryParameter(aliases *string) {
	o.AliasesQueryParameter = aliases
}

// WithFieldsQueryParameter adds the fields to the local host collection get params
func (o *LocalHostCollectionGetParams) WithFieldsQueryParameter(fields []string) *LocalHostCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the local host collection get params
func (o *LocalHostCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithHostnameQueryParameter adds the hostname to the local host collection get params
func (o *LocalHostCollectionGetParams) WithHostnameQueryParameter(hostname *string) *LocalHostCollectionGetParams {
	o.SetHostnameQueryParameter(hostname)
	return o
}

// SetHostnameQueryParameter adds the hostname to the local host collection get params
func (o *LocalHostCollectionGetParams) SetHostnameQueryParameter(hostname *string) {
	o.HostnameQueryParameter = hostname
}

// WithMaxRecordsQueryParameter adds the maxRecords to the local host collection get params
func (o *LocalHostCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *LocalHostCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the local host collection get params
func (o *LocalHostCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the local host collection get params
func (o *LocalHostCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *LocalHostCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the local host collection get params
func (o *LocalHostCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithOwnerNameQueryParameter adds the ownerName to the local host collection get params
func (o *LocalHostCollectionGetParams) WithOwnerNameQueryParameter(ownerName *string) *LocalHostCollectionGetParams {
	o.SetOwnerNameQueryParameter(ownerName)
	return o
}

// SetOwnerNameQueryParameter adds the ownerName to the local host collection get params
func (o *LocalHostCollectionGetParams) SetOwnerNameQueryParameter(ownerName *string) {
	o.OwnerNameQueryParameter = ownerName
}

// WithOwnerUUIDQueryParameter adds the ownerUUID to the local host collection get params
func (o *LocalHostCollectionGetParams) WithOwnerUUIDQueryParameter(ownerUUID *string) *LocalHostCollectionGetParams {
	o.SetOwnerUUIDQueryParameter(ownerUUID)
	return o
}

// SetOwnerUUIDQueryParameter adds the ownerUuid to the local host collection get params
func (o *LocalHostCollectionGetParams) SetOwnerUUIDQueryParameter(ownerUUID *string) {
	o.OwnerUUIDQueryParameter = ownerUUID
}

// WithReturnRecordsQueryParameter adds the returnRecords to the local host collection get params
func (o *LocalHostCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *LocalHostCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the local host collection get params
func (o *LocalHostCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the local host collection get params
func (o *LocalHostCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *LocalHostCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the local host collection get params
func (o *LocalHostCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithScopeQueryParameter adds the scope to the local host collection get params
func (o *LocalHostCollectionGetParams) WithScopeQueryParameter(scope *string) *LocalHostCollectionGetParams {
	o.SetScopeQueryParameter(scope)
	return o
}

// SetScopeQueryParameter adds the scope to the local host collection get params
func (o *LocalHostCollectionGetParams) SetScopeQueryParameter(scope *string) {
	o.ScopeQueryParameter = scope
}

// WriteToRequest writes these params to a swagger request
func (o *LocalHostCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AddressQueryParameter != nil {

		// query param address
		var qrAddress string

		if o.AddressQueryParameter != nil {
			qrAddress = *o.AddressQueryParameter
		}
		qAddress := qrAddress
		if qAddress != "" {

			if err := r.SetQueryParam("address", qAddress); err != nil {
				return err
			}
		}
	}

	if o.AliasesQueryParameter != nil {

		// query param aliases
		var qrAliases string

		if o.AliasesQueryParameter != nil {
			qrAliases = *o.AliasesQueryParameter
		}
		qAliases := qrAliases
		if qAliases != "" {

			if err := r.SetQueryParam("aliases", qAliases); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.HostnameQueryParameter != nil {

		// query param hostname
		var qrHostname string

		if o.HostnameQueryParameter != nil {
			qrHostname = *o.HostnameQueryParameter
		}
		qHostname := qrHostname
		if qHostname != "" {

			if err := r.SetQueryParam("hostname", qHostname); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.OwnerNameQueryParameter != nil {

		// query param owner.name
		var qrOwnerName string

		if o.OwnerNameQueryParameter != nil {
			qrOwnerName = *o.OwnerNameQueryParameter
		}
		qOwnerName := qrOwnerName
		if qOwnerName != "" {

			if err := r.SetQueryParam("owner.name", qOwnerName); err != nil {
				return err
			}
		}
	}

	if o.OwnerUUIDQueryParameter != nil {

		// query param owner.uuid
		var qrOwnerUUID string

		if o.OwnerUUIDQueryParameter != nil {
			qrOwnerUUID = *o.OwnerUUIDQueryParameter
		}
		qOwnerUUID := qrOwnerUUID
		if qOwnerUUID != "" {

			if err := r.SetQueryParam("owner.uuid", qOwnerUUID); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ScopeQueryParameter != nil {

		// query param scope
		var qrScope string

		if o.ScopeQueryParameter != nil {
			qrScope = *o.ScopeQueryParameter
		}
		qScope := qrScope
		if qScope != "" {

			if err := r.SetQueryParam("scope", qScope); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamLocalHostCollectionGet binds the parameter fields
func (o *LocalHostCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamLocalHostCollectionGet binds the parameter order_by
func (o *LocalHostCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
