// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NisCreateReader is a Reader for the NisCreate structure.
type NisCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *NisCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewNisCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewNisCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewNisCreateCreated creates a NisCreateCreated with default headers values
func NewNisCreateCreated() *NisCreateCreated {
	return &NisCreateCreated{}
}

/* NisCreateCreated describes a response with status code 201, with default header values.

Created
*/
type NisCreateCreated struct {
	Payload *models.NisServiceResponse
}

func (o *NisCreateCreated) Error() string {
	return fmt.Sprintf("[POST /name-services/nis][%d] nisCreateCreated  %+v", 201, o.Payload)
}
func (o *NisCreateCreated) GetPayload() *models.NisServiceResponse {
	return o.Payload
}

func (o *NisCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.NisServiceResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewNisCreateDefault creates a NisCreateDefault with default headers values
func NewNisCreateDefault(code int) *NisCreateDefault {
	return &NisCreateDefault{
		_statusCode: code,
	}
}

/* NisCreateDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 1966253    | IPv6 is not enabled in the cluster |
| 2621488    | Invalid SVM context |
| 2621706    | The specified SVM UUID is incorrect for the specified SVM name |
| 3276964    | NIS domain name or NIS server domain is too long. The maximum supported for domain name is 64 characters and the maximum supported for NIS server domain is 255 characters |
| 3276933    | A maximum of 10 NIS servers can be configured per SVM |
| 13434916   | The SVM is in the process of being created. Wait a few minutes, and then try the command again. |
| 23724109   | DNS resolution failed for one or more specified servers  |
| 23724112   | DNS resolution failed due to an internal error. Contact technical support if this issue persists  |
| 23724132   | DNS resolution failed for all the specified servers  |
| 23724130   | Cannot use an IPv6 name server address because there are no IPv6 LIFs |

*/
type NisCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the nis create default response
func (o *NisCreateDefault) Code() int {
	return o._statusCode
}

func (o *NisCreateDefault) Error() string {
	return fmt.Sprintf("[POST /name-services/nis][%d] nis_create default  %+v", o._statusCode, o.Payload)
}
func (o *NisCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *NisCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
