// Code generated by go-swagger; DO NOT EDIT.

package ndmp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewClusterNdmpGetParams creates a new ClusterNdmpGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewClusterNdmpGetParams() *ClusterNdmpGetParams {
	return &ClusterNdmpGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewClusterNdmpGetParamsWithTimeout creates a new ClusterNdmpGetParams object
// with the ability to set a timeout on a request.
func NewClusterNdmpGetParamsWithTimeout(timeout time.Duration) *ClusterNdmpGetParams {
	return &ClusterNdmpGetParams{
		timeout: timeout,
	}
}

// NewClusterNdmpGetParamsWithContext creates a new ClusterNdmpGetParams object
// with the ability to set a context for a request.
func NewClusterNdmpGetParamsWithContext(ctx context.Context) *ClusterNdmpGetParams {
	return &ClusterNdmpGetParams{
		Context: ctx,
	}
}

// NewClusterNdmpGetParamsWithHTTPClient creates a new ClusterNdmpGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewClusterNdmpGetParamsWithHTTPClient(client *http.Client) *ClusterNdmpGetParams {
	return &ClusterNdmpGetParams{
		HTTPClient: client,
	}
}

/* ClusterNdmpGetParams contains all the parameters to send to the API endpoint
   for the cluster ndmp get operation.

   Typically these are written to a http.Request.
*/
type ClusterNdmpGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Mode.

	   Filter by mode
	*/
	ModeQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cluster ndmp get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterNdmpGetParams) WithDefaults() *ClusterNdmpGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cluster ndmp get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterNdmpGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the cluster ndmp get params
func (o *ClusterNdmpGetParams) WithTimeout(timeout time.Duration) *ClusterNdmpGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cluster ndmp get params
func (o *ClusterNdmpGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cluster ndmp get params
func (o *ClusterNdmpGetParams) WithContext(ctx context.Context) *ClusterNdmpGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cluster ndmp get params
func (o *ClusterNdmpGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cluster ndmp get params
func (o *ClusterNdmpGetParams) WithHTTPClient(client *http.Client) *ClusterNdmpGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cluster ndmp get params
func (o *ClusterNdmpGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the cluster ndmp get params
func (o *ClusterNdmpGetParams) WithFieldsQueryParameter(fields []string) *ClusterNdmpGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the cluster ndmp get params
func (o *ClusterNdmpGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithModeQueryParameter adds the mode to the cluster ndmp get params
func (o *ClusterNdmpGetParams) WithModeQueryParameter(mode *string) *ClusterNdmpGetParams {
	o.SetModeQueryParameter(mode)
	return o
}

// SetModeQueryParameter adds the mode to the cluster ndmp get params
func (o *ClusterNdmpGetParams) SetModeQueryParameter(mode *string) {
	o.ModeQueryParameter = mode
}

// WriteToRequest writes these params to a swagger request
func (o *ClusterNdmpGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.ModeQueryParameter != nil {

		// query param mode
		var qrMode string

		if o.ModeQueryParameter != nil {
			qrMode = *o.ModeQueryParameter
		}
		qMode := qrMode
		if qMode != "" {

			if err := r.SetQueryParam("mode", qMode); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamClusterNdmpGet binds the parameter fields
func (o *ClusterNdmpGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
