// Code generated by go-swagger; DO NOT EDIT.

package ndmp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewNdmpNodeSessionDeleteParams creates a new NdmpNodeSessionDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNdmpNodeSessionDeleteParams() *NdmpNodeSessionDeleteParams {
	return &NdmpNodeSessionDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNdmpNodeSessionDeleteParamsWithTimeout creates a new NdmpNodeSessionDeleteParams object
// with the ability to set a timeout on a request.
func NewNdmpNodeSessionDeleteParamsWithTimeout(timeout time.Duration) *NdmpNodeSessionDeleteParams {
	return &NdmpNodeSessionDeleteParams{
		timeout: timeout,
	}
}

// NewNdmpNodeSessionDeleteParamsWithContext creates a new NdmpNodeSessionDeleteParams object
// with the ability to set a context for a request.
func NewNdmpNodeSessionDeleteParamsWithContext(ctx context.Context) *NdmpNodeSessionDeleteParams {
	return &NdmpNodeSessionDeleteParams{
		Context: ctx,
	}
}

// NewNdmpNodeSessionDeleteParamsWithHTTPClient creates a new NdmpNodeSessionDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewNdmpNodeSessionDeleteParamsWithHTTPClient(client *http.Client) *NdmpNodeSessionDeleteParams {
	return &NdmpNodeSessionDeleteParams{
		HTTPClient: client,
	}
}

/* NdmpNodeSessionDeleteParams contains all the parameters to send to the API endpoint
   for the ndmp node session delete operation.

   Typically these are written to a http.Request.
*/
type NdmpNodeSessionDeleteParams struct {

	/* OwnerUUID.

	   NDMP node UUID
	*/
	OwnerUUIDPathParameter string

	/* SessionID.

	   Session identifier
	*/
	SessionIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ndmp node session delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NdmpNodeSessionDeleteParams) WithDefaults() *NdmpNodeSessionDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ndmp node session delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NdmpNodeSessionDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) WithTimeout(timeout time.Duration) *NdmpNodeSessionDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) WithContext(ctx context.Context) *NdmpNodeSessionDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) WithHTTPClient(client *http.Client) *NdmpNodeSessionDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwnerUUIDPathParameter adds the ownerUUID to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) WithOwnerUUIDPathParameter(ownerUUID string) *NdmpNodeSessionDeleteParams {
	o.SetOwnerUUIDPathParameter(ownerUUID)
	return o
}

// SetOwnerUUIDPathParameter adds the ownerUuid to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) SetOwnerUUIDPathParameter(ownerUUID string) {
	o.OwnerUUIDPathParameter = ownerUUID
}

// WithSessionIDPathParameter adds the sessionID to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) WithSessionIDPathParameter(sessionID string) *NdmpNodeSessionDeleteParams {
	o.SetSessionIDPathParameter(sessionID)
	return o
}

// SetSessionIDPathParameter adds the sessionId to the ndmp node session delete params
func (o *NdmpNodeSessionDeleteParams) SetSessionIDPathParameter(sessionID string) {
	o.SessionIDPathParameter = sessionID
}

// WriteToRequest writes these params to a swagger request
func (o *NdmpNodeSessionDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner.uuid
	if err := r.SetPathParam("owner.uuid", o.OwnerUUIDPathParameter); err != nil {
		return err
	}

	// path param session.id
	if err := r.SetPathParam("session.id", o.SessionIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
