// Code generated by go-swagger; DO NOT EDIT.

package ndmp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewNdmpSvmModifyParams creates a new NdmpSvmModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNdmpSvmModifyParams() *NdmpSvmModifyParams {
	return &NdmpSvmModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNdmpSvmModifyParamsWithTimeout creates a new NdmpSvmModifyParams object
// with the ability to set a timeout on a request.
func NewNdmpSvmModifyParamsWithTimeout(timeout time.Duration) *NdmpSvmModifyParams {
	return &NdmpSvmModifyParams{
		timeout: timeout,
	}
}

// NewNdmpSvmModifyParamsWithContext creates a new NdmpSvmModifyParams object
// with the ability to set a context for a request.
func NewNdmpSvmModifyParamsWithContext(ctx context.Context) *NdmpSvmModifyParams {
	return &NdmpSvmModifyParams{
		Context: ctx,
	}
}

// NewNdmpSvmModifyParamsWithHTTPClient creates a new NdmpSvmModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewNdmpSvmModifyParamsWithHTTPClient(client *http.Client) *NdmpSvmModifyParams {
	return &NdmpSvmModifyParams{
		HTTPClient: client,
	}
}

/* NdmpSvmModifyParams contains all the parameters to send to the API endpoint
   for the ndmp svm modify operation.

   Typically these are written to a http.Request.
*/
type NdmpSvmModifyParams struct {

	/* Info.

	   Information specification
	*/
	Info *models.NdmpSvm

	/* SvmUUID.

	   SVM UUID
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ndmp svm modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NdmpSvmModifyParams) WithDefaults() *NdmpSvmModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ndmp svm modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NdmpSvmModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ndmp svm modify params
func (o *NdmpSvmModifyParams) WithTimeout(timeout time.Duration) *NdmpSvmModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ndmp svm modify params
func (o *NdmpSvmModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ndmp svm modify params
func (o *NdmpSvmModifyParams) WithContext(ctx context.Context) *NdmpSvmModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ndmp svm modify params
func (o *NdmpSvmModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ndmp svm modify params
func (o *NdmpSvmModifyParams) WithHTTPClient(client *http.Client) *NdmpSvmModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ndmp svm modify params
func (o *NdmpSvmModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the ndmp svm modify params
func (o *NdmpSvmModifyParams) WithInfo(info *models.NdmpSvm) *NdmpSvmModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the ndmp svm modify params
func (o *NdmpSvmModifyParams) SetInfo(info *models.NdmpSvm) {
	o.Info = info
}

// WithSVMUUIDPathParameter adds the svmUUID to the ndmp svm modify params
func (o *NdmpSvmModifyParams) WithSVMUUIDPathParameter(svmUUID string) *NdmpSvmModifyParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the ndmp svm modify params
func (o *NdmpSvmModifyParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *NdmpSvmModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
