// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewFcPortCollectionGetParams creates a new FcPortCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFcPortCollectionGetParams() *FcPortCollectionGetParams {
	return &FcPortCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFcPortCollectionGetParamsWithTimeout creates a new FcPortCollectionGetParams object
// with the ability to set a timeout on a request.
func NewFcPortCollectionGetParamsWithTimeout(timeout time.Duration) *FcPortCollectionGetParams {
	return &FcPortCollectionGetParams{
		timeout: timeout,
	}
}

// NewFcPortCollectionGetParamsWithContext creates a new FcPortCollectionGetParams object
// with the ability to set a context for a request.
func NewFcPortCollectionGetParamsWithContext(ctx context.Context) *FcPortCollectionGetParams {
	return &FcPortCollectionGetParams{
		Context: ctx,
	}
}

// NewFcPortCollectionGetParamsWithHTTPClient creates a new FcPortCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewFcPortCollectionGetParamsWithHTTPClient(client *http.Client) *FcPortCollectionGetParams {
	return &FcPortCollectionGetParams{
		HTTPClient: client,
	}
}

/* FcPortCollectionGetParams contains all the parameters to send to the API endpoint
   for the fc port collection get operation.

   Typically these are written to a http.Request.
*/
type FcPortCollectionGetParams struct {

	/* Description.

	   Filter by description
	*/
	DescriptionQueryParameter *string

	/* Enabled.

	   Filter by enabled
	*/
	EnabledQueryParameter *bool

	/* FabricConnected.

	   Filter by fabric.connected
	*/
	FabricConnectedQueryParameter *bool

	/* FabricConnectedSpeed.

	   Filter by fabric.connected_speed
	*/
	FabricConnectedSpeedQueryParameter *int64

	/* FabricName.

	   Filter by fabric.name
	*/
	FabricNameQueryParameter *string

	/* FabricPortAddress.

	   Filter by fabric.port_address
	*/
	FabricPortAddressQueryParameter *string

	/* FabricSwitchPort.

	   Filter by fabric.switch_port
	*/
	FabricSwitchPortQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* InterfaceCount.

	   Filter by interface_count
	*/
	InterfaceCountQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* MetricDuration.

	   Filter by metric.duration
	*/
	MetricDurationQueryParameter *string

	/* MetricIopsOther.

	   Filter by metric.iops.other
	*/
	MetricIopsOtherQueryParameter *int64

	/* MetricIopsRead.

	   Filter by metric.iops.read
	*/
	MetricIopsReadQueryParameter *int64

	/* MetricIopsTotal.

	   Filter by metric.iops.total
	*/
	MetricIopsTotalQueryParameter *int64

	/* MetricIopsWrite.

	   Filter by metric.iops.write
	*/
	MetricIopsWriteQueryParameter *int64

	/* MetricLatencyOther.

	   Filter by metric.latency.other
	*/
	MetricLatencyOtherQueryParameter *int64

	/* MetricLatencyRead.

	   Filter by metric.latency.read
	*/
	MetricLatencyReadQueryParameter *int64

	/* MetricLatencyTotal.

	   Filter by metric.latency.total
	*/
	MetricLatencyTotalQueryParameter *int64

	/* MetricLatencyWrite.

	   Filter by metric.latency.write
	*/
	MetricLatencyWriteQueryParameter *int64

	/* MetricStatus.

	   Filter by metric.status
	*/
	MetricStatusQueryParameter *string

	/* MetricThroughputRead.

	   Filter by metric.throughput.read
	*/
	MetricThroughputReadQueryParameter *int64

	/* MetricThroughputTotal.

	   Filter by metric.throughput.total
	*/
	MetricThroughputTotalQueryParameter *int64

	/* MetricThroughputWrite.

	   Filter by metric.throughput.write
	*/
	MetricThroughputWriteQueryParameter *int64

	/* MetricTimestamp.

	   Filter by metric.timestamp
	*/
	MetricTimestampQueryParameter *string

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* NodeName.

	   Filter by node.name
	*/
	NodeNameQueryParameter *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUIDQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* PhysicalProtocol.

	   Filter by physical_protocol
	*/
	PhysicalProtocolQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SpeedConfigured.

	   Filter by speed.configured
	*/
	SpeedConfiguredQueryParameter *string

	/* SpeedMaximum.

	   Filter by speed.maximum
	*/
	SpeedMaximumQueryParameter *string

	/* State.

	   Filter by state
	*/
	StateQueryParameter *string

	/* StatisticsIopsRawOther.

	   Filter by statistics.iops_raw.other
	*/
	StatisticsIopsRawOtherQueryParameter *int64

	/* StatisticsIopsRawRead.

	   Filter by statistics.iops_raw.read
	*/
	StatisticsIopsRawReadQueryParameter *int64

	/* StatisticsIopsRawTotal.

	   Filter by statistics.iops_raw.total
	*/
	StatisticsIopsRawTotalQueryParameter *int64

	/* StatisticsIopsRawWrite.

	   Filter by statistics.iops_raw.write
	*/
	StatisticsIopsRawWriteQueryParameter *int64

	/* StatisticsLatencyRawOther.

	   Filter by statistics.latency_raw.other
	*/
	StatisticsLatencyRawOtherQueryParameter *int64

	/* StatisticsLatencyRawRead.

	   Filter by statistics.latency_raw.read
	*/
	StatisticsLatencyRawReadQueryParameter *int64

	/* StatisticsLatencyRawTotal.

	   Filter by statistics.latency_raw.total
	*/
	StatisticsLatencyRawTotalQueryParameter *int64

	/* StatisticsLatencyRawWrite.

	   Filter by statistics.latency_raw.write
	*/
	StatisticsLatencyRawWriteQueryParameter *int64

	/* StatisticsStatus.

	   Filter by statistics.status
	*/
	StatisticsStatusQueryParameter *string

	/* StatisticsThroughputRawRead.

	   Filter by statistics.throughput_raw.read
	*/
	StatisticsThroughputRawReadQueryParameter *int64

	/* StatisticsThroughputRawTotal.

	   Filter by statistics.throughput_raw.total
	*/
	StatisticsThroughputRawTotalQueryParameter *int64

	/* StatisticsThroughputRawWrite.

	   Filter by statistics.throughput_raw.write
	*/
	StatisticsThroughputRawWriteQueryParameter *int64

	/* StatisticsTimestamp.

	   Filter by statistics.timestamp
	*/
	StatisticsTimestampQueryParameter *string

	/* SupportedProtocols.

	   Filter by supported_protocols
	*/
	SupportedProtocolsQueryParameter *string

	/* TransceiverCapabilities.

	   Filter by transceiver.capabilities
	*/
	TransceiverCapabilitiesQueryParameter *int64

	/* TransceiverFormFactor.

	   Filter by transceiver.form_factor
	*/
	TransceiverFormFactorQueryParameter *string

	/* TransceiverManufacturer.

	   Filter by transceiver.manufacturer
	*/
	TransceiverManufacturerQueryParameter *string

	/* TransceiverPartNumber.

	   Filter by transceiver.part_number
	*/
	TransceiverPartNumberQueryParameter *string

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	/* Wwnn.

	   Filter by wwnn
	*/
	WwnnQueryParameter *string

	/* Wwpn.

	   Filter by wwpn
	*/
	WwpnQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the fc port collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcPortCollectionGetParams) WithDefaults() *FcPortCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the fc port collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcPortCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := FcPortCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the fc port collection get params
func (o *FcPortCollectionGetParams) WithTimeout(timeout time.Duration) *FcPortCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the fc port collection get params
func (o *FcPortCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the fc port collection get params
func (o *FcPortCollectionGetParams) WithContext(ctx context.Context) *FcPortCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the fc port collection get params
func (o *FcPortCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the fc port collection get params
func (o *FcPortCollectionGetParams) WithHTTPClient(client *http.Client) *FcPortCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the fc port collection get params
func (o *FcPortCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDescriptionQueryParameter adds the description to the fc port collection get params
func (o *FcPortCollectionGetParams) WithDescriptionQueryParameter(description *string) *FcPortCollectionGetParams {
	o.SetDescriptionQueryParameter(description)
	return o
}

// SetDescriptionQueryParameter adds the description to the fc port collection get params
func (o *FcPortCollectionGetParams) SetDescriptionQueryParameter(description *string) {
	o.DescriptionQueryParameter = description
}

// WithEnabledQueryParameter adds the enabled to the fc port collection get params
func (o *FcPortCollectionGetParams) WithEnabledQueryParameter(enabled *bool) *FcPortCollectionGetParams {
	o.SetEnabledQueryParameter(enabled)
	return o
}

// SetEnabledQueryParameter adds the enabled to the fc port collection get params
func (o *FcPortCollectionGetParams) SetEnabledQueryParameter(enabled *bool) {
	o.EnabledQueryParameter = enabled
}

// WithFabricConnectedQueryParameter adds the fabricConnected to the fc port collection get params
func (o *FcPortCollectionGetParams) WithFabricConnectedQueryParameter(fabricConnected *bool) *FcPortCollectionGetParams {
	o.SetFabricConnectedQueryParameter(fabricConnected)
	return o
}

// SetFabricConnectedQueryParameter adds the fabricConnected to the fc port collection get params
func (o *FcPortCollectionGetParams) SetFabricConnectedQueryParameter(fabricConnected *bool) {
	o.FabricConnectedQueryParameter = fabricConnected
}

// WithFabricConnectedSpeedQueryParameter adds the fabricConnectedSpeed to the fc port collection get params
func (o *FcPortCollectionGetParams) WithFabricConnectedSpeedQueryParameter(fabricConnectedSpeed *int64) *FcPortCollectionGetParams {
	o.SetFabricConnectedSpeedQueryParameter(fabricConnectedSpeed)
	return o
}

// SetFabricConnectedSpeedQueryParameter adds the fabricConnectedSpeed to the fc port collection get params
func (o *FcPortCollectionGetParams) SetFabricConnectedSpeedQueryParameter(fabricConnectedSpeed *int64) {
	o.FabricConnectedSpeedQueryParameter = fabricConnectedSpeed
}

// WithFabricNameQueryParameter adds the fabricName to the fc port collection get params
func (o *FcPortCollectionGetParams) WithFabricNameQueryParameter(fabricName *string) *FcPortCollectionGetParams {
	o.SetFabricNameQueryParameter(fabricName)
	return o
}

// SetFabricNameQueryParameter adds the fabricName to the fc port collection get params
func (o *FcPortCollectionGetParams) SetFabricNameQueryParameter(fabricName *string) {
	o.FabricNameQueryParameter = fabricName
}

// WithFabricPortAddressQueryParameter adds the fabricPortAddress to the fc port collection get params
func (o *FcPortCollectionGetParams) WithFabricPortAddressQueryParameter(fabricPortAddress *string) *FcPortCollectionGetParams {
	o.SetFabricPortAddressQueryParameter(fabricPortAddress)
	return o
}

// SetFabricPortAddressQueryParameter adds the fabricPortAddress to the fc port collection get params
func (o *FcPortCollectionGetParams) SetFabricPortAddressQueryParameter(fabricPortAddress *string) {
	o.FabricPortAddressQueryParameter = fabricPortAddress
}

// WithFabricSwitchPortQueryParameter adds the fabricSwitchPort to the fc port collection get params
func (o *FcPortCollectionGetParams) WithFabricSwitchPortQueryParameter(fabricSwitchPort *string) *FcPortCollectionGetParams {
	o.SetFabricSwitchPortQueryParameter(fabricSwitchPort)
	return o
}

// SetFabricSwitchPortQueryParameter adds the fabricSwitchPort to the fc port collection get params
func (o *FcPortCollectionGetParams) SetFabricSwitchPortQueryParameter(fabricSwitchPort *string) {
	o.FabricSwitchPortQueryParameter = fabricSwitchPort
}

// WithFieldsQueryParameter adds the fields to the fc port collection get params
func (o *FcPortCollectionGetParams) WithFieldsQueryParameter(fields []string) *FcPortCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the fc port collection get params
func (o *FcPortCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithInterfaceCountQueryParameter adds the interfaceCount to the fc port collection get params
func (o *FcPortCollectionGetParams) WithInterfaceCountQueryParameter(interfaceCount *int64) *FcPortCollectionGetParams {
	o.SetInterfaceCountQueryParameter(interfaceCount)
	return o
}

// SetInterfaceCountQueryParameter adds the interfaceCount to the fc port collection get params
func (o *FcPortCollectionGetParams) SetInterfaceCountQueryParameter(interfaceCount *int64) {
	o.InterfaceCountQueryParameter = interfaceCount
}

// WithMaxRecordsQueryParameter adds the maxRecords to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *FcPortCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithMetricDurationQueryParameter adds the metricDuration to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricDurationQueryParameter(metricDuration *string) *FcPortCollectionGetParams {
	o.SetMetricDurationQueryParameter(metricDuration)
	return o
}

// SetMetricDurationQueryParameter adds the metricDuration to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricDurationQueryParameter(metricDuration *string) {
	o.MetricDurationQueryParameter = metricDuration
}

// WithMetricIopsOtherQueryParameter adds the metricIopsOther to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricIopsOtherQueryParameter(metricIopsOther *int64) *FcPortCollectionGetParams {
	o.SetMetricIopsOtherQueryParameter(metricIopsOther)
	return o
}

// SetMetricIopsOtherQueryParameter adds the metricIopsOther to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricIopsOtherQueryParameter(metricIopsOther *int64) {
	o.MetricIopsOtherQueryParameter = metricIopsOther
}

// WithMetricIopsReadQueryParameter adds the metricIopsRead to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricIopsReadQueryParameter(metricIopsRead *int64) *FcPortCollectionGetParams {
	o.SetMetricIopsReadQueryParameter(metricIopsRead)
	return o
}

// SetMetricIopsReadQueryParameter adds the metricIopsRead to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricIopsReadQueryParameter(metricIopsRead *int64) {
	o.MetricIopsReadQueryParameter = metricIopsRead
}

// WithMetricIopsTotalQueryParameter adds the metricIopsTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricIopsTotalQueryParameter(metricIopsTotal *int64) *FcPortCollectionGetParams {
	o.SetMetricIopsTotalQueryParameter(metricIopsTotal)
	return o
}

// SetMetricIopsTotalQueryParameter adds the metricIopsTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricIopsTotalQueryParameter(metricIopsTotal *int64) {
	o.MetricIopsTotalQueryParameter = metricIopsTotal
}

// WithMetricIopsWriteQueryParameter adds the metricIopsWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricIopsWriteQueryParameter(metricIopsWrite *int64) *FcPortCollectionGetParams {
	o.SetMetricIopsWriteQueryParameter(metricIopsWrite)
	return o
}

// SetMetricIopsWriteQueryParameter adds the metricIopsWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricIopsWriteQueryParameter(metricIopsWrite *int64) {
	o.MetricIopsWriteQueryParameter = metricIopsWrite
}

// WithMetricLatencyOtherQueryParameter adds the metricLatencyOther to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricLatencyOtherQueryParameter(metricLatencyOther *int64) *FcPortCollectionGetParams {
	o.SetMetricLatencyOtherQueryParameter(metricLatencyOther)
	return o
}

// SetMetricLatencyOtherQueryParameter adds the metricLatencyOther to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricLatencyOtherQueryParameter(metricLatencyOther *int64) {
	o.MetricLatencyOtherQueryParameter = metricLatencyOther
}

// WithMetricLatencyReadQueryParameter adds the metricLatencyRead to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricLatencyReadQueryParameter(metricLatencyRead *int64) *FcPortCollectionGetParams {
	o.SetMetricLatencyReadQueryParameter(metricLatencyRead)
	return o
}

// SetMetricLatencyReadQueryParameter adds the metricLatencyRead to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricLatencyReadQueryParameter(metricLatencyRead *int64) {
	o.MetricLatencyReadQueryParameter = metricLatencyRead
}

// WithMetricLatencyTotalQueryParameter adds the metricLatencyTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricLatencyTotalQueryParameter(metricLatencyTotal *int64) *FcPortCollectionGetParams {
	o.SetMetricLatencyTotalQueryParameter(metricLatencyTotal)
	return o
}

// SetMetricLatencyTotalQueryParameter adds the metricLatencyTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricLatencyTotalQueryParameter(metricLatencyTotal *int64) {
	o.MetricLatencyTotalQueryParameter = metricLatencyTotal
}

// WithMetricLatencyWriteQueryParameter adds the metricLatencyWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricLatencyWriteQueryParameter(metricLatencyWrite *int64) *FcPortCollectionGetParams {
	o.SetMetricLatencyWriteQueryParameter(metricLatencyWrite)
	return o
}

// SetMetricLatencyWriteQueryParameter adds the metricLatencyWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricLatencyWriteQueryParameter(metricLatencyWrite *int64) {
	o.MetricLatencyWriteQueryParameter = metricLatencyWrite
}

// WithMetricStatusQueryParameter adds the metricStatus to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricStatusQueryParameter(metricStatus *string) *FcPortCollectionGetParams {
	o.SetMetricStatusQueryParameter(metricStatus)
	return o
}

// SetMetricStatusQueryParameter adds the metricStatus to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricStatusQueryParameter(metricStatus *string) {
	o.MetricStatusQueryParameter = metricStatus
}

// WithMetricThroughputReadQueryParameter adds the metricThroughputRead to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricThroughputReadQueryParameter(metricThroughputRead *int64) *FcPortCollectionGetParams {
	o.SetMetricThroughputReadQueryParameter(metricThroughputRead)
	return o
}

// SetMetricThroughputReadQueryParameter adds the metricThroughputRead to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricThroughputReadQueryParameter(metricThroughputRead *int64) {
	o.MetricThroughputReadQueryParameter = metricThroughputRead
}

// WithMetricThroughputTotalQueryParameter adds the metricThroughputTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricThroughputTotalQueryParameter(metricThroughputTotal *int64) *FcPortCollectionGetParams {
	o.SetMetricThroughputTotalQueryParameter(metricThroughputTotal)
	return o
}

// SetMetricThroughputTotalQueryParameter adds the metricThroughputTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricThroughputTotalQueryParameter(metricThroughputTotal *int64) {
	o.MetricThroughputTotalQueryParameter = metricThroughputTotal
}

// WithMetricThroughputWriteQueryParameter adds the metricThroughputWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricThroughputWriteQueryParameter(metricThroughputWrite *int64) *FcPortCollectionGetParams {
	o.SetMetricThroughputWriteQueryParameter(metricThroughputWrite)
	return o
}

// SetMetricThroughputWriteQueryParameter adds the metricThroughputWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricThroughputWriteQueryParameter(metricThroughputWrite *int64) {
	o.MetricThroughputWriteQueryParameter = metricThroughputWrite
}

// WithMetricTimestampQueryParameter adds the metricTimestamp to the fc port collection get params
func (o *FcPortCollectionGetParams) WithMetricTimestampQueryParameter(metricTimestamp *string) *FcPortCollectionGetParams {
	o.SetMetricTimestampQueryParameter(metricTimestamp)
	return o
}

// SetMetricTimestampQueryParameter adds the metricTimestamp to the fc port collection get params
func (o *FcPortCollectionGetParams) SetMetricTimestampQueryParameter(metricTimestamp *string) {
	o.MetricTimestampQueryParameter = metricTimestamp
}

// WithNameQueryParameter adds the name to the fc port collection get params
func (o *FcPortCollectionGetParams) WithNameQueryParameter(name *string) *FcPortCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the fc port collection get params
func (o *FcPortCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithNodeNameQueryParameter adds the nodeName to the fc port collection get params
func (o *FcPortCollectionGetParams) WithNodeNameQueryParameter(nodeName *string) *FcPortCollectionGetParams {
	o.SetNodeNameQueryParameter(nodeName)
	return o
}

// SetNodeNameQueryParameter adds the nodeName to the fc port collection get params
func (o *FcPortCollectionGetParams) SetNodeNameQueryParameter(nodeName *string) {
	o.NodeNameQueryParameter = nodeName
}

// WithNodeUUIDQueryParameter adds the nodeUUID to the fc port collection get params
func (o *FcPortCollectionGetParams) WithNodeUUIDQueryParameter(nodeUUID *string) *FcPortCollectionGetParams {
	o.SetNodeUUIDQueryParameter(nodeUUID)
	return o
}

// SetNodeUUIDQueryParameter adds the nodeUuid to the fc port collection get params
func (o *FcPortCollectionGetParams) SetNodeUUIDQueryParameter(nodeUUID *string) {
	o.NodeUUIDQueryParameter = nodeUUID
}

// WithOrderByQueryParameter adds the orderBy to the fc port collection get params
func (o *FcPortCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *FcPortCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the fc port collection get params
func (o *FcPortCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPhysicalProtocolQueryParameter adds the physicalProtocol to the fc port collection get params
func (o *FcPortCollectionGetParams) WithPhysicalProtocolQueryParameter(physicalProtocol *string) *FcPortCollectionGetParams {
	o.SetPhysicalProtocolQueryParameter(physicalProtocol)
	return o
}

// SetPhysicalProtocolQueryParameter adds the physicalProtocol to the fc port collection get params
func (o *FcPortCollectionGetParams) SetPhysicalProtocolQueryParameter(physicalProtocol *string) {
	o.PhysicalProtocolQueryParameter = physicalProtocol
}

// WithReturnRecordsQueryParameter adds the returnRecords to the fc port collection get params
func (o *FcPortCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *FcPortCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the fc port collection get params
func (o *FcPortCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the fc port collection get params
func (o *FcPortCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *FcPortCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the fc port collection get params
func (o *FcPortCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSpeedConfiguredQueryParameter adds the speedConfigured to the fc port collection get params
func (o *FcPortCollectionGetParams) WithSpeedConfiguredQueryParameter(speedConfigured *string) *FcPortCollectionGetParams {
	o.SetSpeedConfiguredQueryParameter(speedConfigured)
	return o
}

// SetSpeedConfiguredQueryParameter adds the speedConfigured to the fc port collection get params
func (o *FcPortCollectionGetParams) SetSpeedConfiguredQueryParameter(speedConfigured *string) {
	o.SpeedConfiguredQueryParameter = speedConfigured
}

// WithSpeedMaximumQueryParameter adds the speedMaximum to the fc port collection get params
func (o *FcPortCollectionGetParams) WithSpeedMaximumQueryParameter(speedMaximum *string) *FcPortCollectionGetParams {
	o.SetSpeedMaximumQueryParameter(speedMaximum)
	return o
}

// SetSpeedMaximumQueryParameter adds the speedMaximum to the fc port collection get params
func (o *FcPortCollectionGetParams) SetSpeedMaximumQueryParameter(speedMaximum *string) {
	o.SpeedMaximumQueryParameter = speedMaximum
}

// WithStateQueryParameter adds the state to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStateQueryParameter(state *string) *FcPortCollectionGetParams {
	o.SetStateQueryParameter(state)
	return o
}

// SetStateQueryParameter adds the state to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStateQueryParameter(state *string) {
	o.StateQueryParameter = state
}

// WithStatisticsIopsRawOtherQueryParameter adds the statisticsIopsRawOther to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsIopsRawOtherQueryParameter(statisticsIopsRawOther *int64) *FcPortCollectionGetParams {
	o.SetStatisticsIopsRawOtherQueryParameter(statisticsIopsRawOther)
	return o
}

// SetStatisticsIopsRawOtherQueryParameter adds the statisticsIopsRawOther to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsIopsRawOtherQueryParameter(statisticsIopsRawOther *int64) {
	o.StatisticsIopsRawOtherQueryParameter = statisticsIopsRawOther
}

// WithStatisticsIopsRawReadQueryParameter adds the statisticsIopsRawRead to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsIopsRawReadQueryParameter(statisticsIopsRawRead *int64) *FcPortCollectionGetParams {
	o.SetStatisticsIopsRawReadQueryParameter(statisticsIopsRawRead)
	return o
}

// SetStatisticsIopsRawReadQueryParameter adds the statisticsIopsRawRead to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsIopsRawReadQueryParameter(statisticsIopsRawRead *int64) {
	o.StatisticsIopsRawReadQueryParameter = statisticsIopsRawRead
}

// WithStatisticsIopsRawTotalQueryParameter adds the statisticsIopsRawTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsIopsRawTotalQueryParameter(statisticsIopsRawTotal *int64) *FcPortCollectionGetParams {
	o.SetStatisticsIopsRawTotalQueryParameter(statisticsIopsRawTotal)
	return o
}

// SetStatisticsIopsRawTotalQueryParameter adds the statisticsIopsRawTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsIopsRawTotalQueryParameter(statisticsIopsRawTotal *int64) {
	o.StatisticsIopsRawTotalQueryParameter = statisticsIopsRawTotal
}

// WithStatisticsIopsRawWriteQueryParameter adds the statisticsIopsRawWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsIopsRawWriteQueryParameter(statisticsIopsRawWrite *int64) *FcPortCollectionGetParams {
	o.SetStatisticsIopsRawWriteQueryParameter(statisticsIopsRawWrite)
	return o
}

// SetStatisticsIopsRawWriteQueryParameter adds the statisticsIopsRawWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsIopsRawWriteQueryParameter(statisticsIopsRawWrite *int64) {
	o.StatisticsIopsRawWriteQueryParameter = statisticsIopsRawWrite
}

// WithStatisticsLatencyRawOtherQueryParameter adds the statisticsLatencyRawOther to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsLatencyRawOtherQueryParameter(statisticsLatencyRawOther *int64) *FcPortCollectionGetParams {
	o.SetStatisticsLatencyRawOtherQueryParameter(statisticsLatencyRawOther)
	return o
}

// SetStatisticsLatencyRawOtherQueryParameter adds the statisticsLatencyRawOther to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsLatencyRawOtherQueryParameter(statisticsLatencyRawOther *int64) {
	o.StatisticsLatencyRawOtherQueryParameter = statisticsLatencyRawOther
}

// WithStatisticsLatencyRawReadQueryParameter adds the statisticsLatencyRawRead to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsLatencyRawReadQueryParameter(statisticsLatencyRawRead *int64) *FcPortCollectionGetParams {
	o.SetStatisticsLatencyRawReadQueryParameter(statisticsLatencyRawRead)
	return o
}

// SetStatisticsLatencyRawReadQueryParameter adds the statisticsLatencyRawRead to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsLatencyRawReadQueryParameter(statisticsLatencyRawRead *int64) {
	o.StatisticsLatencyRawReadQueryParameter = statisticsLatencyRawRead
}

// WithStatisticsLatencyRawTotalQueryParameter adds the statisticsLatencyRawTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsLatencyRawTotalQueryParameter(statisticsLatencyRawTotal *int64) *FcPortCollectionGetParams {
	o.SetStatisticsLatencyRawTotalQueryParameter(statisticsLatencyRawTotal)
	return o
}

// SetStatisticsLatencyRawTotalQueryParameter adds the statisticsLatencyRawTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsLatencyRawTotalQueryParameter(statisticsLatencyRawTotal *int64) {
	o.StatisticsLatencyRawTotalQueryParameter = statisticsLatencyRawTotal
}

// WithStatisticsLatencyRawWriteQueryParameter adds the statisticsLatencyRawWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsLatencyRawWriteQueryParameter(statisticsLatencyRawWrite *int64) *FcPortCollectionGetParams {
	o.SetStatisticsLatencyRawWriteQueryParameter(statisticsLatencyRawWrite)
	return o
}

// SetStatisticsLatencyRawWriteQueryParameter adds the statisticsLatencyRawWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsLatencyRawWriteQueryParameter(statisticsLatencyRawWrite *int64) {
	o.StatisticsLatencyRawWriteQueryParameter = statisticsLatencyRawWrite
}

// WithStatisticsStatusQueryParameter adds the statisticsStatus to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsStatusQueryParameter(statisticsStatus *string) *FcPortCollectionGetParams {
	o.SetStatisticsStatusQueryParameter(statisticsStatus)
	return o
}

// SetStatisticsStatusQueryParameter adds the statisticsStatus to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsStatusQueryParameter(statisticsStatus *string) {
	o.StatisticsStatusQueryParameter = statisticsStatus
}

// WithStatisticsThroughputRawReadQueryParameter adds the statisticsThroughputRawRead to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsThroughputRawReadQueryParameter(statisticsThroughputRawRead *int64) *FcPortCollectionGetParams {
	o.SetStatisticsThroughputRawReadQueryParameter(statisticsThroughputRawRead)
	return o
}

// SetStatisticsThroughputRawReadQueryParameter adds the statisticsThroughputRawRead to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsThroughputRawReadQueryParameter(statisticsThroughputRawRead *int64) {
	o.StatisticsThroughputRawReadQueryParameter = statisticsThroughputRawRead
}

// WithStatisticsThroughputRawTotalQueryParameter adds the statisticsThroughputRawTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsThroughputRawTotalQueryParameter(statisticsThroughputRawTotal *int64) *FcPortCollectionGetParams {
	o.SetStatisticsThroughputRawTotalQueryParameter(statisticsThroughputRawTotal)
	return o
}

// SetStatisticsThroughputRawTotalQueryParameter adds the statisticsThroughputRawTotal to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsThroughputRawTotalQueryParameter(statisticsThroughputRawTotal *int64) {
	o.StatisticsThroughputRawTotalQueryParameter = statisticsThroughputRawTotal
}

// WithStatisticsThroughputRawWriteQueryParameter adds the statisticsThroughputRawWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsThroughputRawWriteQueryParameter(statisticsThroughputRawWrite *int64) *FcPortCollectionGetParams {
	o.SetStatisticsThroughputRawWriteQueryParameter(statisticsThroughputRawWrite)
	return o
}

// SetStatisticsThroughputRawWriteQueryParameter adds the statisticsThroughputRawWrite to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsThroughputRawWriteQueryParameter(statisticsThroughputRawWrite *int64) {
	o.StatisticsThroughputRawWriteQueryParameter = statisticsThroughputRawWrite
}

// WithStatisticsTimestampQueryParameter adds the statisticsTimestamp to the fc port collection get params
func (o *FcPortCollectionGetParams) WithStatisticsTimestampQueryParameter(statisticsTimestamp *string) *FcPortCollectionGetParams {
	o.SetStatisticsTimestampQueryParameter(statisticsTimestamp)
	return o
}

// SetStatisticsTimestampQueryParameter adds the statisticsTimestamp to the fc port collection get params
func (o *FcPortCollectionGetParams) SetStatisticsTimestampQueryParameter(statisticsTimestamp *string) {
	o.StatisticsTimestampQueryParameter = statisticsTimestamp
}

// WithSupportedProtocolsQueryParameter adds the supportedProtocols to the fc port collection get params
func (o *FcPortCollectionGetParams) WithSupportedProtocolsQueryParameter(supportedProtocols *string) *FcPortCollectionGetParams {
	o.SetSupportedProtocolsQueryParameter(supportedProtocols)
	return o
}

// SetSupportedProtocolsQueryParameter adds the supportedProtocols to the fc port collection get params
func (o *FcPortCollectionGetParams) SetSupportedProtocolsQueryParameter(supportedProtocols *string) {
	o.SupportedProtocolsQueryParameter = supportedProtocols
}

// WithTransceiverCapabilitiesQueryParameter adds the transceiverCapabilities to the fc port collection get params
func (o *FcPortCollectionGetParams) WithTransceiverCapabilitiesQueryParameter(transceiverCapabilities *int64) *FcPortCollectionGetParams {
	o.SetTransceiverCapabilitiesQueryParameter(transceiverCapabilities)
	return o
}

// SetTransceiverCapabilitiesQueryParameter adds the transceiverCapabilities to the fc port collection get params
func (o *FcPortCollectionGetParams) SetTransceiverCapabilitiesQueryParameter(transceiverCapabilities *int64) {
	o.TransceiverCapabilitiesQueryParameter = transceiverCapabilities
}

// WithTransceiverFormFactorQueryParameter adds the transceiverFormFactor to the fc port collection get params
func (o *FcPortCollectionGetParams) WithTransceiverFormFactorQueryParameter(transceiverFormFactor *string) *FcPortCollectionGetParams {
	o.SetTransceiverFormFactorQueryParameter(transceiverFormFactor)
	return o
}

// SetTransceiverFormFactorQueryParameter adds the transceiverFormFactor to the fc port collection get params
func (o *FcPortCollectionGetParams) SetTransceiverFormFactorQueryParameter(transceiverFormFactor *string) {
	o.TransceiverFormFactorQueryParameter = transceiverFormFactor
}

// WithTransceiverManufacturerQueryParameter adds the transceiverManufacturer to the fc port collection get params
func (o *FcPortCollectionGetParams) WithTransceiverManufacturerQueryParameter(transceiverManufacturer *string) *FcPortCollectionGetParams {
	o.SetTransceiverManufacturerQueryParameter(transceiverManufacturer)
	return o
}

// SetTransceiverManufacturerQueryParameter adds the transceiverManufacturer to the fc port collection get params
func (o *FcPortCollectionGetParams) SetTransceiverManufacturerQueryParameter(transceiverManufacturer *string) {
	o.TransceiverManufacturerQueryParameter = transceiverManufacturer
}

// WithTransceiverPartNumberQueryParameter adds the transceiverPartNumber to the fc port collection get params
func (o *FcPortCollectionGetParams) WithTransceiverPartNumberQueryParameter(transceiverPartNumber *string) *FcPortCollectionGetParams {
	o.SetTransceiverPartNumberQueryParameter(transceiverPartNumber)
	return o
}

// SetTransceiverPartNumberQueryParameter adds the transceiverPartNumber to the fc port collection get params
func (o *FcPortCollectionGetParams) SetTransceiverPartNumberQueryParameter(transceiverPartNumber *string) {
	o.TransceiverPartNumberQueryParameter = transceiverPartNumber
}

// WithUUIDQueryParameter adds the uuid to the fc port collection get params
func (o *FcPortCollectionGetParams) WithUUIDQueryParameter(uuid *string) *FcPortCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the fc port collection get params
func (o *FcPortCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WithWwnnQueryParameter adds the wwnn to the fc port collection get params
func (o *FcPortCollectionGetParams) WithWwnnQueryParameter(wwnn *string) *FcPortCollectionGetParams {
	o.SetWwnnQueryParameter(wwnn)
	return o
}

// SetWwnnQueryParameter adds the wwnn to the fc port collection get params
func (o *FcPortCollectionGetParams) SetWwnnQueryParameter(wwnn *string) {
	o.WwnnQueryParameter = wwnn
}

// WithWwpnQueryParameter adds the wwpn to the fc port collection get params
func (o *FcPortCollectionGetParams) WithWwpnQueryParameter(wwpn *string) *FcPortCollectionGetParams {
	o.SetWwpnQueryParameter(wwpn)
	return o
}

// SetWwpnQueryParameter adds the wwpn to the fc port collection get params
func (o *FcPortCollectionGetParams) SetWwpnQueryParameter(wwpn *string) {
	o.WwpnQueryParameter = wwpn
}

// WriteToRequest writes these params to a swagger request
func (o *FcPortCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DescriptionQueryParameter != nil {

		// query param description
		var qrDescription string

		if o.DescriptionQueryParameter != nil {
			qrDescription = *o.DescriptionQueryParameter
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.EnabledQueryParameter != nil {

		// query param enabled
		var qrEnabled bool

		if o.EnabledQueryParameter != nil {
			qrEnabled = *o.EnabledQueryParameter
		}
		qEnabled := swag.FormatBool(qrEnabled)
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.FabricConnectedQueryParameter != nil {

		// query param fabric.connected
		var qrFabricConnected bool

		if o.FabricConnectedQueryParameter != nil {
			qrFabricConnected = *o.FabricConnectedQueryParameter
		}
		qFabricConnected := swag.FormatBool(qrFabricConnected)
		if qFabricConnected != "" {

			if err := r.SetQueryParam("fabric.connected", qFabricConnected); err != nil {
				return err
			}
		}
	}

	if o.FabricConnectedSpeedQueryParameter != nil {

		// query param fabric.connected_speed
		var qrFabricConnectedSpeed int64

		if o.FabricConnectedSpeedQueryParameter != nil {
			qrFabricConnectedSpeed = *o.FabricConnectedSpeedQueryParameter
		}
		qFabricConnectedSpeed := swag.FormatInt64(qrFabricConnectedSpeed)
		if qFabricConnectedSpeed != "" {

			if err := r.SetQueryParam("fabric.connected_speed", qFabricConnectedSpeed); err != nil {
				return err
			}
		}
	}

	if o.FabricNameQueryParameter != nil {

		// query param fabric.name
		var qrFabricName string

		if o.FabricNameQueryParameter != nil {
			qrFabricName = *o.FabricNameQueryParameter
		}
		qFabricName := qrFabricName
		if qFabricName != "" {

			if err := r.SetQueryParam("fabric.name", qFabricName); err != nil {
				return err
			}
		}
	}

	if o.FabricPortAddressQueryParameter != nil {

		// query param fabric.port_address
		var qrFabricPortAddress string

		if o.FabricPortAddressQueryParameter != nil {
			qrFabricPortAddress = *o.FabricPortAddressQueryParameter
		}
		qFabricPortAddress := qrFabricPortAddress
		if qFabricPortAddress != "" {

			if err := r.SetQueryParam("fabric.port_address", qFabricPortAddress); err != nil {
				return err
			}
		}
	}

	if o.FabricSwitchPortQueryParameter != nil {

		// query param fabric.switch_port
		var qrFabricSwitchPort string

		if o.FabricSwitchPortQueryParameter != nil {
			qrFabricSwitchPort = *o.FabricSwitchPortQueryParameter
		}
		qFabricSwitchPort := qrFabricSwitchPort
		if qFabricSwitchPort != "" {

			if err := r.SetQueryParam("fabric.switch_port", qFabricSwitchPort); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.InterfaceCountQueryParameter != nil {

		// query param interface_count
		var qrInterfaceCount int64

		if o.InterfaceCountQueryParameter != nil {
			qrInterfaceCount = *o.InterfaceCountQueryParameter
		}
		qInterfaceCount := swag.FormatInt64(qrInterfaceCount)
		if qInterfaceCount != "" {

			if err := r.SetQueryParam("interface_count", qInterfaceCount); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.MetricDurationQueryParameter != nil {

		// query param metric.duration
		var qrMetricDuration string

		if o.MetricDurationQueryParameter != nil {
			qrMetricDuration = *o.MetricDurationQueryParameter
		}
		qMetricDuration := qrMetricDuration
		if qMetricDuration != "" {

			if err := r.SetQueryParam("metric.duration", qMetricDuration); err != nil {
				return err
			}
		}
	}

	if o.MetricIopsOtherQueryParameter != nil {

		// query param metric.iops.other
		var qrMetricIopsOther int64

		if o.MetricIopsOtherQueryParameter != nil {
			qrMetricIopsOther = *o.MetricIopsOtherQueryParameter
		}
		qMetricIopsOther := swag.FormatInt64(qrMetricIopsOther)
		if qMetricIopsOther != "" {

			if err := r.SetQueryParam("metric.iops.other", qMetricIopsOther); err != nil {
				return err
			}
		}
	}

	if o.MetricIopsReadQueryParameter != nil {

		// query param metric.iops.read
		var qrMetricIopsRead int64

		if o.MetricIopsReadQueryParameter != nil {
			qrMetricIopsRead = *o.MetricIopsReadQueryParameter
		}
		qMetricIopsRead := swag.FormatInt64(qrMetricIopsRead)
		if qMetricIopsRead != "" {

			if err := r.SetQueryParam("metric.iops.read", qMetricIopsRead); err != nil {
				return err
			}
		}
	}

	if o.MetricIopsTotalQueryParameter != nil {

		// query param metric.iops.total
		var qrMetricIopsTotal int64

		if o.MetricIopsTotalQueryParameter != nil {
			qrMetricIopsTotal = *o.MetricIopsTotalQueryParameter
		}
		qMetricIopsTotal := swag.FormatInt64(qrMetricIopsTotal)
		if qMetricIopsTotal != "" {

			if err := r.SetQueryParam("metric.iops.total", qMetricIopsTotal); err != nil {
				return err
			}
		}
	}

	if o.MetricIopsWriteQueryParameter != nil {

		// query param metric.iops.write
		var qrMetricIopsWrite int64

		if o.MetricIopsWriteQueryParameter != nil {
			qrMetricIopsWrite = *o.MetricIopsWriteQueryParameter
		}
		qMetricIopsWrite := swag.FormatInt64(qrMetricIopsWrite)
		if qMetricIopsWrite != "" {

			if err := r.SetQueryParam("metric.iops.write", qMetricIopsWrite); err != nil {
				return err
			}
		}
	}

	if o.MetricLatencyOtherQueryParameter != nil {

		// query param metric.latency.other
		var qrMetricLatencyOther int64

		if o.MetricLatencyOtherQueryParameter != nil {
			qrMetricLatencyOther = *o.MetricLatencyOtherQueryParameter
		}
		qMetricLatencyOther := swag.FormatInt64(qrMetricLatencyOther)
		if qMetricLatencyOther != "" {

			if err := r.SetQueryParam("metric.latency.other", qMetricLatencyOther); err != nil {
				return err
			}
		}
	}

	if o.MetricLatencyReadQueryParameter != nil {

		// query param metric.latency.read
		var qrMetricLatencyRead int64

		if o.MetricLatencyReadQueryParameter != nil {
			qrMetricLatencyRead = *o.MetricLatencyReadQueryParameter
		}
		qMetricLatencyRead := swag.FormatInt64(qrMetricLatencyRead)
		if qMetricLatencyRead != "" {

			if err := r.SetQueryParam("metric.latency.read", qMetricLatencyRead); err != nil {
				return err
			}
		}
	}

	if o.MetricLatencyTotalQueryParameter != nil {

		// query param metric.latency.total
		var qrMetricLatencyTotal int64

		if o.MetricLatencyTotalQueryParameter != nil {
			qrMetricLatencyTotal = *o.MetricLatencyTotalQueryParameter
		}
		qMetricLatencyTotal := swag.FormatInt64(qrMetricLatencyTotal)
		if qMetricLatencyTotal != "" {

			if err := r.SetQueryParam("metric.latency.total", qMetricLatencyTotal); err != nil {
				return err
			}
		}
	}

	if o.MetricLatencyWriteQueryParameter != nil {

		// query param metric.latency.write
		var qrMetricLatencyWrite int64

		if o.MetricLatencyWriteQueryParameter != nil {
			qrMetricLatencyWrite = *o.MetricLatencyWriteQueryParameter
		}
		qMetricLatencyWrite := swag.FormatInt64(qrMetricLatencyWrite)
		if qMetricLatencyWrite != "" {

			if err := r.SetQueryParam("metric.latency.write", qMetricLatencyWrite); err != nil {
				return err
			}
		}
	}

	if o.MetricStatusQueryParameter != nil {

		// query param metric.status
		var qrMetricStatus string

		if o.MetricStatusQueryParameter != nil {
			qrMetricStatus = *o.MetricStatusQueryParameter
		}
		qMetricStatus := qrMetricStatus
		if qMetricStatus != "" {

			if err := r.SetQueryParam("metric.status", qMetricStatus); err != nil {
				return err
			}
		}
	}

	if o.MetricThroughputReadQueryParameter != nil {

		// query param metric.throughput.read
		var qrMetricThroughputRead int64

		if o.MetricThroughputReadQueryParameter != nil {
			qrMetricThroughputRead = *o.MetricThroughputReadQueryParameter
		}
		qMetricThroughputRead := swag.FormatInt64(qrMetricThroughputRead)
		if qMetricThroughputRead != "" {

			if err := r.SetQueryParam("metric.throughput.read", qMetricThroughputRead); err != nil {
				return err
			}
		}
	}

	if o.MetricThroughputTotalQueryParameter != nil {

		// query param metric.throughput.total
		var qrMetricThroughputTotal int64

		if o.MetricThroughputTotalQueryParameter != nil {
			qrMetricThroughputTotal = *o.MetricThroughputTotalQueryParameter
		}
		qMetricThroughputTotal := swag.FormatInt64(qrMetricThroughputTotal)
		if qMetricThroughputTotal != "" {

			if err := r.SetQueryParam("metric.throughput.total", qMetricThroughputTotal); err != nil {
				return err
			}
		}
	}

	if o.MetricThroughputWriteQueryParameter != nil {

		// query param metric.throughput.write
		var qrMetricThroughputWrite int64

		if o.MetricThroughputWriteQueryParameter != nil {
			qrMetricThroughputWrite = *o.MetricThroughputWriteQueryParameter
		}
		qMetricThroughputWrite := swag.FormatInt64(qrMetricThroughputWrite)
		if qMetricThroughputWrite != "" {

			if err := r.SetQueryParam("metric.throughput.write", qMetricThroughputWrite); err != nil {
				return err
			}
		}
	}

	if o.MetricTimestampQueryParameter != nil {

		// query param metric.timestamp
		var qrMetricTimestamp string

		if o.MetricTimestampQueryParameter != nil {
			qrMetricTimestamp = *o.MetricTimestampQueryParameter
		}
		qMetricTimestamp := qrMetricTimestamp
		if qMetricTimestamp != "" {

			if err := r.SetQueryParam("metric.timestamp", qMetricTimestamp); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NodeNameQueryParameter != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeNameQueryParameter != nil {
			qrNodeName = *o.NodeNameQueryParameter
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUIDQueryParameter != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUIDQueryParameter != nil {
			qrNodeUUID = *o.NodeUUIDQueryParameter
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PhysicalProtocolQueryParameter != nil {

		// query param physical_protocol
		var qrPhysicalProtocol string

		if o.PhysicalProtocolQueryParameter != nil {
			qrPhysicalProtocol = *o.PhysicalProtocolQueryParameter
		}
		qPhysicalProtocol := qrPhysicalProtocol
		if qPhysicalProtocol != "" {

			if err := r.SetQueryParam("physical_protocol", qPhysicalProtocol); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SpeedConfiguredQueryParameter != nil {

		// query param speed.configured
		var qrSpeedConfigured string

		if o.SpeedConfiguredQueryParameter != nil {
			qrSpeedConfigured = *o.SpeedConfiguredQueryParameter
		}
		qSpeedConfigured := qrSpeedConfigured
		if qSpeedConfigured != "" {

			if err := r.SetQueryParam("speed.configured", qSpeedConfigured); err != nil {
				return err
			}
		}
	}

	if o.SpeedMaximumQueryParameter != nil {

		// query param speed.maximum
		var qrSpeedMaximum string

		if o.SpeedMaximumQueryParameter != nil {
			qrSpeedMaximum = *o.SpeedMaximumQueryParameter
		}
		qSpeedMaximum := qrSpeedMaximum
		if qSpeedMaximum != "" {

			if err := r.SetQueryParam("speed.maximum", qSpeedMaximum); err != nil {
				return err
			}
		}
	}

	if o.StateQueryParameter != nil {

		// query param state
		var qrState string

		if o.StateQueryParameter != nil {
			qrState = *o.StateQueryParameter
		}
		qState := qrState
		if qState != "" {

			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}
	}

	if o.StatisticsIopsRawOtherQueryParameter != nil {

		// query param statistics.iops_raw.other
		var qrStatisticsIopsRawOther int64

		if o.StatisticsIopsRawOtherQueryParameter != nil {
			qrStatisticsIopsRawOther = *o.StatisticsIopsRawOtherQueryParameter
		}
		qStatisticsIopsRawOther := swag.FormatInt64(qrStatisticsIopsRawOther)
		if qStatisticsIopsRawOther != "" {

			if err := r.SetQueryParam("statistics.iops_raw.other", qStatisticsIopsRawOther); err != nil {
				return err
			}
		}
	}

	if o.StatisticsIopsRawReadQueryParameter != nil {

		// query param statistics.iops_raw.read
		var qrStatisticsIopsRawRead int64

		if o.StatisticsIopsRawReadQueryParameter != nil {
			qrStatisticsIopsRawRead = *o.StatisticsIopsRawReadQueryParameter
		}
		qStatisticsIopsRawRead := swag.FormatInt64(qrStatisticsIopsRawRead)
		if qStatisticsIopsRawRead != "" {

			if err := r.SetQueryParam("statistics.iops_raw.read", qStatisticsIopsRawRead); err != nil {
				return err
			}
		}
	}

	if o.StatisticsIopsRawTotalQueryParameter != nil {

		// query param statistics.iops_raw.total
		var qrStatisticsIopsRawTotal int64

		if o.StatisticsIopsRawTotalQueryParameter != nil {
			qrStatisticsIopsRawTotal = *o.StatisticsIopsRawTotalQueryParameter
		}
		qStatisticsIopsRawTotal := swag.FormatInt64(qrStatisticsIopsRawTotal)
		if qStatisticsIopsRawTotal != "" {

			if err := r.SetQueryParam("statistics.iops_raw.total", qStatisticsIopsRawTotal); err != nil {
				return err
			}
		}
	}

	if o.StatisticsIopsRawWriteQueryParameter != nil {

		// query param statistics.iops_raw.write
		var qrStatisticsIopsRawWrite int64

		if o.StatisticsIopsRawWriteQueryParameter != nil {
			qrStatisticsIopsRawWrite = *o.StatisticsIopsRawWriteQueryParameter
		}
		qStatisticsIopsRawWrite := swag.FormatInt64(qrStatisticsIopsRawWrite)
		if qStatisticsIopsRawWrite != "" {

			if err := r.SetQueryParam("statistics.iops_raw.write", qStatisticsIopsRawWrite); err != nil {
				return err
			}
		}
	}

	if o.StatisticsLatencyRawOtherQueryParameter != nil {

		// query param statistics.latency_raw.other
		var qrStatisticsLatencyRawOther int64

		if o.StatisticsLatencyRawOtherQueryParameter != nil {
			qrStatisticsLatencyRawOther = *o.StatisticsLatencyRawOtherQueryParameter
		}
		qStatisticsLatencyRawOther := swag.FormatInt64(qrStatisticsLatencyRawOther)
		if qStatisticsLatencyRawOther != "" {

			if err := r.SetQueryParam("statistics.latency_raw.other", qStatisticsLatencyRawOther); err != nil {
				return err
			}
		}
	}

	if o.StatisticsLatencyRawReadQueryParameter != nil {

		// query param statistics.latency_raw.read
		var qrStatisticsLatencyRawRead int64

		if o.StatisticsLatencyRawReadQueryParameter != nil {
			qrStatisticsLatencyRawRead = *o.StatisticsLatencyRawReadQueryParameter
		}
		qStatisticsLatencyRawRead := swag.FormatInt64(qrStatisticsLatencyRawRead)
		if qStatisticsLatencyRawRead != "" {

			if err := r.SetQueryParam("statistics.latency_raw.read", qStatisticsLatencyRawRead); err != nil {
				return err
			}
		}
	}

	if o.StatisticsLatencyRawTotalQueryParameter != nil {

		// query param statistics.latency_raw.total
		var qrStatisticsLatencyRawTotal int64

		if o.StatisticsLatencyRawTotalQueryParameter != nil {
			qrStatisticsLatencyRawTotal = *o.StatisticsLatencyRawTotalQueryParameter
		}
		qStatisticsLatencyRawTotal := swag.FormatInt64(qrStatisticsLatencyRawTotal)
		if qStatisticsLatencyRawTotal != "" {

			if err := r.SetQueryParam("statistics.latency_raw.total", qStatisticsLatencyRawTotal); err != nil {
				return err
			}
		}
	}

	if o.StatisticsLatencyRawWriteQueryParameter != nil {

		// query param statistics.latency_raw.write
		var qrStatisticsLatencyRawWrite int64

		if o.StatisticsLatencyRawWriteQueryParameter != nil {
			qrStatisticsLatencyRawWrite = *o.StatisticsLatencyRawWriteQueryParameter
		}
		qStatisticsLatencyRawWrite := swag.FormatInt64(qrStatisticsLatencyRawWrite)
		if qStatisticsLatencyRawWrite != "" {

			if err := r.SetQueryParam("statistics.latency_raw.write", qStatisticsLatencyRawWrite); err != nil {
				return err
			}
		}
	}

	if o.StatisticsStatusQueryParameter != nil {

		// query param statistics.status
		var qrStatisticsStatus string

		if o.StatisticsStatusQueryParameter != nil {
			qrStatisticsStatus = *o.StatisticsStatusQueryParameter
		}
		qStatisticsStatus := qrStatisticsStatus
		if qStatisticsStatus != "" {

			if err := r.SetQueryParam("statistics.status", qStatisticsStatus); err != nil {
				return err
			}
		}
	}

	if o.StatisticsThroughputRawReadQueryParameter != nil {

		// query param statistics.throughput_raw.read
		var qrStatisticsThroughputRawRead int64

		if o.StatisticsThroughputRawReadQueryParameter != nil {
			qrStatisticsThroughputRawRead = *o.StatisticsThroughputRawReadQueryParameter
		}
		qStatisticsThroughputRawRead := swag.FormatInt64(qrStatisticsThroughputRawRead)
		if qStatisticsThroughputRawRead != "" {

			if err := r.SetQueryParam("statistics.throughput_raw.read", qStatisticsThroughputRawRead); err != nil {
				return err
			}
		}
	}

	if o.StatisticsThroughputRawTotalQueryParameter != nil {

		// query param statistics.throughput_raw.total
		var qrStatisticsThroughputRawTotal int64

		if o.StatisticsThroughputRawTotalQueryParameter != nil {
			qrStatisticsThroughputRawTotal = *o.StatisticsThroughputRawTotalQueryParameter
		}
		qStatisticsThroughputRawTotal := swag.FormatInt64(qrStatisticsThroughputRawTotal)
		if qStatisticsThroughputRawTotal != "" {

			if err := r.SetQueryParam("statistics.throughput_raw.total", qStatisticsThroughputRawTotal); err != nil {
				return err
			}
		}
	}

	if o.StatisticsThroughputRawWriteQueryParameter != nil {

		// query param statistics.throughput_raw.write
		var qrStatisticsThroughputRawWrite int64

		if o.StatisticsThroughputRawWriteQueryParameter != nil {
			qrStatisticsThroughputRawWrite = *o.StatisticsThroughputRawWriteQueryParameter
		}
		qStatisticsThroughputRawWrite := swag.FormatInt64(qrStatisticsThroughputRawWrite)
		if qStatisticsThroughputRawWrite != "" {

			if err := r.SetQueryParam("statistics.throughput_raw.write", qStatisticsThroughputRawWrite); err != nil {
				return err
			}
		}
	}

	if o.StatisticsTimestampQueryParameter != nil {

		// query param statistics.timestamp
		var qrStatisticsTimestamp string

		if o.StatisticsTimestampQueryParameter != nil {
			qrStatisticsTimestamp = *o.StatisticsTimestampQueryParameter
		}
		qStatisticsTimestamp := qrStatisticsTimestamp
		if qStatisticsTimestamp != "" {

			if err := r.SetQueryParam("statistics.timestamp", qStatisticsTimestamp); err != nil {
				return err
			}
		}
	}

	if o.SupportedProtocolsQueryParameter != nil {

		// query param supported_protocols
		var qrSupportedProtocols string

		if o.SupportedProtocolsQueryParameter != nil {
			qrSupportedProtocols = *o.SupportedProtocolsQueryParameter
		}
		qSupportedProtocols := qrSupportedProtocols
		if qSupportedProtocols != "" {

			if err := r.SetQueryParam("supported_protocols", qSupportedProtocols); err != nil {
				return err
			}
		}
	}

	if o.TransceiverCapabilitiesQueryParameter != nil {

		// query param transceiver.capabilities
		var qrTransceiverCapabilities int64

		if o.TransceiverCapabilitiesQueryParameter != nil {
			qrTransceiverCapabilities = *o.TransceiverCapabilitiesQueryParameter
		}
		qTransceiverCapabilities := swag.FormatInt64(qrTransceiverCapabilities)
		if qTransceiverCapabilities != "" {

			if err := r.SetQueryParam("transceiver.capabilities", qTransceiverCapabilities); err != nil {
				return err
			}
		}
	}

	if o.TransceiverFormFactorQueryParameter != nil {

		// query param transceiver.form_factor
		var qrTransceiverFormFactor string

		if o.TransceiverFormFactorQueryParameter != nil {
			qrTransceiverFormFactor = *o.TransceiverFormFactorQueryParameter
		}
		qTransceiverFormFactor := qrTransceiverFormFactor
		if qTransceiverFormFactor != "" {

			if err := r.SetQueryParam("transceiver.form_factor", qTransceiverFormFactor); err != nil {
				return err
			}
		}
	}

	if o.TransceiverManufacturerQueryParameter != nil {

		// query param transceiver.manufacturer
		var qrTransceiverManufacturer string

		if o.TransceiverManufacturerQueryParameter != nil {
			qrTransceiverManufacturer = *o.TransceiverManufacturerQueryParameter
		}
		qTransceiverManufacturer := qrTransceiverManufacturer
		if qTransceiverManufacturer != "" {

			if err := r.SetQueryParam("transceiver.manufacturer", qTransceiverManufacturer); err != nil {
				return err
			}
		}
	}

	if o.TransceiverPartNumberQueryParameter != nil {

		// query param transceiver.part_number
		var qrTransceiverPartNumber string

		if o.TransceiverPartNumberQueryParameter != nil {
			qrTransceiverPartNumber = *o.TransceiverPartNumberQueryParameter
		}
		qTransceiverPartNumber := qrTransceiverPartNumber
		if qTransceiverPartNumber != "" {

			if err := r.SetQueryParam("transceiver.part_number", qTransceiverPartNumber); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if o.WwnnQueryParameter != nil {

		// query param wwnn
		var qrWwnn string

		if o.WwnnQueryParameter != nil {
			qrWwnn = *o.WwnnQueryParameter
		}
		qWwnn := qrWwnn
		if qWwnn != "" {

			if err := r.SetQueryParam("wwnn", qWwnn); err != nil {
				return err
			}
		}
	}

	if o.WwpnQueryParameter != nil {

		// query param wwpn
		var qrWwpn string

		if o.WwpnQueryParameter != nil {
			qrWwpn = *o.WwpnQueryParameter
		}
		qWwpn := qrWwpn
		if qWwpn != "" {

			if err := r.SetQueryParam("wwpn", qWwpn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamFcPortCollectionGet binds the parameter fields
func (o *FcPortCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamFcPortCollectionGet binds the parameter order_by
func (o *FcPortCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
