// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// HTTPProxyCreateReader is a Reader for the HTTPProxyCreate structure.
type HTTPProxyCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *HTTPProxyCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewHTTPProxyCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewHTTPProxyCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewHTTPProxyCreateCreated creates a HTTPProxyCreateCreated with default headers values
func NewHTTPProxyCreateCreated() *HTTPProxyCreateCreated {
	return &HTTPProxyCreateCreated{}
}

/* HTTPProxyCreateCreated describes a response with status code 201, with default header values.

Created
*/
type HTTPProxyCreateCreated struct {
	Payload *models.NetworkHTTPProxyResponse
}

func (o *HTTPProxyCreateCreated) Error() string {
	return fmt.Sprintf("[POST /network/http-proxy][%d] httpProxyCreateCreated  %+v", 201, o.Payload)
}
func (o *HTTPProxyCreateCreated) GetPayload() *models.NetworkHTTPProxyResponse {
	return o.Payload
}

func (o *HTTPProxyCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.NetworkHTTPProxyResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewHTTPProxyCreateDefault creates a HTTPProxyCreateDefault with default headers values
func NewHTTPProxyCreateDefault(code int) *HTTPProxyCreateDefault {
	return &HTTPProxyCreateDefault{
		_statusCode: code,
	}
}

/* HTTPProxyCreateDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 26214473   | HTTP proxy configuration is not valid. |
| 26214476   | The "IPspace" parameter should not be specified in the SVM context. |
| 26214477   | The specified IPspace does not exist. |
| 23724130   | Cannot use an IPv6 name server address because there are no IPv6 interfaces. |
| 26214481   | Username and password cannot be empty when HTTP proxy authentication is enabled. |
| 26214482   | Username and password cannot be specified when HTTP proxy authentication is disabled. |

*/
type HTTPProxyCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the http proxy create default response
func (o *HTTPProxyCreateDefault) Code() int {
	return o._statusCode
}

func (o *HTTPProxyCreateDefault) Error() string {
	return fmt.Sprintf("[POST /network/http-proxy][%d] http_proxy_create default  %+v", o._statusCode, o.Payload)
}
func (o *HTTPProxyCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *HTTPProxyCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
