// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewNetworkEthernetBroadcastDomainModifyParams creates a new NetworkEthernetBroadcastDomainModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNetworkEthernetBroadcastDomainModifyParams() *NetworkEthernetBroadcastDomainModifyParams {
	return &NetworkEthernetBroadcastDomainModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkEthernetBroadcastDomainModifyParamsWithTimeout creates a new NetworkEthernetBroadcastDomainModifyParams object
// with the ability to set a timeout on a request.
func NewNetworkEthernetBroadcastDomainModifyParamsWithTimeout(timeout time.Duration) *NetworkEthernetBroadcastDomainModifyParams {
	return &NetworkEthernetBroadcastDomainModifyParams{
		timeout: timeout,
	}
}

// NewNetworkEthernetBroadcastDomainModifyParamsWithContext creates a new NetworkEthernetBroadcastDomainModifyParams object
// with the ability to set a context for a request.
func NewNetworkEthernetBroadcastDomainModifyParamsWithContext(ctx context.Context) *NetworkEthernetBroadcastDomainModifyParams {
	return &NetworkEthernetBroadcastDomainModifyParams{
		Context: ctx,
	}
}

// NewNetworkEthernetBroadcastDomainModifyParamsWithHTTPClient creates a new NetworkEthernetBroadcastDomainModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewNetworkEthernetBroadcastDomainModifyParamsWithHTTPClient(client *http.Client) *NetworkEthernetBroadcastDomainModifyParams {
	return &NetworkEthernetBroadcastDomainModifyParams{
		HTTPClient: client,
	}
}

/* NetworkEthernetBroadcastDomainModifyParams contains all the parameters to send to the API endpoint
   for the network ethernet broadcast domain modify operation.

   Typically these are written to a http.Request.
*/
type NetworkEthernetBroadcastDomainModifyParams struct {

	// Info.
	Info *models.BroadcastDomain

	/* UUID.

	   Broadcast domain UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the network ethernet broadcast domain modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkEthernetBroadcastDomainModifyParams) WithDefaults() *NetworkEthernetBroadcastDomainModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the network ethernet broadcast domain modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkEthernetBroadcastDomainModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) WithTimeout(timeout time.Duration) *NetworkEthernetBroadcastDomainModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) WithContext(ctx context.Context) *NetworkEthernetBroadcastDomainModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) WithHTTPClient(client *http.Client) *NetworkEthernetBroadcastDomainModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) WithInfo(info *models.BroadcastDomain) *NetworkEthernetBroadcastDomainModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) SetInfo(info *models.BroadcastDomain) {
	o.Info = info
}

// WithUUIDPathParameter adds the uuid to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) WithUUIDPathParameter(uuid string) *NetworkEthernetBroadcastDomainModifyParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the network ethernet broadcast domain modify params
func (o *NetworkEthernetBroadcastDomainModifyParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkEthernetBroadcastDomainModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
