// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNetworkIPBgpPeerGroupGetParams creates a new NetworkIPBgpPeerGroupGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNetworkIPBgpPeerGroupGetParams() *NetworkIPBgpPeerGroupGetParams {
	return &NetworkIPBgpPeerGroupGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkIPBgpPeerGroupGetParamsWithTimeout creates a new NetworkIPBgpPeerGroupGetParams object
// with the ability to set a timeout on a request.
func NewNetworkIPBgpPeerGroupGetParamsWithTimeout(timeout time.Duration) *NetworkIPBgpPeerGroupGetParams {
	return &NetworkIPBgpPeerGroupGetParams{
		timeout: timeout,
	}
}

// NewNetworkIPBgpPeerGroupGetParamsWithContext creates a new NetworkIPBgpPeerGroupGetParams object
// with the ability to set a context for a request.
func NewNetworkIPBgpPeerGroupGetParamsWithContext(ctx context.Context) *NetworkIPBgpPeerGroupGetParams {
	return &NetworkIPBgpPeerGroupGetParams{
		Context: ctx,
	}
}

// NewNetworkIPBgpPeerGroupGetParamsWithHTTPClient creates a new NetworkIPBgpPeerGroupGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNetworkIPBgpPeerGroupGetParamsWithHTTPClient(client *http.Client) *NetworkIPBgpPeerGroupGetParams {
	return &NetworkIPBgpPeerGroupGetParams{
		HTTPClient: client,
	}
}

/* NetworkIPBgpPeerGroupGetParams contains all the parameters to send to the API endpoint
   for the network ip bgp peer group get operation.

   Typically these are written to a http.Request.
*/
type NetworkIPBgpPeerGroupGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* UUID.

	   UUID of the peer group
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the network ip bgp peer group get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkIPBgpPeerGroupGetParams) WithDefaults() *NetworkIPBgpPeerGroupGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the network ip bgp peer group get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkIPBgpPeerGroupGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) WithTimeout(timeout time.Duration) *NetworkIPBgpPeerGroupGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) WithContext(ctx context.Context) *NetworkIPBgpPeerGroupGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) WithHTTPClient(client *http.Client) *NetworkIPBgpPeerGroupGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) WithFieldsQueryParameter(fields []string) *NetworkIPBgpPeerGroupGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithUUIDPathParameter adds the uuid to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) WithUUIDPathParameter(uuid string) *NetworkIPBgpPeerGroupGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the network ip bgp peer group get params
func (o *NetworkIPBgpPeerGroupGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkIPBgpPeerGroupGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNetworkIPBgpPeerGroupGet binds the parameter fields
func (o *NetworkIPBgpPeerGroupGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
