// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3BucketDeleteReader is a Reader for the S3BucketDelete structure.
type S3BucketDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3BucketDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewS3BucketDeleteAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3BucketDeleteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3BucketDeleteAccepted creates a S3BucketDeleteAccepted with default headers values
func NewS3BucketDeleteAccepted() *S3BucketDeleteAccepted {
	return &S3BucketDeleteAccepted{}
}

/* S3BucketDeleteAccepted describes a response with status code 202, with default header values.

Accepted
*/
type S3BucketDeleteAccepted struct {
	Payload *models.JobLinkResponse
}

func (o *S3BucketDeleteAccepted) Error() string {
	return fmt.Sprintf("[DELETE /protocols/s3/buckets/{svm.uuid}/{uuid}][%d] s3BucketDeleteAccepted  %+v", 202, o.Payload)
}
func (o *S3BucketDeleteAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *S3BucketDeleteAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewS3BucketDeleteDefault creates a S3BucketDeleteDefault with default headers values
func NewS3BucketDeleteDefault(code int) *S3BucketDeleteDefault {
	return &S3BucketDeleteDefault{
		_statusCode: code,
	}
}

/* S3BucketDeleteDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error code | Message |
| ---------- | ------- |
| 92405811   | "Failed to delete bucket \\\"{bucket name}\\\" for SVM \\\"{svm.name}\\\". Wait a few minutes and try the operation again.";
| 92405858   | "Failed to \\\"delete\\\" the \\\"bucket\\\" because the operation is only supported on data SVMs.";
| 92405861   | "The specified SVM UUID or bucket UUID does not exist.";
| 92405779   | "Failed to remove bucket \\\"{bucket name}\\\" for SVM \\\"{svm.name}\\\". Reason: {Reason for failure}. ";
| 92405813   | "Failed to delete the object store volume. Reason: {Reason for failure}.";
| 92405864   | "An error occurred when deleting an access policy. The reason for failure is detailed in the error message.";

*/
type S3BucketDeleteDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 bucket delete default response
func (o *S3BucketDeleteDefault) Code() int {
	return o._statusCode
}

func (o *S3BucketDeleteDefault) Error() string {
	return fmt.Sprintf("[DELETE /protocols/s3/buckets/{svm.uuid}/{uuid}][%d] s3_bucket_delete default  %+v", o._statusCode, o.Payload)
}
func (o *S3BucketDeleteDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3BucketDeleteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
