// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3BucketModifyReader is a Reader for the S3BucketModify structure.
type S3BucketModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3BucketModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewS3BucketModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3BucketModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3BucketModifyAccepted creates a S3BucketModifyAccepted with default headers values
func NewS3BucketModifyAccepted() *S3BucketModifyAccepted {
	return &S3BucketModifyAccepted{}
}

/* S3BucketModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type S3BucketModifyAccepted struct {
	Payload *models.JobLinkResponse
}

func (o *S3BucketModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /protocols/s3/buckets/{svm.uuid}/{uuid}][%d] s3BucketModifyAccepted  %+v", 202, o.Payload)
}
func (o *S3BucketModifyAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *S3BucketModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewS3BucketModifyDefault creates a S3BucketModifyDefault with default headers values
func NewS3BucketModifyDefault(code int) *S3BucketModifyDefault {
	return &S3BucketModifyDefault{
		_statusCode: code,
	}
}

/* S3BucketModifyDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error code | Message |
| ---------- | ------- |
| 92405778   | "Failed to modify bucket \\\"{bucket name}\\\" for SVM \\\"{svm.name}\\\". Reason: {Reason for failure}. ";
| 92405846   | "Failed to modify the object store volume. Reason: {Reason for failure}.";
| 92405811   | "Failed to modify bucket \\\"{bucket name}\\\" for SVM \\\"{svm.name}\\\". Wait a few minutes and try the operation again.";
| 92405858   | "Failed to \\\"modify\\\" the \\\"bucket\\\" because the operation is only supported on data SVMs.";
| 92405861   | "The specified SVM UUID or bucket UUID does not exist.";
| 92405863   | "An error occurs when creating an access policy. The reason for failure is detailed in the error message.";
| 92405864   | "An error occurs when deleting an access policy. The reason for failure is detailed in the error message.";
| 92405891   | "The resources specified in the access policy are not valid. Valid ways to specify a resource are \\\"*\\\", \\\"<bucket-name>\\\", \\\"<bucket-name>/.../...\\\". Valid characters for a resource are 0-9, A-Z, a-z, \\\"_\\\", \\\"+\\\", \\\",\\\", \\\";\\\", \\\":\\\", \\\";\\\", \\\"=\\\", \\\".\\\", \\\"&\\\", \\\"@\\\", \\\"?\\\", \\\"(\\\", \\\")\\\", \\\"'\\\", \\\"*\\\", \\\"!\\\", \\\"-\\\" and \\\"\\$\\\".";
| 92405894   | "Statements, principals and resources list can have a maximum of 10 entries.";
| 92405897   | "The principals specified in the access policy are not in the correct format. User name must be between 1 and 64 characters. Valid characters for a user name are 0-9, A-Z, a-z, \\\"_\\\", \\\"+\\\", \\\"=\\\", \\\",\\\", \\\".\\\", \\\"@\\\", and \\\"-\\\". ";
| 92405898   | "The SID specified in the access policy is not valid. Valid characters for a SID are 0-9, A-Z and a-z.";

*/
type S3BucketModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 bucket modify default response
func (o *S3BucketModifyDefault) Code() int {
	return o._statusCode
}

func (o *S3BucketModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /protocols/s3/buckets/{svm.uuid}/{uuid}][%d] s3_bucket_modify default  %+v", o._statusCode, o.Payload)
}
func (o *S3BucketModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3BucketModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
