// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3GroupModifyReader is a Reader for the S3GroupModify structure.
type S3GroupModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3GroupModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewS3GroupModifyOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3GroupModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3GroupModifyOK creates a S3GroupModifyOK with default headers values
func NewS3GroupModifyOK() *S3GroupModifyOK {
	return &S3GroupModifyOK{}
}

/* S3GroupModifyOK describes a response with status code 200, with default header values.

OK
*/
type S3GroupModifyOK struct {
}

func (o *S3GroupModifyOK) Error() string {
	return fmt.Sprintf("[PATCH /protocols/s3/services/{svm.uuid}/groups/{id}][%d] s3GroupModifyOK ", 200)
}

func (o *S3GroupModifyOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewS3GroupModifyDefault creates a S3GroupModifyDefault with default headers values
func NewS3GroupModifyDefault(code int) *S3GroupModifyDefault {
	return &S3GroupModifyDefault{
		_statusCode: code,
	}
}

/* S3GroupModifyDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 92405896   | Users list cannot be empty.
| 92405930   | Group name is not valid. Group names must have between 1 and 128 characters.
| 92405931   | Group name contains invalid characters. Valid characters for a group name are 0-9, A-Z, a-z, "_", "+", "=", ",", ".", "@", and "-".
| 92405934   | User name specified in the user list do not exist for SVM. Use the "object-store-server user create" command to create a user.
| 92405936   | Query characters such as * are not supported in the user list.
| 92405937   | Policy name specified in the policy list do not exist for SVM.
| 92405966   | User name is present more than once in the users field.

*/
type S3GroupModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 group modify default response
func (o *S3GroupModifyDefault) Code() int {
	return o._statusCode
}

func (o *S3GroupModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /protocols/s3/services/{svm.uuid}/groups/{id}][%d] s3_group_modify default  %+v", o._statusCode, o.Payload)
}
func (o *S3GroupModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3GroupModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
