// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewS3PolicyCollectionGetParams creates a new S3PolicyCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewS3PolicyCollectionGetParams() *S3PolicyCollectionGetParams {
	return &S3PolicyCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewS3PolicyCollectionGetParamsWithTimeout creates a new S3PolicyCollectionGetParams object
// with the ability to set a timeout on a request.
func NewS3PolicyCollectionGetParamsWithTimeout(timeout time.Duration) *S3PolicyCollectionGetParams {
	return &S3PolicyCollectionGetParams{
		timeout: timeout,
	}
}

// NewS3PolicyCollectionGetParamsWithContext creates a new S3PolicyCollectionGetParams object
// with the ability to set a context for a request.
func NewS3PolicyCollectionGetParamsWithContext(ctx context.Context) *S3PolicyCollectionGetParams {
	return &S3PolicyCollectionGetParams{
		Context: ctx,
	}
}

// NewS3PolicyCollectionGetParamsWithHTTPClient creates a new S3PolicyCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewS3PolicyCollectionGetParamsWithHTTPClient(client *http.Client) *S3PolicyCollectionGetParams {
	return &S3PolicyCollectionGetParams{
		HTTPClient: client,
	}
}

/* S3PolicyCollectionGetParams contains all the parameters to send to the API endpoint
   for the s3 policy collection get operation.

   Typically these are written to a http.Request.
*/
type S3PolicyCollectionGetParams struct {

	/* Comment.

	   Filter by comment
	*/
	CommentQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReadOnly.

	   Filter by read-only
	*/
	ReadOnlyQueryParameter *bool

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* StatementsActions.

	   Filter by statements.actions
	*/
	StatementsActionsQueryParameter *string

	/* StatementsEffect.

	   Filter by statements.effect
	*/
	StatementsEffectQueryParameter *string

	/* StatementsIndex.

	   Filter by statements.index
	*/
	StatementsIndexQueryParameter *int64

	/* StatementsResources.

	   Filter by statements.resources
	*/
	StatementsResourcesQueryParameter *string

	/* StatementsSid.

	   Filter by statements.sid
	*/
	StatementsSIDQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the s3 policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3PolicyCollectionGetParams) WithDefaults() *S3PolicyCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the s3 policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3PolicyCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := S3PolicyCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithTimeout(timeout time.Duration) *S3PolicyCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithContext(ctx context.Context) *S3PolicyCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithHTTPClient(client *http.Client) *S3PolicyCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCommentQueryParameter adds the comment to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithCommentQueryParameter(comment *string) *S3PolicyCollectionGetParams {
	o.SetCommentQueryParameter(comment)
	return o
}

// SetCommentQueryParameter adds the comment to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetCommentQueryParameter(comment *string) {
	o.CommentQueryParameter = comment
}

// WithFieldsQueryParameter adds the fields to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithFieldsQueryParameter(fields []string) *S3PolicyCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *S3PolicyCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithNameQueryParameter(name *string) *S3PolicyCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *S3PolicyCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReadOnlyQueryParameter adds the readOnly to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithReadOnlyQueryParameter(readOnly *bool) *S3PolicyCollectionGetParams {
	o.SetReadOnlyQueryParameter(readOnly)
	return o
}

// SetReadOnlyQueryParameter adds the readOnly to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetReadOnlyQueryParameter(readOnly *bool) {
	o.ReadOnlyQueryParameter = readOnly
}

// WithReturnRecordsQueryParameter adds the returnRecords to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *S3PolicyCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *S3PolicyCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithStatementsActionsQueryParameter adds the statementsActions to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithStatementsActionsQueryParameter(statementsActions *string) *S3PolicyCollectionGetParams {
	o.SetStatementsActionsQueryParameter(statementsActions)
	return o
}

// SetStatementsActionsQueryParameter adds the statementsActions to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetStatementsActionsQueryParameter(statementsActions *string) {
	o.StatementsActionsQueryParameter = statementsActions
}

// WithStatementsEffectQueryParameter adds the statementsEffect to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithStatementsEffectQueryParameter(statementsEffect *string) *S3PolicyCollectionGetParams {
	o.SetStatementsEffectQueryParameter(statementsEffect)
	return o
}

// SetStatementsEffectQueryParameter adds the statementsEffect to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetStatementsEffectQueryParameter(statementsEffect *string) {
	o.StatementsEffectQueryParameter = statementsEffect
}

// WithStatementsIndexQueryParameter adds the statementsIndex to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithStatementsIndexQueryParameter(statementsIndex *int64) *S3PolicyCollectionGetParams {
	o.SetStatementsIndexQueryParameter(statementsIndex)
	return o
}

// SetStatementsIndexQueryParameter adds the statementsIndex to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetStatementsIndexQueryParameter(statementsIndex *int64) {
	o.StatementsIndexQueryParameter = statementsIndex
}

// WithStatementsResourcesQueryParameter adds the statementsResources to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithStatementsResourcesQueryParameter(statementsResources *string) *S3PolicyCollectionGetParams {
	o.SetStatementsResourcesQueryParameter(statementsResources)
	return o
}

// SetStatementsResourcesQueryParameter adds the statementsResources to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetStatementsResourcesQueryParameter(statementsResources *string) {
	o.StatementsResourcesQueryParameter = statementsResources
}

// WithStatementsSIDQueryParameter adds the statementsSid to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithStatementsSIDQueryParameter(statementsSid *string) *S3PolicyCollectionGetParams {
	o.SetStatementsSIDQueryParameter(statementsSid)
	return o
}

// SetStatementsSIDQueryParameter adds the statementsSid to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetStatementsSIDQueryParameter(statementsSid *string) {
	o.StatementsSIDQueryParameter = statementsSid
}

// WithSVMNameQueryParameter adds the svmName to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *S3PolicyCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDPathParameter adds the svmUUID to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) WithSVMUUIDPathParameter(svmUUID string) *S3PolicyCollectionGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the s3 policy collection get params
func (o *S3PolicyCollectionGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *S3PolicyCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CommentQueryParameter != nil {

		// query param comment
		var qrComment string

		if o.CommentQueryParameter != nil {
			qrComment = *o.CommentQueryParameter
		}
		qComment := qrComment
		if qComment != "" {

			if err := r.SetQueryParam("comment", qComment); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReadOnlyQueryParameter != nil {

		// query param read-only
		var qrReadOnly bool

		if o.ReadOnlyQueryParameter != nil {
			qrReadOnly = *o.ReadOnlyQueryParameter
		}
		qReadOnly := swag.FormatBool(qrReadOnly)
		if qReadOnly != "" {

			if err := r.SetQueryParam("read-only", qReadOnly); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.StatementsActionsQueryParameter != nil {

		// query param statements.actions
		var qrStatementsActions string

		if o.StatementsActionsQueryParameter != nil {
			qrStatementsActions = *o.StatementsActionsQueryParameter
		}
		qStatementsActions := qrStatementsActions
		if qStatementsActions != "" {

			if err := r.SetQueryParam("statements.actions", qStatementsActions); err != nil {
				return err
			}
		}
	}

	if o.StatementsEffectQueryParameter != nil {

		// query param statements.effect
		var qrStatementsEffect string

		if o.StatementsEffectQueryParameter != nil {
			qrStatementsEffect = *o.StatementsEffectQueryParameter
		}
		qStatementsEffect := qrStatementsEffect
		if qStatementsEffect != "" {

			if err := r.SetQueryParam("statements.effect", qStatementsEffect); err != nil {
				return err
			}
		}
	}

	if o.StatementsIndexQueryParameter != nil {

		// query param statements.index
		var qrStatementsIndex int64

		if o.StatementsIndexQueryParameter != nil {
			qrStatementsIndex = *o.StatementsIndexQueryParameter
		}
		qStatementsIndex := swag.FormatInt64(qrStatementsIndex)
		if qStatementsIndex != "" {

			if err := r.SetQueryParam("statements.index", qStatementsIndex); err != nil {
				return err
			}
		}
	}

	if o.StatementsResourcesQueryParameter != nil {

		// query param statements.resources
		var qrStatementsResources string

		if o.StatementsResourcesQueryParameter != nil {
			qrStatementsResources = *o.StatementsResourcesQueryParameter
		}
		qStatementsResources := qrStatementsResources
		if qStatementsResources != "" {

			if err := r.SetQueryParam("statements.resources", qStatementsResources); err != nil {
				return err
			}
		}
	}

	if o.StatementsSIDQueryParameter != nil {

		// query param statements.sid
		var qrStatementsSid string

		if o.StatementsSIDQueryParameter != nil {
			qrStatementsSid = *o.StatementsSIDQueryParameter
		}
		qStatementsSid := qrStatementsSid
		if qStatementsSid != "" {

			if err := r.SetQueryParam("statements.sid", qStatementsSid); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamS3PolicyCollectionGet binds the parameter fields
func (o *S3PolicyCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamS3PolicyCollectionGet binds the parameter order_by
func (o *S3PolicyCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
