// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3ServiceModifyReader is a Reader for the S3ServiceModify structure.
type S3ServiceModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3ServiceModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewS3ServiceModifyOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3ServiceModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3ServiceModifyOK creates a S3ServiceModifyOK with default headers values
func NewS3ServiceModifyOK() *S3ServiceModifyOK {
	return &S3ServiceModifyOK{}
}

/* S3ServiceModifyOK describes a response with status code 200, with default header values.

OK
*/
type S3ServiceModifyOK struct {
}

func (o *S3ServiceModifyOK) Error() string {
	return fmt.Sprintf("[PATCH /protocols/s3/services/{svm.uuid}][%d] s3ServiceModifyOK ", 200)
}

func (o *S3ServiceModifyOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewS3ServiceModifyDefault creates a S3ServiceModifyDefault with default headers values
func NewS3ServiceModifyDefault(code int) *S3ServiceModifyDefault {
	return &S3ServiceModifyDefault{
		_statusCode: code,
	}
}

/* S3ServiceModifyDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 92405789   | The specified object server name contains invalid characters. Valid characters for an object store server name are 0-9, A-Z, a-z, \".\", and \"-\". |
| 92405790   | Object store server names must have between 1 and 15 characters. |

*/
type S3ServiceModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 service modify default response
func (o *S3ServiceModifyDefault) Code() int {
	return o._statusCode
}

func (o *S3ServiceModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /protocols/s3/services/{svm.uuid}][%d] s3_service_modify default  %+v", o._statusCode, o.Payload)
}
func (o *S3ServiceModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3ServiceModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
