// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3UserCreateReader is a Reader for the S3UserCreate structure.
type S3UserCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3UserCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewS3UserCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3UserCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3UserCreateCreated creates a S3UserCreateCreated with default headers values
func NewS3UserCreateCreated() *S3UserCreateCreated {
	return &S3UserCreateCreated{}
}

/* S3UserCreateCreated describes a response with status code 201, with default header values.

Created
*/
type S3UserCreateCreated struct {
	Payload *models.S3UserPostPatchResponse
}

func (o *S3UserCreateCreated) Error() string {
	return fmt.Sprintf("[POST /protocols/s3/services/{svm.uuid}/users][%d] s3UserCreateCreated  %+v", 201, o.Payload)
}
func (o *S3UserCreateCreated) GetPayload() *models.S3UserPostPatchResponse {
	return o.Payload
}

func (o *S3UserCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.S3UserPostPatchResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewS3UserCreateDefault creates a S3UserCreateDefault with default headers values
func NewS3UserCreateDefault(code int) *S3UserCreateDefault {
	return &S3UserCreateDefault{
		_statusCode: code,
	}
}

/* S3UserCreateDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 92405773   | Object store server is not present for specified SVM. Create a object store server and retry the operation. |
| 92405787   | The specified user name contains invalid characters. Valid characters for a user name are 0-9, A-Z, a-z, \"_\", \"+\", \"=\", \",\", \".\", \"@\", and \"-\". |
| 92405788   | User names must have between 1 and 64 characters. |
| 92405791   | Failed to create access-key and secret-key. |
| 92405817   | S3 users can be created only on data SVM. |

*/
type S3UserCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 user create default response
func (o *S3UserCreateDefault) Code() int {
	return o._statusCode
}

func (o *S3UserCreateDefault) Error() string {
	return fmt.Sprintf("[POST /protocols/s3/services/{svm.uuid}/users][%d] s3_user_create default  %+v", o._statusCode, o.Payload)
}
func (o *S3UserCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3UserCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
