// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewIgroupInitiatorModifyParams creates a new IgroupInitiatorModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIgroupInitiatorModifyParams() *IgroupInitiatorModifyParams {
	return &IgroupInitiatorModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIgroupInitiatorModifyParamsWithTimeout creates a new IgroupInitiatorModifyParams object
// with the ability to set a timeout on a request.
func NewIgroupInitiatorModifyParamsWithTimeout(timeout time.Duration) *IgroupInitiatorModifyParams {
	return &IgroupInitiatorModifyParams{
		timeout: timeout,
	}
}

// NewIgroupInitiatorModifyParamsWithContext creates a new IgroupInitiatorModifyParams object
// with the ability to set a context for a request.
func NewIgroupInitiatorModifyParamsWithContext(ctx context.Context) *IgroupInitiatorModifyParams {
	return &IgroupInitiatorModifyParams{
		Context: ctx,
	}
}

// NewIgroupInitiatorModifyParamsWithHTTPClient creates a new IgroupInitiatorModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewIgroupInitiatorModifyParamsWithHTTPClient(client *http.Client) *IgroupInitiatorModifyParams {
	return &IgroupInitiatorModifyParams{
		HTTPClient: client,
	}
}

/* IgroupInitiatorModifyParams contains all the parameters to send to the API endpoint
   for the igroup initiator modify operation.

   Typically these are written to a http.Request.
*/
type IgroupInitiatorModifyParams struct {

	/* IgroupUUID.

	   The unique identifier of the initiator group.

	*/
	IgroupUUIDPathParameter string

	/* Info.

	   The new property values for the initiator.

	*/
	Info *models.IgroupInitiator

	/* Name.

	   The initiator name.

	*/
	NamePathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the igroup initiator modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IgroupInitiatorModifyParams) WithDefaults() *IgroupInitiatorModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the igroup initiator modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IgroupInitiatorModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) WithTimeout(timeout time.Duration) *IgroupInitiatorModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) WithContext(ctx context.Context) *IgroupInitiatorModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) WithHTTPClient(client *http.Client) *IgroupInitiatorModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIgroupUUIDPathParameter adds the igroupUUID to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) WithIgroupUUIDPathParameter(igroupUUID string) *IgroupInitiatorModifyParams {
	o.SetIgroupUUIDPathParameter(igroupUUID)
	return o
}

// SetIgroupUUIDPathParameter adds the igroupUuid to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) SetIgroupUUIDPathParameter(igroupUUID string) {
	o.IgroupUUIDPathParameter = igroupUUID
}

// WithInfo adds the info to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) WithInfo(info *models.IgroupInitiator) *IgroupInitiatorModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) SetInfo(info *models.IgroupInitiator) {
	o.Info = info
}

// WithNamePathParameter adds the name to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) WithNamePathParameter(name string) *IgroupInitiatorModifyParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the igroup initiator modify params
func (o *IgroupInitiatorModifyParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WriteToRequest writes these params to a swagger request
func (o *IgroupInitiatorModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param igroup.uuid
	if err := r.SetPathParam("igroup.uuid", o.IgroupUUIDPathParameter); err != nil {
		return err
	}
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
