// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewIscsiCredentialsDeleteParams creates a new IscsiCredentialsDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIscsiCredentialsDeleteParams() *IscsiCredentialsDeleteParams {
	return &IscsiCredentialsDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIscsiCredentialsDeleteParamsWithTimeout creates a new IscsiCredentialsDeleteParams object
// with the ability to set a timeout on a request.
func NewIscsiCredentialsDeleteParamsWithTimeout(timeout time.Duration) *IscsiCredentialsDeleteParams {
	return &IscsiCredentialsDeleteParams{
		timeout: timeout,
	}
}

// NewIscsiCredentialsDeleteParamsWithContext creates a new IscsiCredentialsDeleteParams object
// with the ability to set a context for a request.
func NewIscsiCredentialsDeleteParamsWithContext(ctx context.Context) *IscsiCredentialsDeleteParams {
	return &IscsiCredentialsDeleteParams{
		Context: ctx,
	}
}

// NewIscsiCredentialsDeleteParamsWithHTTPClient creates a new IscsiCredentialsDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewIscsiCredentialsDeleteParamsWithHTTPClient(client *http.Client) *IscsiCredentialsDeleteParams {
	return &IscsiCredentialsDeleteParams{
		HTTPClient: client,
	}
}

/* IscsiCredentialsDeleteParams contains all the parameters to send to the API endpoint
   for the iscsi credentials delete operation.

   Typically these are written to a http.Request.
*/
type IscsiCredentialsDeleteParams struct {

	/* Initiator.

	   The iSCSI initiator of the credentials object.

	*/
	InitiatorPathParameter string

	/* SvmUUID.

	   The unique identifier of an SVM.

	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the iscsi credentials delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IscsiCredentialsDeleteParams) WithDefaults() *IscsiCredentialsDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the iscsi credentials delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IscsiCredentialsDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) WithTimeout(timeout time.Duration) *IscsiCredentialsDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) WithContext(ctx context.Context) *IscsiCredentialsDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) WithHTTPClient(client *http.Client) *IscsiCredentialsDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInitiatorPathParameter adds the initiator to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) WithInitiatorPathParameter(initiator string) *IscsiCredentialsDeleteParams {
	o.SetInitiatorPathParameter(initiator)
	return o
}

// SetInitiatorPathParameter adds the initiator to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) SetInitiatorPathParameter(initiator string) {
	o.InitiatorPathParameter = initiator
}

// WithSVMUUIDPathParameter adds the svmUUID to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *IscsiCredentialsDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the iscsi credentials delete params
func (o *IscsiCredentialsDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *IscsiCredentialsDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param initiator
	if err := r.SetPathParam("initiator", o.InitiatorPathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
