// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewLunGetParams creates a new LunGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLunGetParams() *LunGetParams {
	return &LunGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLunGetParamsWithTimeout creates a new LunGetParams object
// with the ability to set a timeout on a request.
func NewLunGetParamsWithTimeout(timeout time.Duration) *LunGetParams {
	return &LunGetParams{
		timeout: timeout,
	}
}

// NewLunGetParamsWithContext creates a new LunGetParams object
// with the ability to set a context for a request.
func NewLunGetParamsWithContext(ctx context.Context) *LunGetParams {
	return &LunGetParams{
		Context: ctx,
	}
}

// NewLunGetParamsWithHTTPClient creates a new LunGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewLunGetParamsWithHTTPClient(client *http.Client) *LunGetParams {
	return &LunGetParams{
		HTTPClient: client,
	}
}

/* LunGetParams contains all the parameters to send to the API endpoint
   for the lun get operation.

   Typically these are written to a http.Request.
*/
type LunGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* UUID.

	   The unique identifier of the LUN to retrieve.

	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the lun get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunGetParams) WithDefaults() *LunGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the lun get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the lun get params
func (o *LunGetParams) WithTimeout(timeout time.Duration) *LunGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the lun get params
func (o *LunGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the lun get params
func (o *LunGetParams) WithContext(ctx context.Context) *LunGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the lun get params
func (o *LunGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the lun get params
func (o *LunGetParams) WithHTTPClient(client *http.Client) *LunGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the lun get params
func (o *LunGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the lun get params
func (o *LunGetParams) WithFieldsQueryParameter(fields []string) *LunGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the lun get params
func (o *LunGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithUUIDPathParameter adds the uuid to the lun get params
func (o *LunGetParams) WithUUIDPathParameter(uuid string) *LunGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the lun get params
func (o *LunGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *LunGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamLunGet binds the parameter fields
func (o *LunGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
