// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewLunMapCollectionGetParams creates a new LunMapCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLunMapCollectionGetParams() *LunMapCollectionGetParams {
	return &LunMapCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLunMapCollectionGetParamsWithTimeout creates a new LunMapCollectionGetParams object
// with the ability to set a timeout on a request.
func NewLunMapCollectionGetParamsWithTimeout(timeout time.Duration) *LunMapCollectionGetParams {
	return &LunMapCollectionGetParams{
		timeout: timeout,
	}
}

// NewLunMapCollectionGetParamsWithContext creates a new LunMapCollectionGetParams object
// with the ability to set a context for a request.
func NewLunMapCollectionGetParamsWithContext(ctx context.Context) *LunMapCollectionGetParams {
	return &LunMapCollectionGetParams{
		Context: ctx,
	}
}

// NewLunMapCollectionGetParamsWithHTTPClient creates a new LunMapCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewLunMapCollectionGetParamsWithHTTPClient(client *http.Client) *LunMapCollectionGetParams {
	return &LunMapCollectionGetParams{
		HTTPClient: client,
	}
}

/* LunMapCollectionGetParams contains all the parameters to send to the API endpoint
   for the lun map collection get operation.

   Typically these are written to a http.Request.
*/
type LunMapCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* IgroupInitiators.

	   Filter by igroup.initiators
	*/
	IgroupInitiatorsQueryParameter *string

	/* IgroupName.

	   Filter by igroup.name
	*/
	IgroupNameQueryParameter *string

	/* IgroupOsType.

	   Filter by igroup.os_type
	*/
	IgroupOsTypeQueryParameter *string

	/* IgroupProtocol.

	   Filter by igroup.protocol
	*/
	IgroupProtocolQueryParameter *string

	/* IgroupUUID.

	   Filter by igroup.uuid
	*/
	IgroupUUIDQueryParameter *string

	/* LogicalUnitNumber.

	   Filter by logical_unit_number
	*/
	LogicalUnitNumberQueryParameter *int64

	/* LunName.

	   Filter by lun.name
	*/
	LunNameQueryParameter *string

	/* LunNodeName.

	   Filter by lun.node.name
	*/
	LunNodeNameQueryParameter *string

	/* LunNodeUUID.

	   Filter by lun.node.uuid
	*/
	LunNodeUUIDQueryParameter *string

	/* LunUUID.

	   Filter by lun.uuid
	*/
	LunUUIDQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReportingNodesName.

	   Filter by reporting_nodes.name
	*/
	ReportingNodesNameQueryParameter *string

	/* ReportingNodesUUID.

	   Filter by reporting_nodes.uuid
	*/
	ReportingNodesUUIDQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the lun map collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunMapCollectionGetParams) WithDefaults() *LunMapCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the lun map collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunMapCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := LunMapCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the lun map collection get params
func (o *LunMapCollectionGetParams) WithTimeout(timeout time.Duration) *LunMapCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the lun map collection get params
func (o *LunMapCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the lun map collection get params
func (o *LunMapCollectionGetParams) WithContext(ctx context.Context) *LunMapCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the lun map collection get params
func (o *LunMapCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the lun map collection get params
func (o *LunMapCollectionGetParams) WithHTTPClient(client *http.Client) *LunMapCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the lun map collection get params
func (o *LunMapCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the lun map collection get params
func (o *LunMapCollectionGetParams) WithFieldsQueryParameter(fields []string) *LunMapCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the lun map collection get params
func (o *LunMapCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIgroupInitiatorsQueryParameter adds the igroupInitiators to the lun map collection get params
func (o *LunMapCollectionGetParams) WithIgroupInitiatorsQueryParameter(igroupInitiators *string) *LunMapCollectionGetParams {
	o.SetIgroupInitiatorsQueryParameter(igroupInitiators)
	return o
}

// SetIgroupInitiatorsQueryParameter adds the igroupInitiators to the lun map collection get params
func (o *LunMapCollectionGetParams) SetIgroupInitiatorsQueryParameter(igroupInitiators *string) {
	o.IgroupInitiatorsQueryParameter = igroupInitiators
}

// WithIgroupNameQueryParameter adds the igroupName to the lun map collection get params
func (o *LunMapCollectionGetParams) WithIgroupNameQueryParameter(igroupName *string) *LunMapCollectionGetParams {
	o.SetIgroupNameQueryParameter(igroupName)
	return o
}

// SetIgroupNameQueryParameter adds the igroupName to the lun map collection get params
func (o *LunMapCollectionGetParams) SetIgroupNameQueryParameter(igroupName *string) {
	o.IgroupNameQueryParameter = igroupName
}

// WithIgroupOsTypeQueryParameter adds the igroupOsType to the lun map collection get params
func (o *LunMapCollectionGetParams) WithIgroupOsTypeQueryParameter(igroupOsType *string) *LunMapCollectionGetParams {
	o.SetIgroupOsTypeQueryParameter(igroupOsType)
	return o
}

// SetIgroupOsTypeQueryParameter adds the igroupOsType to the lun map collection get params
func (o *LunMapCollectionGetParams) SetIgroupOsTypeQueryParameter(igroupOsType *string) {
	o.IgroupOsTypeQueryParameter = igroupOsType
}

// WithIgroupProtocolQueryParameter adds the igroupProtocol to the lun map collection get params
func (o *LunMapCollectionGetParams) WithIgroupProtocolQueryParameter(igroupProtocol *string) *LunMapCollectionGetParams {
	o.SetIgroupProtocolQueryParameter(igroupProtocol)
	return o
}

// SetIgroupProtocolQueryParameter adds the igroupProtocol to the lun map collection get params
func (o *LunMapCollectionGetParams) SetIgroupProtocolQueryParameter(igroupProtocol *string) {
	o.IgroupProtocolQueryParameter = igroupProtocol
}

// WithIgroupUUIDQueryParameter adds the igroupUUID to the lun map collection get params
func (o *LunMapCollectionGetParams) WithIgroupUUIDQueryParameter(igroupUUID *string) *LunMapCollectionGetParams {
	o.SetIgroupUUIDQueryParameter(igroupUUID)
	return o
}

// SetIgroupUUIDQueryParameter adds the igroupUuid to the lun map collection get params
func (o *LunMapCollectionGetParams) SetIgroupUUIDQueryParameter(igroupUUID *string) {
	o.IgroupUUIDQueryParameter = igroupUUID
}

// WithLogicalUnitNumberQueryParameter adds the logicalUnitNumber to the lun map collection get params
func (o *LunMapCollectionGetParams) WithLogicalUnitNumberQueryParameter(logicalUnitNumber *int64) *LunMapCollectionGetParams {
	o.SetLogicalUnitNumberQueryParameter(logicalUnitNumber)
	return o
}

// SetLogicalUnitNumberQueryParameter adds the logicalUnitNumber to the lun map collection get params
func (o *LunMapCollectionGetParams) SetLogicalUnitNumberQueryParameter(logicalUnitNumber *int64) {
	o.LogicalUnitNumberQueryParameter = logicalUnitNumber
}

// WithLunNameQueryParameter adds the lunName to the lun map collection get params
func (o *LunMapCollectionGetParams) WithLunNameQueryParameter(lunName *string) *LunMapCollectionGetParams {
	o.SetLunNameQueryParameter(lunName)
	return o
}

// SetLunNameQueryParameter adds the lunName to the lun map collection get params
func (o *LunMapCollectionGetParams) SetLunNameQueryParameter(lunName *string) {
	o.LunNameQueryParameter = lunName
}

// WithLunNodeNameQueryParameter adds the lunNodeName to the lun map collection get params
func (o *LunMapCollectionGetParams) WithLunNodeNameQueryParameter(lunNodeName *string) *LunMapCollectionGetParams {
	o.SetLunNodeNameQueryParameter(lunNodeName)
	return o
}

// SetLunNodeNameQueryParameter adds the lunNodeName to the lun map collection get params
func (o *LunMapCollectionGetParams) SetLunNodeNameQueryParameter(lunNodeName *string) {
	o.LunNodeNameQueryParameter = lunNodeName
}

// WithLunNodeUUIDQueryParameter adds the lunNodeUUID to the lun map collection get params
func (o *LunMapCollectionGetParams) WithLunNodeUUIDQueryParameter(lunNodeUUID *string) *LunMapCollectionGetParams {
	o.SetLunNodeUUIDQueryParameter(lunNodeUUID)
	return o
}

// SetLunNodeUUIDQueryParameter adds the lunNodeUuid to the lun map collection get params
func (o *LunMapCollectionGetParams) SetLunNodeUUIDQueryParameter(lunNodeUUID *string) {
	o.LunNodeUUIDQueryParameter = lunNodeUUID
}

// WithLunUUIDQueryParameter adds the lunUUID to the lun map collection get params
func (o *LunMapCollectionGetParams) WithLunUUIDQueryParameter(lunUUID *string) *LunMapCollectionGetParams {
	o.SetLunUUIDQueryParameter(lunUUID)
	return o
}

// SetLunUUIDQueryParameter adds the lunUuid to the lun map collection get params
func (o *LunMapCollectionGetParams) SetLunUUIDQueryParameter(lunUUID *string) {
	o.LunUUIDQueryParameter = lunUUID
}

// WithMaxRecordsQueryParameter adds the maxRecords to the lun map collection get params
func (o *LunMapCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *LunMapCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the lun map collection get params
func (o *LunMapCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the lun map collection get params
func (o *LunMapCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *LunMapCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the lun map collection get params
func (o *LunMapCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReportingNodesNameQueryParameter adds the reportingNodesName to the lun map collection get params
func (o *LunMapCollectionGetParams) WithReportingNodesNameQueryParameter(reportingNodesName *string) *LunMapCollectionGetParams {
	o.SetReportingNodesNameQueryParameter(reportingNodesName)
	return o
}

// SetReportingNodesNameQueryParameter adds the reportingNodesName to the lun map collection get params
func (o *LunMapCollectionGetParams) SetReportingNodesNameQueryParameter(reportingNodesName *string) {
	o.ReportingNodesNameQueryParameter = reportingNodesName
}

// WithReportingNodesUUIDQueryParameter adds the reportingNodesUUID to the lun map collection get params
func (o *LunMapCollectionGetParams) WithReportingNodesUUIDQueryParameter(reportingNodesUUID *string) *LunMapCollectionGetParams {
	o.SetReportingNodesUUIDQueryParameter(reportingNodesUUID)
	return o
}

// SetReportingNodesUUIDQueryParameter adds the reportingNodesUuid to the lun map collection get params
func (o *LunMapCollectionGetParams) SetReportingNodesUUIDQueryParameter(reportingNodesUUID *string) {
	o.ReportingNodesUUIDQueryParameter = reportingNodesUUID
}

// WithReturnRecordsQueryParameter adds the returnRecords to the lun map collection get params
func (o *LunMapCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *LunMapCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the lun map collection get params
func (o *LunMapCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the lun map collection get params
func (o *LunMapCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *LunMapCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the lun map collection get params
func (o *LunMapCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMNameQueryParameter adds the svmName to the lun map collection get params
func (o *LunMapCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *LunMapCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the lun map collection get params
func (o *LunMapCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the lun map collection get params
func (o *LunMapCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *LunMapCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the lun map collection get params
func (o *LunMapCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *LunMapCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IgroupInitiatorsQueryParameter != nil {

		// query param igroup.initiators
		var qrIgroupInitiators string

		if o.IgroupInitiatorsQueryParameter != nil {
			qrIgroupInitiators = *o.IgroupInitiatorsQueryParameter
		}
		qIgroupInitiators := qrIgroupInitiators
		if qIgroupInitiators != "" {

			if err := r.SetQueryParam("igroup.initiators", qIgroupInitiators); err != nil {
				return err
			}
		}
	}

	if o.IgroupNameQueryParameter != nil {

		// query param igroup.name
		var qrIgroupName string

		if o.IgroupNameQueryParameter != nil {
			qrIgroupName = *o.IgroupNameQueryParameter
		}
		qIgroupName := qrIgroupName
		if qIgroupName != "" {

			if err := r.SetQueryParam("igroup.name", qIgroupName); err != nil {
				return err
			}
		}
	}

	if o.IgroupOsTypeQueryParameter != nil {

		// query param igroup.os_type
		var qrIgroupOsType string

		if o.IgroupOsTypeQueryParameter != nil {
			qrIgroupOsType = *o.IgroupOsTypeQueryParameter
		}
		qIgroupOsType := qrIgroupOsType
		if qIgroupOsType != "" {

			if err := r.SetQueryParam("igroup.os_type", qIgroupOsType); err != nil {
				return err
			}
		}
	}

	if o.IgroupProtocolQueryParameter != nil {

		// query param igroup.protocol
		var qrIgroupProtocol string

		if o.IgroupProtocolQueryParameter != nil {
			qrIgroupProtocol = *o.IgroupProtocolQueryParameter
		}
		qIgroupProtocol := qrIgroupProtocol
		if qIgroupProtocol != "" {

			if err := r.SetQueryParam("igroup.protocol", qIgroupProtocol); err != nil {
				return err
			}
		}
	}

	if o.IgroupUUIDQueryParameter != nil {

		// query param igroup.uuid
		var qrIgroupUUID string

		if o.IgroupUUIDQueryParameter != nil {
			qrIgroupUUID = *o.IgroupUUIDQueryParameter
		}
		qIgroupUUID := qrIgroupUUID
		if qIgroupUUID != "" {

			if err := r.SetQueryParam("igroup.uuid", qIgroupUUID); err != nil {
				return err
			}
		}
	}

	if o.LogicalUnitNumberQueryParameter != nil {

		// query param logical_unit_number
		var qrLogicalUnitNumber int64

		if o.LogicalUnitNumberQueryParameter != nil {
			qrLogicalUnitNumber = *o.LogicalUnitNumberQueryParameter
		}
		qLogicalUnitNumber := swag.FormatInt64(qrLogicalUnitNumber)
		if qLogicalUnitNumber != "" {

			if err := r.SetQueryParam("logical_unit_number", qLogicalUnitNumber); err != nil {
				return err
			}
		}
	}

	if o.LunNameQueryParameter != nil {

		// query param lun.name
		var qrLunName string

		if o.LunNameQueryParameter != nil {
			qrLunName = *o.LunNameQueryParameter
		}
		qLunName := qrLunName
		if qLunName != "" {

			if err := r.SetQueryParam("lun.name", qLunName); err != nil {
				return err
			}
		}
	}

	if o.LunNodeNameQueryParameter != nil {

		// query param lun.node.name
		var qrLunNodeName string

		if o.LunNodeNameQueryParameter != nil {
			qrLunNodeName = *o.LunNodeNameQueryParameter
		}
		qLunNodeName := qrLunNodeName
		if qLunNodeName != "" {

			if err := r.SetQueryParam("lun.node.name", qLunNodeName); err != nil {
				return err
			}
		}
	}

	if o.LunNodeUUIDQueryParameter != nil {

		// query param lun.node.uuid
		var qrLunNodeUUID string

		if o.LunNodeUUIDQueryParameter != nil {
			qrLunNodeUUID = *o.LunNodeUUIDQueryParameter
		}
		qLunNodeUUID := qrLunNodeUUID
		if qLunNodeUUID != "" {

			if err := r.SetQueryParam("lun.node.uuid", qLunNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.LunUUIDQueryParameter != nil {

		// query param lun.uuid
		var qrLunUUID string

		if o.LunUUIDQueryParameter != nil {
			qrLunUUID = *o.LunUUIDQueryParameter
		}
		qLunUUID := qrLunUUID
		if qLunUUID != "" {

			if err := r.SetQueryParam("lun.uuid", qLunUUID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReportingNodesNameQueryParameter != nil {

		// query param reporting_nodes.name
		var qrReportingNodesName string

		if o.ReportingNodesNameQueryParameter != nil {
			qrReportingNodesName = *o.ReportingNodesNameQueryParameter
		}
		qReportingNodesName := qrReportingNodesName
		if qReportingNodesName != "" {

			if err := r.SetQueryParam("reporting_nodes.name", qReportingNodesName); err != nil {
				return err
			}
		}
	}

	if o.ReportingNodesUUIDQueryParameter != nil {

		// query param reporting_nodes.uuid
		var qrReportingNodesUUID string

		if o.ReportingNodesUUIDQueryParameter != nil {
			qrReportingNodesUUID = *o.ReportingNodesUUIDQueryParameter
		}
		qReportingNodesUUID := qrReportingNodesUUID
		if qReportingNodesUUID != "" {

			if err := r.SetQueryParam("reporting_nodes.uuid", qReportingNodesUUID); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamLunMapCollectionGet binds the parameter fields
func (o *LunMapCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamLunMapCollectionGet binds the parameter order_by
func (o *LunMapCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
