// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// LunMapCreateReader is a Reader for the LunMapCreate structure.
type LunMapCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *LunMapCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewLunMapCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewLunMapCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewLunMapCreateCreated creates a LunMapCreateCreated with default headers values
func NewLunMapCreateCreated() *LunMapCreateCreated {
	return &LunMapCreateCreated{}
}

/* LunMapCreateCreated describes a response with status code 201, with default header values.

Created
*/
type LunMapCreateCreated struct {
	Payload *models.LunMapResponse
}

func (o *LunMapCreateCreated) Error() string {
	return fmt.Sprintf("[POST /protocols/san/lun-maps][%d] lunMapCreateCreated  %+v", 201, o.Payload)
}
func (o *LunMapCreateCreated) GetPayload() *models.LunMapResponse {
	return o.Payload
}

func (o *LunMapCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LunMapResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewLunMapCreateDefault creates a LunMapCreateDefault with default headers values
func NewLunMapCreateDefault(code int) *LunMapCreateDefault {
	return &LunMapCreateDefault{
		_statusCode: code,
	}
}

/* LunMapCreateDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 1254207 | The LUN is already mapped to the same initiator group. |
| 2621462 | The specified SVM does not exist or is not accessible to the caller. |
| 2621706 | Both the SVM UUID and SVM name were supplied, but don't refer to the same SVM. |
| 2621707 | No SVM was specified. Either `svm.name` or `svm.uuid` must be supplied. |
| 5374053 | The LUN is the destination of an ongoing restore operation and is inaccessible for I/O and management. Wait for the restore to complete and try the command again. |
| 5374238 | The operation is not allowed on a LUN in a Snapshot copy. |
| 5374316 | A LUN move operation is in progress on the source LUN. |
| 5374329 | A LUN of class `vvol` cannot be mapped. |
| 5374573 | A node has no interface configured with the iSCSI or Fibre Channel protocols for the specified SVM. |
| 5374574 | Multiple nodes have no interface configured with the iSCSI or Fibre Channel protocols for the specified SVM. |
| 5374581 | A node has no interface configured with the iSCSI protocol for the specified SVM. |
| 5374582 | Multiple nodes have no interface configured with the iSCSI protocol for the specified SVM. |
| 5374583 | A node has no interface configured with the Fibre Channel protocol for the specified SVM. |
| 5374584 | Multiple nodes have no interface configured with the Fibre Channel protocol for the specified SVM. |
| 5374901 | Either `lun.uuid` or `lun.name` must be provided to create a LUN map. |
| 5374902 | Either `igroup.uuid` or `igroup.name` must be provided to create a LUN map. |
| 5374920 | The cluster node specified in additional_reporting_node does not exist. |
| 5374921 | The cluster node name and UUID specified in additional_reporting_node do not refer to the same cluster node. |

*/
type LunMapCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the lun map create default response
func (o *LunMapCreateDefault) Code() int {
	return o._statusCode
}

func (o *LunMapCreateDefault) Error() string {
	return fmt.Sprintf("[POST /protocols/san/lun-maps][%d] lun_map_create default  %+v", o._statusCode, o.Payload)
}
func (o *LunMapCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *LunMapCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
