// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewLunMapDeleteParams creates a new LunMapDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLunMapDeleteParams() *LunMapDeleteParams {
	return &LunMapDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLunMapDeleteParamsWithTimeout creates a new LunMapDeleteParams object
// with the ability to set a timeout on a request.
func NewLunMapDeleteParamsWithTimeout(timeout time.Duration) *LunMapDeleteParams {
	return &LunMapDeleteParams{
		timeout: timeout,
	}
}

// NewLunMapDeleteParamsWithContext creates a new LunMapDeleteParams object
// with the ability to set a context for a request.
func NewLunMapDeleteParamsWithContext(ctx context.Context) *LunMapDeleteParams {
	return &LunMapDeleteParams{
		Context: ctx,
	}
}

// NewLunMapDeleteParamsWithHTTPClient creates a new LunMapDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewLunMapDeleteParamsWithHTTPClient(client *http.Client) *LunMapDeleteParams {
	return &LunMapDeleteParams{
		HTTPClient: client,
	}
}

/* LunMapDeleteParams contains all the parameters to send to the API endpoint
   for the lun map delete operation.

   Typically these are written to a http.Request.
*/
type LunMapDeleteParams struct {

	/* IgroupUUID.

	   The unique identifier of the igroup.

	*/
	IgroupUUIDPathParameter string

	/* LunUUID.

	   The unique identifier of the LUN.

	*/
	LunUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the lun map delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunMapDeleteParams) WithDefaults() *LunMapDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the lun map delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunMapDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the lun map delete params
func (o *LunMapDeleteParams) WithTimeout(timeout time.Duration) *LunMapDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the lun map delete params
func (o *LunMapDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the lun map delete params
func (o *LunMapDeleteParams) WithContext(ctx context.Context) *LunMapDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the lun map delete params
func (o *LunMapDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the lun map delete params
func (o *LunMapDeleteParams) WithHTTPClient(client *http.Client) *LunMapDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the lun map delete params
func (o *LunMapDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIgroupUUIDPathParameter adds the igroupUUID to the lun map delete params
func (o *LunMapDeleteParams) WithIgroupUUIDPathParameter(igroupUUID string) *LunMapDeleteParams {
	o.SetIgroupUUIDPathParameter(igroupUUID)
	return o
}

// SetIgroupUUIDPathParameter adds the igroupUuid to the lun map delete params
func (o *LunMapDeleteParams) SetIgroupUUIDPathParameter(igroupUUID string) {
	o.IgroupUUIDPathParameter = igroupUUID
}

// WithLunUUIDPathParameter adds the lunUUID to the lun map delete params
func (o *LunMapDeleteParams) WithLunUUIDPathParameter(lunUUID string) *LunMapDeleteParams {
	o.SetLunUUIDPathParameter(lunUUID)
	return o
}

// SetLunUUIDPathParameter adds the lunUuid to the lun map delete params
func (o *LunMapDeleteParams) SetLunUUIDPathParameter(lunUUID string) {
	o.LunUUIDPathParameter = lunUUID
}

// WriteToRequest writes these params to a swagger request
func (o *LunMapDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param igroup.uuid
	if err := r.SetPathParam("igroup.uuid", o.IgroupUUIDPathParameter); err != nil {
		return err
	}

	// path param lun.uuid
	if err := r.SetPathParam("lun.uuid", o.LunUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
