// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// PortsetCreateReader is a Reader for the PortsetCreate structure.
type PortsetCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PortsetCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewPortsetCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewPortsetCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPortsetCreateCreated creates a PortsetCreateCreated with default headers values
func NewPortsetCreateCreated() *PortsetCreateCreated {
	return &PortsetCreateCreated{}
}

/* PortsetCreateCreated describes a response with status code 201, with default header values.

Created
*/
type PortsetCreateCreated struct {
	Payload *models.PortsetResponse
}

func (o *PortsetCreateCreated) Error() string {
	return fmt.Sprintf("[POST /protocols/san/portsets][%d] portsetCreateCreated  %+v", 201, o.Payload)
}
func (o *PortsetCreateCreated) GetPayload() *models.PortsetResponse {
	return o.Payload
}

func (o *PortsetCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.PortsetResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPortsetCreateDefault creates a PortsetCreateDefault with default headers values
func NewPortsetCreateDefault(code int) *PortsetCreateDefault {
	return &PortsetCreateDefault{
		_statusCode: code,
	}
}

/* PortsetCreateDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 1254259 | A portset with the same name already exists in the SVM. |
| 2621462 | The specified SVM does not exist. |
| 2621706 | The specified `svm.uuid` and `svm.name` do not refer to the same SVM. |
| 2621707 | No SVM was specified. Either `svm.name` or `svm.uuid` must be supplied. |
| 5373958 | The specified portset name contains invalid characters. |
| 5374905 | An invalid interfaces array element was specified. |
| 5374906 | A specified network interface was not found. |
| 5374907 | The specified network interface UUID and name don't identify the same network interface. |
| 5374914 | An attempt was made to add a network interface of an incompatible protocol to a portset. |

*/
type PortsetCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the portset create default response
func (o *PortsetCreateDefault) Code() int {
	return o._statusCode
}

func (o *PortsetCreateDefault) Error() string {
	return fmt.Sprintf("[POST /protocols/san/portsets][%d] portset_create default  %+v", o._statusCode, o.Payload)
}
func (o *PortsetCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PortsetCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
