// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// AccountDeleteReader is a Reader for the AccountDelete structure.
type AccountDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AccountDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAccountDeleteOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewAccountDeleteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAccountDeleteOK creates a AccountDeleteOK with default headers values
func NewAccountDeleteOK() *AccountDeleteOK {
	return &AccountDeleteOK{}
}

/* AccountDeleteOK describes a response with status code 200, with default header values.

OK
*/
type AccountDeleteOK struct {
}

func (o *AccountDeleteOK) Error() string {
	return fmt.Sprintf("[DELETE /security/accounts/{owner.uuid}/{name}][%d] accountDeleteOK ", 200)
}

func (o *AccountDeleteOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewAccountDeleteDefault creates a AccountDeleteDefault with default headers values
func NewAccountDeleteDefault(code int) *AccountDeleteDefault {
	return &AccountDeleteDefault{
		_statusCode: code,
	}
}

/* AccountDeleteDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 5636098 | Last unlocked account that has an admin role cannot be deleted. |
| 5636125 | The operation is not supported on system accounts. |
| 5636146 | Cannot delete the last console account with admin role. |

*/
type AccountDeleteDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the account delete default response
func (o *AccountDeleteDefault) Code() int {
	return o._statusCode
}

func (o *AccountDeleteDefault) Error() string {
	return fmt.Sprintf("[DELETE /security/accounts/{owner.uuid}/{name}][%d] account_delete default  %+v", o._statusCode, o.Payload)
}
func (o *AccountDeleteDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AccountDeleteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
