// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewAzureKeyVaultDeleteParams creates a new AzureKeyVaultDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAzureKeyVaultDeleteParams() *AzureKeyVaultDeleteParams {
	return &AzureKeyVaultDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAzureKeyVaultDeleteParamsWithTimeout creates a new AzureKeyVaultDeleteParams object
// with the ability to set a timeout on a request.
func NewAzureKeyVaultDeleteParamsWithTimeout(timeout time.Duration) *AzureKeyVaultDeleteParams {
	return &AzureKeyVaultDeleteParams{
		timeout: timeout,
	}
}

// NewAzureKeyVaultDeleteParamsWithContext creates a new AzureKeyVaultDeleteParams object
// with the ability to set a context for a request.
func NewAzureKeyVaultDeleteParamsWithContext(ctx context.Context) *AzureKeyVaultDeleteParams {
	return &AzureKeyVaultDeleteParams{
		Context: ctx,
	}
}

// NewAzureKeyVaultDeleteParamsWithHTTPClient creates a new AzureKeyVaultDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewAzureKeyVaultDeleteParamsWithHTTPClient(client *http.Client) *AzureKeyVaultDeleteParams {
	return &AzureKeyVaultDeleteParams{
		HTTPClient: client,
	}
}

/* AzureKeyVaultDeleteParams contains all the parameters to send to the API endpoint
   for the azure key vault delete operation.

   Typically these are written to a http.Request.
*/
type AzureKeyVaultDeleteParams struct {

	/* UUID.

	   AKV UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the azure key vault delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AzureKeyVaultDeleteParams) WithDefaults() *AzureKeyVaultDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the azure key vault delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AzureKeyVaultDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the azure key vault delete params
func (o *AzureKeyVaultDeleteParams) WithTimeout(timeout time.Duration) *AzureKeyVaultDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the azure key vault delete params
func (o *AzureKeyVaultDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the azure key vault delete params
func (o *AzureKeyVaultDeleteParams) WithContext(ctx context.Context) *AzureKeyVaultDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the azure key vault delete params
func (o *AzureKeyVaultDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the azure key vault delete params
func (o *AzureKeyVaultDeleteParams) WithHTTPClient(client *http.Client) *AzureKeyVaultDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the azure key vault delete params
func (o *AzureKeyVaultDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUUIDPathParameter adds the uuid to the azure key vault delete params
func (o *AzureKeyVaultDeleteParams) WithUUIDPathParameter(uuid string) *AzureKeyVaultDeleteParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the azure key vault delete params
func (o *AzureKeyVaultDeleteParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *AzureKeyVaultDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
