// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// AzureKeyVaultRekeyInternalReader is a Reader for the AzureKeyVaultRekeyInternal structure.
type AzureKeyVaultRekeyInternalReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AzureKeyVaultRekeyInternalReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewAzureKeyVaultRekeyInternalAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewAzureKeyVaultRekeyInternalDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAzureKeyVaultRekeyInternalAccepted creates a AzureKeyVaultRekeyInternalAccepted with default headers values
func NewAzureKeyVaultRekeyInternalAccepted() *AzureKeyVaultRekeyInternalAccepted {
	return &AzureKeyVaultRekeyInternalAccepted{}
}

/* AzureKeyVaultRekeyInternalAccepted describes a response with status code 202, with default header values.

Accepted
*/
type AzureKeyVaultRekeyInternalAccepted struct {
}

func (o *AzureKeyVaultRekeyInternalAccepted) Error() string {
	return fmt.Sprintf("[POST /security/azure-key-vaults/{uuid}/rekey-internal][%d] azureKeyVaultRekeyInternalAccepted ", 202)
}

func (o *AzureKeyVaultRekeyInternalAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewAzureKeyVaultRekeyInternalDefault creates a AzureKeyVaultRekeyInternalDefault with default headers values
func NewAzureKeyVaultRekeyInternalDefault(code int) *AzureKeyVaultRekeyInternalDefault {
	return &AzureKeyVaultRekeyInternalDefault{
		_statusCode: code,
	}
}

/* AzureKeyVaultRekeyInternalDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 65537120 | Azure Key Vault is not configured for the given SVM. |
| 65537547 | One or more volume encryption keys for encrypted volumes of this data SVM are stored in the key manager configured for the admin SVM. Use the REST API POST method to migrate this data SVM's keys from the admin SVM's key manager to this data SVM's key manager before running the rekey operation. |
| 65537559 | There are no existing internal keys for the SVM. A rekey operation is allowed for an SVM with one or more encryption keys. |

*/
type AzureKeyVaultRekeyInternalDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the azure key vault rekey internal default response
func (o *AzureKeyVaultRekeyInternalDefault) Code() int {
	return o._statusCode
}

func (o *AzureKeyVaultRekeyInternalDefault) Error() string {
	return fmt.Sprintf("[POST /security/azure-key-vaults/{uuid}/rekey-internal][%d] azure_key_vault_rekey_internal default  %+v", o._statusCode, o.Payload)
}
func (o *AzureKeyVaultRekeyInternalDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AzureKeyVaultRekeyInternalDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
