// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewAzureKeyVaultRestoreParams creates a new AzureKeyVaultRestoreParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAzureKeyVaultRestoreParams() *AzureKeyVaultRestoreParams {
	return &AzureKeyVaultRestoreParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAzureKeyVaultRestoreParamsWithTimeout creates a new AzureKeyVaultRestoreParams object
// with the ability to set a timeout on a request.
func NewAzureKeyVaultRestoreParamsWithTimeout(timeout time.Duration) *AzureKeyVaultRestoreParams {
	return &AzureKeyVaultRestoreParams{
		timeout: timeout,
	}
}

// NewAzureKeyVaultRestoreParamsWithContext creates a new AzureKeyVaultRestoreParams object
// with the ability to set a context for a request.
func NewAzureKeyVaultRestoreParamsWithContext(ctx context.Context) *AzureKeyVaultRestoreParams {
	return &AzureKeyVaultRestoreParams{
		Context: ctx,
	}
}

// NewAzureKeyVaultRestoreParamsWithHTTPClient creates a new AzureKeyVaultRestoreParams object
// with the ability to set a custom HTTPClient for a request.
func NewAzureKeyVaultRestoreParamsWithHTTPClient(client *http.Client) *AzureKeyVaultRestoreParams {
	return &AzureKeyVaultRestoreParams{
		HTTPClient: client,
	}
}

/* AzureKeyVaultRestoreParams contains all the parameters to send to the API endpoint
   for the azure key vault restore operation.

   Typically these are written to a http.Request.
*/
type AzureKeyVaultRestoreParams struct {

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.
	*/
	ReturnTimeoutQueryParameter *int64

	/* UUID.

	   UUID of the existing AKV configuration.
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the azure key vault restore params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AzureKeyVaultRestoreParams) WithDefaults() *AzureKeyVaultRestoreParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the azure key vault restore params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AzureKeyVaultRestoreParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)

		returnTimeoutQueryParameterDefault = int64(0)
	)

	val := AzureKeyVaultRestoreParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) WithTimeout(timeout time.Duration) *AzureKeyVaultRestoreParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) WithContext(ctx context.Context) *AzureKeyVaultRestoreParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) WithHTTPClient(client *http.Client) *AzureKeyVaultRestoreParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithReturnRecordsQueryParameter adds the returnRecords to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) WithReturnRecordsQueryParameter(returnRecords *bool) *AzureKeyVaultRestoreParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *AzureKeyVaultRestoreParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithUUIDPathParameter adds the uuid to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) WithUUIDPathParameter(uuid string) *AzureKeyVaultRestoreParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the azure key vault restore params
func (o *AzureKeyVaultRestoreParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *AzureKeyVaultRestoreParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
