// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// AzureKeyVaultRestoreReader is a Reader for the AzureKeyVaultRestore structure.
type AzureKeyVaultRestoreReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AzureKeyVaultRestoreReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewAzureKeyVaultRestoreAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewAzureKeyVaultRestoreDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAzureKeyVaultRestoreAccepted creates a AzureKeyVaultRestoreAccepted with default headers values
func NewAzureKeyVaultRestoreAccepted() *AzureKeyVaultRestoreAccepted {
	return &AzureKeyVaultRestoreAccepted{}
}

/* AzureKeyVaultRestoreAccepted describes a response with status code 202, with default header values.

Accepted
*/
type AzureKeyVaultRestoreAccepted struct {
}

func (o *AzureKeyVaultRestoreAccepted) Error() string {
	return fmt.Sprintf("[POST /security/azure-key-vaults/{uuid}/restore][%d] azureKeyVaultRestoreAccepted ", 202)
}

func (o *AzureKeyVaultRestoreAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewAzureKeyVaultRestoreDefault creates a AzureKeyVaultRestoreDefault with default headers values
func NewAzureKeyVaultRestoreDefault(code int) *AzureKeyVaultRestoreDefault {
	return &AzureKeyVaultRestoreDefault{
		_statusCode: code,
	}
}

/* AzureKeyVaultRestoreDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 65537120 | Azure Key Vault is not configured for the given SVM. |
| 65537515 | Failed to restore keys on some nodes in the cluster. |

*/
type AzureKeyVaultRestoreDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the azure key vault restore default response
func (o *AzureKeyVaultRestoreDefault) Code() int {
	return o._statusCode
}

func (o *AzureKeyVaultRestoreDefault) Error() string {
	return fmt.Sprintf("[POST /security/azure-key-vaults/{uuid}/restore][%d] azure_key_vault_restore default  %+v", o._statusCode, o.Payload)
}
func (o *AzureKeyVaultRestoreDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AzureKeyVaultRestoreDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
