// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// IpsecModifyReader is a Reader for the IpsecModify structure.
type IpsecModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *IpsecModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewIpsecModifyOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewIpsecModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewIpsecModifyOK creates a IpsecModifyOK with default headers values
func NewIpsecModifyOK() *IpsecModifyOK {
	return &IpsecModifyOK{}
}

/* IpsecModifyOK describes a response with status code 200, with default header values.

OK
*/
type IpsecModifyOK struct {
}

func (o *IpsecModifyOK) Error() string {
	return fmt.Sprintf("[PATCH /security/ipsec][%d] ipsecModifyOK ", 200)
}

func (o *IpsecModifyOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewIpsecModifyDefault creates a IpsecModifyDefault with default headers values
func NewIpsecModifyDefault(code int) *IpsecModifyDefault {
	return &IpsecModifyDefault{
		_statusCode: code,
	}
}

/* IpsecModifyDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 66256898 | Internal error. Failed to enable IPsec. |
| 66256899 | Internal error. Failed to disable IPsec. |
| 66257199 | IPsec is not supported in the current cluster version. |

*/
type IpsecModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the ipsec modify default response
func (o *IpsecModifyDefault) Code() int {
	return o._statusCode
}

func (o *IpsecModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /security/ipsec][%d] ipsec_modify default  %+v", o._statusCode, o.Payload)
}
func (o *IpsecModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *IpsecModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
