// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// IpsecPolicyGetReader is a Reader for the IpsecPolicyGet structure.
type IpsecPolicyGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *IpsecPolicyGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewIpsecPolicyGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewIpsecPolicyGetDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewIpsecPolicyGetOK creates a IpsecPolicyGetOK with default headers values
func NewIpsecPolicyGetOK() *IpsecPolicyGetOK {
	return &IpsecPolicyGetOK{}
}

/* IpsecPolicyGetOK describes a response with status code 200, with default header values.

OK
*/
type IpsecPolicyGetOK struct {
	Payload *models.IpsecPolicy
}

func (o *IpsecPolicyGetOK) Error() string {
	return fmt.Sprintf("[GET /security/ipsec/policies/{uuid}][%d] ipsecPolicyGetOK  %+v", 200, o.Payload)
}
func (o *IpsecPolicyGetOK) GetPayload() *models.IpsecPolicy {
	return o.Payload
}

func (o *IpsecPolicyGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.IpsecPolicy)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewIpsecPolicyGetDefault creates a IpsecPolicyGetDefault with default headers values
func NewIpsecPolicyGetDefault(code int) *IpsecPolicyGetDefault {
	return &IpsecPolicyGetDefault{
		_statusCode: code,
	}
}

/* IpsecPolicyGetDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 66257116 | IPsec policy with the specified UUID was not found. |

*/
type IpsecPolicyGetDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the ipsec policy get default response
func (o *IpsecPolicyGetDefault) Code() int {
	return o._statusCode
}

func (o *IpsecPolicyGetDefault) Error() string {
	return fmt.Sprintf("[GET /security/ipsec/policies/{uuid}][%d] ipsec_policy_get default  %+v", o._statusCode, o.Payload)
}
func (o *IpsecPolicyGetDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *IpsecPolicyGetDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
