// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewIpsecPolicyModifyParams creates a new IpsecPolicyModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpsecPolicyModifyParams() *IpsecPolicyModifyParams {
	return &IpsecPolicyModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpsecPolicyModifyParamsWithTimeout creates a new IpsecPolicyModifyParams object
// with the ability to set a timeout on a request.
func NewIpsecPolicyModifyParamsWithTimeout(timeout time.Duration) *IpsecPolicyModifyParams {
	return &IpsecPolicyModifyParams{
		timeout: timeout,
	}
}

// NewIpsecPolicyModifyParamsWithContext creates a new IpsecPolicyModifyParams object
// with the ability to set a context for a request.
func NewIpsecPolicyModifyParamsWithContext(ctx context.Context) *IpsecPolicyModifyParams {
	return &IpsecPolicyModifyParams{
		Context: ctx,
	}
}

// NewIpsecPolicyModifyParamsWithHTTPClient creates a new IpsecPolicyModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpsecPolicyModifyParamsWithHTTPClient(client *http.Client) *IpsecPolicyModifyParams {
	return &IpsecPolicyModifyParams{
		HTTPClient: client,
	}
}

/* IpsecPolicyModifyParams contains all the parameters to send to the API endpoint
   for the ipsec policy modify operation.

   Typically these are written to a http.Request.
*/
type IpsecPolicyModifyParams struct {

	// Info.
	Info *models.IpsecPolicy

	/* UUID.

	   IPsec policy UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipsec policy modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecPolicyModifyParams) WithDefaults() *IpsecPolicyModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipsec policy modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecPolicyModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) WithTimeout(timeout time.Duration) *IpsecPolicyModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) WithContext(ctx context.Context) *IpsecPolicyModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) WithHTTPClient(client *http.Client) *IpsecPolicyModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) WithInfo(info *models.IpsecPolicy) *IpsecPolicyModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) SetInfo(info *models.IpsecPolicy) {
	o.Info = info
}

// WithUUIDPathParameter adds the uuid to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) WithUUIDPathParameter(uuid string) *IpsecPolicyModifyParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the ipsec policy modify params
func (o *IpsecPolicyModifyParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *IpsecPolicyModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
