// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRolePrivilegeCollectionGetParams creates a new RolePrivilegeCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRolePrivilegeCollectionGetParams() *RolePrivilegeCollectionGetParams {
	return &RolePrivilegeCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRolePrivilegeCollectionGetParamsWithTimeout creates a new RolePrivilegeCollectionGetParams object
// with the ability to set a timeout on a request.
func NewRolePrivilegeCollectionGetParamsWithTimeout(timeout time.Duration) *RolePrivilegeCollectionGetParams {
	return &RolePrivilegeCollectionGetParams{
		timeout: timeout,
	}
}

// NewRolePrivilegeCollectionGetParamsWithContext creates a new RolePrivilegeCollectionGetParams object
// with the ability to set a context for a request.
func NewRolePrivilegeCollectionGetParamsWithContext(ctx context.Context) *RolePrivilegeCollectionGetParams {
	return &RolePrivilegeCollectionGetParams{
		Context: ctx,
	}
}

// NewRolePrivilegeCollectionGetParamsWithHTTPClient creates a new RolePrivilegeCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewRolePrivilegeCollectionGetParamsWithHTTPClient(client *http.Client) *RolePrivilegeCollectionGetParams {
	return &RolePrivilegeCollectionGetParams{
		HTTPClient: client,
	}
}

/* RolePrivilegeCollectionGetParams contains all the parameters to send to the API endpoint
   for the role privilege collection get operation.

   Typically these are written to a http.Request.
*/
type RolePrivilegeCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Role name
	*/
	NamePathParameter string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* OwnerUUID.

	   Role owner UUID
	*/
	OwnerUUIDPathParameter string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the role privilege collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RolePrivilegeCollectionGetParams) WithDefaults() *RolePrivilegeCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the role privilege collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RolePrivilegeCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := RolePrivilegeCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithTimeout(timeout time.Duration) *RolePrivilegeCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithContext(ctx context.Context) *RolePrivilegeCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithHTTPClient(client *http.Client) *RolePrivilegeCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithFieldsQueryParameter(fields []string) *RolePrivilegeCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *RolePrivilegeCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNamePathParameter adds the name to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithNamePathParameter(name string) *RolePrivilegeCollectionGetParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *RolePrivilegeCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithOwnerUUIDPathParameter adds the ownerUUID to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithOwnerUUIDPathParameter(ownerUUID string) *RolePrivilegeCollectionGetParams {
	o.SetOwnerUUIDPathParameter(ownerUUID)
	return o
}

// SetOwnerUUIDPathParameter adds the ownerUuid to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetOwnerUUIDPathParameter(ownerUUID string) {
	o.OwnerUUIDPathParameter = ownerUUID
}

// WithReturnRecordsQueryParameter adds the returnRecords to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *RolePrivilegeCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *RolePrivilegeCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the role privilege collection get params
func (o *RolePrivilegeCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *RolePrivilegeCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	// path param owner.uuid
	if err := r.SetPathParam("owner.uuid", o.OwnerUUIDPathParameter); err != nil {
		return err
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamRolePrivilegeCollectionGet binds the parameter fields
func (o *RolePrivilegeCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamRolePrivilegeCollectionGet binds the parameter order_by
func (o *RolePrivilegeCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
