// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSecurityCertificateCollectionGetParams creates a new SecurityCertificateCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSecurityCertificateCollectionGetParams() *SecurityCertificateCollectionGetParams {
	return &SecurityCertificateCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSecurityCertificateCollectionGetParamsWithTimeout creates a new SecurityCertificateCollectionGetParams object
// with the ability to set a timeout on a request.
func NewSecurityCertificateCollectionGetParamsWithTimeout(timeout time.Duration) *SecurityCertificateCollectionGetParams {
	return &SecurityCertificateCollectionGetParams{
		timeout: timeout,
	}
}

// NewSecurityCertificateCollectionGetParamsWithContext creates a new SecurityCertificateCollectionGetParams object
// with the ability to set a context for a request.
func NewSecurityCertificateCollectionGetParamsWithContext(ctx context.Context) *SecurityCertificateCollectionGetParams {
	return &SecurityCertificateCollectionGetParams{
		Context: ctx,
	}
}

// NewSecurityCertificateCollectionGetParamsWithHTTPClient creates a new SecurityCertificateCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSecurityCertificateCollectionGetParamsWithHTTPClient(client *http.Client) *SecurityCertificateCollectionGetParams {
	return &SecurityCertificateCollectionGetParams{
		HTTPClient: client,
	}
}

/* SecurityCertificateCollectionGetParams contains all the parameters to send to the API endpoint
   for the security certificate collection get operation.

   Typically these are written to a http.Request.
*/
type SecurityCertificateCollectionGetParams struct {

	/* AuthorityKeyIdentifier.

	   Filter by authority_key_identifier
	*/
	AuthorityKeyIDentifierQueryParameter *string

	/* Ca.

	   Filter by ca
	*/
	CaQueryParameter *string

	/* CommonName.

	   Filter by common_name
	*/
	CommonNameQueryParameter *string

	/* ExpiryTime.

	   Filter by expiry_time
	*/
	ExpiryTimeQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* HashFunction.

	   Filter by hash_function
	*/
	HashFunctionQueryParameter *string

	/* IntermediateCertificates.

	   Filter by intermediate_certificates
	*/
	IntermediateCertificatesQueryParameter *string

	/* KeySize.

	   Filter by key_size
	*/
	KeySizeQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* PrivateKey.

	   Filter by private_key
	*/
	PrivateKeyQueryParameter *string

	/* PublicCertificate.

	   Filter by public_certificate
	*/
	PublicCertificateQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Scope.

	   Filter by scope
	*/
	ScopeQueryParameter *string

	/* SerialNumber.

	   Filter by serial_number
	*/
	SerialNumberQueryParameter *string

	/* SubjectKeyIdentifier.

	   Filter by subject_key_identifier
	*/
	SubjectKeyIDentifierQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	/* Type.

	   Filter by type
	*/
	TypeQueryParameter *string

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the security certificate collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SecurityCertificateCollectionGetParams) WithDefaults() *SecurityCertificateCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the security certificate collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SecurityCertificateCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := SecurityCertificateCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithTimeout(timeout time.Duration) *SecurityCertificateCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithContext(ctx context.Context) *SecurityCertificateCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithHTTPClient(client *http.Client) *SecurityCertificateCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAuthorityKeyIDentifierQueryParameter adds the authorityKeyIdentifier to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithAuthorityKeyIDentifierQueryParameter(authorityKeyIdentifier *string) *SecurityCertificateCollectionGetParams {
	o.SetAuthorityKeyIDentifierQueryParameter(authorityKeyIdentifier)
	return o
}

// SetAuthorityKeyIDentifierQueryParameter adds the authorityKeyIdentifier to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetAuthorityKeyIDentifierQueryParameter(authorityKeyIdentifier *string) {
	o.AuthorityKeyIDentifierQueryParameter = authorityKeyIdentifier
}

// WithCaQueryParameter adds the ca to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithCaQueryParameter(ca *string) *SecurityCertificateCollectionGetParams {
	o.SetCaQueryParameter(ca)
	return o
}

// SetCaQueryParameter adds the ca to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetCaQueryParameter(ca *string) {
	o.CaQueryParameter = ca
}

// WithCommonNameQueryParameter adds the commonName to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithCommonNameQueryParameter(commonName *string) *SecurityCertificateCollectionGetParams {
	o.SetCommonNameQueryParameter(commonName)
	return o
}

// SetCommonNameQueryParameter adds the commonName to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetCommonNameQueryParameter(commonName *string) {
	o.CommonNameQueryParameter = commonName
}

// WithExpiryTimeQueryParameter adds the expiryTime to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithExpiryTimeQueryParameter(expiryTime *string) *SecurityCertificateCollectionGetParams {
	o.SetExpiryTimeQueryParameter(expiryTime)
	return o
}

// SetExpiryTimeQueryParameter adds the expiryTime to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetExpiryTimeQueryParameter(expiryTime *string) {
	o.ExpiryTimeQueryParameter = expiryTime
}

// WithFieldsQueryParameter adds the fields to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithFieldsQueryParameter(fields []string) *SecurityCertificateCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithHashFunctionQueryParameter adds the hashFunction to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithHashFunctionQueryParameter(hashFunction *string) *SecurityCertificateCollectionGetParams {
	o.SetHashFunctionQueryParameter(hashFunction)
	return o
}

// SetHashFunctionQueryParameter adds the hashFunction to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetHashFunctionQueryParameter(hashFunction *string) {
	o.HashFunctionQueryParameter = hashFunction
}

// WithIntermediateCertificatesQueryParameter adds the intermediateCertificates to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithIntermediateCertificatesQueryParameter(intermediateCertificates *string) *SecurityCertificateCollectionGetParams {
	o.SetIntermediateCertificatesQueryParameter(intermediateCertificates)
	return o
}

// SetIntermediateCertificatesQueryParameter adds the intermediateCertificates to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetIntermediateCertificatesQueryParameter(intermediateCertificates *string) {
	o.IntermediateCertificatesQueryParameter = intermediateCertificates
}

// WithKeySizeQueryParameter adds the keySize to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithKeySizeQueryParameter(keySize *int64) *SecurityCertificateCollectionGetParams {
	o.SetKeySizeQueryParameter(keySize)
	return o
}

// SetKeySizeQueryParameter adds the keySize to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetKeySizeQueryParameter(keySize *int64) {
	o.KeySizeQueryParameter = keySize
}

// WithMaxRecordsQueryParameter adds the maxRecords to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *SecurityCertificateCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithNameQueryParameter(name *string) *SecurityCertificateCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *SecurityCertificateCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPrivateKeyQueryParameter adds the privateKey to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithPrivateKeyQueryParameter(privateKey *string) *SecurityCertificateCollectionGetParams {
	o.SetPrivateKeyQueryParameter(privateKey)
	return o
}

// SetPrivateKeyQueryParameter adds the privateKey to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetPrivateKeyQueryParameter(privateKey *string) {
	o.PrivateKeyQueryParameter = privateKey
}

// WithPublicCertificateQueryParameter adds the publicCertificate to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithPublicCertificateQueryParameter(publicCertificate *string) *SecurityCertificateCollectionGetParams {
	o.SetPublicCertificateQueryParameter(publicCertificate)
	return o
}

// SetPublicCertificateQueryParameter adds the publicCertificate to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetPublicCertificateQueryParameter(publicCertificate *string) {
	o.PublicCertificateQueryParameter = publicCertificate
}

// WithReturnRecordsQueryParameter adds the returnRecords to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *SecurityCertificateCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *SecurityCertificateCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithScopeQueryParameter adds the scope to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithScopeQueryParameter(scope *string) *SecurityCertificateCollectionGetParams {
	o.SetScopeQueryParameter(scope)
	return o
}

// SetScopeQueryParameter adds the scope to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetScopeQueryParameter(scope *string) {
	o.ScopeQueryParameter = scope
}

// WithSerialNumberQueryParameter adds the serialNumber to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithSerialNumberQueryParameter(serialNumber *string) *SecurityCertificateCollectionGetParams {
	o.SetSerialNumberQueryParameter(serialNumber)
	return o
}

// SetSerialNumberQueryParameter adds the serialNumber to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetSerialNumberQueryParameter(serialNumber *string) {
	o.SerialNumberQueryParameter = serialNumber
}

// WithSubjectKeyIDentifierQueryParameter adds the subjectKeyIdentifier to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithSubjectKeyIDentifierQueryParameter(subjectKeyIdentifier *string) *SecurityCertificateCollectionGetParams {
	o.SetSubjectKeyIDentifierQueryParameter(subjectKeyIdentifier)
	return o
}

// SetSubjectKeyIDentifierQueryParameter adds the subjectKeyIdentifier to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetSubjectKeyIDentifierQueryParameter(subjectKeyIdentifier *string) {
	o.SubjectKeyIDentifierQueryParameter = subjectKeyIdentifier
}

// WithSVMNameQueryParameter adds the svmName to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *SecurityCertificateCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *SecurityCertificateCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WithTypeQueryParameter adds the typeVar to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithTypeQueryParameter(typeVar *string) *SecurityCertificateCollectionGetParams {
	o.SetTypeQueryParameter(typeVar)
	return o
}

// SetTypeQueryParameter adds the type to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetTypeQueryParameter(typeVar *string) {
	o.TypeQueryParameter = typeVar
}

// WithUUIDQueryParameter adds the uuid to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) WithUUIDQueryParameter(uuid *string) *SecurityCertificateCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the security certificate collection get params
func (o *SecurityCertificateCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *SecurityCertificateCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AuthorityKeyIDentifierQueryParameter != nil {

		// query param authority_key_identifier
		var qrAuthorityKeyIdentifier string

		if o.AuthorityKeyIDentifierQueryParameter != nil {
			qrAuthorityKeyIdentifier = *o.AuthorityKeyIDentifierQueryParameter
		}
		qAuthorityKeyIdentifier := qrAuthorityKeyIdentifier
		if qAuthorityKeyIdentifier != "" {

			if err := r.SetQueryParam("authority_key_identifier", qAuthorityKeyIdentifier); err != nil {
				return err
			}
		}
	}

	if o.CaQueryParameter != nil {

		// query param ca
		var qrCa string

		if o.CaQueryParameter != nil {
			qrCa = *o.CaQueryParameter
		}
		qCa := qrCa
		if qCa != "" {

			if err := r.SetQueryParam("ca", qCa); err != nil {
				return err
			}
		}
	}

	if o.CommonNameQueryParameter != nil {

		// query param common_name
		var qrCommonName string

		if o.CommonNameQueryParameter != nil {
			qrCommonName = *o.CommonNameQueryParameter
		}
		qCommonName := qrCommonName
		if qCommonName != "" {

			if err := r.SetQueryParam("common_name", qCommonName); err != nil {
				return err
			}
		}
	}

	if o.ExpiryTimeQueryParameter != nil {

		// query param expiry_time
		var qrExpiryTime string

		if o.ExpiryTimeQueryParameter != nil {
			qrExpiryTime = *o.ExpiryTimeQueryParameter
		}
		qExpiryTime := qrExpiryTime
		if qExpiryTime != "" {

			if err := r.SetQueryParam("expiry_time", qExpiryTime); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.HashFunctionQueryParameter != nil {

		// query param hash_function
		var qrHashFunction string

		if o.HashFunctionQueryParameter != nil {
			qrHashFunction = *o.HashFunctionQueryParameter
		}
		qHashFunction := qrHashFunction
		if qHashFunction != "" {

			if err := r.SetQueryParam("hash_function", qHashFunction); err != nil {
				return err
			}
		}
	}

	if o.IntermediateCertificatesQueryParameter != nil {

		// query param intermediate_certificates
		var qrIntermediateCertificates string

		if o.IntermediateCertificatesQueryParameter != nil {
			qrIntermediateCertificates = *o.IntermediateCertificatesQueryParameter
		}
		qIntermediateCertificates := qrIntermediateCertificates
		if qIntermediateCertificates != "" {

			if err := r.SetQueryParam("intermediate_certificates", qIntermediateCertificates); err != nil {
				return err
			}
		}
	}

	if o.KeySizeQueryParameter != nil {

		// query param key_size
		var qrKeySize int64

		if o.KeySizeQueryParameter != nil {
			qrKeySize = *o.KeySizeQueryParameter
		}
		qKeySize := swag.FormatInt64(qrKeySize)
		if qKeySize != "" {

			if err := r.SetQueryParam("key_size", qKeySize); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PrivateKeyQueryParameter != nil {

		// query param private_key
		var qrPrivateKey string

		if o.PrivateKeyQueryParameter != nil {
			qrPrivateKey = *o.PrivateKeyQueryParameter
		}
		qPrivateKey := qrPrivateKey
		if qPrivateKey != "" {

			if err := r.SetQueryParam("private_key", qPrivateKey); err != nil {
				return err
			}
		}
	}

	if o.PublicCertificateQueryParameter != nil {

		// query param public_certificate
		var qrPublicCertificate string

		if o.PublicCertificateQueryParameter != nil {
			qrPublicCertificate = *o.PublicCertificateQueryParameter
		}
		qPublicCertificate := qrPublicCertificate
		if qPublicCertificate != "" {

			if err := r.SetQueryParam("public_certificate", qPublicCertificate); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ScopeQueryParameter != nil {

		// query param scope
		var qrScope string

		if o.ScopeQueryParameter != nil {
			qrScope = *o.ScopeQueryParameter
		}
		qScope := qrScope
		if qScope != "" {

			if err := r.SetQueryParam("scope", qScope); err != nil {
				return err
			}
		}
	}

	if o.SerialNumberQueryParameter != nil {

		// query param serial_number
		var qrSerialNumber string

		if o.SerialNumberQueryParameter != nil {
			qrSerialNumber = *o.SerialNumberQueryParameter
		}
		qSerialNumber := qrSerialNumber
		if qSerialNumber != "" {

			if err := r.SetQueryParam("serial_number", qSerialNumber); err != nil {
				return err
			}
		}
	}

	if o.SubjectKeyIDentifierQueryParameter != nil {

		// query param subject_key_identifier
		var qrSubjectKeyIdentifier string

		if o.SubjectKeyIDentifierQueryParameter != nil {
			qrSubjectKeyIdentifier = *o.SubjectKeyIDentifierQueryParameter
		}
		qSubjectKeyIdentifier := qrSubjectKeyIdentifier
		if qSubjectKeyIdentifier != "" {

			if err := r.SetQueryParam("subject_key_identifier", qSubjectKeyIdentifier); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.TypeQueryParameter != nil {

		// query param type
		var qrType string

		if o.TypeQueryParameter != nil {
			qrType = *o.TypeQueryParameter
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSecurityCertificateCollectionGet binds the parameter fields
func (o *SecurityCertificateCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamSecurityCertificateCollectionGet binds the parameter order_by
func (o *SecurityCertificateCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
