// Code generated by go-swagger; DO NOT EDIT.

package snaplock

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSnaplockFingerprintOperationGetParams creates a new SnaplockFingerprintOperationGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSnaplockFingerprintOperationGetParams() *SnaplockFingerprintOperationGetParams {
	return &SnaplockFingerprintOperationGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSnaplockFingerprintOperationGetParamsWithTimeout creates a new SnaplockFingerprintOperationGetParams object
// with the ability to set a timeout on a request.
func NewSnaplockFingerprintOperationGetParamsWithTimeout(timeout time.Duration) *SnaplockFingerprintOperationGetParams {
	return &SnaplockFingerprintOperationGetParams{
		timeout: timeout,
	}
}

// NewSnaplockFingerprintOperationGetParamsWithContext creates a new SnaplockFingerprintOperationGetParams object
// with the ability to set a context for a request.
func NewSnaplockFingerprintOperationGetParamsWithContext(ctx context.Context) *SnaplockFingerprintOperationGetParams {
	return &SnaplockFingerprintOperationGetParams{
		Context: ctx,
	}
}

// NewSnaplockFingerprintOperationGetParamsWithHTTPClient creates a new SnaplockFingerprintOperationGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSnaplockFingerprintOperationGetParamsWithHTTPClient(client *http.Client) *SnaplockFingerprintOperationGetParams {
	return &SnaplockFingerprintOperationGetParams{
		HTTPClient: client,
	}
}

/* SnaplockFingerprintOperationGetParams contains all the parameters to send to the API endpoint
   for the snaplock fingerprint operation get operation.

   Typically these are written to a http.Request.
*/
type SnaplockFingerprintOperationGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* ID.

	   Unique identifier of the operation
	*/
	IDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the snaplock fingerprint operation get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnaplockFingerprintOperationGetParams) WithDefaults() *SnaplockFingerprintOperationGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the snaplock fingerprint operation get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnaplockFingerprintOperationGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) WithTimeout(timeout time.Duration) *SnaplockFingerprintOperationGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) WithContext(ctx context.Context) *SnaplockFingerprintOperationGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) WithHTTPClient(client *http.Client) *SnaplockFingerprintOperationGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) WithFieldsQueryParameter(fields []string) *SnaplockFingerprintOperationGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIDPathParameter adds the id to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) WithIDPathParameter(id string) *SnaplockFingerprintOperationGetParams {
	o.SetIDPathParameter(id)
	return o
}

// SetIDPathParameter adds the id to the snaplock fingerprint operation get params
func (o *SnaplockFingerprintOperationGetParams) SetIDPathParameter(id string) {
	o.IDPathParameter = id
}

// WriteToRequest writes these params to a swagger request
func (o *SnaplockFingerprintOperationGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.IDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSnaplockFingerprintOperationGet binds the parameter fields
func (o *SnaplockFingerprintOperationGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
