// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewMonitoredFileCreateParams creates a new MonitoredFileCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMonitoredFileCreateParams() *MonitoredFileCreateParams {
	return &MonitoredFileCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMonitoredFileCreateParamsWithTimeout creates a new MonitoredFileCreateParams object
// with the ability to set a timeout on a request.
func NewMonitoredFileCreateParamsWithTimeout(timeout time.Duration) *MonitoredFileCreateParams {
	return &MonitoredFileCreateParams{
		timeout: timeout,
	}
}

// NewMonitoredFileCreateParamsWithContext creates a new MonitoredFileCreateParams object
// with the ability to set a context for a request.
func NewMonitoredFileCreateParamsWithContext(ctx context.Context) *MonitoredFileCreateParams {
	return &MonitoredFileCreateParams{
		Context: ctx,
	}
}

// NewMonitoredFileCreateParamsWithHTTPClient creates a new MonitoredFileCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewMonitoredFileCreateParamsWithHTTPClient(client *http.Client) *MonitoredFileCreateParams {
	return &MonitoredFileCreateParams{
		HTTPClient: client,
	}
}

/* MonitoredFileCreateParams contains all the parameters to send to the API endpoint
   for the monitored file create operation.

   Typically these are written to a http.Request.
*/
type MonitoredFileCreateParams struct {

	/* Info.

	   Info Specification
	*/
	Info *models.MonitoredFile

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the monitored file create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MonitoredFileCreateParams) WithDefaults() *MonitoredFileCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the monitored file create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MonitoredFileCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := MonitoredFileCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the monitored file create params
func (o *MonitoredFileCreateParams) WithTimeout(timeout time.Duration) *MonitoredFileCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the monitored file create params
func (o *MonitoredFileCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the monitored file create params
func (o *MonitoredFileCreateParams) WithContext(ctx context.Context) *MonitoredFileCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the monitored file create params
func (o *MonitoredFileCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the monitored file create params
func (o *MonitoredFileCreateParams) WithHTTPClient(client *http.Client) *MonitoredFileCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the monitored file create params
func (o *MonitoredFileCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the monitored file create params
func (o *MonitoredFileCreateParams) WithInfo(info *models.MonitoredFile) *MonitoredFileCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the monitored file create params
func (o *MonitoredFileCreateParams) SetInfo(info *models.MonitoredFile) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the monitored file create params
func (o *MonitoredFileCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *MonitoredFileCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the monitored file create params
func (o *MonitoredFileCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *MonitoredFileCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
