// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// QtreeGetReader is a Reader for the QtreeGet structure.
type QtreeGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *QtreeGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewQtreeGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewQtreeGetDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewQtreeGetOK creates a QtreeGetOK with default headers values
func NewQtreeGetOK() *QtreeGetOK {
	return &QtreeGetOK{}
}

/* QtreeGetOK describes a response with status code 200, with default header values.

OK
*/
type QtreeGetOK struct {
	Payload *models.Qtree
}

func (o *QtreeGetOK) Error() string {
	return fmt.Sprintf("[GET /storage/qtrees/{volume.uuid}/{id}][%d] qtreeGetOK  %+v", 200, o.Payload)
}
func (o *QtreeGetOK) GetPayload() *models.Qtree {
	return o.Payload
}

func (o *QtreeGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Qtree)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQtreeGetDefault creates a QtreeGetDefault with default headers values
func NewQtreeGetDefault(code int) *QtreeGetDefault {
	return &QtreeGetDefault{
		_statusCode: code,
	}
}

/* QtreeGetDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 918235 | A volume with UUID was not found. |
| 5242956 | Failed to obtain a qtree with ID. |

*/
type QtreeGetDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the qtree get default response
func (o *QtreeGetDefault) Code() int {
	return o._statusCode
}

func (o *QtreeGetDefault) Error() string {
	return fmt.Sprintf("[GET /storage/qtrees/{volume.uuid}/{id}][%d] qtree_get default  %+v", o._statusCode, o.Payload)
}
func (o *QtreeGetDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *QtreeGetDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
