// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// QuotaRuleModifyReader is a Reader for the QuotaRuleModify structure.
type QuotaRuleModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *QuotaRuleModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewQuotaRuleModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewQuotaRuleModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewQuotaRuleModifyAccepted creates a QuotaRuleModifyAccepted with default headers values
func NewQuotaRuleModifyAccepted() *QuotaRuleModifyAccepted {
	return &QuotaRuleModifyAccepted{}
}

/* QuotaRuleModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type QuotaRuleModifyAccepted struct {
	Payload *models.JobLinkResponse
}

func (o *QuotaRuleModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /storage/quota/rules/{uuid}][%d] quotaRuleModifyAccepted  %+v", 202, o.Payload)
}
func (o *QuotaRuleModifyAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *QuotaRuleModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQuotaRuleModifyDefault creates a QuotaRuleModifyDefault with default headers values
func NewQuotaRuleModifyDefault(code int) *QuotaRuleModifyDefault {
	return &QuotaRuleModifyDefault{
		_statusCode: code,
	}
}

/* QuotaRuleModifyDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 5308501 | Mapping from Windows user to UNIX user for user rule was unsuccessful. |
| 5308502 | Mapping from UNIX user to Windows user for user rule was unsuccessful. |
| 5308545 | The specified quota rule UUID is invalid. |
| 5308561 | Failed to obtain volume quota state or invalid quota state obtained for volume. |
| 5308567 | Quota policy rule modify operation succeeded, but quota resize failed due to internal error. |
| 5308573 | Input value is greater than limit for field. |
| 5308574 | Input value is out of range for field. |
| 5308575 | Input value is incorrectly larger than listed field. |

*/
type QuotaRuleModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the quota rule modify default response
func (o *QuotaRuleModifyDefault) Code() int {
	return o._statusCode
}

func (o *QuotaRuleModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /storage/quota/rules/{uuid}][%d] quota_rule_modify default  %+v", o._statusCode, o.Payload)
}
func (o *QuotaRuleModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *QuotaRuleModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
