// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSnapshotGetParams creates a new SnapshotGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSnapshotGetParams() *SnapshotGetParams {
	return &SnapshotGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSnapshotGetParamsWithTimeout creates a new SnapshotGetParams object
// with the ability to set a timeout on a request.
func NewSnapshotGetParamsWithTimeout(timeout time.Duration) *SnapshotGetParams {
	return &SnapshotGetParams{
		timeout: timeout,
	}
}

// NewSnapshotGetParamsWithContext creates a new SnapshotGetParams object
// with the ability to set a context for a request.
func NewSnapshotGetParamsWithContext(ctx context.Context) *SnapshotGetParams {
	return &SnapshotGetParams{
		Context: ctx,
	}
}

// NewSnapshotGetParamsWithHTTPClient creates a new SnapshotGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSnapshotGetParamsWithHTTPClient(client *http.Client) *SnapshotGetParams {
	return &SnapshotGetParams{
		HTTPClient: client,
	}
}

/* SnapshotGetParams contains all the parameters to send to the API endpoint
   for the snapshot get operation.

   Typically these are written to a http.Request.
*/
type SnapshotGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* UUID.

	   Snapshot copy UUID
	*/
	UUIDPathParameter string

	/* VolumeUUID.

	   Volume UUID
	*/
	VolumeUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the snapshot get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnapshotGetParams) WithDefaults() *SnapshotGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the snapshot get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnapshotGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the snapshot get params
func (o *SnapshotGetParams) WithTimeout(timeout time.Duration) *SnapshotGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapshot get params
func (o *SnapshotGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapshot get params
func (o *SnapshotGetParams) WithContext(ctx context.Context) *SnapshotGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapshot get params
func (o *SnapshotGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapshot get params
func (o *SnapshotGetParams) WithHTTPClient(client *http.Client) *SnapshotGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapshot get params
func (o *SnapshotGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the snapshot get params
func (o *SnapshotGetParams) WithFieldsQueryParameter(fields []string) *SnapshotGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the snapshot get params
func (o *SnapshotGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithUUIDPathParameter adds the uuid to the snapshot get params
func (o *SnapshotGetParams) WithUUIDPathParameter(uuid string) *SnapshotGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the snapshot get params
func (o *SnapshotGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WithVolumeUUIDPathParameter adds the volumeUUID to the snapshot get params
func (o *SnapshotGetParams) WithVolumeUUIDPathParameter(volumeUUID string) *SnapshotGetParams {
	o.SetVolumeUUIDPathParameter(volumeUUID)
	return o
}

// SetVolumeUUIDPathParameter adds the volumeUuid to the snapshot get params
func (o *SnapshotGetParams) SetVolumeUUIDPathParameter(volumeUUID string) {
	o.VolumeUUIDPathParameter = volumeUUID
}

// WriteToRequest writes these params to a swagger request
func (o *SnapshotGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	// path param volume.uuid
	if err := r.SetPathParam("volume.uuid", o.VolumeUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSnapshotGet binds the parameter fields
func (o *SnapshotGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
