// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSnapshotPolicyCollectionGetParams creates a new SnapshotPolicyCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSnapshotPolicyCollectionGetParams() *SnapshotPolicyCollectionGetParams {
	return &SnapshotPolicyCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSnapshotPolicyCollectionGetParamsWithTimeout creates a new SnapshotPolicyCollectionGetParams object
// with the ability to set a timeout on a request.
func NewSnapshotPolicyCollectionGetParamsWithTimeout(timeout time.Duration) *SnapshotPolicyCollectionGetParams {
	return &SnapshotPolicyCollectionGetParams{
		timeout: timeout,
	}
}

// NewSnapshotPolicyCollectionGetParamsWithContext creates a new SnapshotPolicyCollectionGetParams object
// with the ability to set a context for a request.
func NewSnapshotPolicyCollectionGetParamsWithContext(ctx context.Context) *SnapshotPolicyCollectionGetParams {
	return &SnapshotPolicyCollectionGetParams{
		Context: ctx,
	}
}

// NewSnapshotPolicyCollectionGetParamsWithHTTPClient creates a new SnapshotPolicyCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSnapshotPolicyCollectionGetParamsWithHTTPClient(client *http.Client) *SnapshotPolicyCollectionGetParams {
	return &SnapshotPolicyCollectionGetParams{
		HTTPClient: client,
	}
}

/* SnapshotPolicyCollectionGetParams contains all the parameters to send to the API endpoint
   for the snapshot policy collection get operation.

   Typically these are written to a http.Request.
*/
type SnapshotPolicyCollectionGetParams struct {

	/* Comment.

	   Filter by comment
	*/
	CommentQueryParameter *string

	/* CopiesCount.

	   Filter by copies.count
	*/
	CopiesCountQueryParameter *int64

	/* CopiesPrefix.

	   Filter by copies.prefix
	*/
	CopiesPrefixQueryParameter *string

	/* CopiesScheduleName.

	   Filter by copies.schedule.name
	*/
	CopiesScheduleNameQueryParameter *string

	/* CopiesSnapmirrorLabel.

	   Filter by copies.snapmirror_label
	*/
	CopiesSnapmirrorLabelQueryParameter *string

	/* Enabled.

	   Filter by enabled
	*/
	EnabledQueryParameter *bool

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Scope.

	   Filter by scope
	*/
	ScopeQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the snapshot policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnapshotPolicyCollectionGetParams) WithDefaults() *SnapshotPolicyCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the snapshot policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnapshotPolicyCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := SnapshotPolicyCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithTimeout(timeout time.Duration) *SnapshotPolicyCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithContext(ctx context.Context) *SnapshotPolicyCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithHTTPClient(client *http.Client) *SnapshotPolicyCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCommentQueryParameter adds the comment to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithCommentQueryParameter(comment *string) *SnapshotPolicyCollectionGetParams {
	o.SetCommentQueryParameter(comment)
	return o
}

// SetCommentQueryParameter adds the comment to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetCommentQueryParameter(comment *string) {
	o.CommentQueryParameter = comment
}

// WithCopiesCountQueryParameter adds the copiesCount to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithCopiesCountQueryParameter(copiesCount *int64) *SnapshotPolicyCollectionGetParams {
	o.SetCopiesCountQueryParameter(copiesCount)
	return o
}

// SetCopiesCountQueryParameter adds the copiesCount to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetCopiesCountQueryParameter(copiesCount *int64) {
	o.CopiesCountQueryParameter = copiesCount
}

// WithCopiesPrefixQueryParameter adds the copiesPrefix to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithCopiesPrefixQueryParameter(copiesPrefix *string) *SnapshotPolicyCollectionGetParams {
	o.SetCopiesPrefixQueryParameter(copiesPrefix)
	return o
}

// SetCopiesPrefixQueryParameter adds the copiesPrefix to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetCopiesPrefixQueryParameter(copiesPrefix *string) {
	o.CopiesPrefixQueryParameter = copiesPrefix
}

// WithCopiesScheduleNameQueryParameter adds the copiesScheduleName to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithCopiesScheduleNameQueryParameter(copiesScheduleName *string) *SnapshotPolicyCollectionGetParams {
	o.SetCopiesScheduleNameQueryParameter(copiesScheduleName)
	return o
}

// SetCopiesScheduleNameQueryParameter adds the copiesScheduleName to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetCopiesScheduleNameQueryParameter(copiesScheduleName *string) {
	o.CopiesScheduleNameQueryParameter = copiesScheduleName
}

// WithCopiesSnapmirrorLabelQueryParameter adds the copiesSnapmirrorLabel to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithCopiesSnapmirrorLabelQueryParameter(copiesSnapmirrorLabel *string) *SnapshotPolicyCollectionGetParams {
	o.SetCopiesSnapmirrorLabelQueryParameter(copiesSnapmirrorLabel)
	return o
}

// SetCopiesSnapmirrorLabelQueryParameter adds the copiesSnapmirrorLabel to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetCopiesSnapmirrorLabelQueryParameter(copiesSnapmirrorLabel *string) {
	o.CopiesSnapmirrorLabelQueryParameter = copiesSnapmirrorLabel
}

// WithEnabledQueryParameter adds the enabled to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithEnabledQueryParameter(enabled *bool) *SnapshotPolicyCollectionGetParams {
	o.SetEnabledQueryParameter(enabled)
	return o
}

// SetEnabledQueryParameter adds the enabled to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetEnabledQueryParameter(enabled *bool) {
	o.EnabledQueryParameter = enabled
}

// WithFieldsQueryParameter adds the fields to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithFieldsQueryParameter(fields []string) *SnapshotPolicyCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *SnapshotPolicyCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithNameQueryParameter(name *string) *SnapshotPolicyCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *SnapshotPolicyCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *SnapshotPolicyCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *SnapshotPolicyCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithScopeQueryParameter adds the scope to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithScopeQueryParameter(scope *string) *SnapshotPolicyCollectionGetParams {
	o.SetScopeQueryParameter(scope)
	return o
}

// SetScopeQueryParameter adds the scope to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetScopeQueryParameter(scope *string) {
	o.ScopeQueryParameter = scope
}

// WithSVMNameQueryParameter adds the svmName to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *SnapshotPolicyCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *SnapshotPolicyCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WithUUIDQueryParameter adds the uuid to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) WithUUIDQueryParameter(uuid *string) *SnapshotPolicyCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the snapshot policy collection get params
func (o *SnapshotPolicyCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *SnapshotPolicyCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CommentQueryParameter != nil {

		// query param comment
		var qrComment string

		if o.CommentQueryParameter != nil {
			qrComment = *o.CommentQueryParameter
		}
		qComment := qrComment
		if qComment != "" {

			if err := r.SetQueryParam("comment", qComment); err != nil {
				return err
			}
		}
	}

	if o.CopiesCountQueryParameter != nil {

		// query param copies.count
		var qrCopiesCount int64

		if o.CopiesCountQueryParameter != nil {
			qrCopiesCount = *o.CopiesCountQueryParameter
		}
		qCopiesCount := swag.FormatInt64(qrCopiesCount)
		if qCopiesCount != "" {

			if err := r.SetQueryParam("copies.count", qCopiesCount); err != nil {
				return err
			}
		}
	}

	if o.CopiesPrefixQueryParameter != nil {

		// query param copies.prefix
		var qrCopiesPrefix string

		if o.CopiesPrefixQueryParameter != nil {
			qrCopiesPrefix = *o.CopiesPrefixQueryParameter
		}
		qCopiesPrefix := qrCopiesPrefix
		if qCopiesPrefix != "" {

			if err := r.SetQueryParam("copies.prefix", qCopiesPrefix); err != nil {
				return err
			}
		}
	}

	if o.CopiesScheduleNameQueryParameter != nil {

		// query param copies.schedule.name
		var qrCopiesScheduleName string

		if o.CopiesScheduleNameQueryParameter != nil {
			qrCopiesScheduleName = *o.CopiesScheduleNameQueryParameter
		}
		qCopiesScheduleName := qrCopiesScheduleName
		if qCopiesScheduleName != "" {

			if err := r.SetQueryParam("copies.schedule.name", qCopiesScheduleName); err != nil {
				return err
			}
		}
	}

	if o.CopiesSnapmirrorLabelQueryParameter != nil {

		// query param copies.snapmirror_label
		var qrCopiesSnapmirrorLabel string

		if o.CopiesSnapmirrorLabelQueryParameter != nil {
			qrCopiesSnapmirrorLabel = *o.CopiesSnapmirrorLabelQueryParameter
		}
		qCopiesSnapmirrorLabel := qrCopiesSnapmirrorLabel
		if qCopiesSnapmirrorLabel != "" {

			if err := r.SetQueryParam("copies.snapmirror_label", qCopiesSnapmirrorLabel); err != nil {
				return err
			}
		}
	}

	if o.EnabledQueryParameter != nil {

		// query param enabled
		var qrEnabled bool

		if o.EnabledQueryParameter != nil {
			qrEnabled = *o.EnabledQueryParameter
		}
		qEnabled := swag.FormatBool(qrEnabled)
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ScopeQueryParameter != nil {

		// query param scope
		var qrScope string

		if o.ScopeQueryParameter != nil {
			qrScope = *o.ScopeQueryParameter
		}
		qScope := qrScope
		if qScope != "" {

			if err := r.SetQueryParam("scope", qScope); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSnapshotPolicyCollectionGet binds the parameter fields
func (o *SnapshotPolicyCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamSnapshotPolicyCollectionGet binds the parameter order_by
func (o *SnapshotPolicyCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
