// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSnapshotPolicyScheduleCollectionGetParams creates a new SnapshotPolicyScheduleCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSnapshotPolicyScheduleCollectionGetParams() *SnapshotPolicyScheduleCollectionGetParams {
	return &SnapshotPolicyScheduleCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSnapshotPolicyScheduleCollectionGetParamsWithTimeout creates a new SnapshotPolicyScheduleCollectionGetParams object
// with the ability to set a timeout on a request.
func NewSnapshotPolicyScheduleCollectionGetParamsWithTimeout(timeout time.Duration) *SnapshotPolicyScheduleCollectionGetParams {
	return &SnapshotPolicyScheduleCollectionGetParams{
		timeout: timeout,
	}
}

// NewSnapshotPolicyScheduleCollectionGetParamsWithContext creates a new SnapshotPolicyScheduleCollectionGetParams object
// with the ability to set a context for a request.
func NewSnapshotPolicyScheduleCollectionGetParamsWithContext(ctx context.Context) *SnapshotPolicyScheduleCollectionGetParams {
	return &SnapshotPolicyScheduleCollectionGetParams{
		Context: ctx,
	}
}

// NewSnapshotPolicyScheduleCollectionGetParamsWithHTTPClient creates a new SnapshotPolicyScheduleCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSnapshotPolicyScheduleCollectionGetParamsWithHTTPClient(client *http.Client) *SnapshotPolicyScheduleCollectionGetParams {
	return &SnapshotPolicyScheduleCollectionGetParams{
		HTTPClient: client,
	}
}

/* SnapshotPolicyScheduleCollectionGetParams contains all the parameters to send to the API endpoint
   for the snapshot policy schedule collection get operation.

   Typically these are written to a http.Request.
*/
type SnapshotPolicyScheduleCollectionGetParams struct {

	/* Count.

	   Filter by count
	*/
	CountQueryParameter *int64

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* Prefix.

	   Filter by prefix
	*/
	PrefixQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* ScheduleName.

	   Filter by schedule.name
	*/
	ScheduleNameQueryParameter *string

	/* ScheduleUUID.

	   Filter by schedule.uuid
	*/
	ScheduleUUIDQueryParameter *string

	/* SnapmirrorLabel.

	   Filter by snapmirror_label
	*/
	SnapmirrorLabelQueryParameter *string

	/* SnapshotPolicyName.

	   Filter by snapshot_policy.name
	*/
	SnapshotPolicyNameQueryParameter *string

	/* SnapshotPolicyUUID.

	   Snapshot copy policy UUID
	*/
	SnapshotPolicyUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the snapshot policy schedule collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnapshotPolicyScheduleCollectionGetParams) WithDefaults() *SnapshotPolicyScheduleCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the snapshot policy schedule collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnapshotPolicyScheduleCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := SnapshotPolicyScheduleCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithTimeout(timeout time.Duration) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithContext(ctx context.Context) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithHTTPClient(client *http.Client) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCountQueryParameter adds the count to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithCountQueryParameter(count *int64) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetCountQueryParameter(count)
	return o
}

// SetCountQueryParameter adds the count to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetCountQueryParameter(count *int64) {
	o.CountQueryParameter = count
}

// WithFieldsQueryParameter adds the fields to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithFieldsQueryParameter(fields []string) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPrefixQueryParameter adds the prefix to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithPrefixQueryParameter(prefix *string) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetPrefixQueryParameter(prefix)
	return o
}

// SetPrefixQueryParameter adds the prefix to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetPrefixQueryParameter(prefix *string) {
	o.PrefixQueryParameter = prefix
}

// WithReturnRecordsQueryParameter adds the returnRecords to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithScheduleNameQueryParameter adds the scheduleName to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithScheduleNameQueryParameter(scheduleName *string) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetScheduleNameQueryParameter(scheduleName)
	return o
}

// SetScheduleNameQueryParameter adds the scheduleName to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetScheduleNameQueryParameter(scheduleName *string) {
	o.ScheduleNameQueryParameter = scheduleName
}

// WithScheduleUUIDQueryParameter adds the scheduleUUID to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithScheduleUUIDQueryParameter(scheduleUUID *string) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetScheduleUUIDQueryParameter(scheduleUUID)
	return o
}

// SetScheduleUUIDQueryParameter adds the scheduleUuid to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetScheduleUUIDQueryParameter(scheduleUUID *string) {
	o.ScheduleUUIDQueryParameter = scheduleUUID
}

// WithSnapmirrorLabelQueryParameter adds the snapmirrorLabel to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithSnapmirrorLabelQueryParameter(snapmirrorLabel *string) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetSnapmirrorLabelQueryParameter(snapmirrorLabel)
	return o
}

// SetSnapmirrorLabelQueryParameter adds the snapmirrorLabel to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetSnapmirrorLabelQueryParameter(snapmirrorLabel *string) {
	o.SnapmirrorLabelQueryParameter = snapmirrorLabel
}

// WithSnapshotPolicyNameQueryParameter adds the snapshotPolicyName to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithSnapshotPolicyNameQueryParameter(snapshotPolicyName *string) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetSnapshotPolicyNameQueryParameter(snapshotPolicyName)
	return o
}

// SetSnapshotPolicyNameQueryParameter adds the snapshotPolicyName to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetSnapshotPolicyNameQueryParameter(snapshotPolicyName *string) {
	o.SnapshotPolicyNameQueryParameter = snapshotPolicyName
}

// WithSnapshotPolicyUUIDPathParameter adds the snapshotPolicyUUID to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) WithSnapshotPolicyUUIDPathParameter(snapshotPolicyUUID string) *SnapshotPolicyScheduleCollectionGetParams {
	o.SetSnapshotPolicyUUIDPathParameter(snapshotPolicyUUID)
	return o
}

// SetSnapshotPolicyUUIDPathParameter adds the snapshotPolicyUuid to the snapshot policy schedule collection get params
func (o *SnapshotPolicyScheduleCollectionGetParams) SetSnapshotPolicyUUIDPathParameter(snapshotPolicyUUID string) {
	o.SnapshotPolicyUUIDPathParameter = snapshotPolicyUUID
}

// WriteToRequest writes these params to a swagger request
func (o *SnapshotPolicyScheduleCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CountQueryParameter != nil {

		// query param count
		var qrCount int64

		if o.CountQueryParameter != nil {
			qrCount = *o.CountQueryParameter
		}
		qCount := swag.FormatInt64(qrCount)
		if qCount != "" {

			if err := r.SetQueryParam("count", qCount); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PrefixQueryParameter != nil {

		// query param prefix
		var qrPrefix string

		if o.PrefixQueryParameter != nil {
			qrPrefix = *o.PrefixQueryParameter
		}
		qPrefix := qrPrefix
		if qPrefix != "" {

			if err := r.SetQueryParam("prefix", qPrefix); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ScheduleNameQueryParameter != nil {

		// query param schedule.name
		var qrScheduleName string

		if o.ScheduleNameQueryParameter != nil {
			qrScheduleName = *o.ScheduleNameQueryParameter
		}
		qScheduleName := qrScheduleName
		if qScheduleName != "" {

			if err := r.SetQueryParam("schedule.name", qScheduleName); err != nil {
				return err
			}
		}
	}

	if o.ScheduleUUIDQueryParameter != nil {

		// query param schedule.uuid
		var qrScheduleUUID string

		if o.ScheduleUUIDQueryParameter != nil {
			qrScheduleUUID = *o.ScheduleUUIDQueryParameter
		}
		qScheduleUUID := qrScheduleUUID
		if qScheduleUUID != "" {

			if err := r.SetQueryParam("schedule.uuid", qScheduleUUID); err != nil {
				return err
			}
		}
	}

	if o.SnapmirrorLabelQueryParameter != nil {

		// query param snapmirror_label
		var qrSnapmirrorLabel string

		if o.SnapmirrorLabelQueryParameter != nil {
			qrSnapmirrorLabel = *o.SnapmirrorLabelQueryParameter
		}
		qSnapmirrorLabel := qrSnapmirrorLabel
		if qSnapmirrorLabel != "" {

			if err := r.SetQueryParam("snapmirror_label", qSnapmirrorLabel); err != nil {
				return err
			}
		}
	}

	if o.SnapshotPolicyNameQueryParameter != nil {

		// query param snapshot_policy.name
		var qrSnapshotPolicyName string

		if o.SnapshotPolicyNameQueryParameter != nil {
			qrSnapshotPolicyName = *o.SnapshotPolicyNameQueryParameter
		}
		qSnapshotPolicyName := qrSnapshotPolicyName
		if qSnapshotPolicyName != "" {

			if err := r.SetQueryParam("snapshot_policy.name", qSnapshotPolicyName); err != nil {
				return err
			}
		}
	}

	// path param snapshot_policy.uuid
	if err := r.SetPathParam("snapshot_policy.uuid", o.SnapshotPolicyUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSnapshotPolicyScheduleCollectionGet binds the parameter fields
func (o *SnapshotPolicyScheduleCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamSnapshotPolicyScheduleCollectionGet binds the parameter order_by
func (o *SnapshotPolicyScheduleCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
