// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSplitLoadCollectionGetParams creates a new SplitLoadCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSplitLoadCollectionGetParams() *SplitLoadCollectionGetParams {
	return &SplitLoadCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSplitLoadCollectionGetParamsWithTimeout creates a new SplitLoadCollectionGetParams object
// with the ability to set a timeout on a request.
func NewSplitLoadCollectionGetParamsWithTimeout(timeout time.Duration) *SplitLoadCollectionGetParams {
	return &SplitLoadCollectionGetParams{
		timeout: timeout,
	}
}

// NewSplitLoadCollectionGetParamsWithContext creates a new SplitLoadCollectionGetParams object
// with the ability to set a context for a request.
func NewSplitLoadCollectionGetParamsWithContext(ctx context.Context) *SplitLoadCollectionGetParams {
	return &SplitLoadCollectionGetParams{
		Context: ctx,
	}
}

// NewSplitLoadCollectionGetParamsWithHTTPClient creates a new SplitLoadCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSplitLoadCollectionGetParamsWithHTTPClient(client *http.Client) *SplitLoadCollectionGetParams {
	return &SplitLoadCollectionGetParams{
		HTTPClient: client,
	}
}

/* SplitLoadCollectionGetParams contains all the parameters to send to the API endpoint
   for the split load collection get operation.

   Typically these are written to a http.Request.
*/
type SplitLoadCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* LoadAllowable.

	   Filter by load.allowable
	*/
	LoadAllowableQueryParameter *int64

	/* LoadCurrent.

	   Filter by load.current
	*/
	LoadCurrentQueryParameter *int64

	/* LoadMaximum.

	   Filter by load.maximum
	*/
	LoadMaximumQueryParameter *int64

	/* LoadTokenReserved.

	   Filter by load.token_reserved
	*/
	LoadTokenReservedQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* NodeName.

	   Filter by node.name
	*/
	NodeNameQueryParameter *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUIDQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the split load collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SplitLoadCollectionGetParams) WithDefaults() *SplitLoadCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the split load collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SplitLoadCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := SplitLoadCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithTimeout(timeout time.Duration) *SplitLoadCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithContext(ctx context.Context) *SplitLoadCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithHTTPClient(client *http.Client) *SplitLoadCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithFieldsQueryParameter(fields []string) *SplitLoadCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithLoadAllowableQueryParameter adds the loadAllowable to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithLoadAllowableQueryParameter(loadAllowable *int64) *SplitLoadCollectionGetParams {
	o.SetLoadAllowableQueryParameter(loadAllowable)
	return o
}

// SetLoadAllowableQueryParameter adds the loadAllowable to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetLoadAllowableQueryParameter(loadAllowable *int64) {
	o.LoadAllowableQueryParameter = loadAllowable
}

// WithLoadCurrentQueryParameter adds the loadCurrent to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithLoadCurrentQueryParameter(loadCurrent *int64) *SplitLoadCollectionGetParams {
	o.SetLoadCurrentQueryParameter(loadCurrent)
	return o
}

// SetLoadCurrentQueryParameter adds the loadCurrent to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetLoadCurrentQueryParameter(loadCurrent *int64) {
	o.LoadCurrentQueryParameter = loadCurrent
}

// WithLoadMaximumQueryParameter adds the loadMaximum to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithLoadMaximumQueryParameter(loadMaximum *int64) *SplitLoadCollectionGetParams {
	o.SetLoadMaximumQueryParameter(loadMaximum)
	return o
}

// SetLoadMaximumQueryParameter adds the loadMaximum to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetLoadMaximumQueryParameter(loadMaximum *int64) {
	o.LoadMaximumQueryParameter = loadMaximum
}

// WithLoadTokenReservedQueryParameter adds the loadTokenReserved to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithLoadTokenReservedQueryParameter(loadTokenReserved *int64) *SplitLoadCollectionGetParams {
	o.SetLoadTokenReservedQueryParameter(loadTokenReserved)
	return o
}

// SetLoadTokenReservedQueryParameter adds the loadTokenReserved to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetLoadTokenReservedQueryParameter(loadTokenReserved *int64) {
	o.LoadTokenReservedQueryParameter = loadTokenReserved
}

// WithMaxRecordsQueryParameter adds the maxRecords to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *SplitLoadCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNodeNameQueryParameter adds the nodeName to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithNodeNameQueryParameter(nodeName *string) *SplitLoadCollectionGetParams {
	o.SetNodeNameQueryParameter(nodeName)
	return o
}

// SetNodeNameQueryParameter adds the nodeName to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetNodeNameQueryParameter(nodeName *string) {
	o.NodeNameQueryParameter = nodeName
}

// WithNodeUUIDQueryParameter adds the nodeUUID to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithNodeUUIDQueryParameter(nodeUUID *string) *SplitLoadCollectionGetParams {
	o.SetNodeUUIDQueryParameter(nodeUUID)
	return o
}

// SetNodeUUIDQueryParameter adds the nodeUuid to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetNodeUUIDQueryParameter(nodeUUID *string) {
	o.NodeUUIDQueryParameter = nodeUUID
}

// WithOrderByQueryParameter adds the orderBy to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *SplitLoadCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *SplitLoadCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the split load collection get params
func (o *SplitLoadCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *SplitLoadCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the split load collection get params
func (o *SplitLoadCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *SplitLoadCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.LoadAllowableQueryParameter != nil {

		// query param load.allowable
		var qrLoadAllowable int64

		if o.LoadAllowableQueryParameter != nil {
			qrLoadAllowable = *o.LoadAllowableQueryParameter
		}
		qLoadAllowable := swag.FormatInt64(qrLoadAllowable)
		if qLoadAllowable != "" {

			if err := r.SetQueryParam("load.allowable", qLoadAllowable); err != nil {
				return err
			}
		}
	}

	if o.LoadCurrentQueryParameter != nil {

		// query param load.current
		var qrLoadCurrent int64

		if o.LoadCurrentQueryParameter != nil {
			qrLoadCurrent = *o.LoadCurrentQueryParameter
		}
		qLoadCurrent := swag.FormatInt64(qrLoadCurrent)
		if qLoadCurrent != "" {

			if err := r.SetQueryParam("load.current", qLoadCurrent); err != nil {
				return err
			}
		}
	}

	if o.LoadMaximumQueryParameter != nil {

		// query param load.maximum
		var qrLoadMaximum int64

		if o.LoadMaximumQueryParameter != nil {
			qrLoadMaximum = *o.LoadMaximumQueryParameter
		}
		qLoadMaximum := swag.FormatInt64(qrLoadMaximum)
		if qLoadMaximum != "" {

			if err := r.SetQueryParam("load.maximum", qLoadMaximum); err != nil {
				return err
			}
		}
	}

	if o.LoadTokenReservedQueryParameter != nil {

		// query param load.token_reserved
		var qrLoadTokenReserved int64

		if o.LoadTokenReservedQueryParameter != nil {
			qrLoadTokenReserved = *o.LoadTokenReservedQueryParameter
		}
		qLoadTokenReserved := swag.FormatInt64(qrLoadTokenReserved)
		if qLoadTokenReserved != "" {

			if err := r.SetQueryParam("load.token_reserved", qLoadTokenReserved); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NodeNameQueryParameter != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeNameQueryParameter != nil {
			qrNodeName = *o.NodeNameQueryParameter
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUIDQueryParameter != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUIDQueryParameter != nil {
			qrNodeUUID = *o.NodeUUIDQueryParameter
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSplitLoadCollectionGet binds the parameter fields
func (o *SplitLoadCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamSplitLoadCollectionGet binds the parameter order_by
func (o *SplitLoadCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
