// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewTokenCollectionGetParams creates a new TokenCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewTokenCollectionGetParams() *TokenCollectionGetParams {
	return &TokenCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewTokenCollectionGetParamsWithTimeout creates a new TokenCollectionGetParams object
// with the ability to set a timeout on a request.
func NewTokenCollectionGetParamsWithTimeout(timeout time.Duration) *TokenCollectionGetParams {
	return &TokenCollectionGetParams{
		timeout: timeout,
	}
}

// NewTokenCollectionGetParamsWithContext creates a new TokenCollectionGetParams object
// with the ability to set a context for a request.
func NewTokenCollectionGetParamsWithContext(ctx context.Context) *TokenCollectionGetParams {
	return &TokenCollectionGetParams{
		Context: ctx,
	}
}

// NewTokenCollectionGetParamsWithHTTPClient creates a new TokenCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewTokenCollectionGetParamsWithHTTPClient(client *http.Client) *TokenCollectionGetParams {
	return &TokenCollectionGetParams{
		HTTPClient: client,
	}
}

/* TokenCollectionGetParams contains all the parameters to send to the API endpoint
   for the token collection get operation.

   Typically these are written to a http.Request.
*/
type TokenCollectionGetParams struct {

	/* ExpiryTimeLeft.

	   Filter by expiry_time.left
	*/
	ExpiryTimeLeftQueryParameter *string

	/* ExpiryTimeLimit.

	   Filter by expiry_time.limit
	*/
	ExpiryTimeLimitQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* NodeName.

	   Filter by node.name
	*/
	NodeNameQueryParameter *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUIDQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReserveSize.

	   Filter by reserve_size
	*/
	ReserveSizeQueryParameter *int64

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the token collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TokenCollectionGetParams) WithDefaults() *TokenCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the token collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TokenCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := TokenCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the token collection get params
func (o *TokenCollectionGetParams) WithTimeout(timeout time.Duration) *TokenCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the token collection get params
func (o *TokenCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the token collection get params
func (o *TokenCollectionGetParams) WithContext(ctx context.Context) *TokenCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the token collection get params
func (o *TokenCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the token collection get params
func (o *TokenCollectionGetParams) WithHTTPClient(client *http.Client) *TokenCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the token collection get params
func (o *TokenCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithExpiryTimeLeftQueryParameter adds the expiryTimeLeft to the token collection get params
func (o *TokenCollectionGetParams) WithExpiryTimeLeftQueryParameter(expiryTimeLeft *string) *TokenCollectionGetParams {
	o.SetExpiryTimeLeftQueryParameter(expiryTimeLeft)
	return o
}

// SetExpiryTimeLeftQueryParameter adds the expiryTimeLeft to the token collection get params
func (o *TokenCollectionGetParams) SetExpiryTimeLeftQueryParameter(expiryTimeLeft *string) {
	o.ExpiryTimeLeftQueryParameter = expiryTimeLeft
}

// WithExpiryTimeLimitQueryParameter adds the expiryTimeLimit to the token collection get params
func (o *TokenCollectionGetParams) WithExpiryTimeLimitQueryParameter(expiryTimeLimit *string) *TokenCollectionGetParams {
	o.SetExpiryTimeLimitQueryParameter(expiryTimeLimit)
	return o
}

// SetExpiryTimeLimitQueryParameter adds the expiryTimeLimit to the token collection get params
func (o *TokenCollectionGetParams) SetExpiryTimeLimitQueryParameter(expiryTimeLimit *string) {
	o.ExpiryTimeLimitQueryParameter = expiryTimeLimit
}

// WithFieldsQueryParameter adds the fields to the token collection get params
func (o *TokenCollectionGetParams) WithFieldsQueryParameter(fields []string) *TokenCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the token collection get params
func (o *TokenCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the token collection get params
func (o *TokenCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *TokenCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the token collection get params
func (o *TokenCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNodeNameQueryParameter adds the nodeName to the token collection get params
func (o *TokenCollectionGetParams) WithNodeNameQueryParameter(nodeName *string) *TokenCollectionGetParams {
	o.SetNodeNameQueryParameter(nodeName)
	return o
}

// SetNodeNameQueryParameter adds the nodeName to the token collection get params
func (o *TokenCollectionGetParams) SetNodeNameQueryParameter(nodeName *string) {
	o.NodeNameQueryParameter = nodeName
}

// WithNodeUUIDQueryParameter adds the nodeUUID to the token collection get params
func (o *TokenCollectionGetParams) WithNodeUUIDQueryParameter(nodeUUID *string) *TokenCollectionGetParams {
	o.SetNodeUUIDQueryParameter(nodeUUID)
	return o
}

// SetNodeUUIDQueryParameter adds the nodeUuid to the token collection get params
func (o *TokenCollectionGetParams) SetNodeUUIDQueryParameter(nodeUUID *string) {
	o.NodeUUIDQueryParameter = nodeUUID
}

// WithOrderByQueryParameter adds the orderBy to the token collection get params
func (o *TokenCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *TokenCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the token collection get params
func (o *TokenCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReserveSizeQueryParameter adds the reserveSize to the token collection get params
func (o *TokenCollectionGetParams) WithReserveSizeQueryParameter(reserveSize *int64) *TokenCollectionGetParams {
	o.SetReserveSizeQueryParameter(reserveSize)
	return o
}

// SetReserveSizeQueryParameter adds the reserveSize to the token collection get params
func (o *TokenCollectionGetParams) SetReserveSizeQueryParameter(reserveSize *int64) {
	o.ReserveSizeQueryParameter = reserveSize
}

// WithReturnRecordsQueryParameter adds the returnRecords to the token collection get params
func (o *TokenCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *TokenCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the token collection get params
func (o *TokenCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the token collection get params
func (o *TokenCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *TokenCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the token collection get params
func (o *TokenCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithUUIDQueryParameter adds the uuid to the token collection get params
func (o *TokenCollectionGetParams) WithUUIDQueryParameter(uuid *string) *TokenCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the token collection get params
func (o *TokenCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *TokenCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ExpiryTimeLeftQueryParameter != nil {

		// query param expiry_time.left
		var qrExpiryTimeLeft string

		if o.ExpiryTimeLeftQueryParameter != nil {
			qrExpiryTimeLeft = *o.ExpiryTimeLeftQueryParameter
		}
		qExpiryTimeLeft := qrExpiryTimeLeft
		if qExpiryTimeLeft != "" {

			if err := r.SetQueryParam("expiry_time.left", qExpiryTimeLeft); err != nil {
				return err
			}
		}
	}

	if o.ExpiryTimeLimitQueryParameter != nil {

		// query param expiry_time.limit
		var qrExpiryTimeLimit string

		if o.ExpiryTimeLimitQueryParameter != nil {
			qrExpiryTimeLimit = *o.ExpiryTimeLimitQueryParameter
		}
		qExpiryTimeLimit := qrExpiryTimeLimit
		if qExpiryTimeLimit != "" {

			if err := r.SetQueryParam("expiry_time.limit", qExpiryTimeLimit); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NodeNameQueryParameter != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeNameQueryParameter != nil {
			qrNodeName = *o.NodeNameQueryParameter
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUIDQueryParameter != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUIDQueryParameter != nil {
			qrNodeUUID = *o.NodeUUIDQueryParameter
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReserveSizeQueryParameter != nil {

		// query param reserve_size
		var qrReserveSize int64

		if o.ReserveSizeQueryParameter != nil {
			qrReserveSize = *o.ReserveSizeQueryParameter
		}
		qReserveSize := swag.FormatInt64(qrReserveSize)
		if qReserveSize != "" {

			if err := r.SetQueryParam("reserve_size", qReserveSize); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamTokenCollectionGet binds the parameter fields
func (o *TokenCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamTokenCollectionGet binds the parameter order_by
func (o *TokenCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
