// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewTokenGetParams creates a new TokenGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewTokenGetParams() *TokenGetParams {
	return &TokenGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewTokenGetParamsWithTimeout creates a new TokenGetParams object
// with the ability to set a timeout on a request.
func NewTokenGetParamsWithTimeout(timeout time.Duration) *TokenGetParams {
	return &TokenGetParams{
		timeout: timeout,
	}
}

// NewTokenGetParamsWithContext creates a new TokenGetParams object
// with the ability to set a context for a request.
func NewTokenGetParamsWithContext(ctx context.Context) *TokenGetParams {
	return &TokenGetParams{
		Context: ctx,
	}
}

// NewTokenGetParamsWithHTTPClient creates a new TokenGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewTokenGetParamsWithHTTPClient(client *http.Client) *TokenGetParams {
	return &TokenGetParams{
		HTTPClient: client,
	}
}

/* TokenGetParams contains all the parameters to send to the API endpoint
   for the token get operation.

   Typically these are written to a http.Request.
*/
type TokenGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* NodeUUID.

	   Node UUID
	*/
	NodeUUIDPathParameter string

	/* UUID.

	   Token UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the token get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TokenGetParams) WithDefaults() *TokenGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the token get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TokenGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the token get params
func (o *TokenGetParams) WithTimeout(timeout time.Duration) *TokenGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the token get params
func (o *TokenGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the token get params
func (o *TokenGetParams) WithContext(ctx context.Context) *TokenGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the token get params
func (o *TokenGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the token get params
func (o *TokenGetParams) WithHTTPClient(client *http.Client) *TokenGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the token get params
func (o *TokenGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the token get params
func (o *TokenGetParams) WithFieldsQueryParameter(fields []string) *TokenGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the token get params
func (o *TokenGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithNodeUUIDPathParameter adds the nodeUUID to the token get params
func (o *TokenGetParams) WithNodeUUIDPathParameter(nodeUUID string) *TokenGetParams {
	o.SetNodeUUIDPathParameter(nodeUUID)
	return o
}

// SetNodeUUIDPathParameter adds the nodeUuid to the token get params
func (o *TokenGetParams) SetNodeUUIDPathParameter(nodeUUID string) {
	o.NodeUUIDPathParameter = nodeUUID
}

// WithUUIDPathParameter adds the uuid to the token get params
func (o *TokenGetParams) WithUUIDPathParameter(uuid string) *TokenGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the token get params
func (o *TokenGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *TokenGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param node.uuid
	if err := r.SetPathParam("node.uuid", o.NodeUUIDPathParameter); err != nil {
		return err
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamTokenGet binds the parameter fields
func (o *TokenGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
