// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVolumeEfficiencyPolicyGetParams creates a new VolumeEfficiencyPolicyGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVolumeEfficiencyPolicyGetParams() *VolumeEfficiencyPolicyGetParams {
	return &VolumeEfficiencyPolicyGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVolumeEfficiencyPolicyGetParamsWithTimeout creates a new VolumeEfficiencyPolicyGetParams object
// with the ability to set a timeout on a request.
func NewVolumeEfficiencyPolicyGetParamsWithTimeout(timeout time.Duration) *VolumeEfficiencyPolicyGetParams {
	return &VolumeEfficiencyPolicyGetParams{
		timeout: timeout,
	}
}

// NewVolumeEfficiencyPolicyGetParamsWithContext creates a new VolumeEfficiencyPolicyGetParams object
// with the ability to set a context for a request.
func NewVolumeEfficiencyPolicyGetParamsWithContext(ctx context.Context) *VolumeEfficiencyPolicyGetParams {
	return &VolumeEfficiencyPolicyGetParams{
		Context: ctx,
	}
}

// NewVolumeEfficiencyPolicyGetParamsWithHTTPClient creates a new VolumeEfficiencyPolicyGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewVolumeEfficiencyPolicyGetParamsWithHTTPClient(client *http.Client) *VolumeEfficiencyPolicyGetParams {
	return &VolumeEfficiencyPolicyGetParams{
		HTTPClient: client,
	}
}

/* VolumeEfficiencyPolicyGetParams contains all the parameters to send to the API endpoint
   for the volume efficiency policy get operation.

   Typically these are written to a http.Request.
*/
type VolumeEfficiencyPolicyGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* UUID.

	   Volume efficiency policy UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the volume efficiency policy get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VolumeEfficiencyPolicyGetParams) WithDefaults() *VolumeEfficiencyPolicyGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the volume efficiency policy get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VolumeEfficiencyPolicyGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) WithTimeout(timeout time.Duration) *VolumeEfficiencyPolicyGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) WithContext(ctx context.Context) *VolumeEfficiencyPolicyGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) WithHTTPClient(client *http.Client) *VolumeEfficiencyPolicyGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) WithFieldsQueryParameter(fields []string) *VolumeEfficiencyPolicyGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithUUIDPathParameter adds the uuid to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) WithUUIDPathParameter(uuid string) *VolumeEfficiencyPolicyGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the volume efficiency policy get params
func (o *VolumeEfficiencyPolicyGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *VolumeEfficiencyPolicyGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamVolumeEfficiencyPolicyGet binds the parameter fields
func (o *VolumeEfficiencyPolicyGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
