// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewAutoUpdateConfigurationCollectionGetParams creates a new AutoUpdateConfigurationCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAutoUpdateConfigurationCollectionGetParams() *AutoUpdateConfigurationCollectionGetParams {
	return &AutoUpdateConfigurationCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAutoUpdateConfigurationCollectionGetParamsWithTimeout creates a new AutoUpdateConfigurationCollectionGetParams object
// with the ability to set a timeout on a request.
func NewAutoUpdateConfigurationCollectionGetParamsWithTimeout(timeout time.Duration) *AutoUpdateConfigurationCollectionGetParams {
	return &AutoUpdateConfigurationCollectionGetParams{
		timeout: timeout,
	}
}

// NewAutoUpdateConfigurationCollectionGetParamsWithContext creates a new AutoUpdateConfigurationCollectionGetParams object
// with the ability to set a context for a request.
func NewAutoUpdateConfigurationCollectionGetParamsWithContext(ctx context.Context) *AutoUpdateConfigurationCollectionGetParams {
	return &AutoUpdateConfigurationCollectionGetParams{
		Context: ctx,
	}
}

// NewAutoUpdateConfigurationCollectionGetParamsWithHTTPClient creates a new AutoUpdateConfigurationCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewAutoUpdateConfigurationCollectionGetParamsWithHTTPClient(client *http.Client) *AutoUpdateConfigurationCollectionGetParams {
	return &AutoUpdateConfigurationCollectionGetParams{
		HTTPClient: client,
	}
}

/* AutoUpdateConfigurationCollectionGetParams contains all the parameters to send to the API endpoint
   for the auto update configuration collection get operation.

   Typically these are written to a http.Request.
*/
type AutoUpdateConfigurationCollectionGetParams struct {

	/* Action.

	   Filter by action
	*/
	ActionQueryParameter *string

	/* Category.

	   Filter by category
	*/
	CategoryQueryParameter *string

	/* DescriptionCode.

	   Filter by description.code
	*/
	DescriptionCodeQueryParameter *string

	/* DescriptionMessage.

	   Filter by description.message
	*/
	DescriptionMessageQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the auto update configuration collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AutoUpdateConfigurationCollectionGetParams) WithDefaults() *AutoUpdateConfigurationCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the auto update configuration collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AutoUpdateConfigurationCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := AutoUpdateConfigurationCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithTimeout(timeout time.Duration) *AutoUpdateConfigurationCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithContext(ctx context.Context) *AutoUpdateConfigurationCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithHTTPClient(client *http.Client) *AutoUpdateConfigurationCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActionQueryParameter adds the action to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithActionQueryParameter(action *string) *AutoUpdateConfigurationCollectionGetParams {
	o.SetActionQueryParameter(action)
	return o
}

// SetActionQueryParameter adds the action to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetActionQueryParameter(action *string) {
	o.ActionQueryParameter = action
}

// WithCategoryQueryParameter adds the category to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithCategoryQueryParameter(category *string) *AutoUpdateConfigurationCollectionGetParams {
	o.SetCategoryQueryParameter(category)
	return o
}

// SetCategoryQueryParameter adds the category to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetCategoryQueryParameter(category *string) {
	o.CategoryQueryParameter = category
}

// WithDescriptionCodeQueryParameter adds the descriptionCode to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithDescriptionCodeQueryParameter(descriptionCode *string) *AutoUpdateConfigurationCollectionGetParams {
	o.SetDescriptionCodeQueryParameter(descriptionCode)
	return o
}

// SetDescriptionCodeQueryParameter adds the descriptionCode to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetDescriptionCodeQueryParameter(descriptionCode *string) {
	o.DescriptionCodeQueryParameter = descriptionCode
}

// WithDescriptionMessageQueryParameter adds the descriptionMessage to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithDescriptionMessageQueryParameter(descriptionMessage *string) *AutoUpdateConfigurationCollectionGetParams {
	o.SetDescriptionMessageQueryParameter(descriptionMessage)
	return o
}

// SetDescriptionMessageQueryParameter adds the descriptionMessage to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetDescriptionMessageQueryParameter(descriptionMessage *string) {
	o.DescriptionMessageQueryParameter = descriptionMessage
}

// WithFieldsQueryParameter adds the fields to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithFieldsQueryParameter(fields []string) *AutoUpdateConfigurationCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *AutoUpdateConfigurationCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *AutoUpdateConfigurationCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *AutoUpdateConfigurationCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *AutoUpdateConfigurationCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithUUIDQueryParameter adds the uuid to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) WithUUIDQueryParameter(uuid *string) *AutoUpdateConfigurationCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the auto update configuration collection get params
func (o *AutoUpdateConfigurationCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *AutoUpdateConfigurationCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ActionQueryParameter != nil {

		// query param action
		var qrAction string

		if o.ActionQueryParameter != nil {
			qrAction = *o.ActionQueryParameter
		}
		qAction := qrAction
		if qAction != "" {

			if err := r.SetQueryParam("action", qAction); err != nil {
				return err
			}
		}
	}

	if o.CategoryQueryParameter != nil {

		// query param category
		var qrCategory string

		if o.CategoryQueryParameter != nil {
			qrCategory = *o.CategoryQueryParameter
		}
		qCategory := qrCategory
		if qCategory != "" {

			if err := r.SetQueryParam("category", qCategory); err != nil {
				return err
			}
		}
	}

	if o.DescriptionCodeQueryParameter != nil {

		// query param description.code
		var qrDescriptionCode string

		if o.DescriptionCodeQueryParameter != nil {
			qrDescriptionCode = *o.DescriptionCodeQueryParameter
		}
		qDescriptionCode := qrDescriptionCode
		if qDescriptionCode != "" {

			if err := r.SetQueryParam("description.code", qDescriptionCode); err != nil {
				return err
			}
		}
	}

	if o.DescriptionMessageQueryParameter != nil {

		// query param description.message
		var qrDescriptionMessage string

		if o.DescriptionMessageQueryParameter != nil {
			qrDescriptionMessage = *o.DescriptionMessageQueryParameter
		}
		qDescriptionMessage := qrDescriptionMessage
		if qDescriptionMessage != "" {

			if err := r.SetQueryParam("description.message", qDescriptionMessage); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamAutoUpdateConfigurationCollectionGet binds the parameter fields
func (o *AutoUpdateConfigurationCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamAutoUpdateConfigurationCollectionGet binds the parameter order_by
func (o *AutoUpdateConfigurationCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
