// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewAutosupportMessageCollectionGetParams creates a new AutosupportMessageCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAutosupportMessageCollectionGetParams() *AutosupportMessageCollectionGetParams {
	return &AutosupportMessageCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAutosupportMessageCollectionGetParamsWithTimeout creates a new AutosupportMessageCollectionGetParams object
// with the ability to set a timeout on a request.
func NewAutosupportMessageCollectionGetParamsWithTimeout(timeout time.Duration) *AutosupportMessageCollectionGetParams {
	return &AutosupportMessageCollectionGetParams{
		timeout: timeout,
	}
}

// NewAutosupportMessageCollectionGetParamsWithContext creates a new AutosupportMessageCollectionGetParams object
// with the ability to set a context for a request.
func NewAutosupportMessageCollectionGetParamsWithContext(ctx context.Context) *AutosupportMessageCollectionGetParams {
	return &AutosupportMessageCollectionGetParams{
		Context: ctx,
	}
}

// NewAutosupportMessageCollectionGetParamsWithHTTPClient creates a new AutosupportMessageCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewAutosupportMessageCollectionGetParamsWithHTTPClient(client *http.Client) *AutosupportMessageCollectionGetParams {
	return &AutosupportMessageCollectionGetParams{
		HTTPClient: client,
	}
}

/* AutosupportMessageCollectionGetParams contains all the parameters to send to the API endpoint
   for the autosupport message collection get operation.

   Typically these are written to a http.Request.
*/
type AutosupportMessageCollectionGetParams struct {

	/* Destination.

	   Filter by destination
	*/
	DestinationQueryParameter *string

	/* ErrorCode.

	   Filter by error.code
	*/
	ErrorCodeQueryParameter *int64

	/* ErrorMessage.

	   Filter by error.message
	*/
	ErrorMessageQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* GeneratedOn.

	   Filter by generated_on
	*/
	GeneratedOnQueryParameter *string

	/* Index.

	   Filter by index
	*/
	IndexQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* NodeName.

	   Filter by node.name
	*/
	NodeNameQueryParameter *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUIDQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* State.

	   Filter by state
	*/
	StateQueryParameter *string

	/* Subject.

	   Filter by subject
	*/
	SubjectQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the autosupport message collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AutosupportMessageCollectionGetParams) WithDefaults() *AutosupportMessageCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the autosupport message collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AutosupportMessageCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := AutosupportMessageCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithTimeout(timeout time.Duration) *AutosupportMessageCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithContext(ctx context.Context) *AutosupportMessageCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithHTTPClient(client *http.Client) *AutosupportMessageCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDestinationQueryParameter adds the destination to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithDestinationQueryParameter(destination *string) *AutosupportMessageCollectionGetParams {
	o.SetDestinationQueryParameter(destination)
	return o
}

// SetDestinationQueryParameter adds the destination to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetDestinationQueryParameter(destination *string) {
	o.DestinationQueryParameter = destination
}

// WithErrorCodeQueryParameter adds the errorCode to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithErrorCodeQueryParameter(errorCode *int64) *AutosupportMessageCollectionGetParams {
	o.SetErrorCodeQueryParameter(errorCode)
	return o
}

// SetErrorCodeQueryParameter adds the errorCode to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetErrorCodeQueryParameter(errorCode *int64) {
	o.ErrorCodeQueryParameter = errorCode
}

// WithErrorMessageQueryParameter adds the errorMessage to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithErrorMessageQueryParameter(errorMessage *string) *AutosupportMessageCollectionGetParams {
	o.SetErrorMessageQueryParameter(errorMessage)
	return o
}

// SetErrorMessageQueryParameter adds the errorMessage to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetErrorMessageQueryParameter(errorMessage *string) {
	o.ErrorMessageQueryParameter = errorMessage
}

// WithFieldsQueryParameter adds the fields to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithFieldsQueryParameter(fields []string) *AutosupportMessageCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithGeneratedOnQueryParameter adds the generatedOn to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithGeneratedOnQueryParameter(generatedOn *string) *AutosupportMessageCollectionGetParams {
	o.SetGeneratedOnQueryParameter(generatedOn)
	return o
}

// SetGeneratedOnQueryParameter adds the generatedOn to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetGeneratedOnQueryParameter(generatedOn *string) {
	o.GeneratedOnQueryParameter = generatedOn
}

// WithIndexQueryParameter adds the index to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithIndexQueryParameter(index *int64) *AutosupportMessageCollectionGetParams {
	o.SetIndexQueryParameter(index)
	return o
}

// SetIndexQueryParameter adds the index to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetIndexQueryParameter(index *int64) {
	o.IndexQueryParameter = index
}

// WithMaxRecordsQueryParameter adds the maxRecords to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *AutosupportMessageCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNodeNameQueryParameter adds the nodeName to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithNodeNameQueryParameter(nodeName *string) *AutosupportMessageCollectionGetParams {
	o.SetNodeNameQueryParameter(nodeName)
	return o
}

// SetNodeNameQueryParameter adds the nodeName to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetNodeNameQueryParameter(nodeName *string) {
	o.NodeNameQueryParameter = nodeName
}

// WithNodeUUIDQueryParameter adds the nodeUUID to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithNodeUUIDQueryParameter(nodeUUID *string) *AutosupportMessageCollectionGetParams {
	o.SetNodeUUIDQueryParameter(nodeUUID)
	return o
}

// SetNodeUUIDQueryParameter adds the nodeUuid to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetNodeUUIDQueryParameter(nodeUUID *string) {
	o.NodeUUIDQueryParameter = nodeUUID
}

// WithOrderByQueryParameter adds the orderBy to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *AutosupportMessageCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *AutosupportMessageCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *AutosupportMessageCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithStateQueryParameter adds the state to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithStateQueryParameter(state *string) *AutosupportMessageCollectionGetParams {
	o.SetStateQueryParameter(state)
	return o
}

// SetStateQueryParameter adds the state to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetStateQueryParameter(state *string) {
	o.StateQueryParameter = state
}

// WithSubjectQueryParameter adds the subject to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) WithSubjectQueryParameter(subject *string) *AutosupportMessageCollectionGetParams {
	o.SetSubjectQueryParameter(subject)
	return o
}

// SetSubjectQueryParameter adds the subject to the autosupport message collection get params
func (o *AutosupportMessageCollectionGetParams) SetSubjectQueryParameter(subject *string) {
	o.SubjectQueryParameter = subject
}

// WriteToRequest writes these params to a swagger request
func (o *AutosupportMessageCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DestinationQueryParameter != nil {

		// query param destination
		var qrDestination string

		if o.DestinationQueryParameter != nil {
			qrDestination = *o.DestinationQueryParameter
		}
		qDestination := qrDestination
		if qDestination != "" {

			if err := r.SetQueryParam("destination", qDestination); err != nil {
				return err
			}
		}
	}

	if o.ErrorCodeQueryParameter != nil {

		// query param error.code
		var qrErrorCode int64

		if o.ErrorCodeQueryParameter != nil {
			qrErrorCode = *o.ErrorCodeQueryParameter
		}
		qErrorCode := swag.FormatInt64(qrErrorCode)
		if qErrorCode != "" {

			if err := r.SetQueryParam("error.code", qErrorCode); err != nil {
				return err
			}
		}
	}

	if o.ErrorMessageQueryParameter != nil {

		// query param error.message
		var qrErrorMessage string

		if o.ErrorMessageQueryParameter != nil {
			qrErrorMessage = *o.ErrorMessageQueryParameter
		}
		qErrorMessage := qrErrorMessage
		if qErrorMessage != "" {

			if err := r.SetQueryParam("error.message", qErrorMessage); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.GeneratedOnQueryParameter != nil {

		// query param generated_on
		var qrGeneratedOn string

		if o.GeneratedOnQueryParameter != nil {
			qrGeneratedOn = *o.GeneratedOnQueryParameter
		}
		qGeneratedOn := qrGeneratedOn
		if qGeneratedOn != "" {

			if err := r.SetQueryParam("generated_on", qGeneratedOn); err != nil {
				return err
			}
		}
	}

	if o.IndexQueryParameter != nil {

		// query param index
		var qrIndex int64

		if o.IndexQueryParameter != nil {
			qrIndex = *o.IndexQueryParameter
		}
		qIndex := swag.FormatInt64(qrIndex)
		if qIndex != "" {

			if err := r.SetQueryParam("index", qIndex); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NodeNameQueryParameter != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeNameQueryParameter != nil {
			qrNodeName = *o.NodeNameQueryParameter
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUIDQueryParameter != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUIDQueryParameter != nil {
			qrNodeUUID = *o.NodeUUIDQueryParameter
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.StateQueryParameter != nil {

		// query param state
		var qrState string

		if o.StateQueryParameter != nil {
			qrState = *o.StateQueryParameter
		}
		qState := qrState
		if qState != "" {

			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}
	}

	if o.SubjectQueryParameter != nil {

		// query param subject
		var qrSubject string

		if o.SubjectQueryParameter != nil {
			qrSubject = *o.SubjectQueryParameter
		}
		qSubject := qrSubject
		if qSubject != "" {

			if err := r.SetQueryParam("subject", qSubject); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamAutosupportMessageCollectionGet binds the parameter fields
func (o *AutosupportMessageCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamAutosupportMessageCollectionGet binds the parameter order_by
func (o *AutosupportMessageCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
