// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewConfigurationBackupFileCollectionGetParams creates a new ConfigurationBackupFileCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewConfigurationBackupFileCollectionGetParams() *ConfigurationBackupFileCollectionGetParams {
	return &ConfigurationBackupFileCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewConfigurationBackupFileCollectionGetParamsWithTimeout creates a new ConfigurationBackupFileCollectionGetParams object
// with the ability to set a timeout on a request.
func NewConfigurationBackupFileCollectionGetParamsWithTimeout(timeout time.Duration) *ConfigurationBackupFileCollectionGetParams {
	return &ConfigurationBackupFileCollectionGetParams{
		timeout: timeout,
	}
}

// NewConfigurationBackupFileCollectionGetParamsWithContext creates a new ConfigurationBackupFileCollectionGetParams object
// with the ability to set a context for a request.
func NewConfigurationBackupFileCollectionGetParamsWithContext(ctx context.Context) *ConfigurationBackupFileCollectionGetParams {
	return &ConfigurationBackupFileCollectionGetParams{
		Context: ctx,
	}
}

// NewConfigurationBackupFileCollectionGetParamsWithHTTPClient creates a new ConfigurationBackupFileCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewConfigurationBackupFileCollectionGetParamsWithHTTPClient(client *http.Client) *ConfigurationBackupFileCollectionGetParams {
	return &ConfigurationBackupFileCollectionGetParams{
		HTTPClient: client,
	}
}

/* ConfigurationBackupFileCollectionGetParams contains all the parameters to send to the API endpoint
   for the configuration backup file collection get operation.

   Typically these are written to a http.Request.
*/
type ConfigurationBackupFileCollectionGetParams struct {

	/* Auto.

	   Filter by auto
	*/
	AutoQueryParameter *bool

	/* BackupNodesName.

	   Filter by backup_nodes.name
	*/
	BackupNodesNameQueryParameter *string

	/* DownloadLink.

	   Filter by download_link
	*/
	DownloadLinkQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* NodeName.

	   Filter by node.name
	*/
	NodeNameQueryParameter *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUIDQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Size.

	   Filter by size
	*/
	SizeQueryParameter *int64

	/* Time.

	   Filter by time
	*/
	TimeQueryParameter *string

	/* Type.

	   Filter by type
	*/
	TypeQueryParameter *string

	/* Version.

	   Filter by version
	*/
	VersionQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the configuration backup file collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ConfigurationBackupFileCollectionGetParams) WithDefaults() *ConfigurationBackupFileCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the configuration backup file collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ConfigurationBackupFileCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ConfigurationBackupFileCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithTimeout(timeout time.Duration) *ConfigurationBackupFileCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithContext(ctx context.Context) *ConfigurationBackupFileCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithHTTPClient(client *http.Client) *ConfigurationBackupFileCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAutoQueryParameter adds the auto to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithAutoQueryParameter(auto *bool) *ConfigurationBackupFileCollectionGetParams {
	o.SetAutoQueryParameter(auto)
	return o
}

// SetAutoQueryParameter adds the auto to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetAutoQueryParameter(auto *bool) {
	o.AutoQueryParameter = auto
}

// WithBackupNodesNameQueryParameter adds the backupNodesName to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithBackupNodesNameQueryParameter(backupNodesName *string) *ConfigurationBackupFileCollectionGetParams {
	o.SetBackupNodesNameQueryParameter(backupNodesName)
	return o
}

// SetBackupNodesNameQueryParameter adds the backupNodesName to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetBackupNodesNameQueryParameter(backupNodesName *string) {
	o.BackupNodesNameQueryParameter = backupNodesName
}

// WithDownloadLinkQueryParameter adds the downloadLink to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithDownloadLinkQueryParameter(downloadLink *string) *ConfigurationBackupFileCollectionGetParams {
	o.SetDownloadLinkQueryParameter(downloadLink)
	return o
}

// SetDownloadLinkQueryParameter adds the downloadLink to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetDownloadLinkQueryParameter(downloadLink *string) {
	o.DownloadLinkQueryParameter = downloadLink
}

// WithFieldsQueryParameter adds the fields to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithFieldsQueryParameter(fields []string) *ConfigurationBackupFileCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ConfigurationBackupFileCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithNameQueryParameter(name *string) *ConfigurationBackupFileCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithNodeNameQueryParameter adds the nodeName to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithNodeNameQueryParameter(nodeName *string) *ConfigurationBackupFileCollectionGetParams {
	o.SetNodeNameQueryParameter(nodeName)
	return o
}

// SetNodeNameQueryParameter adds the nodeName to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetNodeNameQueryParameter(nodeName *string) {
	o.NodeNameQueryParameter = nodeName
}

// WithNodeUUIDQueryParameter adds the nodeUUID to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithNodeUUIDQueryParameter(nodeUUID *string) *ConfigurationBackupFileCollectionGetParams {
	o.SetNodeUUIDQueryParameter(nodeUUID)
	return o
}

// SetNodeUUIDQueryParameter adds the nodeUuid to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetNodeUUIDQueryParameter(nodeUUID *string) {
	o.NodeUUIDQueryParameter = nodeUUID
}

// WithOrderByQueryParameter adds the orderBy to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ConfigurationBackupFileCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ConfigurationBackupFileCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ConfigurationBackupFileCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSizeQueryParameter adds the size to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithSizeQueryParameter(size *int64) *ConfigurationBackupFileCollectionGetParams {
	o.SetSizeQueryParameter(size)
	return o
}

// SetSizeQueryParameter adds the size to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetSizeQueryParameter(size *int64) {
	o.SizeQueryParameter = size
}

// WithTimeQueryParameter adds the time to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithTimeQueryParameter(time *string) *ConfigurationBackupFileCollectionGetParams {
	o.SetTimeQueryParameter(time)
	return o
}

// SetTimeQueryParameter adds the time to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetTimeQueryParameter(time *string) {
	o.TimeQueryParameter = time
}

// WithTypeQueryParameter adds the typeVar to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithTypeQueryParameter(typeVar *string) *ConfigurationBackupFileCollectionGetParams {
	o.SetTypeQueryParameter(typeVar)
	return o
}

// SetTypeQueryParameter adds the type to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetTypeQueryParameter(typeVar *string) {
	o.TypeQueryParameter = typeVar
}

// WithVersionQueryParameter adds the version to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) WithVersionQueryParameter(version *string) *ConfigurationBackupFileCollectionGetParams {
	o.SetVersionQueryParameter(version)
	return o
}

// SetVersionQueryParameter adds the version to the configuration backup file collection get params
func (o *ConfigurationBackupFileCollectionGetParams) SetVersionQueryParameter(version *string) {
	o.VersionQueryParameter = version
}

// WriteToRequest writes these params to a swagger request
func (o *ConfigurationBackupFileCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AutoQueryParameter != nil {

		// query param auto
		var qrAuto bool

		if o.AutoQueryParameter != nil {
			qrAuto = *o.AutoQueryParameter
		}
		qAuto := swag.FormatBool(qrAuto)
		if qAuto != "" {

			if err := r.SetQueryParam("auto", qAuto); err != nil {
				return err
			}
		}
	}

	if o.BackupNodesNameQueryParameter != nil {

		// query param backup_nodes.name
		var qrBackupNodesName string

		if o.BackupNodesNameQueryParameter != nil {
			qrBackupNodesName = *o.BackupNodesNameQueryParameter
		}
		qBackupNodesName := qrBackupNodesName
		if qBackupNodesName != "" {

			if err := r.SetQueryParam("backup_nodes.name", qBackupNodesName); err != nil {
				return err
			}
		}
	}

	if o.DownloadLinkQueryParameter != nil {

		// query param download_link
		var qrDownloadLink string

		if o.DownloadLinkQueryParameter != nil {
			qrDownloadLink = *o.DownloadLinkQueryParameter
		}
		qDownloadLink := qrDownloadLink
		if qDownloadLink != "" {

			if err := r.SetQueryParam("download_link", qDownloadLink); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NodeNameQueryParameter != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeNameQueryParameter != nil {
			qrNodeName = *o.NodeNameQueryParameter
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUIDQueryParameter != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUIDQueryParameter != nil {
			qrNodeUUID = *o.NodeUUIDQueryParameter
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SizeQueryParameter != nil {

		// query param size
		var qrSize int64

		if o.SizeQueryParameter != nil {
			qrSize = *o.SizeQueryParameter
		}
		qSize := swag.FormatInt64(qrSize)
		if qSize != "" {

			if err := r.SetQueryParam("size", qSize); err != nil {
				return err
			}
		}
	}

	if o.TimeQueryParameter != nil {

		// query param time
		var qrTime string

		if o.TimeQueryParameter != nil {
			qrTime = *o.TimeQueryParameter
		}
		qTime := qrTime
		if qTime != "" {

			if err := r.SetQueryParam("time", qTime); err != nil {
				return err
			}
		}
	}

	if o.TypeQueryParameter != nil {

		// query param type
		var qrType string

		if o.TypeQueryParameter != nil {
			qrType = *o.TypeQueryParameter
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if o.VersionQueryParameter != nil {

		// query param version
		var qrVersion string

		if o.VersionQueryParameter != nil {
			qrVersion = *o.VersionQueryParameter
		}
		qVersion := qrVersion
		if qVersion != "" {

			if err := r.SetQueryParam("version", qVersion); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamConfigurationBackupFileCollectionGet binds the parameter fields
func (o *ConfigurationBackupFileCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamConfigurationBackupFileCollectionGet binds the parameter order_by
func (o *ConfigurationBackupFileCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
