// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewEmsFilterCollectionGetParams creates a new EmsFilterCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewEmsFilterCollectionGetParams() *EmsFilterCollectionGetParams {
	return &EmsFilterCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewEmsFilterCollectionGetParamsWithTimeout creates a new EmsFilterCollectionGetParams object
// with the ability to set a timeout on a request.
func NewEmsFilterCollectionGetParamsWithTimeout(timeout time.Duration) *EmsFilterCollectionGetParams {
	return &EmsFilterCollectionGetParams{
		timeout: timeout,
	}
}

// NewEmsFilterCollectionGetParamsWithContext creates a new EmsFilterCollectionGetParams object
// with the ability to set a context for a request.
func NewEmsFilterCollectionGetParamsWithContext(ctx context.Context) *EmsFilterCollectionGetParams {
	return &EmsFilterCollectionGetParams{
		Context: ctx,
	}
}

// NewEmsFilterCollectionGetParamsWithHTTPClient creates a new EmsFilterCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewEmsFilterCollectionGetParamsWithHTTPClient(client *http.Client) *EmsFilterCollectionGetParams {
	return &EmsFilterCollectionGetParams{
		HTTPClient: client,
	}
}

/* EmsFilterCollectionGetParams contains all the parameters to send to the API endpoint
   for the ems filter collection get operation.

   Typically these are written to a http.Request.
*/
type EmsFilterCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* RulesIndex.

	   Filter by rules.index
	*/
	RulesIndexQueryParameter *int64

	/* RulesMessageCriteriaNamePattern.

	   Filter by rules.message_criteria.name_pattern
	*/
	RulesMessageCriteriaNamePatternQueryParameter *string

	/* RulesMessageCriteriaSeverities.

	   Filter by rules.message_criteria.severities
	*/
	RulesMessageCriteriaSeveritiesQueryParameter *string

	/* RulesMessageCriteriaSnmpTrapTypes.

	   Filter by rules.message_criteria.snmp_trap_types
	*/
	RulesMessageCriteriaSnmpTrapTypesQueryParameter *string

	/* RulesType.

	   Filter by rules.type
	*/
	RulesTypeQueryParameter *string

	/* SystemDefined.

	   Filter by system_defined
	*/
	SystemDefinedQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ems filter collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EmsFilterCollectionGetParams) WithDefaults() *EmsFilterCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ems filter collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EmsFilterCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := EmsFilterCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithTimeout(timeout time.Duration) *EmsFilterCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithContext(ctx context.Context) *EmsFilterCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithHTTPClient(client *http.Client) *EmsFilterCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithFieldsQueryParameter(fields []string) *EmsFilterCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *EmsFilterCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithNameQueryParameter(name *string) *EmsFilterCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *EmsFilterCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *EmsFilterCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *EmsFilterCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithRulesIndexQueryParameter adds the rulesIndex to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithRulesIndexQueryParameter(rulesIndex *int64) *EmsFilterCollectionGetParams {
	o.SetRulesIndexQueryParameter(rulesIndex)
	return o
}

// SetRulesIndexQueryParameter adds the rulesIndex to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetRulesIndexQueryParameter(rulesIndex *int64) {
	o.RulesIndexQueryParameter = rulesIndex
}

// WithRulesMessageCriteriaNamePatternQueryParameter adds the rulesMessageCriteriaNamePattern to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithRulesMessageCriteriaNamePatternQueryParameter(rulesMessageCriteriaNamePattern *string) *EmsFilterCollectionGetParams {
	o.SetRulesMessageCriteriaNamePatternQueryParameter(rulesMessageCriteriaNamePattern)
	return o
}

// SetRulesMessageCriteriaNamePatternQueryParameter adds the rulesMessageCriteriaNamePattern to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetRulesMessageCriteriaNamePatternQueryParameter(rulesMessageCriteriaNamePattern *string) {
	o.RulesMessageCriteriaNamePatternQueryParameter = rulesMessageCriteriaNamePattern
}

// WithRulesMessageCriteriaSeveritiesQueryParameter adds the rulesMessageCriteriaSeverities to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithRulesMessageCriteriaSeveritiesQueryParameter(rulesMessageCriteriaSeverities *string) *EmsFilterCollectionGetParams {
	o.SetRulesMessageCriteriaSeveritiesQueryParameter(rulesMessageCriteriaSeverities)
	return o
}

// SetRulesMessageCriteriaSeveritiesQueryParameter adds the rulesMessageCriteriaSeverities to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetRulesMessageCriteriaSeveritiesQueryParameter(rulesMessageCriteriaSeverities *string) {
	o.RulesMessageCriteriaSeveritiesQueryParameter = rulesMessageCriteriaSeverities
}

// WithRulesMessageCriteriaSnmpTrapTypesQueryParameter adds the rulesMessageCriteriaSnmpTrapTypes to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithRulesMessageCriteriaSnmpTrapTypesQueryParameter(rulesMessageCriteriaSnmpTrapTypes *string) *EmsFilterCollectionGetParams {
	o.SetRulesMessageCriteriaSnmpTrapTypesQueryParameter(rulesMessageCriteriaSnmpTrapTypes)
	return o
}

// SetRulesMessageCriteriaSnmpTrapTypesQueryParameter adds the rulesMessageCriteriaSnmpTrapTypes to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetRulesMessageCriteriaSnmpTrapTypesQueryParameter(rulesMessageCriteriaSnmpTrapTypes *string) {
	o.RulesMessageCriteriaSnmpTrapTypesQueryParameter = rulesMessageCriteriaSnmpTrapTypes
}

// WithRulesTypeQueryParameter adds the rulesType to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithRulesTypeQueryParameter(rulesType *string) *EmsFilterCollectionGetParams {
	o.SetRulesTypeQueryParameter(rulesType)
	return o
}

// SetRulesTypeQueryParameter adds the rulesType to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetRulesTypeQueryParameter(rulesType *string) {
	o.RulesTypeQueryParameter = rulesType
}

// WithSystemDefinedQueryParameter adds the systemDefined to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) WithSystemDefinedQueryParameter(systemDefined *bool) *EmsFilterCollectionGetParams {
	o.SetSystemDefinedQueryParameter(systemDefined)
	return o
}

// SetSystemDefinedQueryParameter adds the systemDefined to the ems filter collection get params
func (o *EmsFilterCollectionGetParams) SetSystemDefinedQueryParameter(systemDefined *bool) {
	o.SystemDefinedQueryParameter = systemDefined
}

// WriteToRequest writes these params to a swagger request
func (o *EmsFilterCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.RulesIndexQueryParameter != nil {

		// query param rules.index
		var qrRulesIndex int64

		if o.RulesIndexQueryParameter != nil {
			qrRulesIndex = *o.RulesIndexQueryParameter
		}
		qRulesIndex := swag.FormatInt64(qrRulesIndex)
		if qRulesIndex != "" {

			if err := r.SetQueryParam("rules.index", qRulesIndex); err != nil {
				return err
			}
		}
	}

	if o.RulesMessageCriteriaNamePatternQueryParameter != nil {

		// query param rules.message_criteria.name_pattern
		var qrRulesMessageCriteriaNamePattern string

		if o.RulesMessageCriteriaNamePatternQueryParameter != nil {
			qrRulesMessageCriteriaNamePattern = *o.RulesMessageCriteriaNamePatternQueryParameter
		}
		qRulesMessageCriteriaNamePattern := qrRulesMessageCriteriaNamePattern
		if qRulesMessageCriteriaNamePattern != "" {

			if err := r.SetQueryParam("rules.message_criteria.name_pattern", qRulesMessageCriteriaNamePattern); err != nil {
				return err
			}
		}
	}

	if o.RulesMessageCriteriaSeveritiesQueryParameter != nil {

		// query param rules.message_criteria.severities
		var qrRulesMessageCriteriaSeverities string

		if o.RulesMessageCriteriaSeveritiesQueryParameter != nil {
			qrRulesMessageCriteriaSeverities = *o.RulesMessageCriteriaSeveritiesQueryParameter
		}
		qRulesMessageCriteriaSeverities := qrRulesMessageCriteriaSeverities
		if qRulesMessageCriteriaSeverities != "" {

			if err := r.SetQueryParam("rules.message_criteria.severities", qRulesMessageCriteriaSeverities); err != nil {
				return err
			}
		}
	}

	if o.RulesMessageCriteriaSnmpTrapTypesQueryParameter != nil {

		// query param rules.message_criteria.snmp_trap_types
		var qrRulesMessageCriteriaSnmpTrapTypes string

		if o.RulesMessageCriteriaSnmpTrapTypesQueryParameter != nil {
			qrRulesMessageCriteriaSnmpTrapTypes = *o.RulesMessageCriteriaSnmpTrapTypesQueryParameter
		}
		qRulesMessageCriteriaSnmpTrapTypes := qrRulesMessageCriteriaSnmpTrapTypes
		if qRulesMessageCriteriaSnmpTrapTypes != "" {

			if err := r.SetQueryParam("rules.message_criteria.snmp_trap_types", qRulesMessageCriteriaSnmpTrapTypes); err != nil {
				return err
			}
		}
	}

	if o.RulesTypeQueryParameter != nil {

		// query param rules.type
		var qrRulesType string

		if o.RulesTypeQueryParameter != nil {
			qrRulesType = *o.RulesTypeQueryParameter
		}
		qRulesType := qrRulesType
		if qRulesType != "" {

			if err := r.SetQueryParam("rules.type", qRulesType); err != nil {
				return err
			}
		}
	}

	if o.SystemDefinedQueryParameter != nil {

		// query param system_defined
		var qrSystemDefined bool

		if o.SystemDefinedQueryParameter != nil {
			qrSystemDefined = *o.SystemDefinedQueryParameter
		}
		qSystemDefined := swag.FormatBool(qrSystemDefined)
		if qSystemDefined != "" {

			if err := r.SetQueryParam("system_defined", qSystemDefined); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamEmsFilterCollectionGet binds the parameter fields
func (o *EmsFilterCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamEmsFilterCollectionGet binds the parameter order_by
func (o *EmsFilterCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
