// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SnmpUsersCreateReader is a Reader for the SnmpUsersCreate structure.
type SnmpUsersCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SnmpUsersCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewSnmpUsersCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSnmpUsersCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSnmpUsersCreateCreated creates a SnmpUsersCreateCreated with default headers values
func NewSnmpUsersCreateCreated() *SnmpUsersCreateCreated {
	return &SnmpUsersCreateCreated{}
}

/* SnmpUsersCreateCreated describes a response with status code 201, with default header values.

Created
*/
type SnmpUsersCreateCreated struct {
	Payload *models.SnmpUser
}

func (o *SnmpUsersCreateCreated) Error() string {
	return fmt.Sprintf("[POST /support/snmp/users][%d] snmpUsersCreateCreated  %+v", 201, o.Payload)
}
func (o *SnmpUsersCreateCreated) GetPayload() *models.SnmpUser {
	return o.Payload
}

func (o *SnmpUsersCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SnmpUser)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSnmpUsersCreateDefault creates a SnmpUsersCreateDefault with default headers values
func NewSnmpUsersCreateDefault(code int) *SnmpUsersCreateDefault {
	return &SnmpUsersCreateDefault{
		_statusCode: code,
	}
}

/* SnmpUsersCreateDefault describes a response with status code -1, with default header values.

 ONTAP Error Response Codes
| Error Code | Description |
| ---------- | ----------- |
| 2621475 | This operation is not allowed on a node SVM. |
| 2621601 | This operation is not permitted on a system SVM. |
| 5636101 | One role for all applications and authentication methods is recommended for a user account. |
| 5636106 | Engine ID starting with first bit set as 1 in first octet should have a minimum of 5 or maximum of 32 octets. |
| 5636107 | Engine ID specified is based on an IP address, and must therefore be 9 octets in length. |
| 5636108 | Engine ID specified is based on an IPv6 address, and must therefore be 21 octets in length. |
| 5636109 | Engine ID specified is based on a MAC address, and must therefore be 11 octets in length. |
| 5636110 | Engine ID starting with first bit set as 0 in the first octet needs to be 12 octets in length. |
| 5636111 | Engine ID cannot have all zeroes. |
| 5636112 | Invalid Engine ID specified. |
| 5636113 | Cannot enable SNMP user capability for data SVM. |
| 5636116 | Cannot read SNMP user capability for data SVM. |
| 5636121 | User account name is reserved for use by the system. |
| 5636123 | Cannot create an SNMP user with a role other than readonly, none, or admin. |
| 5636124 | Cannot create an SNMP user with a role other than vsadmin-readonly, none, or vsadmin. |
| 5636126 | Cannot create a user with the user name, group name, or role \"autosupport\" because it is reserved by the system. |
| 5636148 | Failed to discover SNMPv3 engine ID of remote SNMP agent. |
| 5636150 | The switch_address parameter can be specified only for administrative SVMs. |
| 5636152 | 0.0.0.0 cannot be specified as the IP Address for the switch_address parameter. |
| 5636153 | Engine ID is already associated with user. |
| 5832711 | The only application permitted for user \"diag\" is \"console.\" |
| 7077897 | Invalid character in username. Valid characters\":\" A-Z, a-z, 0-9, \".\", \"_\", and \"-\". Note that the user name cannot start with \"-\". |
| 7077898 | The username must contain both letters and numbers. |
| 7077899 | Username does not meet length requirements. |
| 7077906 | Cannot use given role with this SVM because a role with that name has not been defined for the SVM. |
| 9043995 | Failed to create SNMP community. Reason\":\" SNMPv1 and SNMPv2c are not supported when cluster FIPS mode is enabled. |
| 9043999 | ONTAP failed to create an SNMPv3 user because SNMPv3 is disabled in the cluster. |

*/
type SnmpUsersCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the snmp users create default response
func (o *SnmpUsersCreateDefault) Code() int {
	return o._statusCode
}

func (o *SnmpUsersCreateDefault) Error() string {
	return fmt.Sprintf("[POST /support/snmp/users][%d] snmp_users_create default  %+v", o._statusCode, o.Payload)
}
func (o *SnmpUsersCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SnmpUsersCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
