// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSnmpUsersGetParams creates a new SnmpUsersGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSnmpUsersGetParams() *SnmpUsersGetParams {
	return &SnmpUsersGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSnmpUsersGetParamsWithTimeout creates a new SnmpUsersGetParams object
// with the ability to set a timeout on a request.
func NewSnmpUsersGetParamsWithTimeout(timeout time.Duration) *SnmpUsersGetParams {
	return &SnmpUsersGetParams{
		timeout: timeout,
	}
}

// NewSnmpUsersGetParamsWithContext creates a new SnmpUsersGetParams object
// with the ability to set a context for a request.
func NewSnmpUsersGetParamsWithContext(ctx context.Context) *SnmpUsersGetParams {
	return &SnmpUsersGetParams{
		Context: ctx,
	}
}

// NewSnmpUsersGetParamsWithHTTPClient creates a new SnmpUsersGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSnmpUsersGetParamsWithHTTPClient(client *http.Client) *SnmpUsersGetParams {
	return &SnmpUsersGetParams{
		HTTPClient: client,
	}
}

/* SnmpUsersGetParams contains all the parameters to send to the API endpoint
   for the snmp users get operation.

   Typically these are written to a http.Request.
*/
type SnmpUsersGetParams struct {

	/* EngineID.

	   Engine ID of owning SVM or remote switch.
	*/
	EngineIDPathParameter string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Name.

	   SNMP user name.
	*/
	NamePathParameter string

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the snmp users get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnmpUsersGetParams) WithDefaults() *SnmpUsersGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the snmp users get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnmpUsersGetParams) SetDefaults() {
	var (
		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := SnmpUsersGetParams{
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the snmp users get params
func (o *SnmpUsersGetParams) WithTimeout(timeout time.Duration) *SnmpUsersGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snmp users get params
func (o *SnmpUsersGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snmp users get params
func (o *SnmpUsersGetParams) WithContext(ctx context.Context) *SnmpUsersGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snmp users get params
func (o *SnmpUsersGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snmp users get params
func (o *SnmpUsersGetParams) WithHTTPClient(client *http.Client) *SnmpUsersGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snmp users get params
func (o *SnmpUsersGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEngineIDPathParameter adds the engineID to the snmp users get params
func (o *SnmpUsersGetParams) WithEngineIDPathParameter(engineID string) *SnmpUsersGetParams {
	o.SetEngineIDPathParameter(engineID)
	return o
}

// SetEngineIDPathParameter adds the engineId to the snmp users get params
func (o *SnmpUsersGetParams) SetEngineIDPathParameter(engineID string) {
	o.EngineIDPathParameter = engineID
}

// WithFieldsQueryParameter adds the fields to the snmp users get params
func (o *SnmpUsersGetParams) WithFieldsQueryParameter(fields []string) *SnmpUsersGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the snmp users get params
func (o *SnmpUsersGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithNamePathParameter adds the name to the snmp users get params
func (o *SnmpUsersGetParams) WithNamePathParameter(name string) *SnmpUsersGetParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the snmp users get params
func (o *SnmpUsersGetParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the snmp users get params
func (o *SnmpUsersGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *SnmpUsersGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the snmp users get params
func (o *SnmpUsersGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *SnmpUsersGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param engine_id
	if err := r.SetPathParam("engine_id", o.EngineIDPathParameter); err != nil {
		return err
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSnmpUsersGet binds the parameter fields
func (o *SnmpUsersGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
