// Code generated by go-swagger; DO NOT EDIT.

package svm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSvmMigrationVolumeCollectionGetParams creates a new SvmMigrationVolumeCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSvmMigrationVolumeCollectionGetParams() *SvmMigrationVolumeCollectionGetParams {
	return &SvmMigrationVolumeCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSvmMigrationVolumeCollectionGetParamsWithTimeout creates a new SvmMigrationVolumeCollectionGetParams object
// with the ability to set a timeout on a request.
func NewSvmMigrationVolumeCollectionGetParamsWithTimeout(timeout time.Duration) *SvmMigrationVolumeCollectionGetParams {
	return &SvmMigrationVolumeCollectionGetParams{
		timeout: timeout,
	}
}

// NewSvmMigrationVolumeCollectionGetParamsWithContext creates a new SvmMigrationVolumeCollectionGetParams object
// with the ability to set a context for a request.
func NewSvmMigrationVolumeCollectionGetParamsWithContext(ctx context.Context) *SvmMigrationVolumeCollectionGetParams {
	return &SvmMigrationVolumeCollectionGetParams{
		Context: ctx,
	}
}

// NewSvmMigrationVolumeCollectionGetParamsWithHTTPClient creates a new SvmMigrationVolumeCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSvmMigrationVolumeCollectionGetParamsWithHTTPClient(client *http.Client) *SvmMigrationVolumeCollectionGetParams {
	return &SvmMigrationVolumeCollectionGetParams{
		HTTPClient: client,
	}
}

/* SvmMigrationVolumeCollectionGetParams contains all the parameters to send to the API endpoint
   for the svm migration volume collection get operation.

   Typically these are written to a http.Request.
*/
type SvmMigrationVolumeCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmMigrationUUID.

	   Migration UUID
	*/
	SVMMigrationUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the svm migration volume collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SvmMigrationVolumeCollectionGetParams) WithDefaults() *SvmMigrationVolumeCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the svm migration volume collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SvmMigrationVolumeCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := SvmMigrationVolumeCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithTimeout(timeout time.Duration) *SvmMigrationVolumeCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithContext(ctx context.Context) *SvmMigrationVolumeCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithHTTPClient(client *http.Client) *SvmMigrationVolumeCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithFieldsQueryParameter(fields []string) *SvmMigrationVolumeCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *SvmMigrationVolumeCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *SvmMigrationVolumeCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *SvmMigrationVolumeCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *SvmMigrationVolumeCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMMigrationUUIDPathParameter adds the svmMigrationUUID to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) WithSVMMigrationUUIDPathParameter(svmMigrationUUID string) *SvmMigrationVolumeCollectionGetParams {
	o.SetSVMMigrationUUIDPathParameter(svmMigrationUUID)
	return o
}

// SetSVMMigrationUUIDPathParameter adds the svmMigrationUuid to the svm migration volume collection get params
func (o *SvmMigrationVolumeCollectionGetParams) SetSVMMigrationUUIDPathParameter(svmMigrationUUID string) {
	o.SVMMigrationUUIDPathParameter = svmMigrationUUID
}

// WriteToRequest writes these params to a swagger request
func (o *SvmMigrationVolumeCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param svm_migration.uuid
	if err := r.SetPathParam("svm_migration.uuid", o.SVMMigrationUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSvmMigrationVolumeCollectionGet binds the parameter fields
func (o *SvmMigrationVolumeCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamSvmMigrationVolumeCollectionGet binds the parameter order_by
func (o *SvmMigrationVolumeCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
