// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ApplicationCifsProperties application cifs properties
//
// swagger:model application_cifs_properties
type ApplicationCifsProperties struct {

	// backing storage
	BackingStorage *ApplicationCifsPropertiesBackingStorage `json:"backing_storage,omitempty"`

	// ips
	Ips []string `json:"ips,omitempty"`

	// Junction path
	// Read Only: true
	Path string `json:"path,omitempty"`

	// permissions
	// Read Only: true
	Permissions []*ApplicationCifsPropertiesPermissionsItems0 `json:"permissions,omitempty"`

	// server
	Server *ApplicationCifsPropertiesServer `json:"server,omitempty"`

	// share
	Share *ApplicationCifsPropertiesShare `json:"share,omitempty"`
}

// Validate validates this application cifs properties
func (m *ApplicationCifsProperties) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateBackingStorage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePermissions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateServer(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateShare(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationCifsProperties) validateBackingStorage(formats strfmt.Registry) error {
	if swag.IsZero(m.BackingStorage) { // not required
		return nil
	}

	if m.BackingStorage != nil {
		if err := m.BackingStorage.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("backing_storage")
			}
			return err
		}
	}

	return nil
}

func (m *ApplicationCifsProperties) validatePermissions(formats strfmt.Registry) error {
	if swag.IsZero(m.Permissions) { // not required
		return nil
	}

	for i := 0; i < len(m.Permissions); i++ {
		if swag.IsZero(m.Permissions[i]) { // not required
			continue
		}

		if m.Permissions[i] != nil {
			if err := m.Permissions[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("permissions" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ApplicationCifsProperties) validateServer(formats strfmt.Registry) error {
	if swag.IsZero(m.Server) { // not required
		return nil
	}

	if m.Server != nil {
		if err := m.Server.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("server")
			}
			return err
		}
	}

	return nil
}

func (m *ApplicationCifsProperties) validateShare(formats strfmt.Registry) error {
	if swag.IsZero(m.Share) { // not required
		return nil
	}

	if m.Share != nil {
		if err := m.Share.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("share")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this application cifs properties based on the context it is used
func (m *ApplicationCifsProperties) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateBackingStorage(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateIps(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePath(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePermissions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateServer(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateShare(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationCifsProperties) contextValidateBackingStorage(ctx context.Context, formats strfmt.Registry) error {

	if m.BackingStorage != nil {
		if err := m.BackingStorage.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("backing_storage")
			}
			return err
		}
	}

	return nil
}

func (m *ApplicationCifsProperties) contextValidateIps(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Ips); i++ {

		if err := validate.ReadOnly(ctx, "ips"+"."+strconv.Itoa(i), "body", string(m.Ips[i])); err != nil {
			return err
		}

	}

	return nil
}

func (m *ApplicationCifsProperties) contextValidatePath(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "path", "body", string(m.Path)); err != nil {
		return err
	}

	return nil
}

func (m *ApplicationCifsProperties) contextValidatePermissions(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "permissions", "body", []*ApplicationCifsPropertiesPermissionsItems0(m.Permissions)); err != nil {
		return err
	}

	for i := 0; i < len(m.Permissions); i++ {

		if m.Permissions[i] != nil {
			if err := m.Permissions[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("permissions" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ApplicationCifsProperties) contextValidateServer(ctx context.Context, formats strfmt.Registry) error {

	if m.Server != nil {
		if err := m.Server.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("server")
			}
			return err
		}
	}

	return nil
}

func (m *ApplicationCifsProperties) contextValidateShare(ctx context.Context, formats strfmt.Registry) error {

	if m.Share != nil {
		if err := m.Share.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("share")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ApplicationCifsProperties) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ApplicationCifsProperties) UnmarshalBinary(b []byte) error {
	var res ApplicationCifsProperties
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ApplicationCifsPropertiesBackingStorage application cifs properties backing storage
//
// swagger:model ApplicationCifsPropertiesBackingStorage
type ApplicationCifsPropertiesBackingStorage struct {

	// Backing storage type
	// Read Only: true
	// Enum: [volume]
	Type string `json:"type,omitempty"`

	// Backing storage UUID
	// Read Only: true
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this application cifs properties backing storage
func (m *ApplicationCifsPropertiesBackingStorage) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var applicationCifsPropertiesBackingStorageTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["volume"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		applicationCifsPropertiesBackingStorageTypeTypePropEnum = append(applicationCifsPropertiesBackingStorageTypeTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ApplicationCifsPropertiesBackingStorage
	// ApplicationCifsPropertiesBackingStorage
	// type
	// Type
	// volume
	// END DEBUGGING
	// ApplicationCifsPropertiesBackingStorageTypeVolume captures enum value "volume"
	ApplicationCifsPropertiesBackingStorageTypeVolume string = "volume"
)

// prop value enum
func (m *ApplicationCifsPropertiesBackingStorage) validateTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, applicationCifsPropertiesBackingStorageTypeTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ApplicationCifsPropertiesBackingStorage) validateType(formats strfmt.Registry) error {
	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("backing_storage"+"."+"type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this application cifs properties backing storage based on the context it is used
func (m *ApplicationCifsPropertiesBackingStorage) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateType(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationCifsPropertiesBackingStorage) contextValidateType(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "backing_storage"+"."+"type", "body", string(m.Type)); err != nil {
		return err
	}

	return nil
}

func (m *ApplicationCifsPropertiesBackingStorage) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "backing_storage"+"."+"uuid", "body", string(m.UUID)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ApplicationCifsPropertiesBackingStorage) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ApplicationCifsPropertiesBackingStorage) UnmarshalBinary(b []byte) error {
	var res ApplicationCifsPropertiesBackingStorage
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ApplicationCifsPropertiesPermissionsItems0 application cifs properties permissions items0
//
// swagger:model ApplicationCifsPropertiesPermissionsItems0
type ApplicationCifsPropertiesPermissionsItems0 struct {

	// Access granted to the user or group
	// Read Only: true
	Access string `json:"access,omitempty"`

	// User or group
	// Read Only: true
	UserOrGroup string `json:"user_or_group,omitempty"`
}

// Validate validates this application cifs properties permissions items0
func (m *ApplicationCifsPropertiesPermissionsItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validate this application cifs properties permissions items0 based on the context it is used
func (m *ApplicationCifsPropertiesPermissionsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAccess(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUserOrGroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationCifsPropertiesPermissionsItems0) contextValidateAccess(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "access", "body", string(m.Access)); err != nil {
		return err
	}

	return nil
}

func (m *ApplicationCifsPropertiesPermissionsItems0) contextValidateUserOrGroup(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "user_or_group", "body", string(m.UserOrGroup)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ApplicationCifsPropertiesPermissionsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ApplicationCifsPropertiesPermissionsItems0) UnmarshalBinary(b []byte) error {
	var res ApplicationCifsPropertiesPermissionsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ApplicationCifsPropertiesServer application cifs properties server
//
// swagger:model ApplicationCifsPropertiesServer
type ApplicationCifsPropertiesServer struct {

	// Server name
	// Read Only: true
	Name string `json:"name,omitempty"`
}

// Validate validates this application cifs properties server
func (m *ApplicationCifsPropertiesServer) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validate this application cifs properties server based on the context it is used
func (m *ApplicationCifsPropertiesServer) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationCifsPropertiesServer) contextValidateName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "server"+"."+"name", "body", string(m.Name)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ApplicationCifsPropertiesServer) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ApplicationCifsPropertiesServer) UnmarshalBinary(b []byte) error {
	var res ApplicationCifsPropertiesServer
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ApplicationCifsPropertiesShare application cifs properties share
//
// swagger:model ApplicationCifsPropertiesShare
type ApplicationCifsPropertiesShare struct {

	// Share name
	// Read Only: true
	Name string `json:"name,omitempty"`
}

// Validate validates this application cifs properties share
func (m *ApplicationCifsPropertiesShare) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validate this application cifs properties share based on the context it is used
func (m *ApplicationCifsPropertiesShare) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationCifsPropertiesShare) contextValidateName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "share"+"."+"name", "body", string(m.Name)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ApplicationCifsPropertiesShare) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ApplicationCifsPropertiesShare) UnmarshalBinary(b []byte) error {
	var res ApplicationCifsPropertiesShare
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
