// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ApplicationLunMappingObject application lun mapping object
//
// swagger:model application_lun_mapping_object
type ApplicationLunMappingObject struct {

	// All possible Fibre Channel Protocol (FCP) access endpoints for the LUN.
	// Read Only: true
	Fcp []*ApplicationSanAccessFcpEndpoint `json:"fcp,omitempty"`

	// igroup
	Igroup *ApplicationLunMappingObjectIgroup `json:"igroup,omitempty"`

	// All possible iSCSI access endpoints for the LUN.
	// Read Only: true
	Iscsi []*ApplicationSanAccessIscsiEndpoint `json:"iscsi,omitempty"`

	// LUN ID
	// Read Only: true
	// Maximum: 4095
	// Minimum: 0
	LunID int64 `json:"lun_id,omitempty"`
}

// Validate validates this application lun mapping object
func (m *ApplicationLunMappingObject) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateFcp(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIgroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIscsi(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLunID(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationLunMappingObject) validateFcp(formats strfmt.Registry) error {
	if swag.IsZero(m.Fcp) { // not required
		return nil
	}

	for i := 0; i < len(m.Fcp); i++ {
		if swag.IsZero(m.Fcp[i]) { // not required
			continue
		}

		if m.Fcp[i] != nil {
			if err := m.Fcp[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("fcp" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ApplicationLunMappingObject) validateIgroup(formats strfmt.Registry) error {
	if swag.IsZero(m.Igroup) { // not required
		return nil
	}

	if m.Igroup != nil {
		if err := m.Igroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("igroup")
			}
			return err
		}
	}

	return nil
}

func (m *ApplicationLunMappingObject) validateIscsi(formats strfmt.Registry) error {
	if swag.IsZero(m.Iscsi) { // not required
		return nil
	}

	for i := 0; i < len(m.Iscsi); i++ {
		if swag.IsZero(m.Iscsi[i]) { // not required
			continue
		}

		if m.Iscsi[i] != nil {
			if err := m.Iscsi[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("iscsi" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ApplicationLunMappingObject) validateLunID(formats strfmt.Registry) error {
	if swag.IsZero(m.LunID) { // not required
		return nil
	}

	if err := validate.MinimumInt("lun_id", "body", m.LunID, 0, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("lun_id", "body", m.LunID, 4095, false); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this application lun mapping object based on the context it is used
func (m *ApplicationLunMappingObject) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateFcp(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateIgroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateIscsi(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLunID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationLunMappingObject) contextValidateFcp(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "fcp", "body", []*ApplicationSanAccessFcpEndpoint(m.Fcp)); err != nil {
		return err
	}

	for i := 0; i < len(m.Fcp); i++ {

		if m.Fcp[i] != nil {
			if err := m.Fcp[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("fcp" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ApplicationLunMappingObject) contextValidateIgroup(ctx context.Context, formats strfmt.Registry) error {

	if m.Igroup != nil {
		if err := m.Igroup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("igroup")
			}
			return err
		}
	}

	return nil
}

func (m *ApplicationLunMappingObject) contextValidateIscsi(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "iscsi", "body", []*ApplicationSanAccessIscsiEndpoint(m.Iscsi)); err != nil {
		return err
	}

	for i := 0; i < len(m.Iscsi); i++ {

		if m.Iscsi[i] != nil {
			if err := m.Iscsi[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("iscsi" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ApplicationLunMappingObject) contextValidateLunID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "lun_id", "body", int64(m.LunID)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ApplicationLunMappingObject) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ApplicationLunMappingObject) UnmarshalBinary(b []byte) error {
	var res ApplicationLunMappingObject
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ApplicationLunMappingObjectIgroup application lun mapping object igroup
//
// swagger:model ApplicationLunMappingObjectIgroup
type ApplicationLunMappingObjectIgroup struct {

	// initiators
	Initiators []string `json:"initiators,omitempty"`

	// Igroup name
	// Read Only: true
	Name string `json:"name,omitempty"`

	// Igroup UUID
	// Read Only: true
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this application lun mapping object igroup
func (m *ApplicationLunMappingObjectIgroup) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validate this application lun mapping object igroup based on the context it is used
func (m *ApplicationLunMappingObjectIgroup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateInitiators(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ApplicationLunMappingObjectIgroup) contextValidateInitiators(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Initiators); i++ {

		if err := validate.ReadOnly(ctx, "igroup"+"."+"initiators"+"."+strconv.Itoa(i), "body", string(m.Initiators[i])); err != nil {
			return err
		}

	}

	return nil
}

func (m *ApplicationLunMappingObjectIgroup) contextValidateName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "igroup"+"."+"name", "body", string(m.Name)); err != nil {
		return err
	}

	return nil
}

func (m *ApplicationLunMappingObjectIgroup) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "igroup"+"."+"uuid", "body", string(m.UUID)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ApplicationLunMappingObjectIgroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ApplicationLunMappingObjectIgroup) UnmarshalBinary(b []byte) error {
	var res ApplicationLunMappingObjectIgroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
