// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// FpolicyEngine The engine defines how ONTAP makes and manages connections to external FPolicy servers.
//
// swagger:model fpolicy_engine
type FpolicyEngine struct {

	// Specifies the name to assign to the external server configuration.
	// Example: fp_ex_eng
	Name string `json:"name,omitempty"`

	// Port number of the FPolicy server application.
	// Example: 9876
	Port int64 `json:"port,omitempty"`

	// primary servers
	// Example: ["10.132.145.20","10.140.101.109"]
	PrimaryServers []string `json:"primary_servers,omitempty"`

	// secondary servers
	// Example: ["10.132.145.20","10.132.145.21"]
	SecondaryServers []string `json:"secondary_servers,omitempty"`

	// svm
	Svm *FpolicyEngineSvm `json:"svm,omitempty"`

	// The notification mode determines what ONTAP does after sending notifications to FPolicy servers.
	//   The possible values are:
	//     * synchronous  - After sending a notification, wait for a response from the FPolicy server.
	//     * asynchronous - After sending a notification, file request processing continues.
	//
	// Enum: [synchronous asynchronous]
	Type *string `json:"type,omitempty"`
}

// Validate validates this fpolicy engine
func (m *FpolicyEngine) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSvm(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *FpolicyEngine) validateSvm(formats strfmt.Registry) error {
	if swag.IsZero(m.Svm) { // not required
		return nil
	}

	if m.Svm != nil {
		if err := m.Svm.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

var fpolicyEngineTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["synchronous","asynchronous"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		fpolicyEngineTypeTypePropEnum = append(fpolicyEngineTypeTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// fpolicy_engine
	// FpolicyEngine
	// type
	// Type
	// synchronous
	// END DEBUGGING
	// FpolicyEngineTypeSynchronous captures enum value "synchronous"
	FpolicyEngineTypeSynchronous string = "synchronous"

	// BEGIN DEBUGGING
	// fpolicy_engine
	// FpolicyEngine
	// type
	// Type
	// asynchronous
	// END DEBUGGING
	// FpolicyEngineTypeAsynchronous captures enum value "asynchronous"
	FpolicyEngineTypeAsynchronous string = "asynchronous"
)

// prop value enum
func (m *FpolicyEngine) validateTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, fpolicyEngineTypeTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *FpolicyEngine) validateType(formats strfmt.Registry) error {
	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("type", "body", *m.Type); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this fpolicy engine based on the context it is used
func (m *FpolicyEngine) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSvm(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *FpolicyEngine) contextValidateSvm(ctx context.Context, formats strfmt.Registry) error {

	if m.Svm != nil {
		if err := m.Svm.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *FpolicyEngine) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *FpolicyEngine) UnmarshalBinary(b []byte) error {
	var res FpolicyEngine
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// FpolicyEngineSvm fpolicy engine svm
//
// swagger:model FpolicyEngineSvm
type FpolicyEngineSvm struct {

	// SVM UUID
	// Read Only: true
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this fpolicy engine svm
func (m *FpolicyEngineSvm) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validate this fpolicy engine svm based on the context it is used
func (m *FpolicyEngineSvm) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *FpolicyEngineSvm) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "svm"+"."+"uuid", "body", string(m.UUID)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *FpolicyEngineSvm) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *FpolicyEngineSvm) UnmarshalBinary(b []byte) error {
	var res FpolicyEngineSvm
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
