// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// PerformanceMetricIoTypeReference Indicates the type of I/O operation that can be associated with the type of performance metric. I/O operations can be "total", "read", "write", and "other". An I/O operation of type "total" is an aggregation of all operation types for any type of performance metric.
//
// swagger:model performance_metric_io_type_reference
type PerformanceMetricIoTypeReference struct {

	// Performance metric for other I/O operations. Other I/O operations can be metadata operations, such as directory lookups and so on.
	Other int64 `json:"other,omitempty"`

	// Performance metric for read I/O operations.
	// Example: 200
	Read int64 `json:"read,omitempty"`

	// Performance metric aggregated over all types of I/O operations.
	// Example: 1000
	Total int64 `json:"total,omitempty"`

	// Peformance metric for write I/O operations.
	// Example: 100
	Write int64 `json:"write,omitempty"`
}

// Validate validates this performance metric io type reference
func (m *PerformanceMetricIoTypeReference) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this performance metric io type reference based on context it is used
func (m *PerformanceMetricIoTypeReference) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *PerformanceMetricIoTypeReference) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PerformanceMetricIoTypeReference) UnmarshalBinary(b []byte) error {
	var res PerformanceMetricIoTypeReference
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
