// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// S3BucketPolicyStatement Specifies information about a single access permission.
//
// swagger:model s3_bucket_policy_statement
type S3BucketPolicyStatement struct {

	// actions
	// Example: ["GetObject","PutObject","DeleteObject","ListBucket"]
	Actions []string `json:"actions,omitempty"`

	// Specifies bucket policy conditions.
	Conditions []*S3BucketPolicyCondition `json:"conditions,omitempty"`

	// Specifies whether access is allowed or denied when a user requests the specific action. If access (to allow) is not granted explicitly to a resource, access is implicitly denied. Access can also be denied explicitly to a resource, in order to make sure that a user cannot access it, even if a different policy grants access.
	// Example: allow
	// Enum: [allow deny]
	Effect string `json:"effect,omitempty"`

	// principals
	// Example: ["user1","group/grp1"]
	Principals []string `json:"principals,omitempty"`

	// resources
	// Example: ["bucket1","bucket1/*"]
	Resources []string `json:"resources,omitempty"`

	// Specifies the statement identifier used to differentiate between statements.
	// Example: FullAccessToUser1
	Sid string `json:"sid,omitempty"`
}

// Validate validates this s3 bucket policy statement
func (m *S3BucketPolicyStatement) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateConditions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEffect(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *S3BucketPolicyStatement) validateConditions(formats strfmt.Registry) error {
	if swag.IsZero(m.Conditions) { // not required
		return nil
	}

	for i := 0; i < len(m.Conditions); i++ {
		if swag.IsZero(m.Conditions[i]) { // not required
			continue
		}

		if m.Conditions[i] != nil {
			if err := m.Conditions[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("conditions" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var s3BucketPolicyStatementTypeEffectPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["allow","deny"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		s3BucketPolicyStatementTypeEffectPropEnum = append(s3BucketPolicyStatementTypeEffectPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// s3_bucket_policy_statement
	// S3BucketPolicyStatement
	// effect
	// Effect
	// allow
	// END DEBUGGING
	// S3BucketPolicyStatementEffectAllow captures enum value "allow"
	S3BucketPolicyStatementEffectAllow string = "allow"

	// BEGIN DEBUGGING
	// s3_bucket_policy_statement
	// S3BucketPolicyStatement
	// effect
	// Effect
	// deny
	// END DEBUGGING
	// S3BucketPolicyStatementEffectDeny captures enum value "deny"
	S3BucketPolicyStatementEffectDeny string = "deny"
)

// prop value enum
func (m *S3BucketPolicyStatement) validateEffectEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, s3BucketPolicyStatementTypeEffectPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *S3BucketPolicyStatement) validateEffect(formats strfmt.Registry) error {
	if swag.IsZero(m.Effect) { // not required
		return nil
	}

	// value enum
	if err := m.validateEffectEnum("effect", "body", m.Effect); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this s3 bucket policy statement based on the context it is used
func (m *S3BucketPolicyStatement) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateConditions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *S3BucketPolicyStatement) contextValidateConditions(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Conditions); i++ {

		if m.Conditions[i] != nil {
			if err := m.Conditions[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("conditions" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *S3BucketPolicyStatement) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *S3BucketPolicyStatement) UnmarshalBinary(b []byte) error {
	var res S3BucketPolicyStatement
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
