// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// SnapmirrorDestinationCreation Use this object to provision the destination endpoint when establishing a SnapMirror relationship for a FlexVol volume, FlexGroup volume, SVM, Consistency Group or ONTAP S3 Bucket. Given a source endpoint, the destination endpoint is provisioned in the SVM specified in the "destination.path" property. While protecting an SVM, the SVM destination endpoint can only be provisioned on the local cluster. To provision the SVM destination endpoint use the optional "source.cluster.name" property to specify the remote cluster name or use the optional "source.cluster.uuid" property to specify the remote cluster UUID. When "create_destination.enabled" option is specified while making a POST for a SnapMirror relationship, the relationship can be automatically initialized by setting the "state" either to "snapmirrored" when the policy is of type "async" or to "in_sync" when the policy is of type "sync". The "destination.path" property must specify the destination endpoint path. For example, for FlexVol volume and FlexGroup volume, the "destination.path" can be specified as <destination-SVM-name:dp-volume-name>, for SVM data protection, the "destination.path" must be specified as <destination-SVM-name:>, and for Consistency Group, the "destination.path" must be specified as <destination-SVM-name:/cg/consistency-group-name> along with the "destination.consistency_group_volumes" property to indicate the list of destination volumes of type "DP" in the Consistency Group. For a FlexVol volume, a FlexGroup volume, Consistency Group or a Bucket destination endpoint, the properties in this object can be specified either from the source or the destination cluster. For an SVM destination endpoint, the properties in this object can be specified from the destination cluster only. This object is not supported for non ONTAP endpoints. While protecting a S3 Bucket, the optional "size" property can be used to create ONTAP S3 Bucket destination endpoint of the specified size.
//
// swagger:model snapmirror_destination_creation
type SnapmirrorDestinationCreation struct {

	// Optional property to create the destination endpoint when establishing a SnapMirror relationship. It is assumed to be "false" if no other property is set and assumed to be "true" if any other property is set.
	Enabled bool `json:"enabled,omitempty"`

	// Optional property to specify the size of destination endpoint in bytes. This property is applicable only to ONTAP S3 Bucket endpoints. The minimum size for S3 bucket is 80MB and maximum size is 64TB. If not specified, system will create destination with default size of 800GB.
	Size int64 `json:"size,omitempty"`

	// storage service
	StorageService *SnapmirrorDestinationCreationStorageService `json:"storage_service,omitempty"`

	// tiering
	Tiering *SnapmirrorDestinationCreationTiering `json:"tiering,omitempty"`
}

// Validate validates this snapmirror destination creation
func (m *SnapmirrorDestinationCreation) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateStorageService(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTiering(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SnapmirrorDestinationCreation) validateStorageService(formats strfmt.Registry) error {
	if swag.IsZero(m.StorageService) { // not required
		return nil
	}

	if m.StorageService != nil {
		if err := m.StorageService.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("storage_service")
			}
			return err
		}
	}

	return nil
}

func (m *SnapmirrorDestinationCreation) validateTiering(formats strfmt.Registry) error {
	if swag.IsZero(m.Tiering) { // not required
		return nil
	}

	if m.Tiering != nil {
		if err := m.Tiering.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this snapmirror destination creation based on the context it is used
func (m *SnapmirrorDestinationCreation) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateStorageService(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTiering(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SnapmirrorDestinationCreation) contextValidateStorageService(ctx context.Context, formats strfmt.Registry) error {

	if m.StorageService != nil {
		if err := m.StorageService.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("storage_service")
			}
			return err
		}
	}

	return nil
}

func (m *SnapmirrorDestinationCreation) contextValidateTiering(ctx context.Context, formats strfmt.Registry) error {

	if m.Tiering != nil {
		if err := m.Tiering.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SnapmirrorDestinationCreation) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SnapmirrorDestinationCreation) UnmarshalBinary(b []byte) error {
	var res SnapmirrorDestinationCreation
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SnapmirrorDestinationCreationStorageService snapmirror destination creation storage service
//
// swagger:model SnapmirrorDestinationCreationStorageService
type SnapmirrorDestinationCreationStorageService struct {

	// This property indicates whether to create the destination endpoint using storage service.
	Enabled bool `json:"enabled,omitempty"`

	// Optional property to enforce storage service performance on the destination endpoint. This property is applicable to FlexVol volume, FlexGroup volume, and Consistency Group endpoints.
	EnforcePerformance *bool `json:"enforce_performance,omitempty"`

	// Optional property to specify the storage service name for the destination endpoint. This property is considered when the property "create_destination.storage_service.enabled" is set to "true". When the property "create_destination.storage_service.enabled" is set to "true" and the "create_destination.storage_service.name" for the endpoint is not specified, then ONTAP selects the highest storage service available on the cluster to provision the destination endpoint. This property is applicable to FlexVol volume, FlexGroup volume, and Consistency Group endpoints.
	// Enum: [extreme performance value]
	Name string `json:"name,omitempty"`
}

// Validate validates this snapmirror destination creation storage service
func (m *SnapmirrorDestinationCreationStorageService) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var snapmirrorDestinationCreationStorageServiceTypeNamePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["extreme","performance","value"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		snapmirrorDestinationCreationStorageServiceTypeNamePropEnum = append(snapmirrorDestinationCreationStorageServiceTypeNamePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// SnapmirrorDestinationCreationStorageService
	// SnapmirrorDestinationCreationStorageService
	// name
	// Name
	// extreme
	// END DEBUGGING
	// SnapmirrorDestinationCreationStorageServiceNameExtreme captures enum value "extreme"
	SnapmirrorDestinationCreationStorageServiceNameExtreme string = "extreme"

	// BEGIN DEBUGGING
	// SnapmirrorDestinationCreationStorageService
	// SnapmirrorDestinationCreationStorageService
	// name
	// Name
	// performance
	// END DEBUGGING
	// SnapmirrorDestinationCreationStorageServiceNamePerformance captures enum value "performance"
	SnapmirrorDestinationCreationStorageServiceNamePerformance string = "performance"

	// BEGIN DEBUGGING
	// SnapmirrorDestinationCreationStorageService
	// SnapmirrorDestinationCreationStorageService
	// name
	// Name
	// value
	// END DEBUGGING
	// SnapmirrorDestinationCreationStorageServiceNameValue captures enum value "value"
	SnapmirrorDestinationCreationStorageServiceNameValue string = "value"
)

// prop value enum
func (m *SnapmirrorDestinationCreationStorageService) validateNameEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, snapmirrorDestinationCreationStorageServiceTypeNamePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *SnapmirrorDestinationCreationStorageService) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	// value enum
	if err := m.validateNameEnum("storage_service"+"."+"name", "body", m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this snapmirror destination creation storage service based on context it is used
func (m *SnapmirrorDestinationCreationStorageService) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SnapmirrorDestinationCreationStorageService) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SnapmirrorDestinationCreationStorageService) UnmarshalBinary(b []byte) error {
	var res SnapmirrorDestinationCreationStorageService
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SnapmirrorDestinationCreationTiering snapmirror destination creation tiering
//
// swagger:model SnapmirrorDestinationCreationTiering
type SnapmirrorDestinationCreationTiering struct {

	// Optional property to specify the destination endpoint's tiering policy when "create_destination.tiering.supported" is set to "true". This property is applicable to FlexVol volume, FlexGroup volume, and Consistency Group endpoints. This property determines whether the user data blocks of the destination endpoint in a FabricPool will be tiered to the cloud store when they become cold. FabricPool combines flash (performance tier) with a cloud store into a single aggregate. Temperature of the destination endpoint volume blocks increases if they are accessed frequently and decreases when they are not.<br>all &dash; This policy allows tiering of both destination endpoint Snapshot copies and the user transfered data blocks to the cloud store as soon as possible by ignoring the temperature on the volume blocks. This tiering policy is not applicable for Consistency Group destination endpoints or for synchronous relationships.<br>auto &dash; This policy allows tiering of both destination endpoint Snapshot copies and the active file system user data to the cloud store<br>none &dash; Destination endpoint volume blocks will not be tiered to the cloud store.<br>snapshot_only &dash; This policy allows tiering of only the destination endpoint volume Snapshot copies not associated with the active file system. The default tiering policy is "snapshot_only" for a FlexVol volume and "none" for a FlexGroup volume.
	// Enum: [all auto none snapshot_only]
	Policy string `json:"policy,omitempty"`

	// Optional property to enable provisioning of the destination endpoint volumes on FabricPool aggregates. This property is applicable to FlexVol volume, FlexGroup volume, and Consistency Group endpoints. Only FabricPool aggregates are used if this property is set to "true" and only non FabricPool aggregates are used if this property is set to "false". Tiering support for a FlexGroup volume can be changed by moving all of the constituents to the required aggregates. Note that in order to tier data, not only do the destination endpoint volumes need to support tiering by using FabricPools, the "create_destination.tiering.policy" must not be "none". A destination endpoint that uses FabricPools but has a tiering "policy" of "none" supports tiering but will not tier any data.
	Supported bool `json:"supported,omitempty"`
}

// Validate validates this snapmirror destination creation tiering
func (m *SnapmirrorDestinationCreationTiering) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var snapmirrorDestinationCreationTieringTypePolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["all","auto","none","snapshot_only"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		snapmirrorDestinationCreationTieringTypePolicyPropEnum = append(snapmirrorDestinationCreationTieringTypePolicyPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// SnapmirrorDestinationCreationTiering
	// SnapmirrorDestinationCreationTiering
	// policy
	// Policy
	// all
	// END DEBUGGING
	// SnapmirrorDestinationCreationTieringPolicyAll captures enum value "all"
	SnapmirrorDestinationCreationTieringPolicyAll string = "all"

	// BEGIN DEBUGGING
	// SnapmirrorDestinationCreationTiering
	// SnapmirrorDestinationCreationTiering
	// policy
	// Policy
	// auto
	// END DEBUGGING
	// SnapmirrorDestinationCreationTieringPolicyAuto captures enum value "auto"
	SnapmirrorDestinationCreationTieringPolicyAuto string = "auto"

	// BEGIN DEBUGGING
	// SnapmirrorDestinationCreationTiering
	// SnapmirrorDestinationCreationTiering
	// policy
	// Policy
	// none
	// END DEBUGGING
	// SnapmirrorDestinationCreationTieringPolicyNone captures enum value "none"
	SnapmirrorDestinationCreationTieringPolicyNone string = "none"

	// BEGIN DEBUGGING
	// SnapmirrorDestinationCreationTiering
	// SnapmirrorDestinationCreationTiering
	// policy
	// Policy
	// snapshot_only
	// END DEBUGGING
	// SnapmirrorDestinationCreationTieringPolicySnapshotOnly captures enum value "snapshot_only"
	SnapmirrorDestinationCreationTieringPolicySnapshotOnly string = "snapshot_only"
)

// prop value enum
func (m *SnapmirrorDestinationCreationTiering) validatePolicyEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, snapmirrorDestinationCreationTieringTypePolicyPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *SnapmirrorDestinationCreationTiering) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	// value enum
	if err := m.validatePolicyEnum("tiering"+"."+"policy", "body", m.Policy); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this snapmirror destination creation tiering based on context it is used
func (m *SnapmirrorDestinationCreationTiering) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SnapmirrorDestinationCreationTiering) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SnapmirrorDestinationCreationTiering) UnmarshalBinary(b []byte) error {
	var res SnapmirrorDestinationCreationTiering
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
