// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// SvmMigrationVolume Volume transfer information
//
// swagger:model svm_migration_volume
type SvmMigrationVolume struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// List of transfer errors
	// Read Only: true
	Errors []*SvmMigrationVolumeErrorsItems0 `json:"errors,omitempty"`

	// Indicates whether the volume transfer relationship is healthy.
	Healthy bool `json:"healthy,omitempty"`

	// node
	Node *SvmMigrationVolumeNode `json:"node,omitempty"`

	// svm
	Svm *SvmMigrationVolumeSvm `json:"svm,omitempty"`

	// Status of the transfer.
	// Read Only: true
	// Enum: [Idle Transferring Aborting OutOfSync InSync Transitioning ReadyForCutoverPreCommit CutoverPreCommitting CuttingOver]
	TransferState string `json:"transfer_state,omitempty"`

	// volume
	Volume *SvmMigrationVolumeVolume `json:"volume,omitempty"`
}

// Validate validates this svm migration volume
func (m *SvmMigrationVolume) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateErrors(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSvm(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTransferState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVolume(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolume) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *SvmMigrationVolume) validateErrors(formats strfmt.Registry) error {
	if swag.IsZero(m.Errors) { // not required
		return nil
	}

	for i := 0; i < len(m.Errors); i++ {
		if swag.IsZero(m.Errors[i]) { // not required
			continue
		}

		if m.Errors[i] != nil {
			if err := m.Errors[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("errors" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *SvmMigrationVolume) validateNode(formats strfmt.Registry) error {
	if swag.IsZero(m.Node) { // not required
		return nil
	}

	if m.Node != nil {
		if err := m.Node.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

func (m *SvmMigrationVolume) validateSvm(formats strfmt.Registry) error {
	if swag.IsZero(m.Svm) { // not required
		return nil
	}

	if m.Svm != nil {
		if err := m.Svm.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

var svmMigrationVolumeTypeTransferStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["Idle","Transferring","Aborting","OutOfSync","InSync","Transitioning","ReadyForCutoverPreCommit","CutoverPreCommitting","CuttingOver"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		svmMigrationVolumeTypeTransferStatePropEnum = append(svmMigrationVolumeTypeTransferStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// Idle
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateIdle captures enum value "Idle"
	SvmMigrationVolumeTransferStateIdle string = "Idle"

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// Transferring
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateTransferring captures enum value "Transferring"
	SvmMigrationVolumeTransferStateTransferring string = "Transferring"

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// Aborting
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateAborting captures enum value "Aborting"
	SvmMigrationVolumeTransferStateAborting string = "Aborting"

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// OutOfSync
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateOutOfSync captures enum value "OutOfSync"
	SvmMigrationVolumeTransferStateOutOfSync string = "OutOfSync"

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// InSync
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateInSync captures enum value "InSync"
	SvmMigrationVolumeTransferStateInSync string = "InSync"

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// Transitioning
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateTransitioning captures enum value "Transitioning"
	SvmMigrationVolumeTransferStateTransitioning string = "Transitioning"

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// ReadyForCutoverPreCommit
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateReadyForCutoverPreCommit captures enum value "ReadyForCutoverPreCommit"
	SvmMigrationVolumeTransferStateReadyForCutoverPreCommit string = "ReadyForCutoverPreCommit"

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// CutoverPreCommitting
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateCutoverPreCommitting captures enum value "CutoverPreCommitting"
	SvmMigrationVolumeTransferStateCutoverPreCommitting string = "CutoverPreCommitting"

	// BEGIN DEBUGGING
	// svm_migration_volume
	// SvmMigrationVolume
	// transfer_state
	// TransferState
	// CuttingOver
	// END DEBUGGING
	// SvmMigrationVolumeTransferStateCuttingOver captures enum value "CuttingOver"
	SvmMigrationVolumeTransferStateCuttingOver string = "CuttingOver"
)

// prop value enum
func (m *SvmMigrationVolume) validateTransferStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, svmMigrationVolumeTypeTransferStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *SvmMigrationVolume) validateTransferState(formats strfmt.Registry) error {
	if swag.IsZero(m.TransferState) { // not required
		return nil
	}

	// value enum
	if err := m.validateTransferStateEnum("transfer_state", "body", m.TransferState); err != nil {
		return err
	}

	return nil
}

func (m *SvmMigrationVolume) validateVolume(formats strfmt.Registry) error {
	if swag.IsZero(m.Volume) { // not required
		return nil
	}

	if m.Volume != nil {
		if err := m.Volume.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("volume")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this svm migration volume based on the context it is used
func (m *SvmMigrationVolume) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateErrors(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNode(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSvm(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTransferState(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateVolume(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolume) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *SvmMigrationVolume) contextValidateErrors(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "errors", "body", []*SvmMigrationVolumeErrorsItems0(m.Errors)); err != nil {
		return err
	}

	for i := 0; i < len(m.Errors); i++ {

		if m.Errors[i] != nil {
			if err := m.Errors[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("errors" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *SvmMigrationVolume) contextValidateNode(ctx context.Context, formats strfmt.Registry) error {

	if m.Node != nil {
		if err := m.Node.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

func (m *SvmMigrationVolume) contextValidateSvm(ctx context.Context, formats strfmt.Registry) error {

	if m.Svm != nil {
		if err := m.Svm.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

func (m *SvmMigrationVolume) contextValidateTransferState(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "transfer_state", "body", string(m.TransferState)); err != nil {
		return err
	}

	return nil
}

func (m *SvmMigrationVolume) contextValidateVolume(ctx context.Context, formats strfmt.Registry) error {

	if m.Volume != nil {
		if err := m.Volume.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("volume")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmMigrationVolume) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmMigrationVolume) UnmarshalBinary(b []byte) error {
	var res SvmMigrationVolume
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmMigrationVolumeErrorsItems0 Specifies failure codes and messages.
//
// swagger:model SvmMigrationVolumeErrorsItems0
type SvmMigrationVolumeErrorsItems0 struct {

	// Message code
	Code int64 `json:"code,omitempty"`

	// Detailed message of warning or error.
	Message string `json:"message,omitempty"`
}

// Validate validates this svm migration volume errors items0
func (m *SvmMigrationVolumeErrorsItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this svm migration volume errors items0 based on context it is used
func (m *SvmMigrationVolumeErrorsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *SvmMigrationVolumeErrorsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmMigrationVolumeErrorsItems0) UnmarshalBinary(b []byte) error {
	var res SvmMigrationVolumeErrorsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmMigrationVolumeNode Node in the destination cluster where the volume is hosted
//
// swagger:model SvmMigrationVolumeNode
type SvmMigrationVolumeNode struct {

	// links
	Links *SvmMigrationVolumeNodeLinks `json:"_links,omitempty"`

	// name
	// Example: node1
	Name string `json:"name,omitempty"`

	// uuid
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this svm migration volume node
func (m *SvmMigrationVolumeNode) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeNode) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this svm migration volume node based on the context it is used
func (m *SvmMigrationVolumeNode) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeNode) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmMigrationVolumeNode) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmMigrationVolumeNode) UnmarshalBinary(b []byte) error {
	var res SvmMigrationVolumeNode
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmMigrationVolumeNodeLinks svm migration volume node links
//
// swagger:model SvmMigrationVolumeNodeLinks
type SvmMigrationVolumeNodeLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm migration volume node links
func (m *SvmMigrationVolumeNodeLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeNodeLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this svm migration volume node links based on the context it is used
func (m *SvmMigrationVolumeNodeLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeNodeLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmMigrationVolumeNodeLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmMigrationVolumeNodeLinks) UnmarshalBinary(b []byte) error {
	var res SvmMigrationVolumeNodeLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmMigrationVolumeSvm SVM information
//
// swagger:model SvmMigrationVolumeSvm
type SvmMigrationVolumeSvm struct {

	// links
	Links *SvmMigrationVolumeSvmLinks `json:"_links,omitempty"`

	// The name of the SVM.
	//
	// Example: svm1
	Name string `json:"name,omitempty"`

	// The unique identifier of the SVM.
	//
	// Example: 02c9e252-41be-11e9-81d5-00a0986138f7
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this svm migration volume svm
func (m *SvmMigrationVolumeSvm) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeSvm) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this svm migration volume svm based on the context it is used
func (m *SvmMigrationVolumeSvm) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeSvm) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmMigrationVolumeSvm) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmMigrationVolumeSvm) UnmarshalBinary(b []byte) error {
	var res SvmMigrationVolumeSvm
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmMigrationVolumeSvmLinks svm migration volume svm links
//
// swagger:model SvmMigrationVolumeSvmLinks
type SvmMigrationVolumeSvmLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm migration volume svm links
func (m *SvmMigrationVolumeSvmLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeSvmLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this svm migration volume svm links based on the context it is used
func (m *SvmMigrationVolumeSvmLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeSvmLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmMigrationVolumeSvmLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmMigrationVolumeSvmLinks) UnmarshalBinary(b []byte) error {
	var res SvmMigrationVolumeSvmLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmMigrationVolumeVolume Volume information in the destination cluster
//
// swagger:model SvmMigrationVolumeVolume
type SvmMigrationVolumeVolume struct {

	// links
	Links *SvmMigrationVolumeVolumeLinks `json:"_links,omitempty"`

	// The name of the volume.
	// Example: volume1
	Name string `json:"name,omitempty"`

	// Unique identifier for the volume. This corresponds to the instance-uuid that is exposed in the CLI and ONTAPI. It does not change due to a volume move.
	// Example: 028baa66-41bd-11e9-81d5-00a0986138f7
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this svm migration volume volume
func (m *SvmMigrationVolumeVolume) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeVolume) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("volume" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this svm migration volume volume based on the context it is used
func (m *SvmMigrationVolumeVolume) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeVolume) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("volume" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmMigrationVolumeVolume) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmMigrationVolumeVolume) UnmarshalBinary(b []byte) error {
	var res SvmMigrationVolumeVolume
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// SvmMigrationVolumeVolumeLinks svm migration volume volume links
//
// swagger:model SvmMigrationVolumeVolumeLinks
type SvmMigrationVolumeVolumeLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this svm migration volume volume links
func (m *SvmMigrationVolumeVolumeLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeVolumeLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("volume" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this svm migration volume volume links based on the context it is used
func (m *SvmMigrationVolumeVolumeLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *SvmMigrationVolumeVolumeLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("volume" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *SvmMigrationVolumeVolumeLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *SvmMigrationVolumeVolumeLinks) UnmarshalBinary(b []byte) error {
	var res SvmMigrationVolumeVolumeLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
