// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewAntiRansomwareSuspectCollectionGetParams creates a new AntiRansomwareSuspectCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAntiRansomwareSuspectCollectionGetParams() *AntiRansomwareSuspectCollectionGetParams {
	return &AntiRansomwareSuspectCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAntiRansomwareSuspectCollectionGetParamsWithTimeout creates a new AntiRansomwareSuspectCollectionGetParams object
// with the ability to set a timeout on a request.
func NewAntiRansomwareSuspectCollectionGetParamsWithTimeout(timeout time.Duration) *AntiRansomwareSuspectCollectionGetParams {
	return &AntiRansomwareSuspectCollectionGetParams{
		timeout: timeout,
	}
}

// NewAntiRansomwareSuspectCollectionGetParamsWithContext creates a new AntiRansomwareSuspectCollectionGetParams object
// with the ability to set a context for a request.
func NewAntiRansomwareSuspectCollectionGetParamsWithContext(ctx context.Context) *AntiRansomwareSuspectCollectionGetParams {
	return &AntiRansomwareSuspectCollectionGetParams{
		Context: ctx,
	}
}

// NewAntiRansomwareSuspectCollectionGetParamsWithHTTPClient creates a new AntiRansomwareSuspectCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewAntiRansomwareSuspectCollectionGetParamsWithHTTPClient(client *http.Client) *AntiRansomwareSuspectCollectionGetParams {
	return &AntiRansomwareSuspectCollectionGetParams{
		HTTPClient: client,
	}
}

/* AntiRansomwareSuspectCollectionGetParams contains all the parameters to send to the API endpoint
   for the anti ransomware suspect collection get operation.

   Typically these are written to a http.Request.
*/
type AntiRansomwareSuspectCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* FileFormat.

	   Filter by file.format
	*/
	FileFormatQueryParameter *string

	/* FileName.

	   Filter by file.name
	*/
	FileNameQueryParameter *string

	/* FilePath.

	   Filter by file.path
	*/
	FilePathQueryParameter *string

	/* FileSuspectTime.

	   Filter by file.suspect_time
	*/
	FileSuspectTimeQueryParameter *string

	/* IsFalsePositive.

	   Filter by is_false_positive
	*/
	IsFalsePositiveQueryParameter *bool

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* VolumeName.

	   Filter by volume.name
	*/
	VolumeNameQueryParameter *string

	/* VolumeUUID.

	   Filter by volume.uuid
	*/
	VolumeUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the anti ransomware suspect collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AntiRansomwareSuspectCollectionGetParams) WithDefaults() *AntiRansomwareSuspectCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the anti ransomware suspect collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AntiRansomwareSuspectCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := AntiRansomwareSuspectCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithTimeout(timeout time.Duration) *AntiRansomwareSuspectCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithContext(ctx context.Context) *AntiRansomwareSuspectCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithHTTPClient(client *http.Client) *AntiRansomwareSuspectCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithFieldsQueryParameter(fields []string) *AntiRansomwareSuspectCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithFileFormatQueryParameter adds the fileFormat to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithFileFormatQueryParameter(fileFormat *string) *AntiRansomwareSuspectCollectionGetParams {
	o.SetFileFormatQueryParameter(fileFormat)
	return o
}

// SetFileFormatQueryParameter adds the fileFormat to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetFileFormatQueryParameter(fileFormat *string) {
	o.FileFormatQueryParameter = fileFormat
}

// WithFileNameQueryParameter adds the fileName to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithFileNameQueryParameter(fileName *string) *AntiRansomwareSuspectCollectionGetParams {
	o.SetFileNameQueryParameter(fileName)
	return o
}

// SetFileNameQueryParameter adds the fileName to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetFileNameQueryParameter(fileName *string) {
	o.FileNameQueryParameter = fileName
}

// WithFilePathQueryParameter adds the filePath to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithFilePathQueryParameter(filePath *string) *AntiRansomwareSuspectCollectionGetParams {
	o.SetFilePathQueryParameter(filePath)
	return o
}

// SetFilePathQueryParameter adds the filePath to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetFilePathQueryParameter(filePath *string) {
	o.FilePathQueryParameter = filePath
}

// WithFileSuspectTimeQueryParameter adds the fileSuspectTime to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithFileSuspectTimeQueryParameter(fileSuspectTime *string) *AntiRansomwareSuspectCollectionGetParams {
	o.SetFileSuspectTimeQueryParameter(fileSuspectTime)
	return o
}

// SetFileSuspectTimeQueryParameter adds the fileSuspectTime to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetFileSuspectTimeQueryParameter(fileSuspectTime *string) {
	o.FileSuspectTimeQueryParameter = fileSuspectTime
}

// WithIsFalsePositiveQueryParameter adds the isFalsePositive to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithIsFalsePositiveQueryParameter(isFalsePositive *bool) *AntiRansomwareSuspectCollectionGetParams {
	o.SetIsFalsePositiveQueryParameter(isFalsePositive)
	return o
}

// SetIsFalsePositiveQueryParameter adds the isFalsePositive to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetIsFalsePositiveQueryParameter(isFalsePositive *bool) {
	o.IsFalsePositiveQueryParameter = isFalsePositive
}

// WithMaxRecordsQueryParameter adds the maxRecords to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *AntiRansomwareSuspectCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *AntiRansomwareSuspectCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *AntiRansomwareSuspectCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *AntiRansomwareSuspectCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithVolumeNameQueryParameter adds the volumeName to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithVolumeNameQueryParameter(volumeName *string) *AntiRansomwareSuspectCollectionGetParams {
	o.SetVolumeNameQueryParameter(volumeName)
	return o
}

// SetVolumeNameQueryParameter adds the volumeName to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetVolumeNameQueryParameter(volumeName *string) {
	o.VolumeNameQueryParameter = volumeName
}

// WithVolumeUUIDQueryParameter adds the volumeUUID to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) WithVolumeUUIDQueryParameter(volumeUUID *string) *AntiRansomwareSuspectCollectionGetParams {
	o.SetVolumeUUIDQueryParameter(volumeUUID)
	return o
}

// SetVolumeUUIDQueryParameter adds the volumeUuid to the anti ransomware suspect collection get params
func (o *AntiRansomwareSuspectCollectionGetParams) SetVolumeUUIDQueryParameter(volumeUUID *string) {
	o.VolumeUUIDQueryParameter = volumeUUID
}

// WriteToRequest writes these params to a swagger request
func (o *AntiRansomwareSuspectCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.FileFormatQueryParameter != nil {

		// query param file.format
		var qrFileFormat string

		if o.FileFormatQueryParameter != nil {
			qrFileFormat = *o.FileFormatQueryParameter
		}
		qFileFormat := qrFileFormat
		if qFileFormat != "" {

			if err := r.SetQueryParam("file.format", qFileFormat); err != nil {
				return err
			}
		}
	}

	if o.FileNameQueryParameter != nil {

		// query param file.name
		var qrFileName string

		if o.FileNameQueryParameter != nil {
			qrFileName = *o.FileNameQueryParameter
		}
		qFileName := qrFileName
		if qFileName != "" {

			if err := r.SetQueryParam("file.name", qFileName); err != nil {
				return err
			}
		}
	}

	if o.FilePathQueryParameter != nil {

		// query param file.path
		var qrFilePath string

		if o.FilePathQueryParameter != nil {
			qrFilePath = *o.FilePathQueryParameter
		}
		qFilePath := qrFilePath
		if qFilePath != "" {

			if err := r.SetQueryParam("file.path", qFilePath); err != nil {
				return err
			}
		}
	}

	if o.FileSuspectTimeQueryParameter != nil {

		// query param file.suspect_time
		var qrFileSuspectTime string

		if o.FileSuspectTimeQueryParameter != nil {
			qrFileSuspectTime = *o.FileSuspectTimeQueryParameter
		}
		qFileSuspectTime := qrFileSuspectTime
		if qFileSuspectTime != "" {

			if err := r.SetQueryParam("file.suspect_time", qFileSuspectTime); err != nil {
				return err
			}
		}
	}

	if o.IsFalsePositiveQueryParameter != nil {

		// query param is_false_positive
		var qrIsFalsePositive bool

		if o.IsFalsePositiveQueryParameter != nil {
			qrIsFalsePositive = *o.IsFalsePositiveQueryParameter
		}
		qIsFalsePositive := swag.FormatBool(qrIsFalsePositive)
		if qIsFalsePositive != "" {

			if err := r.SetQueryParam("is_false_positive", qIsFalsePositive); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.VolumeNameQueryParameter != nil {

		// query param volume.name
		var qrVolumeName string

		if o.VolumeNameQueryParameter != nil {
			qrVolumeName = *o.VolumeNameQueryParameter
		}
		qVolumeName := qrVolumeName
		if qVolumeName != "" {

			if err := r.SetQueryParam("volume.name", qVolumeName); err != nil {
				return err
			}
		}
	}

	if o.VolumeUUIDQueryParameter != nil {

		// query param volume.uuid
		var qrVolumeUUID string

		if o.VolumeUUIDQueryParameter != nil {
			qrVolumeUUID = *o.VolumeUUIDQueryParameter
		}
		qVolumeUUID := qrVolumeUUID
		if qVolumeUUID != "" {

			if err := r.SetQueryParam("volume.uuid", qVolumeUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamAntiRansomwareSuspectCollectionGet binds the parameter fields
func (o *AntiRansomwareSuspectCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamAntiRansomwareSuspectCollectionGet binds the parameter order_by
func (o *AntiRansomwareSuspectCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
